/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languages/tokenizationRegistry","vs/editor/common/model/textModelSearch","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Z){for(var e=[],f=0,t=Z.length;f<t;f++)e[f]=pe[Z[f]];return e};define(pe[55],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(t,k){if(!t)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=f}),define(pe[74],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function f(T){return T?T.replace(/\$\((.*?)\)/g,(I,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=f;class t{constructor(I,_,P){this.id=I,this.definition=_,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(T,I){const _=["codicon","codicon-"+T];return I&&_.push("codicon-modifier-"+I),_}e.getClassNamesArray=k;var D;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function _(y){if(y instanceof t)return["codicon","codicon-"+y.id];const l=I.exec(y.id);if(!l)return _(t.error);let[,b,p]=l;const g=["codicon","codicon-"+b];return p&&g.push("codicon-modifier-"+p.substr(1)),g}T.asClassNameArray=_;function P(y){return _(y).join(" ")}T.asClassName=P;function R(y){return"."+_(y).join(".")}T.asCSSSelector=R})(D=e.CSSIcon||(e.CSSIcon={}))}),define(pe[75],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function t(R){const y=[];for(let l in R)f.call(R,l)&&y.push(R[l]);return y}e.values=t;function k(R,y){for(let l in R)if(f.call(R,l)&&y({key:l,value:R[l]},function(){delete R[l]})===!1)return}e.forEach=k;function D(R,y){const l=Object.create(null);for(const b of R){const p=y(b);let g=l[p];g||(g=l[p]=[]),g.push(b)}return l}e.groupBy=D;function T(R){const y=Object.create(null);return R&&R.forEach((l,b)=>{y[b]=l}),y}e.fromMap=T;function I(R,y){const l=[],b=[];for(let p of R)y.has(p)||l.push(p);for(let p of y)R.has(p)||b.push(p);return{removed:l,added:b}}e.diffSets=I;function _(R,y){const l=[],b=[];for(let[p,g]of R)y.has(p)||l.push(g);for(let[p,g]of y)R.has(p)||b.push(g);return{removed:l,added:b}}e.diffMaps=_;class P{constructor(){this.map=new Map}add(y,l){let b=this.map.get(y);b||(b=new Set,this.map.set(y,b)),b.add(l)}delete(y,l){const b=this.map.get(y);!b||(b.delete(l),b.size===0&&this.map.delete(y))}forEach(y,l){const b=this.map.get(y);!b||b.forEach(l)}}e.SetMap=P}),define(pe[56],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(T){return(I,_,P)=>{let R=null,y=null;if(typeof P.value=="function"?(R="value",y=P.value):typeof P.get=="function"&&(R="get",y=P.get),!y)throw new Error("not supported");P[R]=T(y,_)}}e.createDecorator=f;function t(T,I,_){let P=null,R=null;if(typeof _.value=="function"?(P="value",R=_.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(P="get",R=_.get),!R)throw new Error("not supported");const y=`$memoize$${I}`;_[P]=function(...l){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[y]}}e.memoize=t;function k(T,I,_){return f((P,R)=>{const y=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...b){this[l]||(this[l]=_?_():void 0),clearTimeout(this[y]),I&&(this[l]=I(this[l],...b),b=[this[l]]),this[y]=setTimeout(()=>{P.apply(this,b),this[l]=_?_():void 0},T)}})}e.debounce=k;function D(T,I,_){return f((P,R)=>{const y=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,b=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...g){if(this[l]||(this[l]=_?_():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),I&&(this[l]=I(this[l],...g)),this[p])return;const E=this[b]+T;E<=Date.now()?(this[b]=Date.now(),P.apply(this,[this[l]]),this[l]=_?_():void 0):(this[p]=!0,this[y]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),P.apply(this,[this[l]]),this[l]=_?_():void 0},E-Date.now()))}})}e.throttle=D}),define(pe[16],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(S=>{S(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=f,e.errorHandler=new f;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function k(m){_(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=k;function D(m){_(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=D;function T(m){if(m instanceof Error){let{name:o,message:S}=m;const r=m.stacktrace||m.stack;return{$isError:!0,name:o,message:S,stack:r}}return m}e.transformErrorForSerialization=T;const I="Canceled";function _(m){return m instanceof P?!0:m instanceof Error&&m.name===I&&m.message===I}e.isCancellationError=_;class P extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=P;function R(){const m=new Error(I);return m.name=m.message,m}e.canceled=R;function y(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=y;function l(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=l;function b(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function p(m){const o=new Error(`${m} has been disposed`);return o.name="DISPOSED",o}e.disposed=p;function g(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=g;class E extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=E;class L extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=L;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function a(m){const o=m;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=a;function s(m,o=Object.create(null)){const S=new Error(m);return o.actions&&(S.actions=o.actions),S}e.createErrorWithActions=s}),define(pe[17],ve([0,1,16]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(K,Q=0){return K[K.length-(1+Q)]}e.tail=t;function k(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=k;function D(K,Q,ae=(fe,be)=>fe===be){if(K===Q)return!0;if(!K||!Q||K.length!==Q.length)return!1;for(let fe=0,be=K.length;fe<be;fe++)if(!ae(K[fe],Q[fe]))return!1;return!0}e.equals=D;function T(K,Q,ae){let fe=0,be=K.length-1;for(;fe<=be;){const Me=(fe+be)/2|0,ze=ae(K[Me],Q);if(ze<0)fe=Me+1;else if(ze>0)be=Me-1;else return Me}return-(fe+1)}e.binarySearch=T;function I(K,Q){let ae=0,fe=K.length;if(fe===0)return 0;for(;ae<fe;){const be=Math.floor((ae+fe)/2);Q(K[be])?fe=be:ae=be+1}return ae}e.findFirstInSorted=I;function _(K,Q,ae){if(K=K|0,K>=Q.length)throw new TypeError("invalid index");let fe=Q[Math.floor(Q.length*Math.random())],be=[],Me=[],ze=[];for(let Ge of Q){const Je=ae(Ge,fe);Je<0?be.push(Ge):Je>0?Me.push(Ge):ze.push(Ge)}return K<be.length?_(K,be,ae):K<be.length+ze.length?ze[0]:_(K-(be.length+ze.length),Me,ae)}e.quickSelect=_;function P(K,Q){const ae=[];let fe;for(const be of K.slice(0).sort(Q))!fe||Q(fe[0],be)!==0?(fe=[be],ae.push(fe)):fe.push(be);return ae}e.groupBy=P;function R(K,Q,ae){const fe=[];function be(Ge,Je,q){if(Je===0&&q.length===0)return;const te=fe[fe.length-1];te&&te.start+te.deleteCount===Ge?(te.deleteCount+=Je,te.toInsert.push(...q)):fe.push({start:Ge,deleteCount:Je,toInsert:q})}let Me=0,ze=0;for(;;){if(Me===K.length){be(Me,0,Q.slice(ze));break}if(ze===Q.length){be(Me,K.length-Me,[]);break}const Ge=K[Me],Je=Q[ze],q=ae(Ge,Je);q===0?(Me+=1,ze+=1):q<0?(be(Me,1,[]),Me+=1):q>0&&(be(Me,0,[Je]),ze+=1)}return fe}e.sortedDiff=R;function y(K,Q,ae){const fe=R(K,Q,ae),be=[],Me=[];for(const ze of fe)be.push(...K.slice(ze.start,ze.start+ze.deleteCount)),Me.push(...ze.toInsert);return{removed:be,added:Me}}e.delta=y;function l(K,Q,ae){if(ae===0)return[];const fe=K.slice(0,ae).sort(Q);return p(K,Q,fe,ae,K.length),fe}e.top=l;function b(K,Q,ae,fe,be){return ae===0?Promise.resolve([]):new Promise((Me,ze)=>{(async()=>{const Ge=K.length,Je=K.slice(0,ae).sort(Q);for(let q=ae,te=Math.min(ae+fe,Ge);q<Ge;q=te,te=Math.min(te+fe,Ge)){if(q>ae&&await new Promise(G=>setTimeout(G)),be&&be.isCancellationRequested)throw(0,f.canceled)();p(K,Q,Je,q,te)}return Je})().then(Me,ze)})}e.topAsync=b;function p(K,Q,ae,fe,be){for(const Me=ae.length;fe<be;fe++){const ze=K[fe];if(Q(ze,ae[Me-1])<0){ae.pop();const Ge=I(ae,Je=>Q(ze,Je)<0);ae.splice(Ge,0,ze)}}}function g(K){return K.filter(Q=>!!Q)}e.coalesce=g;function E(K){let Q=0;for(let ae=0;ae<K.length;ae++)K[ae]&&(K[Q]=K[ae],Q+=1);K.length=Q}e.coalesceInPlace=E;function L(K,Q,ae){K.splice(ae,0,K.splice(Q,1)[0])}e.move=L;function C(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=C;function a(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=a;function s(K,Q=ae=>ae){const ae=new Set;return K.filter(fe=>{const be=Q(fe);return ae.has(be)?!1:(ae.add(be),!0)})}e.distinct=s;function m(K){const Q=new Set;return ae=>{const fe=K(ae);return Q.has(fe)?!1:(Q.add(fe),!0)}}e.uniqueFilter=m;function o(K,Q){const ae=S(K,Q);if(ae!==-1)return K[ae]}e.findLast=o;function S(K,Q){for(let ae=K.length-1;ae>=0;ae--){const fe=K[ae];if(Q(fe))return ae}return-1}e.lastIndex=S;function r(K,Q){return K.length>0?K[0]:Q}e.firstOrDefault=r;function i(K,Q,ae=(fe,be)=>fe===be){let fe=0;for(let be=0,Me=Math.min(K.length,Q.length);be<Me&&ae(K[be],Q[be]);be++)fe++;return fe}e.commonPrefixLength=i;function n(K){return[].concat(...K)}e.flatten=n;function u(K,Q){let ae=typeof Q=="number"?K:0;typeof Q=="number"?ae=K:(ae=0,Q=K);const fe=[];if(ae<=Q)for(let be=ae;be<Q;be++)fe.push(be);else for(let be=ae;be>Q;be--)fe.push(be);return fe}e.range=u;function c(K,Q,ae){return K.reduce((fe,be)=>(fe[Q(be)]=ae?ae(be):be,fe),Object.create(null))}e.index=c;function d(K,Q){return K.push(Q),()=>h(K,Q)}e.insert=d;function h(K,Q){const ae=K.indexOf(Q);if(ae>-1)return K.splice(ae,1),Q}e.remove=h;function v(K,Q,ae){const fe=K.slice(0,Q),be=K.slice(Q);return fe.concat(ae,be)}e.arrayInsert=v;function w(K,Q){let ae;if(typeof Q=="number"){let fe=Q;ae=()=>{const be=Math.sin(fe++)*179426549;return be-Math.floor(be)}}else ae=Math.random;for(let fe=K.length-1;fe>0;fe-=1){const be=Math.floor(ae()*(fe+1)),Me=K[fe];K[fe]=K[be],K[be]=Me}}e.shuffle=w;function A(K,Q){const ae=K.indexOf(Q);ae>-1&&(K.splice(ae,1),K.unshift(Q))}e.pushToStart=A;function O(K,Q){const ae=K.indexOf(Q);ae>-1&&(K.splice(ae,1),K.push(Q))}e.pushToEnd=O;function N(K,Q){return Array.isArray(K)?K.map(Q):Q(K)}e.mapArrayOrNot=N;function F(K){return Array.isArray(K)?K:[K]}e.asArray=F;function M(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=M;function V(K,Q){for(const ae of K){const fe=Q(ae);if(fe!==void 0)return fe}}e.mapFind=V;function $(K,Q,ae){const fe=B(K,Q),be=K.length,Me=ae.length;K.length=be+Me;for(let ze=be-1;ze>=fe;ze--)K[ze+Me]=K[ze];for(let ze=0;ze<Me;ze++)K[ze+fe]=ae[ze]}e.insertInto=$;function U(K,Q,ae,fe){const be=B(K,Q),Me=K.splice(be,ae);return $(K,be,fe),Me}e.splice=U;function B(K,Q){return Q<0?Math.max(Q+K.length,0):Math.min(Q,K.length)}function W(K,Q){return(ae,fe)=>Q(K(ae),K(fe))}e.compareBy=W;const H=(K,Q)=>K-Q;e.numberComparator=H;function x(K,Q){if(K.length===0)return;let ae=K[0];for(let fe=1;fe<K.length;fe++){const be=K[fe];Q(be,ae)>0&&(ae=be)}return ae}e.findMaxBy=x;function J(K,Q){if(K.length===0)return;let ae=K[0];for(let fe=1;fe<K.length;fe++){const be=K[fe];Q(be,ae)>=0&&(ae=be)}return ae}e.findLastMaxBy=J;function ne(K,Q){return x(K,(ae,fe)=>-Q(ae,fe))}e.findMinBy=ne;class se{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let ae=this.firstIdx;for(;ae<this.items.length&&Q(this.items[ae]);)ae++;const fe=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,fe}takeFromEndWhile(Q){let ae=this.lastIdx;for(;ae>=0&&Q(this.items[ae]);)ae--;const fe=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,fe}peek(){return this.items[this.firstIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}takeCount(Q){const ae=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,ae}}e.ArrayQueue=se}),define(pe[76],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(t){const k=this;let D=!1,T;return function(){return D||(D=!0,T=t.apply(k,arguments)),T}}e.once=f}),define(pe[77],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(pe[78],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function k(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}t.is=k;const D=Object.freeze([]);function T(){return D}t.empty=T;function*I(m){yield m}t.single=I;function _(m){return m||D}t.from=_;function P(m){return!m||m[Symbol.iterator]().next().done===!0}t.isEmpty=P;function R(m){return m[Symbol.iterator]().next().value}t.first=R;function y(m,o){for(const S of m)if(o(S))return!0;return!1}t.some=y;function l(m,o){for(const S of m)if(o(S))return S}t.find=l;function*b(m,o){for(const S of m)o(S)&&(yield S)}t.filter=b;function*p(m,o){let S=0;for(const r of m)yield o(r,S++)}t.map=p;function*g(...m){for(const o of m)for(const S of o)yield S}t.concat=g;function*E(m){for(const o of m)for(const S of o)yield S}t.concatNested=E;function L(m,o,S){let r=S;for(const i of m)r=o(r,i);return r}t.reduce=L;function*C(m,o,S=m.length){for(o<0&&(o+=m.length),S<0?S+=m.length:S>m.length&&(S=m.length);o<S;o++)yield m[o]}t.slice=C;function a(m,o=Number.POSITIVE_INFINITY){const S=[];if(o===0)return[S,m];const r=m[Symbol.iterator]();for(let i=0;i<o;i++){const n=r.next();if(n.done)return[S,t.empty()];S.push(n.value)}return[S,{[Symbol.iterator](){return r}}]}t.consume=a;function s(m,o,S=(r,i)=>r===i){const r=m[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const n=r.next(),u=i.next();if(n.done!==u.done)return!1;if(n.done)return!0;if(!S(n.value,u.value))return!1}}t.equals=s})(f=e.Iterable||(e.Iterable={}))}),define(pe[57],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(o){o.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function T(o,S=!1){let r=0,i=o.length,n="",u=0,c=16,d=0;function h(M){let V=0,$=0;for(;V<M;){const U=o.charCodeAt(r);if(U>=48&&U<=57)$=$*16+U-48;else if(U>=65&&U<=70)$=$*16+U-65+10;else if(U>=97&&U<=102)$=$*16+U-97+10;else break;r++,V++}return V<M&&($=-1),$}function v(M){r=M,n="",u=0,c=16,d=0}function w(){const M=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&P(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&P(o.charCodeAt(r)))for(r++;r<o.length&&P(o.charCodeAt(r));)r++;else return d=3,o.substring(M,r);let V=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&P(o.charCodeAt(r))){for(r++;r<o.length&&P(o.charCodeAt(r));)r++;V=r}else d=3;return o.substring(M,V)}function A(){let M="",V=r;for(;;){if(r>=i){M+=o.substring(V,r),d=2;break}const $=o.charCodeAt(r);if($===34){M+=o.substring(V,r),r++;break}if($===92){if(M+=o.substring(V,r),r++,r>=i){d=2;break}switch(o.charCodeAt(r++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const B=h(4);B>=0?M+=String.fromCharCode(B):d=4;break}default:d=5}V=r;continue}if($>=0&&$<=31)if(_($)){M+=o.substring(V,r),d=2;break}else d=6;r++}return M}function O(){if(n="",d=0,u=r,r>=i)return u=i,c=17;let M=o.charCodeAt(r);if(I(M)){do r++,n+=String.fromCharCode(M),M=o.charCodeAt(r);while(I(M));return c=15}if(_(M))return r++,n+=String.fromCharCode(M),M===13&&o.charCodeAt(r)===10&&(r++,n+=`
`),c=14;switch(M){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,n=A(),c=10;case 47:{const V=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<i&&!_(o.charCodeAt(r));)r++;return n=o.substring(V,r),c=12}if(o.charCodeAt(r+1)===42){r+=2;const $=i-1;let U=!1;for(;r<$;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,d=1),n=o.substring(V,r),c=13}return n+=String.fromCharCode(M),r++,c=16}case 45:if(n+=String.fromCharCode(M),r++,r===i||!P(o.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=w(),c=11;default:for(;r<i&&N(M);)r++,M=o.charCodeAt(r);if(u!==r){switch(n=o.substring(u,r),n){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return n+=String.fromCharCode(M),r++,c=16}}function N(M){if(I(M)||_(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:v,getPosition:()=>r,scan:S?F:O,getToken:()=>c,getTokenValue:()=>n,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>d}}e.createScanner=T;function I(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function _(o){return o===10||o===13||o===8232||o===8233}function P(o){return o>=48&&o<=57}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function y(o,S){const r=[],i=new Object;let n;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function d(h,v,w,A){u.value=h,u.offset=v,u.length=w,u.type=A,u.colonOffset=void 0,n=u}try{a(o,{onObjectBegin:(h,v)=>{if(S<=h)throw i;n=void 0,c=S>h,r.push("")},onObjectProperty:(h,v,w)=>{if(S<v||(d(h,v,w,"property"),r[r.length-1]=h,S<=v+w))throw i},onObjectEnd:(h,v)=>{if(S<=h)throw i;n=void 0,r.pop()},onArrayBegin:(h,v)=>{if(S<=h)throw i;n=void 0,r.push(0)},onArrayEnd:(h,v)=>{if(S<=h)throw i;n=void 0,r.pop()},onLiteralValue:(h,v,w)=>{if(S<v||(d(h,v,w,m(h)),S<=v+w))throw i},onSeparator:(h,v,w)=>{if(S<=v)throw i;if(h===":"&&n&&n.type==="property")n.colonOffset=v,c=!1,n=void 0;else if(h===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:(c=!0,r[r.length-1]=""),n=void 0}}})}catch(h){if(h!==i)throw h}return{path:r,previousNode:n,isAtPropertyKey:c,matches:h=>{let v=0;for(let w=0;v<h.length&&w<r.length;w++)if(h[v]===r[w]||h[v]==="*")v++;else if(h[v]!=="**")return!1;return v===h.length}}}e.getLocation=y;function l(o,S=[],r=D.DEFAULT){let i=null,n=[];const u=[];function c(h){Array.isArray(n)?n.push(h):i!==null&&(n[i]=h)}return a(o,{onObjectBegin:()=>{const h={};c(h),u.push(n),n=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{n=u.pop()},onArrayBegin:()=>{const h=[];c(h),u.push(n),n=h,i=null},onArrayEnd:()=>{n=u.pop()},onLiteralValue:c,onError:(h,v,w)=>{S.push({error:h,offset:v,length:w})}},r),n[0]}e.parse=l;function b(o,S=[],r=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function u(h){return i.children.push(h),h}a(o,{onObjectBegin:h=>{i=u({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,v,w)=>{i=u({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:v,length:w,parent:i})},onObjectEnd:(h,v)=>{i.length=h+v-i.offset,i=i.parent,n(h+v)},onArrayBegin:(h,v)=>{i=u({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,v)=>{i.length=h+v-i.offset,i=i.parent,n(h+v)},onLiteralValue:(h,v,w)=>{u({type:m(h),offset:v,length:w,parent:i,value:h}),n(v+w)},onSeparator:(h,v,w)=>{i.type==="property"&&(h===":"?i.colonOffset=v:h===","&&n(v))},onError:(h,v,w)=>{S.push({error:h,offset:v,length:w})}},r);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=b;function p(o,S){if(!o)return;let r=o;for(let i of S)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.findNodeAtLocation=p;function g(o){if(!o.parent||!o.parent.children)return[];const S=g(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;S.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&S.push(r)}return S}e.getNodePath=g;function E(o){switch(o.type){case"array":return o.children.map(E);case"object":{const S=Object.create(null);for(let r of o.children){const i=r.children[1];i&&(S[r.children[0].value]=E(i))}return S}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=E;function L(o,S,r=!1){return S>=o.offset&&S<o.offset+o.length||r&&S===o.offset+o.length}e.contains=L;function C(o,S,r=!1){if(L(o,S,r)){const i=o.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=S;n++){const u=C(i[n],S,r);if(u)return u}return o}}e.findNodeAtOffset=C;function a(o,S,r=D.DEFAULT){const i=T(o,!1);function n(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(se){return se?K=>se(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=n(S.onObjectBegin),d=u(S.onObjectProperty),h=n(S.onObjectEnd),v=n(S.onArrayBegin),w=n(S.onArrayEnd),A=u(S.onLiteralValue),O=u(S.onSeparator),N=n(S.onComment),F=u(S.onError),M=r&&r.disallowComments,V=r&&r.allowTrailingComma;function $(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(se){case 12:case 13:M?U(10):N();break;case 16:U(1);break;case 15:case 14:break;default:return se}}}function U(se,K=[],Q=[]){if(F(se),K.length+Q.length>0){let ae=i.getToken();for(;ae!==17;){if(K.indexOf(ae)!==-1){$();break}else if(Q.indexOf(ae)!==-1)break;ae=$()}}}function B(se){const K=i.getTokenValue();return se?A(K):d(K),$(),!0}function W(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(U(2),se=0)}catch{U(2)}A(se);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return $(),!0}function H(){return i.getToken()!==10?(U(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(O(":"),$(),ne()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function x(){c(),$();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||U(4,[],[]),O(","),$(),i.getToken()===2&&V)break}else se&&U(6,[],[]);H()||U(4,[],[2,5]),se=!0}return h(),i.getToken()!==2?U(7,[2],[]):$(),!0}function J(){v(),$();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||U(4,[],[]),O(","),$(),i.getToken()===4&&V)break}else se&&U(6,[],[]);ne()||U(4,[],[4,5]),se=!0}return w(),i.getToken()!==4?U(8,[4],[]):$(),!0}function ne(){switch(i.getToken()){case 3:return J();case 1:return x();case 10:return B(!0);default:return W()}}return $(),i.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):ne()?(i.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=a;function s(o,S){let r=T(o),i=[],n,u=0,c;do switch(c=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:u!==c&&i.push(o.substring(u,c)),S!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,S)),u=r.getPosition();break}while(n!==17);return i.join("")}e.stripComments=s;function m(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(pe[139],ve([0,1,57]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,R,y){let l,b,p,g,E;if(R){for(g=R.offset,E=g+R.length,p=g;p>0&&!_(P,p-1);)p--;let c=E;for(;c<P.length&&!_(P,c);)c++;b=P.substring(p,c),l=T(b,y)}else b=P,l=0,p=0,g=0,E=P.length;const L=I(y,P);let C=!1,a=0,s;y.insertSpaces?s=D(" ",y.tabSize||4):s="	";const m=(0,f.createScanner)(b,!1);let o=!1;function S(){return L+D(s,l+a)}function r(){let c=m.scan();for(C=!1;c===15||c===14;)C=C||c===14,c=m.scan();return o=c===16||m.getTokenError()!==0,c}const i=[];function n(c,d,h){!o&&d<E&&h>g&&P.substring(d,h)!==c&&i.push({offset:d,length:h-d,content:c})}let u=r();if(u!==17){const c=m.getTokenOffset()+p,d=D(s,l);n(d,p,c)}for(;u!==17;){let c=m.getTokenOffset()+m.getTokenLength()+p,d=r(),h="";for(;!C&&(d===12||d===13);){const w=m.getTokenOffset()+p;n(" ",c,w),c=m.getTokenOffset()+m.getTokenLength()+p,h=d===12?S():"",d=r()}if(d===2)u!==1&&(a--,h=S());else if(d===4)u!==3&&(a--,h=S());else{switch(u){case 3:case 1:a++,h=S();break;case 5:case 12:h=S();break;case 13:C?h=S():h=" ";break;case 6:h=" ";break;case 10:if(d===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?h=" ":d!==5&&d!==17&&(o=!0);break;case 16:o=!0;break}C&&(d===12||d===13)&&(h=S())}const v=m.getTokenOffset()+p;n(h,c,v),u=d}return i}e.format=t;function k(P,R){const y=JSON.stringify(P,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?y.replace(/\r\n|\r|\n/g,R.eol):y}e.toFormattedString=k;function D(P,R){let y="";for(let l=0;l<R;l++)y+=P;return y}function T(P,R){let y=0,l=0;const b=R.tabSize||4;for(;y<P.length;){const p=P.charAt(y);if(p===" ")l++;else if(p==="	")l+=b;else break;y++}return Math.floor(l/b)}function I(P,R){for(let y=0;y<R.length;y++){const l=R.charAt(y);if(l==="\r")return y+1<R.length&&R.charAt(y+1)===`
`?`\r
`:"\r";if(l===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=I;function _(P,R){return`\r
`.indexOf(P.charAt(R))!==-1}e.isEOL=_}),define(pe[140],ve([0,1,57,139]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,R,y){return D(P,R,void 0,y)}e.removeProperty=k;function D(P,R,y,l,b){const p=R.slice(),g=[],E=(0,f.parseTree)(P,g);let L,C;for(;p.length>0&&(C=p.pop(),L=(0,f.findNodeAtLocation)(E,p),L===void 0&&y!==void 0);)typeof C=="string"?y={[C]:y}:y=[y];if(L)if(L.type==="object"&&typeof C=="string"&&Array.isArray(L.children)){const a=(0,f.findNodeAtLocation)(L,[C]);if(a!==void 0)if(y===void 0){if(!a.parent)throw new Error("Malformed AST");const s=L.children.indexOf(a.parent);let m,o=a.parent.offset+a.parent.length;if(s>0){const S=L.children[s-1];m=S.offset+S.length}else m=L.offset+1,L.children.length>1&&(o=L.children[1].offset);return T(P,{offset:m,length:o-m,content:""},l)}else return T(P,{offset:a.offset,length:a.length,content:JSON.stringify(y)},l);else{if(y===void 0)return[];const s=`${JSON.stringify(C)}: ${JSON.stringify(y)}`,m=b?b(L.children.map(S=>S.children[0].value)):L.children.length;let o;if(m>0){const S=L.children[m-1];o={offset:S.offset+S.length,length:0,content:","+s}}else L.children.length===0?o={offset:L.offset+1,length:0,content:s}:o={offset:L.offset+1,length:0,content:s+","};return T(P,o,l)}}else if(L.type==="array"&&typeof C=="number"&&Array.isArray(L.children))if(y!==void 0){const a=`${JSON.stringify(y)}`;let s;if(L.children.length===0||C===0)s={offset:L.offset+1,length:0,content:L.children.length===0?a:a+","};else{const m=C===-1||C>L.children.length?L.children.length:C,o=L.children[m-1];s={offset:o.offset+o.length,length:0,content:","+a}}return T(P,s,l)}else{const a=C,s=L.children[a];let m;if(L.children.length===1)m={offset:L.offset+1,length:L.length-2,content:""};else if(L.children.length-1===a){const o=L.children[a-1],S=o.offset+o.length,r=L.offset+L.length;m={offset:S,length:r-2-S,content:""}}else m={offset:s.offset,length:L.children[a+1].offset-s.offset,content:""};return T(P,m,l)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${L.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return T(P,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(y)},l)}}e.setProperty=D;function T(P,R,y){let l=I(P,R),b=R.offset,p=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;b>0&&!(0,t.isEOL)(l,b-1);)b--;for(;p<l.length&&!(0,t.isEOL)(l,p);)p++}const g=(0,t.format)(l,{offset:b,length:p-b},y);for(let L=g.length-1;L>=0;L--){const C=g[L];l=I(l,C),b=Math.min(b,C.offset),p=Math.max(p,C.offset+C.length),p+=C.content.length-C.length}const E=P.length-(l.length-p)-b;return[{offset:b,length:E,content:l.substring(b,p)}]}e.withFormatting=T;function I(P,R){return P.substring(0,R.offset)+R.content+P.substring(R.offset+R.length)}e.applyEdit=I;function _(P,R){let y=R.slice(0).sort((b,p)=>{const g=b.offset-p.offset;return g===0?b.length-p.length:g}),l=P.length;for(let b=y.length-1;b>=0;b--){let p=y[b];if(p.offset+p.length<=l)P=I(P,p);else throw new Error("Overlapping edit");l=p.offset}return P}e.applyEdits=_}),define(pe[92],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new f(()=>k(this.getValue()))}}e.Lazy=f}),define(pe[6],ve([0,1,76,78]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let D=null;function T(i){D=i}if(e.setDisposableTracker=T,k){const i="__is_disposable_tracked__";T(new class{trackDisposable(n){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[i]||console.log(u)},3e3)}setParent(n,u){if(n&&n!==C.None)try{n[i]=!0}catch{}}markAsDisposed(n){if(n&&n!==C.None)try{n[i]=!0}catch{}}markAsSingleton(n){}})}function I(i){return D?.trackDisposable(i),i}function _(i){D?.markAsDisposed(i)}function P(i,n){D?.setParent(i,n)}function R(i,n){if(!!D)for(const u of i)D.setParent(u,n)}function y(i){return D?.markAsSingleton(i),i}e.markAsSingleton=y;class l extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=l;function b(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=b;function p(i){if(t.Iterable.is(i)){let n=[];for(const u of i)if(u)try{u.dispose()}catch(c){n.push(c)}if(n.length===1)throw n[0];if(n.length>1)throw new l(n);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=p;function g(...i){const n=E(()=>p(i));return R(i,n),n}e.combinedDisposable=g;function E(i){const n=I({dispose:(0,f.once)(()=>{_(n),i()})});return n}e.toDisposable=E;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{p(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return P(n,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new L,I(this),P(this._store,this)}dispose(){_(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&P(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&P(n,null),n}}e.MutableDisposable=a;class s{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class m{constructor(){this.references=new Map}acquire(n,...u){let c=this.references.get(n);c||(c={counter:0,object:this.createReferencedObject(n,...u)},this.references.set(n,c));const{object:d}=c,h=(0,f.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(n,c.object),this.references.delete(n))});return c.counter++,{object:d,dispose:h}}}e.ReferenceCollection=m;class o{constructor(n){this.referenceCollection=n}async acquire(n,...u){const c=this.referenceCollection.acquire(n,...u);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(d){throw c.dispose(),d}}}e.AsyncReferenceCollection=o;class S{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=S;function r(i){const n=new L;try{i(n)}finally{n.dispose()}}e.disposeOnReturn=r}),define(pe[93],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(D){this.element=D,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class t{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let D=this._first;for(;D!==f.Undefined;){const T=D.next;D.prev=f.Undefined,D.next=f.Undefined,D=T}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,T){const I=new f(D);if(this._first===f.Undefined)this._first=I,this._last=I;else if(T){const P=this._last;this._last=I,I.prev=P,P.next=I}else{const P=this._first;this._first=I,I.next=P,P.prev=I}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(I))}}shift(){if(this._first!==f.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==f.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==f.Undefined&&D.next!==f.Undefined){const T=D.prev;T.next=D.next,D.next.prev=T}else D.prev===f.Undefined&&D.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):D.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):D.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==f.Undefined;)yield D.element,D=D.next}}e.LinkedList=t}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Re,Ae){for(var De=0;De<Ae.length;De++){var ce=Ae[De];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Re,ce.key,ce)}}function e(Re,Ae,De){return Ae&&Z(Re.prototype,Ae),De&&Z(Re,De),Re}function f(Re,Ae){if(!!Re){if(typeof Re=="string")return t(Re,Ae);var De=Object.prototype.toString.call(Re).slice(8,-1);if(De==="Object"&&Re.constructor&&(De=Re.constructor.name),De==="Map"||De==="Set")return Array.from(Re);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return t(Re,Ae)}}function t(Re,Ae){(Ae==null||Ae>Re.length)&&(Ae=Re.length);for(var De=0,ce=new Array(Ae);De<Ae;De++)ce[De]=Re[De];return ce}function k(Re,Ae){var De=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(De)return(De=De.call(Re)).next.bind(De);if(Array.isArray(Re)||(De=f(Re))||Ae&&Re&&typeof Re.length=="number"){De&&(Re=De);var ce=0;return function(){return ce>=Re.length?{done:!0}:{done:!1,value:Re[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var D={exports:{}};function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Re){D.exports.defaults=Re}D.exports={defaults:T(),getDefaults:T,changeDefaults:I};var _=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ae){return l[Ae]};function p(Re,Ae){if(Ae){if(_.test(Re))return Re.replace(P,b)}else if(R.test(Re))return Re.replace(y,b);return Re}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E(Re){return Re.replace(g,function(Ae,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var L=/(^|[^\[])\^/g;function C(Re,Ae){Re=Re.source||Re,Ae=Ae||"";var De={replace:function(de,we){return we=we.source||we,we=we.replace(L,"$1"),Re=Re.replace(de,we),De},getRegex:function(){return new RegExp(Re,Ae)}};return De}var a=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Re,Ae,De){if(Re){var ce;try{ce=decodeURIComponent(E(De)).replace(a,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}Ae&&!s.test(De)&&(De=n(Ae,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var o={},S=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Re,Ae){o[" "+Re]||(S.test(Re)?o[" "+Re]=Re+"/":o[" "+Re]=h(Re,"/",!0)),Re=o[" "+Re];var De=Re.indexOf(":")===-1;return Ae.substring(0,2)==="//"?De?Ae:Re.replace(r,"$1")+Ae:Ae.charAt(0)==="/"?De?Ae:Re.replace(i,"$1")+Ae:Re+Ae}var u={exec:function(){}};function c(Re){for(var Ae=1,De,ce;Ae<arguments.length;Ae++){De=arguments[Ae];for(ce in De)Object.prototype.hasOwnProperty.call(De,ce)&&(Re[ce]=De[ce])}return Re}function d(Re,Ae){var De=Re.replace(/\|/g,function(we,ye,Oe){for(var Ke=!1,We=ye;--We>=0&&Oe[We]==="\\";)Ke=!Ke;return Ke?"|":" |"}),ce=De.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce[ce.length-1].trim()||ce.pop(),ce.length>Ae)ce.splice(Ae);else for(;ce.length<Ae;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function h(Re,Ae,De){var ce=Re.length;if(ce===0)return"";for(var de=0;de<ce;){var we=Re.charAt(ce-de-1);if(we===Ae&&!De)de++;else if(we!==Ae&&De)de++;else break}return Re.substr(0,ce-de)}function v(Re,Ae){if(Re.indexOf(Ae[1])===-1)return-1;for(var De=Re.length,ce=0,de=0;de<De;de++)if(Re[de]==="\\")de++;else if(Re[de]===Ae[0])ce++;else if(Re[de]===Ae[1]&&(ce--,ce<0))return de;return-1}function w(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Re,Ae){if(Ae<1)return"";for(var De="";Ae>1;)Ae&1&&(De+=Re),Ae>>=1,Re+=Re;return De+Re}var O={escape:p,unescape:E,edit:C,cleanUrl:m,resolveUrl:n,noopTest:u,merge:c,splitCells:d,rtrim:h,findClosingBracket:v,checkSanitizeDeprecation:w,repeatString:A},N=D.exports.defaults,F=O.rtrim,M=O.splitCells,V=O.escape,$=O.findClosingBracket;function U(Re,Ae,De,ce){var de=Ae.href,we=Ae.title?V(Ae.title):null,ye=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){ce.state.inLink=!0;var Oe={type:"link",raw:De,href:de,title:we,text:ye,tokens:ce.inlineTokens(ye,[])};return ce.state.inLink=!1,Oe}else return{type:"image",raw:De,href:de,title:we,text:V(ye)}}function B(Re,Ae){var De=Re.match(/^(\s+)(?:```)/);if(De===null)return Ae;var ce=De[1];return Ae.split(`
`).map(function(de){var we=de.match(/^\s+/);if(we===null)return de;var ye=we[0];return ye.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var W=function(){function Re(De){this.options=De||N}var Ae=Re.prototype;return Ae.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Ae.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var we=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},Ae.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var we=de[0],ye=B(we,de[3]||"");return{type:"code",raw:we,lang:de[2]?de[2].trim():de[2],text:ye}}},Ae.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var we=de[2].trim();if(/#$/.test(we)){var ye=F(we,"#");(this.options.pedantic||!ye||/ $/.test(ye))&&(we=ye.trim())}var Oe={type:"heading",raw:de[0],depth:de[1].length,text:we,tokens:[]};return this.lexer.inline(Oe.text,Oe.tokens),Oe}},Ae.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},Ae.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var we=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},Ae.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var we,ye,Oe,Ke,We,Ze,lt,ct,$e,Ee,_e=de[1].trim(),he=_e.length>1,Y={type:"list",raw:"",ordered:he,start:he?+_e.slice(0,-1):"",loose:!1,items:[]};_e=he?"\\d{1,9}\\"+_e.slice(-1):"\\"+_e,this.options.pedantic&&(_e=he?_e:"[*+-]");for(var ke=new RegExp("^( {0,3}"+_e+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ce&&!(this.rules.block.hr.test(ce)||!(de=ke.exec(ce)));){$e=de[2].split(`
`),this.options.pedantic?(Ke=2,Ee=$e[0].trimLeft()):(Ke=de[2].search(/[^ ]/),Ke=de[1].length+(Ke>4?1:Ke),Ee=$e[0].slice(Ke-de[1].length)),Ze=!1,we=de[0],!$e[0]&&/^ *$/.test($e[1])&&(we=de[1]+$e.slice(0,2).join(`
`)+`
`,Y.loose=!0,$e=[]);var Ne=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(We=1;We<$e.length;We++){if(ct=$e[We],this.options.pedantic&&(ct=ct.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ne.test(ct)){we=de[1]+$e.slice(0,We).join(`
`)+`
`;break}if(!Ze){ct.trim()||(Ze=!0),ct.search(/[^ ]/)>=Ke?Ee+=`
`+ct.slice(Ke):Ee+=`
`+ct;continue}if(ct.search(/[^ ]/)>=Ke||!ct.trim()){Ee+=`
`+ct.slice(Ke);continue}else{we=de[1]+$e.slice(0,We).join(`
`)+`
`;break}}Y.loose||(lt?Y.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(ye=/^\[[ xX]\] /.exec(Ee),ye&&(Oe=ye[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Y.items.push({type:"list_item",raw:we,task:!!ye,checked:Oe,loose:!1,text:Ee}),Y.raw+=we,ce=ce.slice(we.length)}Y.items[Y.items.length-1].raw=we.trimRight(),Y.items[Y.items.length-1].text=Ee.trimRight(),Y.raw=Y.raw.trimRight();var Xe=Y.items.length;for(We=0;We<Xe;We++)this.lexer.state.top=!1,Y.items[We].tokens=this.lexer.blockTokens(Y.items[We].text,[]),Y.items[We].tokens.some(function(Qe){return Qe.type==="space"})&&(Y.loose=!0,Y.items[We].loose=!0);return Y}},Ae.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var we={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},Ae.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var we=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:de[0],href:de[2],title:de[3]}}},Ae.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var we={type:"table",header:M(de[1]).map(function(lt){return{text:lt}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=de[0];var ye=we.align.length,Oe,Ke,We,Ze;for(Oe=0;Oe<ye;Oe++)/^ *-+: *$/.test(we.align[Oe])?we.align[Oe]="right":/^ *:-+: *$/.test(we.align[Oe])?we.align[Oe]="center":/^ *:-+ *$/.test(we.align[Oe])?we.align[Oe]="left":we.align[Oe]=null;for(ye=we.rows.length,Oe=0;Oe<ye;Oe++)we.rows[Oe]=M(we.rows[Oe],we.header.length).map(function(lt){return{text:lt}});for(ye=we.header.length,Ke=0;Ke<ye;Ke++)we.header[Ke].tokens=[],this.lexer.inlineTokens(we.header[Ke].text,we.header[Ke].tokens);for(ye=we.rows.length,Ke=0;Ke<ye;Ke++)for(Ze=we.rows[Ke],We=0;We<Ze.length;We++)Ze[We].tokens=[],this.lexer.inlineTokens(Ze[We].text,Ze[We].tokens);return we}}},Ae.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de){var we={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var we={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.text=function(ce){var de=this.rules.block.text.exec(ce);if(de){var we={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},Ae.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:V(de[1])}},Ae.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):V(de[0]):de[0]}},Ae.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var we=de[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ye=F(we.slice(0,-1),"\\");if((we.length-ye.length)%2==0)return}else{var Oe=$(de[2],"()");if(Oe>-1){var Ke=de[0].indexOf("!")===0?5:4,We=Ke+de[1].length+Oe;de[2]=de[2].substring(0,Oe),de[0]=de[0].substring(0,We).trim(),de[3]=""}}var Ze=de[2],lt="";if(this.options.pedantic){var ct=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ze);ct&&(Ze=ct[1],lt=ct[3])}else lt=de[3]?de[3].slice(1,-1):"";return Ze=Ze.trim(),/^</.test(Ze)&&(this.options.pedantic&&!/>$/.test(we)?Ze=Ze.slice(1):Ze=Ze.slice(1,-1)),U(de,{href:Ze&&Ze.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Ae.reflink=function(ce,de){var we;if((we=this.rules.inline.reflink.exec(ce))||(we=this.rules.inline.nolink.exec(ce))){var ye=(we[2]||we[1]).replace(/\s+/g," ");if(ye=de[ye.toLowerCase()],!ye||!ye.href){var Oe=we[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return U(we,ye,we[0],this.lexer)}},Ae.emStrong=function(ce,de,we){we===void 0&&(we="");var ye=this.rules.inline.emStrong.lDelim.exec(ce);if(!!ye&&!(ye[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=ye[1]||ye[2]||"";if(!Oe||Oe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ke=ye[0].length-1,We,Ze,lt=Ke,ct=0,$e=ye[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,de=de.slice(-1*ce.length+Ke);(ye=$e.exec(de))!=null;)if(We=ye[1]||ye[2]||ye[3]||ye[4]||ye[5]||ye[6],!!We){if(Ze=We.length,ye[3]||ye[4]){lt+=Ze;continue}else if((ye[5]||ye[6])&&Ke%3&&!((Ke+Ze)%3)){ct+=Ze;continue}if(lt-=Ze,!(lt>0)){if(Ze=Math.min(Ze,Ze+lt+ct),Math.min(Ke,Ze)%2){var Ee=ce.slice(1,Ke+ye.index+Ze);return{type:"em",raw:ce.slice(0,Ke+ye.index+Ze+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var _e=ce.slice(2,Ke+ye.index+Ze-1);return{type:"strong",raw:ce.slice(0,Ke+ye.index+Ze+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}}}}},Ae.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var we=de[2].replace(/\n/g," "),ye=/[^ ]/.test(we),Oe=/^ /.test(we)&&/ $/.test(we);return ye&&Oe&&(we=we.substring(1,we.length-1)),we=V(we,!0),{type:"codespan",raw:de[0],text:we}}},Ae.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},Ae.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Ae.autolink=function(ce,de){var we=this.rules.inline.autolink.exec(ce);if(we){var ye,Oe;return we[2]==="@"?(ye=V(this.options.mangle?de(we[1]):we[1]),Oe="mailto:"+ye):(ye=V(we[1]),Oe=ye),{type:"link",raw:we[0],text:ye,href:Oe,tokens:[{type:"text",raw:ye,text:ye}]}}},Ae.url=function(ce,de){var we;if(we=this.rules.inline.url.exec(ce)){var ye,Oe;if(we[2]==="@")ye=V(this.options.mangle?de(we[0]):we[0]),Oe="mailto:"+ye;else{var Ke;do Ke=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ke!==we[0]);ye=V(we[0]),we[1]==="www."?Oe="http://"+ye:Oe=ye}return{type:"link",raw:we[0],text:ye,href:Oe,tokens:[{type:"text",raw:ye,text:ye}]}}},Ae.inlineText=function(ce,de){var we=this.rules.inline.text.exec(ce);if(we){var ye;return this.lexer.state.inRawBlock?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):V(we[0]):we[0]:ye=V(this.options.smartypants?de(we[0]):we[0]),{type:"text",raw:we[0],text:ye}}},Re}(),H=O.noopTest,x=O.edit,J=O.merge,ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=x(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=x(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=x(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=x(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=x(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=x(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=J({},ne),ne.gfm=J({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=x(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=J({},ne.normal,{html:x(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:x(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=x(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=x(ne._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=x(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=x(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=x(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=x(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=x(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=x(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=x(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=x(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=J({},se),se.pedantic=J({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:x(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:x(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=J({},se.normal,{escape:x(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=x(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=J({},se.gfm,{br:x(se.br).replace("{2,}","*").getRegex(),text:x(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var K={block:ne,inline:se},Q=W,ae=D.exports.defaults,fe=K.block,be=K.inline,Me=O.repeatString;function ze(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ge(Re){var Ae="",De,ce,de=Re.length;for(De=0;De<de;De++)ce=Re.charCodeAt(De),Math.random()>.5&&(ce="x"+ce.toString(16)),Ae+="&#"+ce+";";return Ae}var Je=function(){function Re(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ae,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:fe.normal,inline:be.normal};this.options.pedantic?(ce.block=fe.pedantic,ce.inline=be.pedantic):this.options.gfm&&(ce.block=fe.gfm,this.options.breaks?ce.inline=be.breaks:ce.inline=be.gfm),this.tokenizer.rules=ce}Re.lex=function(ce,de){var we=new Re(de);return we.lex(ce)},Re.lexInline=function(ce,de){var we=new Re(de);return we.inlineTokens(ce)};var Ae=Re.prototype;return Ae.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Ae.blockTokens=function(ce,de){var we=this;de===void 0&&(de=[]),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var ye,Oe,Ke,We;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(ye=lt.call({lexer:we},ce,de))?(ce=ce.substring(ye.raw.length),de.push(ye),!0):!1}))){if(ye=this.tokenizer.space(ce)){ce=ce.substring(ye.raw.length),ye.type&&de.push(ye);continue}if(ye=this.tokenizer.code(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye);continue}if(ye=this.tokenizer.fences(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.heading(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.hr(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.blockquote(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.list(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.html(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.def(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[ye.tag]||(this.tokens.links[ye.tag]={href:ye.href,title:ye.title});continue}if(ye=this.tokenizer.table(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.lheading(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=1/0,ct=ce.slice(1),$e=void 0;we.options.extensions.startBlock.forEach(function(Ee){$e=Ee.call({lexer:this},ct),typeof $e=="number"&&$e>=0&&(lt=Math.min(lt,$e))}),lt<1/0&&lt>=0&&(Ke=ce.substring(0,lt+1))}(),this.state.top&&(ye=this.tokenizer.paragraph(Ke))){Oe=de[de.length-1],We&&Oe.type==="paragraph"?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye),We=Ke.length!==ce.length,ce=ce.substring(ye.raw.length);continue}if(ye=this.tokenizer.text(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+ye.raw,Oe.text+=`
`+ye.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):de.push(ye);continue}if(ce){var Ze="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ze);break}else throw new Error(Ze)}}return this.state.top=!0,de},Ae.inline=function(ce,de){this.inlineQueue.push({src:ce,tokens:de})},Ae.inlineTokens=function(ce,de){var we=this;de===void 0&&(de=[]);var ye,Oe,Ke,We=ce,Ze,lt,ct;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Ze=this.tokenizer.rules.inline.reflinkSearch.exec(We))!=null;)$e.includes(Ze[0].slice(Ze[0].lastIndexOf("[")+1,-1))&&(We=We.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ze=this.tokenizer.rules.inline.blockSkip.exec(We))!=null;)We=We.slice(0,Ze.index)+"["+Me("a",Ze[0].length-2)+"]"+We.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ze=this.tokenizer.rules.inline.escapedEmSt.exec(We))!=null;)We=We.slice(0,Ze.index)+"++"+We.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(lt||(ct=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_e){return(ye=_e.call({lexer:we},ce,de))?(ce=ce.substring(ye.raw.length),de.push(ye),!0):!1}))){if(ye=this.tokenizer.escape(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.tag(ce)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&ye.type==="text"&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ye=this.tokenizer.link(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(ye.raw.length),Oe=de[de.length-1],Oe&&ye.type==="text"&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ye=this.tokenizer.emStrong(ce,We,ct)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.codespan(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.br(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.del(ce)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(ye=this.tokenizer.autolink(ce,Ge)){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(!this.state.inLink&&(ye=this.tokenizer.url(ce,Ge))){ce=ce.substring(ye.raw.length),de.push(ye);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var _e=1/0,he=ce.slice(1),Y=void 0;we.options.extensions.startInline.forEach(function(ke){Y=ke.call({lexer:this},he),typeof Y=="number"&&Y>=0&&(_e=Math.min(_e,Y))}),_e<1/0&&_e>=0&&(Ke=ce.substring(0,_e+1))}(),ye=this.tokenizer.inlineText(Ke,ze)){ce=ce.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(ct=ye.raw.slice(-1)),lt=!0,Oe=de[de.length-1],Oe&&Oe.type==="text"?(Oe.raw+=ye.raw,Oe.text+=ye.text):de.push(ye);continue}if(ce){var Ee="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return de},e(Re,null,[{key:"rules",get:function(){return{block:fe,inline:be}}}]),Re}(),q=D.exports.defaults,te=O.cleanUrl,G=O.escape,X=function(){function Re(De){this.options=De||q}var Ae=Re.prototype;return Ae.code=function(ce,de,we){var ye=(de||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(ce,ye);Oe!=null&&Oe!==ce&&(we=!0,ce=Oe)}return ce=ce.replace(/\n$/,"")+`
`,ye?'<pre><code class="'+this.options.langPrefix+G(ye,!0)+'">'+(we?ce:G(ce,!0))+`</code></pre>
`:"<pre><code>"+(we?ce:G(ce,!0))+`</code></pre>
`},Ae.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},Ae.html=function(ce){return ce},Ae.heading=function(ce,de,we,ye){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+ye.slug(we)+'">'+ce+"</h"+de+`>
`:"<h"+de+">"+ce+"</h"+de+`>
`},Ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ae.list=function(ce,de,we){var ye=de?"ol":"ul",Oe=de&&we!==1?' start="'+we+'"':"";return"<"+ye+Oe+`>
`+ce+"</"+ye+`>
`},Ae.listitem=function(ce){return"<li>"+ce+`</li>
`},Ae.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ae.paragraph=function(ce){return"<p>"+ce+`</p>
`},Ae.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},Ae.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},Ae.tablecell=function(ce,de){var we=de.header?"th":"td",ye=de.align?"<"+we+' align="'+de.align+'">':"<"+we+">";return ye+ce+"</"+we+`>
`},Ae.strong=function(ce){return"<strong>"+ce+"</strong>"},Ae.em=function(ce){return"<em>"+ce+"</em>"},Ae.codespan=function(ce){return"<code>"+ce+"</code>"},Ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ae.del=function(ce){return"<del>"+ce+"</del>"},Ae.link=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var ye='<a href="'+G(ce)+'"';return de&&(ye+=' title="'+de+'"'),ye+=">"+we+"</a>",ye},Ae.image=function(ce,de,we){if(ce=te(this.options.sanitize,this.options.baseUrl,ce),ce===null)return we;var ye='<img src="'+ce+'" alt="'+we+'"';return de&&(ye+=' title="'+de+'"'),ye+=this.options.xhtml?"/>":">",ye},Ae.text=function(ce){return ce},Re}(),oe=function(){function Re(){}var Ae=Re.prototype;return Ae.strong=function(ce){return ce},Ae.em=function(ce){return ce},Ae.codespan=function(ce){return ce},Ae.del=function(ce){return ce},Ae.html=function(ce){return ce},Ae.text=function(ce){return ce},Ae.link=function(ce,de,we){return""+we},Ae.image=function(ce,de,we){return""+we},Ae.br=function(){return""},Re}(),me=function(){function Re(){this.seen={}}var Ae=Re.prototype;return Ae.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ae.getNextSafeSlug=function(ce,de){var we=ce,ye=0;if(this.seen.hasOwnProperty(we)){ye=this.seen[ce];do ye++,we=ce+"-"+ye;while(this.seen.hasOwnProperty(we))}return de||(this.seen[ce]=ye,this.seen[we]=0),we},Ae.slug=function(ce,de){de===void 0&&(de={});var we=this.serialize(ce);return this.getNextSafeSlug(we,de.dryrun)},Re}(),Ie=X,xe=oe,Ye=me,it=D.exports.defaults,st=O.unescape,ot=function(){function Re(De){this.options=De||it,this.options.renderer=this.options.renderer||new Ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new xe,this.slugger=new Ye}Re.parse=function(ce,de){var we=new Re(de);return we.parse(ce)},Re.parseInline=function(ce,de){var we=new Re(de);return we.parseInline(ce)};var Ae=Re.prototype;return Ae.parse=function(ce,de){de===void 0&&(de=!0);var we="",ye,Oe,Ke,We,Ze,lt,ct,$e,Ee,_e,he,Y,ke,Ne,Xe,Qe,pt,St,Ct,ft=ce.length;for(ye=0;ye<ft;ye++){if(_e=ce[ye],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_e.type]&&(Ct=this.options.extensions.renderers[_e.type].call({parser:this},_e),Ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_e.type))){we+=Ct||"";continue}switch(_e.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(_e.tokens),_e.depth,st(this.parseInline(_e.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(_e.text,_e.lang,_e.escaped);continue}case"table":{for($e="",ct="",We=_e.header.length,Oe=0;Oe<We;Oe++)ct+=this.renderer.tablecell(this.parseInline(_e.header[Oe].tokens),{header:!0,align:_e.align[Oe]});for($e+=this.renderer.tablerow(ct),Ee="",We=_e.rows.length,Oe=0;Oe<We;Oe++){for(lt=_e.rows[Oe],ct="",Ze=lt.length,Ke=0;Ke<Ze;Ke++)ct+=this.renderer.tablecell(this.parseInline(lt[Ke].tokens),{header:!1,align:_e.align[Ke]});Ee+=this.renderer.tablerow(ct)}we+=this.renderer.table($e,Ee);continue}case"blockquote":{Ee=this.parse(_e.tokens),we+=this.renderer.blockquote(Ee);continue}case"list":{for(he=_e.ordered,Y=_e.start,ke=_e.loose,We=_e.items.length,Ee="",Oe=0;Oe<We;Oe++)Xe=_e.items[Oe],Qe=Xe.checked,pt=Xe.task,Ne="",Xe.task&&(St=this.renderer.checkbox(Qe),ke?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=St+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=St+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:St}):Ne+=St),Ne+=this.parse(Xe.tokens,ke),Ee+=this.renderer.listitem(Ne,pt,Qe);we+=this.renderer.list(Ee,he,Y);continue}case"html":{we+=this.renderer.html(_e.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(_e.tokens));continue}case"text":{for(Ee=_e.tokens?this.parseInline(_e.tokens):_e.text;ye+1<ft&&ce[ye+1].type==="text";)_e=ce[++ye],Ee+=`
`+(_e.tokens?this.parseInline(_e.tokens):_e.text);we+=de?this.renderer.paragraph(Ee):Ee;continue}default:{var wt='Token with "'+_e.type+'" type was not found.';if(this.options.silent){console.error(wt);return}else throw new Error(wt)}}}return we},Ae.parseInline=function(ce,de){de=de||this.renderer;var we="",ye,Oe,Ke,We=ce.length;for(ye=0;ye<We;ye++){if(Oe=ce[ye],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(Ke=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){we+=Ke||"";continue}switch(Oe.type){case"escape":{we+=de.text(Oe.text);break}case"html":{we+=de.html(Oe.text);break}case"link":{we+=de.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,de));break}case"image":{we+=de.image(Oe.href,Oe.title,Oe.text);break}case"strong":{we+=de.strong(this.parseInline(Oe.tokens,de));break}case"em":{we+=de.em(this.parseInline(Oe.tokens,de));break}case"codespan":{we+=de.codespan(Oe.text);break}case"br":{we+=de.br();break}case"del":{we+=de.del(this.parseInline(Oe.tokens,de));break}case"text":{we+=de.text(Oe.text);break}default:{var Ze='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}}return we},Re}(),tt=Je,rt=ot,gt=W,Ue=X,It=oe,ee=me,ie=O.merge,Se=O.checkSanitizeDeprecation,re=O.escape,Ce=D.exports.getDefaults,Fe=D.exports.changeDefaults,qe=D.exports.defaults;function Ve(Re,Ae,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ae=="function"&&(De=Ae,Ae=null),Ae=ie({},Ve.defaults,Ae||{}),Se(Ae),De){var ce=Ae.highlight,de;try{de=tt.lex(Re,Ae)}catch(Ke){return De(Ke)}var we=function(We){var Ze;if(!We)try{Ae.walkTokens&&Ve.walkTokens(de,Ae.walkTokens),Ze=rt.parse(de,Ae)}catch(lt){We=lt}return Ae.highlight=ce,We?De(We):De(null,Ze)};if(!ce||ce.length<3||(delete Ae.highlight,!de.length))return we();var ye=0;Ve.walkTokens(de,function(Ke){Ke.type==="code"&&(ye++,setTimeout(function(){ce(Ke.text,Ke.lang,function(We,Ze){if(We)return we(We);Ze!=null&&Ze!==Ke.text&&(Ke.text=Ze,Ke.escaped=!0),ye--,ye===0&&we()})},0))}),ye===0&&we();return}try{var Oe=tt.lex(Re,Ae);return Ae.walkTokens&&Ve.walkTokens(Oe,Ae.walkTokens),rt.parse(Oe,Ae)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(Ke.message+"",!0)+"</pre>";throw Ke}}Ve.options=Ve.setOptions=function(Re){return ie(Ve.defaults,Re),Fe(Ve.defaults),Ve},Ve.getDefaults=Ce,Ve.defaults=qe,Ve.use=function(){for(var Re=this,Ae=arguments.length,De=new Array(Ae),ce=0;ce<Ae;ce++)De[ce]=arguments[ce];var de=ie.apply(void 0,[{}].concat(De)),we=Ve.defaults.extensions||{renderers:{},childTokens:{}},ye;De.forEach(function(Oe){if(Oe.extensions&&(ye=!0,Oe.extensions.forEach(function(We){if(!We.name)throw new Error("extension name required");if(We.renderer){var Ze=we.renderers?we.renderers[We.name]:null;Ze?we.renderers[We.name]=function(){for(var lt=arguments.length,ct=new Array(lt),$e=0;$e<lt;$e++)ct[$e]=arguments[$e];var Ee=We.renderer.apply(this,ct);return Ee===!1&&(Ee=Ze.apply(this,ct)),Ee}:we.renderers[We.name]=We.renderer}if(We.tokenizer){if(!We.level||We.level!=="block"&&We.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[We.level]?we[We.level].unshift(We.tokenizer):we[We.level]=[We.tokenizer],We.start&&(We.level==="block"?we.startBlock?we.startBlock.push(We.start):we.startBlock=[We.start]:We.level==="inline"&&(we.startInline?we.startInline.push(We.start):we.startInline=[We.start]))}We.childTokens&&(we.childTokens[We.name]=We.childTokens)})),Oe.renderer&&function(){var We=Ve.defaults.renderer||new Ue,Ze=function($e){var Ee=We[$e];We[$e]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var ke=Oe.renderer[$e].apply(We,he);return ke===!1&&(ke=Ee.apply(We,he)),ke}};for(var lt in Oe.renderer)Ze(lt);de.renderer=We}(),Oe.tokenizer&&function(){var We=Ve.defaults.tokenizer||new gt,Ze=function($e){var Ee=We[$e];We[$e]=function(){for(var _e=arguments.length,he=new Array(_e),Y=0;Y<_e;Y++)he[Y]=arguments[Y];var ke=Oe.tokenizer[$e].apply(We,he);return ke===!1&&(ke=Ee.apply(We,he)),ke}};for(var lt in Oe.tokenizer)Ze(lt);de.tokenizer=We}(),Oe.walkTokens){var Ke=Ve.defaults.walkTokens;de.walkTokens=function(We){Oe.walkTokens.call(Re,We),Ke&&Ke(We)}}ye&&(de.extensions=we),Ve.setOptions(de)})},Ve.walkTokens=function(Re,Ae){for(var De=function(){var ye=de.value;switch(Ae(ye),ye.type){case"table":{for(var Oe=k(ye.header),Ke;!(Ke=Oe()).done;){var We=Ke.value;Ve.walkTokens(We.tokens,Ae)}for(var Ze=k(ye.rows),lt;!(lt=Ze()).done;)for(var ct=lt.value,$e=k(ct),Ee;!(Ee=$e()).done;){var _e=Ee.value;Ve.walkTokens(_e.tokens,Ae)}break}case"list":{Ve.walkTokens(ye.items,Ae);break}default:Ve.defaults.extensions&&Ve.defaults.extensions.childTokens&&Ve.defaults.extensions.childTokens[ye.type]?Ve.defaults.extensions.childTokens[ye.type].forEach(function(he){Ve.walkTokens(ye[he],Ae)}):ye.tokens&&Ve.walkTokens(ye.tokens,Ae)}},ce=k(Re),de;!(de=ce()).done;)De()},Ve.parseInline=function(Re,Ae){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ae=ie({},Ve.defaults,Ae||{}),Se(Ae);try{var De=tt.lexInline(Re,Ae);return Ae.walkTokens&&Ve.walkTokens(De,Ae.walkTokens),rt.parseInline(De,Ae)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Ae.silent)return"<p>An error occurred:</p><pre>"+re(ce.message+"",!0)+"</pre>";throw ce}},Ve.Parser=rt,Ve.parser=rt.parse,Ve.Renderer=Ue,Ve.TextRenderer=It,Ve.Lexer=tt,Ve.lexer=tt.lex,Ve.Tokenizer=gt,Ve.Slugger=ee,Ve.parse=Ve;var ut=Ve;return ut}),define(pe[94],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(I,_,P){return Math.min(Math.max(I,_),P)}e.clamp=f;function t(I,_){return(_+I%_)%_}e.rot=t;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class D{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=D;class T{constructor(_){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(_),this._values.fill(0,0,_)}update(_){const P=this._values[this._index];return this._values[this._index]=_,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=_,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function Z(k){const D=[];typeof k=="number"&&D.push("code/timeOrigin",k);function T(_){D.push(_,Date.now())}function I(){const _=[];for(let P=0;P<D.length;P+=2)_.push({name:D[P],startTime:D[P+1]});return _}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(k+T.startTime)});return D}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function f(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=f(t))}(),define(pe[12],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let t=!1,k=!1,D=!1,T=!1,I=!1,_=!1,P=!1,R=!1,y,l=f,b,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const E=typeof g?.versions?.electron=="string",L=E&&g?.type==="renderer";if(e.isElectronSandboxed=L&&g?.sandboxed,typeof navigator=="object"&&!L)p=navigator.userAgent,t=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,R=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=p.indexOf("Linux")>=0,_=!0,y=navigator.language,l=y;else if(typeof g=="object"){t=g.platform==="win32",k=g.platform==="darwin",D=g.platform==="linux",T=D&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,P=E,y=f,l=f;const n=g.env.VSCODE_NLS_CONFIG;if(n)try{const u=JSON.parse(n),c=u.availableLanguages["*"];y=u.locale,l=c||f,b=u._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var C;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function a(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let s=0;k?s=1:t?s=3:D&&(s=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=D,e.isLinuxSnap=T,e.isNative=I,e.isElectron=P,e.isWeb=_,e.isIOS=R,e.platform=s,e.userAgent=p,e.language=l;var m;(function(n){function u(){return e.language}n.value=u;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=c;function d(){return e.language==="en"}n.isDefault=d})(m=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=b,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let d=0,h=n.length;d<h;d++){const v=n[d];if(v.id===c.data.vscodeScheduleAsyncWork){n.splice(d,1),v.callback();return}}});let u=0;return c=>{const d=++u;n.push({id:d,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return n=>setTimeout(n)})();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||R?2:t?1:3;let S=!0,r=!1;function i(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,S=new Uint16Array(n.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=i}),define(pe[40],ve([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const k=f.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(pe[9],ve([0,1,40]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,D=90,T=122,I=46,_=47,P=92,R=58,y=63;class l extends Error{constructor(s,m,o){let S;typeof m=="string"&&m.indexOf("not ")===0?(S="must not be",m=m.replace(/^not /,"")):S="must be";const r=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${r} ${S} of type ${m}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function b(a,s){if(typeof a!="string")throw new l(s,"string",a)}function p(a){return a===_||a===P}function g(a){return a===_}function E(a){return a>=t&&a<=D||a>=k&&a<=T}function L(a,s,m,o){let S="",r=0,i=-1,n=0,u=0;for(let c=0;c<=a.length;++c){if(c<a.length)u=a.charCodeAt(c);else{if(o(u))break;u=_}if(o(u)){if(!(i===c-1||n===1))if(n===2){if(S.length<2||r!==2||S.charCodeAt(S.length-1)!==I||S.charCodeAt(S.length-2)!==I){if(S.length>2){const d=S.lastIndexOf(m);d===-1?(S="",r=0):(S=S.slice(0,d),r=S.length-1-S.lastIndexOf(m)),i=c,n=0;continue}else if(S.length!==0){S="",r=0,i=c,n=0;continue}}s&&(S+=S.length>0?`${m}..`:"..",r=2)}else S.length>0?S+=`${m}${a.slice(i+1,c)}`:S=a.slice(i+1,c),r=c-i-1;i=c,n=0}else u===I&&n!==-1?++n:n=-1}return S}function C(a,s){if(s===null||typeof s!="object")throw new l("pathObject","Object",s);const m=s.dir||s.root,o=s.base||`${s.name||""}${s.ext||""}`;return m?m===s.root?`${m}${o}`:`${m}${a}${o}`:o}e.win32={resolve(...a){let s="",m="",o=!1;for(let S=a.length-1;S>=-1;S--){let r;if(S>=0){if(r=a[S],b(r,"path"),r.length===0)continue}else s.length===0?r=f.cwd():(r=f.env[`=${s}`]||f.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==s.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${s}\\`));const i=r.length;let n=0,u="",c=!1;const d=r.charCodeAt(0);if(i===1)p(d)&&(n=1,c=!0);else if(p(d))if(c=!0,p(r.charCodeAt(1))){let h=2,v=h;for(;h<i&&!p(r.charCodeAt(h));)h++;if(h<i&&h!==v){const w=r.slice(v,h);for(v=h;h<i&&p(r.charCodeAt(h));)h++;if(h<i&&h!==v){for(v=h;h<i&&!p(r.charCodeAt(h));)h++;(h===i||h!==v)&&(u=`\\\\${w}\\${r.slice(v,h)}`,n=h)}}}else n=1;else E(d)&&r.charCodeAt(1)===R&&(u=r.slice(0,2),n=2,i>2&&p(r.charCodeAt(2))&&(c=!0,n=3));if(u.length>0)if(s.length>0){if(u.toLowerCase()!==s.toLowerCase())continue}else s=u;if(o){if(s.length>0)break}else if(m=`${r.slice(n)}\\${m}`,o=c,c&&s.length>0)break}return m=L(m,!o,"\\",p),o?`${s}\\${m}`:`${s}${m}`||"."},normalize(a){b(a,"path");const s=a.length;if(s===0)return".";let m=0,o,S=!1;const r=a.charCodeAt(0);if(s===1)return g(r)?"\\":a;if(p(r))if(S=!0,p(a.charCodeAt(1))){let n=2,u=n;for(;n<s&&!p(a.charCodeAt(n));)n++;if(n<s&&n!==u){const c=a.slice(u,n);for(u=n;n<s&&p(a.charCodeAt(n));)n++;if(n<s&&n!==u){for(u=n;n<s&&!p(a.charCodeAt(n));)n++;if(n===s)return`\\\\${c}\\${a.slice(u)}\\`;n!==u&&(o=`\\\\${c}\\${a.slice(u,n)}`,m=n)}}}else m=1;else E(r)&&a.charCodeAt(1)===R&&(o=a.slice(0,2),m=2,s>2&&p(a.charCodeAt(2))&&(S=!0,m=3));let i=m<s?L(a.slice(m),!S,"\\",p):"";return i.length===0&&!S&&(i="."),i.length>0&&p(a.charCodeAt(s-1))&&(i+="\\"),o===void 0?S?`\\${i}`:i:S?`${o}\\${i}`:`${o}${i}`},isAbsolute(a){b(a,"path");const s=a.length;if(s===0)return!1;const m=a.charCodeAt(0);return p(m)||s>2&&E(m)&&a.charCodeAt(1)===R&&p(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let s,m;for(let r=0;r<a.length;++r){const i=a[r];b(i,"path"),i.length>0&&(s===void 0?s=m=i:s+=`\\${i}`)}if(s===void 0)return".";let o=!0,S=0;if(typeof m=="string"&&p(m.charCodeAt(0))){++S;const r=m.length;r>1&&p(m.charCodeAt(1))&&(++S,r>2&&(p(m.charCodeAt(2))?++S:o=!1))}if(o){for(;S<s.length&&p(s.charCodeAt(S));)S++;S>=2&&(s=`\\${s.slice(S)}`)}return e.win32.normalize(s)},relative(a,s){if(b(a,"from"),b(s,"to"),a===s)return"";const m=e.win32.resolve(a),o=e.win32.resolve(s);if(m===o||(a=m.toLowerCase(),s=o.toLowerCase(),a===s))return"";let S=0;for(;S<a.length&&a.charCodeAt(S)===P;)S++;let r=a.length;for(;r-1>S&&a.charCodeAt(r-1)===P;)r--;const i=r-S;let n=0;for(;n<s.length&&s.charCodeAt(n)===P;)n++;let u=s.length;for(;u-1>n&&s.charCodeAt(u-1)===P;)u--;const c=u-n,d=i<c?i:c;let h=-1,v=0;for(;v<d;v++){const A=a.charCodeAt(S+v);if(A!==s.charCodeAt(n+v))break;A===P&&(h=v)}if(v!==d){if(h===-1)return o}else{if(c>d){if(s.charCodeAt(n+v)===P)return o.slice(n+v+1);if(v===2)return o.slice(n+v)}i>d&&(a.charCodeAt(S+v)===P?h=v:v===2&&(h=3)),h===-1&&(h=0)}let w="";for(v=S+h+1;v<=r;++v)(v===r||a.charCodeAt(v)===P)&&(w+=w.length===0?"..":"\\..");return n+=h,w.length>0?`${w}${o.slice(n,u)}`:(o.charCodeAt(n)===P&&++n,o.slice(n,u))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const s=e.win32.resolve(a);if(s.length<=2)return a;if(s.charCodeAt(0)===P){if(s.charCodeAt(1)===P){const m=s.charCodeAt(2);if(m!==y&&m!==I)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===R&&s.charCodeAt(2)===P)return`\\\\?\\${s}`;return a},dirname(a){b(a,"path");const s=a.length;if(s===0)return".";let m=-1,o=0;const S=a.charCodeAt(0);if(s===1)return p(S)?a:".";if(p(S)){if(m=o=1,p(a.charCodeAt(1))){let n=2,u=n;for(;n<s&&!p(a.charCodeAt(n));)n++;if(n<s&&n!==u){for(u=n;n<s&&p(a.charCodeAt(n));)n++;if(n<s&&n!==u){for(u=n;n<s&&!p(a.charCodeAt(n));)n++;if(n===s)return a;n!==u&&(m=o=n+1)}}}}else E(S)&&a.charCodeAt(1)===R&&(m=s>2&&p(a.charCodeAt(2))?3:2,o=m);let r=-1,i=!0;for(let n=s-1;n>=o;--n)if(p(a.charCodeAt(n))){if(!i){r=n;break}}else i=!1;if(r===-1){if(m===-1)return".";r=m}return a.slice(0,r)},basename(a,s){s!==void 0&&b(s,"ext"),b(a,"path");let m=0,o=-1,S=!0,r;if(a.length>=2&&E(a.charCodeAt(0))&&a.charCodeAt(1)===R&&(m=2),s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let i=s.length-1,n=-1;for(r=a.length-1;r>=m;--r){const u=a.charCodeAt(r);if(p(u)){if(!S){m=r+1;break}}else n===-1&&(S=!1,n=r+1),i>=0&&(u===s.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=n))}return m===o?o=n:o===-1&&(o=a.length),a.slice(m,o)}for(r=a.length-1;r>=m;--r)if(p(a.charCodeAt(r))){if(!S){m=r+1;break}}else o===-1&&(S=!1,o=r+1);return o===-1?"":a.slice(m,o)},extname(a){b(a,"path");let s=0,m=-1,o=0,S=-1,r=!0,i=0;a.length>=2&&a.charCodeAt(1)===R&&E(a.charCodeAt(0))&&(s=o=2);for(let n=a.length-1;n>=s;--n){const u=a.charCodeAt(n);if(p(u)){if(!r){o=n+1;break}continue}S===-1&&(r=!1,S=n+1),u===I?m===-1?m=n:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||S===-1||i===0||i===1&&m===S-1&&m===o+1?"":a.slice(m,S)},format:C.bind(null,"\\"),parse(a){b(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const m=a.length;let o=0,S=a.charCodeAt(0);if(m===1)return p(S)?(s.root=s.dir=a,s):(s.base=s.name=a,s);if(p(S)){if(o=1,p(a.charCodeAt(1))){let h=2,v=h;for(;h<m&&!p(a.charCodeAt(h));)h++;if(h<m&&h!==v){for(v=h;h<m&&p(a.charCodeAt(h));)h++;if(h<m&&h!==v){for(v=h;h<m&&!p(a.charCodeAt(h));)h++;h===m?o=h:h!==v&&(o=h+1)}}}}else if(E(S)&&a.charCodeAt(1)===R){if(m<=2)return s.root=s.dir=a,s;if(o=2,p(a.charCodeAt(2))){if(m===3)return s.root=s.dir=a,s;o=3}}o>0&&(s.root=a.slice(0,o));let r=-1,i=o,n=-1,u=!0,c=a.length-1,d=0;for(;c>=o;--c){if(S=a.charCodeAt(c),p(S)){if(!u){i=c+1;break}continue}n===-1&&(u=!1,n=c+1),S===I?r===-1?r=c:d!==1&&(d=1):r!==-1&&(d=-1)}return n!==-1&&(r===-1||d===0||d===1&&r===n-1&&r===i+1?s.base=s.name=a.slice(i,n):(s.name=a.slice(i,r),s.base=a.slice(i,n),s.ext=a.slice(r,n))),i>0&&i!==o?s.dir=a.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let s="",m=!1;for(let o=a.length-1;o>=-1&&!m;o--){const S=o>=0?a[o]:f.cwd();b(S,"path"),S.length!==0&&(s=`${S}/${s}`,m=S.charCodeAt(0)===_)}return s=L(s,!m,"/",g),m?`/${s}`:s.length>0?s:"."},normalize(a){if(b(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===_,m=a.charCodeAt(a.length-1)===_;return a=L(a,!s,"/",g),a.length===0?s?"/":m?"./":".":(m&&(a+="/"),s?`/${a}`:a)},isAbsolute(a){return b(a,"path"),a.length>0&&a.charCodeAt(0)===_},join(...a){if(a.length===0)return".";let s;for(let m=0;m<a.length;++m){const o=a[m];b(o,"path"),o.length>0&&(s===void 0?s=o:s+=`/${o}`)}return s===void 0?".":e.posix.normalize(s)},relative(a,s){if(b(a,"from"),b(s,"to"),a===s||(a=e.posix.resolve(a),s=e.posix.resolve(s),a===s))return"";const m=1,o=a.length,S=o-m,r=1,i=s.length-r,n=S<i?S:i;let u=-1,c=0;for(;c<n;c++){const h=a.charCodeAt(m+c);if(h!==s.charCodeAt(r+c))break;h===_&&(u=c)}if(c===n)if(i>n){if(s.charCodeAt(r+c)===_)return s.slice(r+c+1);if(c===0)return s.slice(r+c)}else S>n&&(a.charCodeAt(m+c)===_?u=c:c===0&&(u=0));let d="";for(c=m+u+1;c<=o;++c)(c===o||a.charCodeAt(c)===_)&&(d+=d.length===0?"..":"/..");return`${d}${s.slice(r+u)}`},toNamespacedPath(a){return a},dirname(a){if(b(a,"path"),a.length===0)return".";const s=a.charCodeAt(0)===_;let m=-1,o=!0;for(let S=a.length-1;S>=1;--S)if(a.charCodeAt(S)===_){if(!o){m=S;break}}else o=!1;return m===-1?s?"/":".":s&&m===1?"//":a.slice(0,m)},basename(a,s){s!==void 0&&b(s,"ext"),b(a,"path");let m=0,o=-1,S=!0,r;if(s!==void 0&&s.length>0&&s.length<=a.length){if(s===a)return"";let i=s.length-1,n=-1;for(r=a.length-1;r>=0;--r){const u=a.charCodeAt(r);if(u===_){if(!S){m=r+1;break}}else n===-1&&(S=!1,n=r+1),i>=0&&(u===s.charCodeAt(i)?--i==-1&&(o=r):(i=-1,o=n))}return m===o?o=n:o===-1&&(o=a.length),a.slice(m,o)}for(r=a.length-1;r>=0;--r)if(a.charCodeAt(r)===_){if(!S){m=r+1;break}}else o===-1&&(S=!1,o=r+1);return o===-1?"":a.slice(m,o)},extname(a){b(a,"path");let s=-1,m=0,o=-1,S=!0,r=0;for(let i=a.length-1;i>=0;--i){const n=a.charCodeAt(i);if(n===_){if(!S){m=i+1;break}continue}o===-1&&(S=!1,o=i+1),n===I?s===-1?s=i:r!==1&&(r=1):s!==-1&&(r=-1)}return s===-1||o===-1||r===0||r===1&&s===o-1&&s===m+1?"":a.slice(s,o)},format:C.bind(null,"/"),parse(a){b(a,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return s;const m=a.charCodeAt(0)===_;let o;m?(s.root="/",o=1):o=0;let S=-1,r=0,i=-1,n=!0,u=a.length-1,c=0;for(;u>=o;--u){const d=a.charCodeAt(u);if(d===_){if(!n){r=u+1;break}continue}i===-1&&(n=!1,i=u+1),d===I?S===-1?S=u:c!==1&&(c=1):S!==-1&&(c=-1)}if(i!==-1){const d=r===0&&m?1:r;S===-1||c===0||c===1&&S===i-1&&S===r+1?s.base=s.name=a.slice(d,i):(s.name=a.slice(d,S),s.base=a.slice(d,i),s.ext=a.slice(S,i))}return r>0?s.dir=a.slice(0,r-1):m&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[95],ve([0,1,9]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(y){y.text="text/plain",y.binary="application/octet-stream",y.unknown="application/unknown",y.markdown="text/markdown",y.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(y){const l=(0,f.extname)(y),b=k[l.toLowerCase()];return b!==void 0?b:I(y)}e.getMediaOrTextMime=T;function I(y){const l=(0,f.extname)(y);return D[l.toLowerCase()]}e.getMediaMime=I;function _(y){for(const l in D)if(D[l]===y)return l}e.getExtensionForMimeType=_;const P=/^(.+)\/(.+?)(;.+)?$/;function R(y,l){const b=P.exec(y);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:l?void 0:y}e.normalizeMimeType=R}),define(pe[96],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var t;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(D,...T){const I=T.reduce((R,y)=>(R[y]=!0,R),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(R=>!I[R]).forEach(R=>{for(let y=0;y<_.length;y++)if(R.search(_[y])!==-1){delete D[R];break}})}e.sanitizeProcessEnvironment=k}),define(pe[46],ve([0,1,12]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=f.globals.performance&&typeof f.globals.performance.now=="function";class k{constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=k}),define(pe[3],ve([0,1,16,76,6,93,46]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(s){s.None=()=>k.Disposable.None;function m(B){return(W,H=null,x)=>{let J=!1,ne;return ne=B(se=>{if(!J)return ne?ne.dispose():J=!0,W.call(H,se)},null,x),J&&ne.dispose(),ne}}s.once=m;function o(B,W){return c((H,x=null,J)=>B(ne=>H.call(x,W(ne)),null,J))}s.map=o;function S(B,W){return c((H,x=null,J)=>B(ne=>{W(ne),H.call(x,ne)},null,J))}s.forEach=S;function r(B,W){return c((H,x=null,J)=>B(ne=>W(ne)&&H.call(x,ne),null,J))}s.filter=r;function i(B){return B}s.signal=i;function n(...B){return(W,H=null,x)=>(0,k.combinedDisposable)(...B.map(J=>J(ne=>W.call(H,ne),null,x)))}s.any=n;function u(B,W,H){let x=H;return o(B,J=>(x=W(x,J),x))}s.reduce=u;function c(B){let W;const H=new l({onFirstListenerAdd(){W=B(H.fire,H)},onLastListenerRemove(){W.dispose()}});return H.event}function d(B,W,H,x=100,J=!1){let ne,se,K=0;return B(Q=>{K++,ne=H(ne,Q),J&&!se&&(W(ne),ne=void 0),clearTimeout(se),se=setTimeout(()=>{const ae=ne;ne=void 0,se=void 0,(!J||K>1)&&W(ae),K=0},x)})}s.debouncedListener=d;function h(B,W,H=100,x=!1,J){let ne,se,K,Q=0;const ae=new l({leakWarningThreshold:J,onFirstListenerAdd(){ne=B(fe=>{Q++,se=W(se,fe),x&&!K&&(ae.fire(se),se=void 0),clearTimeout(K),K=setTimeout(()=>{const be=se;se=void 0,K=void 0,(!x||Q>1)&&ae.fire(be),Q=0},H)})},onLastListenerRemove(){ne.dispose()}});return ae.event}s.debounce=h;function v(B,W=(H,x)=>H===x){let H=!0,x;return r(B,J=>{const ne=H||!W(J,x);return H=!1,x=J,ne})}s.latch=v;function w(B,W){return[s.filter(B,W),s.filter(B,H=>!W(H))]}s.split=w;function A(B,W=!1,H=[]){let x=H.slice(),J=B(K=>{x?x.push(K):se.fire(K)});const ne=()=>{x&&x.forEach(K=>se.fire(K)),x=null},se=new l({onFirstListenerAdd(){J||(J=B(K=>se.fire(K)))},onFirstListenerDidAdd(){x&&(W?setTimeout(ne):ne())},onLastListenerRemove(){J&&J.dispose(),J=null}});return se.event}s.buffer=A;class O{constructor(W){this.event=W}map(W){return new O(o(this.event,W))}forEach(W){return new O(S(this.event,W))}filter(W){return new O(r(this.event,W))}reduce(W,H){return new O(u(this.event,W,H))}latch(){return new O(v(this.event))}debounce(W,H=100,x=!1,J){return new O(h(this.event,W,H,x,J))}on(W,H,x){return this.event(W,H,x)}once(W,H,x){return m(this.event)(W,H,x)}}function N(B){return new O(B)}s.chain=N;function F(B,W,H=x=>x){const x=(...K)=>se.fire(H(...K)),J=()=>B.on(W,x),ne=()=>B.removeListener(W,x),se=new l({onFirstListenerAdd:J,onLastListenerRemove:ne});return se.event}s.fromNodeEventEmitter=F;function M(B,W,H=x=>x){const x=(...K)=>se.fire(H(...K)),J=()=>B.addEventListener(W,x),ne=()=>B.removeEventListener(W,x),se=new l({onFirstListenerAdd:J,onLastListenerRemove:ne});return se.event}s.fromDOMEventEmitter=M;function V(B){return new Promise(W=>m(B)(W))}s.toPromise=V;function $(B,W){return W(void 0),B(H=>W(H))}s.runAndSubscribe=$;function U(B,W){let H=null;function x(ne){H?.dispose(),H=new k.DisposableStore,W(ne,H)}x(void 0);const J=B(ne=>x(ne));return(0,k.toDisposable)(()=>{J.dispose(),H?.dispose()})}s.runAndSubscribeWithStore=U})(I=e.Event||(e.Event={}));class _{constructor(m){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${m}_${_._idPool++}`}start(m){this._stopWatch=new T.StopWatch(!0),this._listenerCount=m}stop(){if(this._stopWatch){const m=this._stopWatch.elapsed();this._elapsedOverall+=m,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${m.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let P=-1;function R(s){const m=P;return P=s,{dispose(){P=m}}}e.setGlobalLeakWarningThreshold=R;class y{constructor(m,o=Math.random().toString(18).slice(2,5)){this.customThreshold=m,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(m){let o=P;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||m<o)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(S)||0;if(this._stacks.set(S,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,n=0;for(const[u,c]of this._stacks)(!i||n<c)&&(i=u,n=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${n}):`),console.warn(i)}return()=>{const i=this._stacks.get(S)||0;this._stacks.set(S,i-1)}}}class l{constructor(m){this._disposed=!1,this._options=m,this._leakageMon=P>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(m,o,S)=>{this._listeners||(this._listeners=new D.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[m,o]:m);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,m,o);const n=this._leakageMon?.check(this._listeners.size),u=(0,k.toDisposable)(()=>{n&&n(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof k.DisposableStore?S.add(u):Array.isArray(S)&&S.push(u),u}),this._event}fire(m){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,m]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,S]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,S):o[0].call(o[1],S)}catch(r){(0,f.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class b extends l{async fireAsync(m,o,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,m]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),n=[],u={...i,token:o,waitUntil:c=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");S&&(c=S(c,typeof r=="function"?r:r[0])),n.push(c)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(c){(0,f.onUnexpectedError)(c);continue}Object.freeze(n),await Promise.allSettled(n).then(c=>{for(const d of c)d.status==="rejected"&&(0,f.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=b;class p extends l{constructor(m){super(m);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=m?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const m=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(m))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(m){this._listeners&&(this._isPaused!==0?this._eventQueue.push(m):super.fire(m))}}e.PauseableEmitter=p;class g extends p{constructor(m){super(m);this._delay=m.delay??100}fire(m){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(m)}}e.DebounceEmitter=g;class E extends l{constructor(m){super(m);this._queuedEvents=[],this._mergeFn=m?.merge}fire(m){this._queuedEvents.push(m),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(m){const o={event:m,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const S=()=>{this.hasListeners&&this.unhook(o);const r=this.events.indexOf(o);this.events.splice(r,1)};return(0,k.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(m=>this.hook(m))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(m=>this.unhook(m))}hook(m){m.listener=m.event(o=>this.emitter.fire(o))}unhook(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=L;class C{constructor(){this.buffers=[]}wrapEvent(m){return(o,S,r)=>m(i=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>o.call(S,i)):o.call(S,i)},void 0,r)}bufferEvents(m){const o=[];this.buffers.push(o);const S=m();return this.buffers.pop(),o.forEach(r=>r()),S}}e.EventBufferer=C;class a{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(m){this.inputEvent=m,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=m(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(pe[21],ve([0,1,3]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,_){const P=setTimeout(I.bind(_),0);return{dispose(){clearTimeout(P)}}});var k;(function(I){function _(P){return P===I.None||P===I.Cancelled||P instanceof D?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}I.isCancellationToken=_,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=k.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(pe[141],ve([0,1,21]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new f.CancellationTokenSource,I=this.task(T.token);return this.result={promise:I,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;class k{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const I=JSON.stringify(T);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=k}),define(pe[97],ve([0,1,16,6]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=k;function D(a){const s=a;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(a,s){return new I(a,s)}e.newWriteableStream=T;class I{constructor(s,m){this.reducer=s,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(m=>m(s))}emitError(s){this.listeners.error.length===0?(0,f.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(m=>m(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,m){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(s,m){if(this.state.destroyed)return;let o;switch(s){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const S=o.indexOf(m);S>=0&&o.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(a,s){const m=[];let o;for(;(o=a.read())!==null;)m.push(o);return s(m)}e.consumeReadable=_;function P(a,s,m){const o=[];let S;for(;(S=a.read())!==null&&o.length<m;)o.push(S);return S===null&&o.length>0?s(o):{read:()=>{if(o.length>0)return o.shift();if(typeof S!="undefined"){const r=S;return S=void 0,r}return a.read()}}}e.peekReadable=P;function R(a,s){return new Promise((m,o)=>{const S=[];y(a,{onData:r=>{s&&S.push(r)},onError:r=>{s?o(r):m(void 0)},onEnd:()=>{m(s?s(S):void 0)}})})}e.consumeStream=R;function y(a,s){let m=!1;return a.on("error",o=>{m||s.onError(o)}),a.on("end",()=>{m||s.onEnd()}),a.on("data",o=>{m||s.onData(o)}),(0,t.toDisposable)(()=>m=!0)}e.listenStream=y;function l(a,s){return new Promise((m,o)=>{const S=new t.DisposableStore,r=[],i=c=>{if(r.push(c),r.length>s)return S.dispose(),a.pause(),m({stream:a,buffer:r,ended:!1})},n=c=>o(c),u=()=>m({stream:a,buffer:r,ended:!0});S.add((0,t.toDisposable)(()=>a.removeListener("error",n))),a.on("error",n),S.add((0,t.toDisposable)(()=>a.removeListener("end",u))),a.on("end",u),S.add((0,t.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=l;function b(a,s){const m=T(s);return m.end(a),m}e.toStream=b;function p(){const a=T(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=p;function g(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}e.toReadable=g;function E(a,s,m){const o=T(m);return y(a,{onData:S=>o.write(s.data(S)),onError:S=>o.error(s.error?s.error(S):S),onEnd:()=>o.end()}),o}e.transform=E;function L(a,s,m){let o=!1;return{read:()=>{const S=s.read();return o?S:(o=!0,S!==null?m([a,S]):a)}}}e.prefixedReadable=L;function C(a,s,m){let o=!1;const S=T(m);return y(s,{onData:r=>o?S.write(r):(o=!0,S.write(m([a,r]))),onError:r=>S.error(r),onEnd:()=>{o||(o=!0,S.write(a)),S.end()}}),S}e.prefixedStream=C}),define(pe[22],ve([0,1,97]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let k,D;class T{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,h){return!(h?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(d)):(k||(k=new TextEncoder),new T(k.encode(d)))}static fromByteArray(d){const h=T.alloc(d.length);for(let v=0,w=d.length;v<w;v++)h.buffer[v]=d[v];return h}static concat(d,h){if(typeof h=="undefined"){h=0;for(let A=0,O=d.length;A<O;A++)h+=d[A].byteLength}const v=T.alloc(h);let w=0;for(let A=0,O=d.length;A<O;A++){const N=d[A];v.set(N,w),w+=N.byteLength}return v}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(d,h){return new T(this.buffer.subarray(d,h))}set(d,h){if(d instanceof T)this.buffer.set(d.buffer,h);else if(d instanceof Uint8Array)this.buffer.set(d,h);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),h);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),h);else throw new Error("Unkown argument 'array'")}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,h){R(this.buffer,d,h)}readUInt32LE(d){return y(this.buffer,d)}writeUInt32LE(d,h){l(this.buffer,d,h)}readUInt8(d){return b(this.buffer,d)}writeUInt8(d,h){p(this.buffer,d,h)}}e.VSBuffer=T;function I(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0}e.readUInt16LE=I;function _(c,d,h){c[h+0]=d&255,d=d>>>8,c[h+1]=d&255}e.writeUInt16LE=_;function P(c,d){return c[d]*2**24+c[d+1]*2**16+c[d+2]*2**8+c[d+3]}e.readUInt32BE=P;function R(c,d,h){c[h+3]=d,d=d>>>8,c[h+2]=d,d=d>>>8,c[h+1]=d,d=d>>>8,c[h]=d}e.writeUInt32BE=R;function y(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0|c[d+2]<<16>>>0|c[d+3]<<24>>>0}e.readUInt32LE=y;function l(c,d,h){c[h+0]=d&255,d=d>>>8,c[h+1]=d&255,d=d>>>8,c[h+2]=d&255,d=d>>>8,c[h+3]=d&255}e.writeUInt32LE=l;function b(c,d){return c[d]}e.readUInt8=b;function p(c,d,h){c[h]=d}e.writeUInt8=p;function g(c){return f.consumeReadable(c,d=>T.concat(d))}e.readableToBuffer=g;function E(c){return f.toReadable(c)}e.bufferToReadable=E;function L(c){return f.consumeStream(c,d=>T.concat(d))}e.streamToBuffer=L;async function C(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await L(c.stream)])}e.bufferedStreamToBuffer=C;function a(c){return f.toStream(c,d=>T.concat(d))}e.bufferToStream=a;function s(c){return f.transform(c,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}e.streamToBufferReadableStream=s;function m(c){return f.newWriteableStream(d=>T.concat(d),c)}e.newWriteableBufferStream=m;function o(c,d){return f.prefixedReadable(c,d,h=>T.concat(h))}e.prefixedBufferReadable=o;function S(c,d){return f.prefixedStream(c,d,h=>T.concat(h))}e.prefixedBufferStream=S;function r(c){let d=0,h=0,v=0;const w=new Uint8Array(Math.floor(c.length/4*3)),A=N=>{switch(h){case 3:w[v++]=d|N,h=0;break;case 2:w[v++]=d|N>>>2,d=N<<6,h=3;break;case 1:w[v++]=d|N>>>4,d=N<<4,h=2;break;default:d=N<<2,h=1}};for(let N=0;N<c.length;N++){const F=c.charCodeAt(N);if(F>=65&&F<=90)A(F-65);else if(F>=97&&F<=122)A(F-97+26);else if(F>=48&&F<=57)A(F-48+52);else if(F===43||F===45)A(62);else if(F===47||F===95)A(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${c[N]}`)}}const O=v;for(;h>0;)A(0);return T.wrap(w).slice(0,O)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:c},d=!0,h=!1){const v=h?n:i;let w="";const A=c.byteLength%3;let O=0;for(;O<c.byteLength-A;O+=3){const N=c[O+0],F=c[O+1],M=c[O+2];w+=v[N>>>2],w+=v[(N<<4|F>>>4)&63],w+=v[(F<<2|M>>>6)&63],w+=v[M&63]}if(A===1){const N=c[O+0];w+=v[N>>>2],w+=v[N<<4&63],d&&(w+="==")}else if(A===2){const N=c[O+0],F=c[O+1];w+=v[N>>>2],w+=v[(N<<4|F>>>4)&63],w+=v[F<<2&63],d&&(w+="=")}return w}e.encodeBase64=u}),define(pe[8],ve([0,1,141,92]),function(Z,e,f,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.isFalsyOrWhitespace=D;const T=/{(\d+)}/g;function I(re,...Ce){return Ce.length===0?re:re.replace(T,function(Fe,qe){const Ve=parseInt(qe,10);return isNaN(Ve)||Ve<0||Ve>=Ce.length?Fe:Ce[Ve]})}e.format=I;const _=/{([^}]+)}/g;function P(re,Ce){return re.replace(_,(Fe,qe)=>Ce[qe]??Fe)}e.format2=P;function R(re){return re.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=R;function y(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function l(re,Ce){let Fe=0;const qe=Ce.charCodeAt(0);for(let Ve=re.length-1;Ve>=0;Ve--)re.charCodeAt(Ve)===qe&&Fe++;return Fe}e.count=l;function b(re,Ce,Fe="\u2026"){return re.length<=Ce?re:`${re.substr(0,Ce)}${Fe}`}e.truncate=b;function p(re,Ce=" "){const Fe=g(re,Ce);return E(Fe,Ce)}e.trim=p;function g(re,Ce){if(!re||!Ce)return re;const Fe=Ce.length;if(Fe===0||re.length===0)return re;let qe=0;for(;re.indexOf(Ce,qe)===qe;)qe=qe+Fe;return re.substring(qe)}e.ltrim=g;function E(re,Ce){if(!re||!Ce)return re;const Fe=Ce.length,qe=re.length;if(Fe===0||qe===0)return re;let Ve=qe,ut=-1;for(;ut=re.lastIndexOf(Ce,Ve-1),!(ut===-1||ut+Fe!==Ve);){if(ut===0)return"";Ve=ut}return re.substring(0,Ve)}e.rtrim=E;function L(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=L;function C(re){return re.replace(/\*/g,"")}e.stripWildcards=C;function a(re,Ce,Fe={}){if(!re)throw new Error("Cannot create regex from empty string");Ce||(re=y(re)),Fe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let qe="";return Fe.global&&(qe+="g"),Fe.matchCase||(qe+="i"),Fe.multiline&&(qe+="m"),Fe.unicode&&(qe+="u"),new RegExp(re,qe)}e.createRegExp=a;function s(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function m(re){return!!re.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function o(re){return(re.global?"g":"")+(re.ignoreCase?"i":"")+(re.multiline?"m":"")+(re.unicode?"u":"")}e.regExpFlags=o;function S(re){return re.split(/\r\n|\r|\n/)}e.splitLines=S;function r(re){for(let Ce=0,Fe=re.length;Ce<Fe;Ce++){const qe=re.charCodeAt(Ce);if(qe!==32&&qe!==9)return Ce}return-1}e.firstNonWhitespaceIndex=r;function i(re,Ce=0,Fe=re.length){for(let qe=Ce;qe<Fe;qe++){const Ve=re.charCodeAt(qe);if(Ve!==32&&Ve!==9)return re.substring(Ce,qe)}return re.substring(Ce,Fe)}e.getLeadingWhitespace=i;function n(re,Ce=re.length-1){for(let Fe=Ce;Fe>=0;Fe--){const qe=re.charCodeAt(Fe);if(qe!==32&&qe!==9)return Fe}return-1}e.lastNonWhitespaceIndex=n;function u(re,Ce){return re<Ce?-1:re>Ce?1:0}e.compare=u;function c(re,Ce,Fe=0,qe=re.length,Ve=0,ut=Ce.length){for(;Fe<qe&&Ve<ut;Fe++,Ve++){let De=re.charCodeAt(Fe),ce=Ce.charCodeAt(Ve);if(De<ce)return-1;if(De>ce)return 1}const Re=qe-Fe,Ae=ut-Ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=c;function d(re,Ce){return h(re,Ce,0,re.length,0,Ce.length)}e.compareIgnoreCase=d;function h(re,Ce,Fe=0,qe=re.length,Ve=0,ut=Ce.length){for(;Fe<qe&&Ve<ut;Fe++,Ve++){let De=re.charCodeAt(Fe),ce=Ce.charCodeAt(Ve);if(De===ce)continue;if(De>=128||ce>=128)return c(re.toLowerCase(),Ce.toLowerCase(),Fe,qe,Ve,ut);v(De)&&(De-=32),v(ce)&&(ce-=32);const de=De-ce;if(de!==0)return de}const Re=qe-Fe,Ae=ut-Ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=h;function v(re){return re>=97&&re<=122}e.isLowerAsciiLetter=v;function w(re){return re>=65&&re<=90}e.isUpperAsciiLetter=w;function A(re,Ce){return re.length===Ce.length&&h(re,Ce)===0}e.equalsIgnoreCase=A;function O(re,Ce){const Fe=Ce.length;return Ce.length>re.length?!1:h(re,Ce,0,Fe)===0}e.startsWithIgnoreCase=O;function N(re,Ce){let Fe,qe=Math.min(re.length,Ce.length);for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(Fe)!==Ce.charCodeAt(Fe))return Fe;return qe}e.commonPrefixLength=N;function F(re,Ce){let Fe,qe=Math.min(re.length,Ce.length);const Ve=re.length-1,ut=Ce.length-1;for(Fe=0;Fe<qe;Fe++)if(re.charCodeAt(Ve-Fe)!==Ce.charCodeAt(ut-Fe))return Fe;return qe}e.commonSuffixLength=F;function M(re){return 55296<=re&&re<=56319}e.isHighSurrogate=M;function V(re){return 56320<=re&&re<=57343}e.isLowSurrogate=V;function $(re,Ce){return(re-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=$;function U(re,Ce,Fe){const qe=re.charCodeAt(Fe);if(M(qe)&&Fe+1<Ce){const Ve=re.charCodeAt(Fe+1);if(V(Ve))return $(qe,Ve)}return qe}e.getNextCodePoint=U;function B(re,Ce){const Fe=re.charCodeAt(Ce-1);if(V(Fe)&&Ce>1){const qe=re.charCodeAt(Ce-2);if(M(qe))return $(qe,Fe)}return Fe}class W{constructor(Ce,Fe=0){this._str=Ce,this._len=Ce.length,this._offset=Fe}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=B(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=U(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class H{constructor(Ce,Fe=0){this._iterator=new W(Ce,Fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let Ve=Ce.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ut=Fe.offset,Re=Ce.getGraphemeBreakType(Fe.nextCodePoint());if(st(Ve,Re)){Fe.setOffset(ut);break}Ve=Re}return Fe.offset-qe}prevGraphemeLength(){const Ce=tt.getInstance(),Fe=this._iterator,qe=Fe.offset;let Ve=Ce.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ut=Fe.offset,Re=Ce.getGraphemeBreakType(Fe.prevCodePoint());if(st(Re,Ve)){Fe.setOffset(ut);break}Ve=Re}return qe-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=H;function x(re,Ce){return new H(re,Ce).nextGraphemeLength()}e.nextCharLength=x;function J(re,Ce){return new H(re,Ce).prevGraphemeLength()}e.prevCharLength=J;function ne(re,Ce){Ce>0&&V(re.charCodeAt(Ce))&&Ce--;const Fe=Ce+x(re,Ce);return[Fe-J(re,Fe),Fe]}e.getCharContainingOffset=ne;const se=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(re){return se.test(re)}e.containsRTL=K;const Q=/^[\t\n\r\x20-\x7E]*$/;function ae(re){return Q.test(re)}e.isBasicASCII=ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(re){return e.UNUSUAL_LINE_TERMINATORS.test(re)}e.containsUnusualLineTerminators=fe;function be(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.isFullWidthCharacter=be;function Me(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.isEmojiImprecise=Me;function ze(re,Ce){if(re.length<Ce)return re;const Fe=/\b/g;let qe=0;for(;Fe.test(re)&&!(re.length-Fe.lastIndex<Ce);)qe=Fe.lastIndex,Fe.lastIndex+=1;return re.substring(qe).replace(/^\s/,"")}e.lcut=ze;const Ge=/\x1B\x5B[12]?K/g,Je=/\x1b\[\d+m/g,q=/\x1b\[0?m/g;function te(re){return re&&(re=re.replace(Ge,""),re=re.replace(Je,""),re=re.replace(q,"")),re}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function X(re){return G(re)?re.substr(1):re}e.stripUTF8BOM=X;function oe(re,Ce){if(!re||!Ce||re.length<Ce.length)return!1;const Fe=Ce.length,qe=re.toLowerCase();let Ve=0,ut=-1;for(;Ve<Fe;){const Re=qe.indexOf(Ce[Ve],ut+1);if(Re<0)return!1;ut=Re,Ve++}return!0}e.fuzzyContains=oe;function me(re,Ce=!1){return re?(Ce&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.containsUppercaseCharacter=me;function Ie(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.uppercaseFirstLetter=Ie;function xe(re,Ce=1){if(Ce===0)return"";let Fe=-1;do Fe=re.indexOf(`
`,Fe+1),Ce--;while(Ce>0&&Fe>=0);return Fe===-1?re:(re[Fe-1]==="\r"&&Fe--,re.substr(0,Fe))}e.getNLines=xe;function Ye(re){const Ce=90-65+1;return re=re%(2*Ce),re<Ce?String.fromCharCode(97+re):String.fromCharCode(65+re-Ce)}e.singleLetterHash=Ye;function it(re){return tt.getInstance().getGraphemeBreakType(re)}e.getGraphemeBreakType=it;function st(re,Ce){return re===0?Ce!==5&&Ce!==7:re===2&&Ce===3?!1:re===4||re===2||re===3||Ce===4||Ce===2||Ce===3?!0:!(re===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(re===11||re===9)&&(Ce===9||Ce===10)||(re===12||re===10)&&Ce===10||Ce===5||Ce===13||Ce===7||re===1||re===13&&Ce===14||re===6&&Ce===6)}var ot;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class tt{constructor(){this._data=rt()}static getInstance(){return tt._INSTANCE||(tt._INSTANCE=new tt),tt._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Fe=this._data,qe=Fe.length/3;let Ve=1;for(;Ve<=qe;)if(Ce<Fe[3*Ve])Ve=2*Ve;else if(Ce>Fe[3*Ve+1])Ve=2*Ve+1;else return Fe[3*Ve+2];return 0}}tt._INSTANCE=null;function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function gt(re,Ce){if(re===0)return 0;const Fe=Ue(re,Ce);if(Fe!==void 0)return Fe;const qe=new W(Ce,re);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=gt;function Ue(re,Ce){const Fe=new W(Ce,re);let qe=Fe.prevCodePoint();for(;It(qe)||qe===65039||qe===8419;){if(Fe.offset===0)return;qe=Fe.prevCodePoint()}if(!Me(qe))return;let Ve=Fe.offset;return Ve>0&&Fe.prevCodePoint()===8205&&(Ve=Fe.offset),Ve}function It(re){return 127995<=re&&re<=127999}var ee;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class ie{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return ie.cache.get(Array.from(Ce))}static getLocales(){return ie._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ie,k=ie,ie.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ie.cache=new f.LRUCachedComputed(re=>{function Ce(ce){const de=new Map;for(let we=0;we<ce.length;we+=2)de.set(ce[we],ce[we+1]);return de}function Fe(ce,de){const we=new Map(ce);for(const[ye,Oe]of de)we.set(ye,Oe);return we}function qe(ce,de){if(!ce)return de;const we=new Map;for(const[ye,Oe]of ce)de.has(ye)&&we.set(ye,Oe);return we}const Ve=k.ambiguousCharacterData.getValue();let ut=re.filter(ce=>!ce.startsWith("_")&&ce in Ve);ut.length===0&&(ut=["_default"]);let Re;for(const ce of ut){const de=Ce(Ve[ce]);Re=qe(Re,de)}const Ae=Ce(Ve._common),De=Fe(Ae,Re);return new ie(De)}),ie._locales=new t.Lazy(()=>Object.keys(ie.ambiguousCharacterData.getValue()).filter(re=>!re.startsWith("_")));class Se{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Se.getRawData())),this._data}static isInvisibleCharacter(Ce){return Se.getData().has(Ce)}static get codePoints(){return Se.getData()}}e.InvisibleCharacters=Se,Se._data=void 0}),define(pe[58],ve([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(L){return k(L,0)}e.hash=t;function k(L,C){switch(typeof L){case"object":return L===null?D(349,C):Array.isArray(L)?_(L,C):P(L,C);case"string":return I(L,C);case"boolean":return T(L,C);case"number":return D(L,C);case"undefined":return D(937,C);default:return D(617,C)}}e.doHash=k;function D(L,C){return(C<<5)-C+L|0}e.numberHash=D;function T(L,C){return D(L?433:863,C)}function I(L,C){C=D(149417,C);for(let a=0,s=L.length;a<s;a++)C=D(L.charCodeAt(a),C);return C}e.stringHash=I;function _(L,C){return C=D(104579,C),L.reduce((a,s)=>k(s,a),C)}function P(L,C){return C=D(181387,C),Object.keys(L).sort().reduce((a,s)=>(a=I(s,a),k(L[s],a)),C)}class R{constructor(){this._value=0}get value(){return this._value}hash(C){return this._value=k(C,this._value),this._value}}e.Hasher=R;var y;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function l(L,C,a=32){const s=a-C,m=~((1<<s)-1);return(L<<C|(m&L)>>>s)>>>0}function b(L,C=0,a=L.byteLength,s=0){for(let m=0;m<a;m++)L[C+m]=s}function p(L,C,a="0"){for(;L.length<C;)L=a+L;return L}function g(L,C=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(a=>a.toString(16).padStart(2,"0")).join(""):p((L>>>0).toString(16),C/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const a=C.length;if(a===0)return;const s=this._buff;let m=this._buffLen,o=this._leftoverHighSurrogate,S,r;for(o!==0?(S=o,r=-1,o=0):(S=C.charCodeAt(0),r=0);;){let i=S;if(f.isHighSurrogate(S))if(r+1<a){const n=C.charCodeAt(r+1);f.isLowSurrogate(n)?(r++,i=f.computeCodePoint(S,n)):i=65533}else{o=S;break}else f.isLowSurrogate(S)&&(i=65533);if(m=this._push(s,m,i),r++,r<a)S=C.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=o}_push(C,a,s){return s<128?C[a++]=s:s<2048?(C[a++]=192|(s&1984)>>>6,C[a++]=128|(s&63)>>>0):s<65536?(C[a++]=224|(s&61440)>>>12,C[a++]=128|(s&4032)>>>6,C[a++]=128|(s&63)>>>0):(C[a++]=240|(s&1835008)>>>18,C[a++]=128|(s&258048)>>>12,C[a++]=128|(s&4032)>>>6,C[a++]=128|(s&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=E._bigBlock32,a=this._buffDV;for(let c=0;c<64;c+=4)C.setUint32(c,a.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)C.setUint32(c,l(C.getUint32(c-12,!1)^C.getUint32(c-32,!1)^C.getUint32(c-56,!1)^C.getUint32(c-64,!1),1),!1);let s=this._h0,m=this._h1,o=this._h2,S=this._h3,r=this._h4,i,n,u;for(let c=0;c<80;c++)c<20?(i=m&o|~m&S,n=1518500249):c<40?(i=m^o^S,n=1859775393):c<60?(i=m&o|m&S|o&S,n=2400959708):(i=m^o^S,n=3395469782),u=l(s,5)+i+r+n+C.getUint32(c*4,!1)&4294967295,r=S,S=o,o=l(m,30),m=s,s=u;this._h0=this._h0+s&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[24],ve([0,1,17,8]),function(Z,e,f,t){"use strict";var k,D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,i,n){let u=r.get(i);return u===void 0&&(u=n,r.set(i,u)),u}e.getOrSet=I;function _(r){const i=[];return r.forEach((n,u)=>{i.push(`${u} => ${n}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=_;function P(r){const i=[];return r.forEach(n=>{i.push(n)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return n-u}value(){return this._value[this._pos]}}e.StringIterator=R;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class l{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let n=i.length-1;n>=0;n--,this._valueLen--){const u=this._value.charCodeAt(n);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var b;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(E||(E={}));class L{constructor(i){this._iter=i}static forUris(i=()=>!1){return new L(new p(i))}static forPaths(i=!1){return new L(new l(void 0,!i))}static forStrings(){return new L(new R)}static forConfigKeys(){return new L(new y)}clear(){this._root=void 0}fill(i,n){if(n){const u=n.slice(0);(0,f.shuffle)(u);for(let c of u)this.set(c,i)}else{const u=i.slice(0);(0,f.shuffle)(u);for(let c of u)this.set(c[0],c[1])}}set(i,n){const u=this._iter.reset(i);let c;this._root||(this._root=new g,this._root.segment=u.value());const d=[];for(c=this._root;;){const v=u.cmp(c.segment);if(v>0)c.left||(c.left=new g,c.left.segment=u.value()),d.push([-1,c]),c=c.left;else if(v<0)c.right||(c.right=new g,c.right.segment=u.value()),d.push([1,c]),c=c.right;else if(u.hasNext())u.next(),c.mid||(c.mid=new g,c.mid.segment=u.value()),d.push([0,c]),c=c.mid;else break}const h=c.value;c.value=n,c.key=i;for(let v=d.length-1;v>=0;v--){const w=d[v][1];w.updateHeight();const A=w.balanceFactor();if(A<-1||A>1){const O=d[v][0],N=d[v+1][0];if(O===1&&N===1)d[v][1]=w.rotateLeft();else if(O===-1&&N===-1)d[v][1]=w.rotateRight();else if(O===1&&N===-1)w.right=d[v+1][1]=d[v+1][1].rotateRight(),d[v][1]=w.rotateLeft();else if(O===-1&&N===1)w.left=d[v+1][1]=d[v+1][1].rotateLeft(),d[v][1]=w.rotateRight();else throw new Error;if(v>0)switch(d[v-1][0]){case-1:d[v-1][1].left=d[v][1];break;case 1:d[v-1][1].right=d[v][1];break;case 0:d[v-1][1].mid=d[v][1];break}else this._root=d[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const n=this._iter.reset(i);let u=this._root;for(;u;){const c=n.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else break}return u}has(i){const n=this._getNode(i);return!(n?.value===void 0&&n?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const u=this._iter.reset(i),c=[];let d=this._root;for(;d;){const h=u.cmp(d.segment);if(h>0)c.push([-1,d]),d=d.left;else if(h<0)c.push([1,d]),d=d.right;else if(u.hasNext())u.next(),c.push([0,d]),d=d.mid;else break}if(!!d){if(n?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this._min(d.right),{key:v,value:w,segment:A}=h;this._delete(h.key,!1),d.key=v,d.value=w,d.segment=A}else{const h=d.left??d.right;if(c.length>0){const[v,w]=c[c.length-1];switch(v){case-1:w.left=h;break;case 0:w.mid=h;break;case 1:w.right=h;break}}else this._root=h}for(let h=c.length-1;h>=0;h--){const v=c[h][1];v.updateHeight();const w=v.balanceFactor();if(w>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),c[h][1]=v.rotateLeft()):w<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),c[h][1]=v.rotateRight()),h>0)switch(c[h-1][0]){case-1:c[h-1][1].left=c[h][1];break;case 1:c[h-1][1].right=c[h][1];break;case 0:c[h-1][1].mid=c[h][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const n=this._iter.reset(i);let u=this._root,c;for(;u;){const d=n.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(n.hasNext())n.next(),c=u.value||c,u=u.mid;else break}return u&&u.value||c}findSuperstr(i){const n=this._iter.reset(i);let u=this._root;for(;u;){const c=n.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(n.hasNext())n.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[n,u]of this)i(u,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=n=>{if(!n)return!0;const u=n.balanceFactor();return u<-1||u>1?!1:i(n.left)&&i(n.right)};return i(this._root)}}e.TernarySearchTree=L;class C{constructor(i,n){this.uri=i,this.value=n}}class a{constructor(i,n){this[k]="ResourceMap",i instanceof a?(this.map=new Map(i.map),this.toKey=n??a.defaultToKey):(this.map=new Map,this.toKey=i??a.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),new C(i,n)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[u,c]of this.map)i(c.value,c.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=a,a.defaultToKey=r=>r.toString();var s;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class m{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,n=0){const u=this._map.get(i);if(!!u)return n!==0&&this.touch(u,n),u.value}set(i,n,u=0){let c=this._map.get(i);if(c)c.value=n,u!==0&&this.touch(c,u);else{switch(c={key:i,value:n,next:void 0,previous:void 0},u){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const u=this._state;let c=this._head;for(;c;){if(n?i.bind(n)(c.value,c.key,this):i(c.value,c.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,n=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.key,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}values(){const i=this,n=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:u.value,done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}entries(){const i=this,n=this._state;let u=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(u){const d={value:[u.key,u.value],done:!1};return u=u.next,d}else return{value:void 0,done:!0}}};return c}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,u=this.size;for(;n&&u>i;)this._map.delete(n.key),n=n.next,u--;this._head=n,this._size=u,n&&(n.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,u=i.previous;if(!n||!u)throw new Error("Invalid list");n.previous=u,u.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const u=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(u.previous=c,c.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const u=i.next,c=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=c,c.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,u)=>{i.push([u,n])}),i}fromJSON(i){this.clear();for(const[n,u]of i)this.set(n,u)}}e.LinkedMap=m;class o extends m{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class S{constructor(i){T.set(this,void 0),nt(this,T,i,"f")}get size(){return Le(this,T,"f").size}forEach(i,n){Le(this,T,"f").forEach(i,n)}get(i){return Le(this,T,"f").get(i)}has(i){return Le(this,T,"f").has(i)}entries(){return Le(this,T,"f").entries()}keys(){return Le(this,T,"f").keys()}values(){return Le(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Le(this,T,"f").entries()}}e.ReadonlyMapView=S}),define(pe[98],ve([0,1,24,8]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...G){return function(X,oe){for(let me=0,Ie=G.length;me<Ie;me++){const xe=G[me](X,oe);if(xe)return xe}return null}}e.or=k,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(G,X,oe){if(!oe||oe.length<X.length)return null;let me;return G?me=t.startsWithIgnoreCase(oe,X):me=oe.indexOf(X)===0,me?X.length>0?[{start:0,end:X.length}]:[]:null}function T(G,X){const oe=X.toLowerCase().indexOf(G.toLowerCase());return oe===-1?null:[{start:oe,end:oe+G.length}]}e.matchesContiguousSubString=T;function I(G,X){return _(G.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=I;function _(G,X,oe,me){if(oe===G.length)return[];if(me===X.length)return null;if(G[oe]===X[me]){let Ie=null;return(Ie=_(G,X,oe+1,me+1))?L({start:me,end:me+1},Ie):null}return _(G,X,oe,me+1)}function P(G){return 97<=G&&G<=122}function R(G){return 65<=G&&G<=90}e.isUpper=R;function y(G){return 48<=G&&G<=57}function l(G){return G===32||G===9||G===10||G===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>b.add(G.charCodeAt(0)));function p(G){return l(G)||b.has(G)}function g(G,X){return G===X||p(G)&&p(X)}function E(G){return P(G)||R(G)||y(G)}function L(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function C(G,X){for(let oe=X;oe<G.length;oe++){const me=G.charCodeAt(oe);if(R(me)||y(me)||oe>0&&!E(G.charCodeAt(oe-1)))return oe}return G.length}function a(G,X,oe,me){if(oe===G.length)return[];if(me===X.length)return null;if(G[oe]!==X[me].toLowerCase())return null;{let Ie=null,xe=me+1;for(Ie=a(G,X,oe+1,me+1);!Ie&&(xe=C(X,xe))<X.length;)Ie=a(G,X,oe+1,xe),xe++;return Ie===null?null:L({start:me,end:me+1},Ie)}}function s(G){let X=0,oe=0,me=0,Ie=0,xe=0;for(let tt=0;tt<G.length;tt++)xe=G.charCodeAt(tt),R(xe)&&X++,P(xe)&&oe++,E(xe)&&me++,y(xe)&&Ie++;const Ye=X/G.length,it=oe/G.length,st=me/G.length,ot=Ie/G.length;return{upperPercent:Ye,lowerPercent:it,alphaPercent:st,numericPercent:ot}}function m(G){const{upperPercent:X,lowerPercent:oe}=G;return oe===0&&X>.6}function o(G){const{upperPercent:X,lowerPercent:oe,alphaPercent:me,numericPercent:Ie}=G;return oe>.2&&X<.8&&me>.6&&Ie<.2}function S(G){let X=0,oe=0,me=0,Ie=0;for(let xe=0;xe<G.length;xe++)me=G.charCodeAt(xe),R(me)&&X++,P(me)&&oe++,l(me)&&Ie++;return(X===0||oe===0)&&Ie===0?G.length<=30:X<=5}function r(G,X){if(!X||(X=X.trim(),X.length===0)||!S(G)||X.length>60)return null;const oe=s(X);if(!o(oe)){if(!m(oe))return null;X=X.toLowerCase()}let me=null,Ie=0;for(G=G.toLowerCase();Ie<X.length&&(me=a(G,X,0,Ie))===null;)Ie=C(X,Ie+1);return me}e.matchesCamelCase=r;function i(G,X,oe=!1){if(!X||X.length===0)return null;let me=null,Ie=0;for(G=G.toLowerCase(),X=X.toLowerCase();Ie<X.length&&(me=n(G,X,0,Ie,oe))===null;)Ie=u(X,Ie+1);return me}e.matchesWords=i;function n(G,X,oe,me,Ie){if(oe===G.length)return[];if(me===X.length)return null;if(g(G.charCodeAt(oe),X.charCodeAt(me))){let xe=null,Ye=me+1;if(xe=n(G,X,oe+1,me+1,Ie),!Ie)for(;!xe&&(Ye=u(X,Ye))<X.length;)xe=n(G,X,oe+1,Ye,Ie),Ye++;return xe===null?null:L({start:me,end:me+1},xe)}else return null}function u(G,X){for(let oe=X;oe<G.length;oe++)if(p(G.charCodeAt(oe))||oe>0&&p(G.charCodeAt(oe-1)))return oe;return G.length}const c=k(e.matchesPrefix,r,T),d=k(e.matchesPrefix,r,I),h=new f.LRUCache(1e4);function v(G,X,oe=!1){if(typeof G!="string"||typeof X!="string")return null;let me=h.get(G);me||(me=new RegExp(t.convertSimple2RegExpPattern(G),"i"),h.set(G,me));const Ie=me.exec(X);return Ie?[{start:Ie.index,end:Ie.index+Ie[0].length}]:oe?d(G,X):c(G,X)}e.matchesFuzzy=v;function w(G,X){const oe=be(G,G.toLowerCase(),0,X,X.toLowerCase(),0,!0);return oe?O(oe):null}e.matchesFuzzy2=w;function A(G,X,oe,me,Ie,xe){const Ye=Math.min(13,G.length);for(;oe<Ye;oe++){const it=be(G,X,oe,me,Ie,xe,!1);if(it)return it}return[0,xe]}e.anyScore=A;function O(G){if(typeof G=="undefined")return[];const X=[],oe=G[1];for(let me=G.length-1;me>1;me--){const Ie=G[me]+oe,xe=X[X.length-1];xe&&xe.end===Ie?xe.end=Ie+1:X.push({start:Ie,end:Ie+1})}return X}e.createMatches=O;const N=128;function F(){const G=[],X=[];for(let oe=0;oe<=N;oe++)X[oe]=0;for(let oe=0;oe<=N;oe++)G.push(X.slice(0));return G}function M(G){const X=[];for(let oe=0;oe<=G;oe++)X[oe]=0;return X}const V=M(2*N),$=M(2*N),U=F(),B=F(),W=F(),H=!1;function x(G,X,oe,me,Ie){function xe(it,st,ot=" "){for(;it.length<st;)it=ot+it;return it}let Ye=` |   |${me.split("").map(it=>xe(it,3)).join("|")}
`;for(let it=0;it<=oe;it++)it===0?Ye+=" |":Ye+=`${X[it-1]}|`,Ye+=G[it].slice(0,Ie+1).map(st=>xe(st.toString(),3)).join("|")+`
`;return Ye}function J(G,X,oe,me){G=G.substr(X),oe=oe.substr(me),console.log(x(B,G,G.length,oe,oe.length)),console.log(x(W,G,G.length,oe,oe.length)),console.log(x(U,G,G.length,oe,oe.length))}function ne(G,X){if(X<0||X>=G.length)return!1;const oe=G.codePointAt(X);switch(oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(oe)}}function se(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function K(G,X,oe){return X[G]!==oe[G]}function Q(G,X,oe,me,Ie,xe,Ye=!1){for(;X<oe&&Ie<xe;)G[X]===me[Ie]&&(Ye&&(V[X]=Ie),X+=1),Ie+=1;return X===oe}e.isPatternInWord=Q;var ae;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var fe;(function(G){G.Default=[-100,0];function X(oe){return!oe||oe.length===2&&oe[0]===-100&&oe[1]===0}G.isDefault=X})(fe=e.FuzzyScore||(e.FuzzyScore={}));function be(G,X,oe,me,Ie,xe,Ye){const it=G.length>N?N:G.length,st=me.length>N?N:me.length;if(oe>=it||xe>=st||it-oe>st-xe||!Q(X,oe,it,Ie,xe,st,!0))return;Me(it,st,oe,xe,X,Ie);let ot=1,tt=1,rt=oe,gt=xe;const Ue=[!1];for(ot=1,rt=oe;rt<it;ot++,rt++){const re=V[rt],Ce=$[rt],Fe=rt+1<it?$[rt+1]:st;for(tt=re-xe+1,gt=re;gt<Fe;tt++,gt++){let qe=Number.MIN_SAFE_INTEGER,Ve=!1;gt<=Ce&&(qe=ze(G,X,rt,oe,me,Ie,gt,st,xe,U[ot-1][tt-1]===0,Ue));let ut=0;qe!==Number.MAX_SAFE_INTEGER&&(Ve=!0,ut=qe+B[ot-1][tt-1]);const Re=gt>re,Ae=Re?B[ot][tt-1]+(U[ot][tt-1]>0?-5:0):0,De=gt>re+1&&U[ot][tt-1]>0,ce=De?B[ot][tt-2]+(U[ot][tt-2]>0?-5:0):0;if(De&&(!Re||ce>=Ae)&&(!Ve||ce>=ut))B[ot][tt]=ce,W[ot][tt]=3,U[ot][tt]=0;else if(Re&&(!Ve||Ae>=ut))B[ot][tt]=Ae,W[ot][tt]=2,U[ot][tt]=0;else if(Ve)B[ot][tt]=ut,W[ot][tt]=1,U[ot][tt]=U[ot-1][tt-1]+1;else throw new Error("not possible")}}if(H&&J(G,oe,me,xe),!Ue[0]&&!Ye)return;ot--,tt--;const It=[B[ot][tt],xe];let ee=0,ie=0;for(;ot>=1;){let re=tt;do{const Ce=W[ot][re];if(Ce===3)re=re-2;else if(Ce===2)re=re-1;else break}while(re>=1);ee>1&&X[oe+ot-1]===Ie[xe+tt-1]&&!K(re+xe-1,me,Ie)&&ee+1>U[ot][re]&&(re=tt),re===tt?ee++:ee=1,ie||(ie=re),ot--,tt=re-1,It.push(tt)}st===it&&(It[0]+=2);const Se=ie-it;return It[0]-=Se,It}e.fuzzyScore=be;function Me(G,X,oe,me,Ie,xe){let Ye=G-1,it=X-1;for(;Ye>=oe&&it>=me;)Ie[Ye]===xe[it]&&($[Ye]=it,Ye--),it--}function ze(G,X,oe,me,Ie,xe,Ye,it,st,ot,tt){if(X[oe]!==xe[Ye])return Number.MIN_SAFE_INTEGER;let rt=1,gt=!1;return Ye===oe-me?rt=G[oe]===Ie[Ye]?7:5:K(Ye,Ie,xe)&&(Ye===0||!K(Ye-1,Ie,xe))?(rt=G[oe]===Ie[Ye]?7:5,gt=!0):ne(xe,Ye)&&(Ye===0||!ne(xe,Ye-1))?rt=5:(ne(xe,Ye-1)||se(xe,Ye-1))&&(rt=5,gt=!0),rt>1&&oe===me&&(tt[0]=!0),gt||(gt=K(Ye,Ie,xe)||ne(xe,Ye-1)||se(xe,Ye-1)),oe===me?Ye>st&&(rt-=gt?3:5):ot?rt+=gt?2:0:rt+=gt?0:1,Ye+1===it&&(rt-=gt?3:5),rt}function Ge(G,X,oe,me,Ie,xe,Ye){return q(G,X,oe,me,Ie,xe,!0,Ye)}e.fuzzyScoreGracefulAggressive=Ge;function Je(G,X,oe,me,Ie,xe,Ye){return q(G,X,oe,me,Ie,xe,!1,Ye)}e.fuzzyScoreGraceful=Je;function q(G,X,oe,me,Ie,xe,Ye,it){let st=be(G,X,oe,me,Ie,xe,it);if(st&&!Ye)return st;if(G.length>=3){const ot=Math.min(7,G.length-1);for(let tt=oe+1;tt<ot;tt++){const rt=te(G,tt);if(rt){const gt=be(rt,rt.toLowerCase(),oe,me,Ie,xe,it);gt&&(gt[0]-=3,(!st||gt[0]>st[0])&&(st=gt))}}}return st}function te(G,X){if(X+1>=G.length)return;const oe=G[X],me=G[X+1];if(oe!==me)return G.slice(0,X)+me+oe+G.slice(X+2)}}),define(pe[142],ve([0,1,74,98,8]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(f.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${D.source}`,"g");function _(E){return E.replace(I,(L,C)=>C?L:`\\${L}`)}e.escapeIcons=_;const P=new RegExp(`\\\\${D.source}`,"g");function R(E){return E.replace(P,L=>`\\${L}`)}e.markdownEscapeEscapedIcons=R;const y=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function l(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(y,(L,C,a,s)=>a?L:C||s||"")}e.stripIcons=l;function b(E){const L=E.indexOf(e.iconStartMarker);return L===-1?{text:E}:p(E,L)}e.parseLabelWithIcons=b;function p(E,L){const C=[];let a="";function s(c){if(c){a+=c;for(const d of c)C.push(S)}}let m=-1,o="",S=0,r,i,n=L;const u=E.length;for(s(E.substr(0,L));n<u;)r=E[n],i=E[n+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(m=n,s(o),o=e.iconStartMarker,n++):r===")"&&m!==-1?(S+=n-m+1,m=-1,o=""):m!==-1?T.test(r)?o+=r:(s(o),m=-1,o=""):s(r),n++;return s(o),{text:a,iconOffsets:C}}function g(E,L,C=!1){const{text:a,iconOffsets:s}=L;if(!s||s.length===0)return(0,t.matchesFuzzy)(E,a,C);const m=(0,k.ltrim)(a," "),o=a.length-m.length,S=(0,t.matchesFuzzy)(E,m,C);if(S)for(const r of S){const i=s[r.start+o]+o;r.start+=i,r.end+=i}return S}e.matchesFuzzyIconAware=g}),define(pe[99],ve([0,1,16,142]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(b="",p=!1){if(this.value=b,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(b,p=0){return this.value+=P(this.supportThemeIcons?(0,t.escapeIcons)(b):b).replace(/([ \t]+)/g,(g,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,p){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=D;function T(l){return I(l)?!l.value:Array.isArray(l)?l.every(T):!0}e.isEmptyMarkdownString=T;function I(l){return l instanceof D?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function _(l,b){return l===b?!0:!l||!b?!1:l.value===b.value&&l.isTrusted===b.isTrusted&&l.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=_;function P(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function R(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function y(l){const b=[],p=l.split("|").map(E=>E.trim());l=p[0];const g=p[1];if(g){const E=/height=(\d+)/.exec(g),L=/width=(\d+)/.exec(g),C=E?E[1]:"",a=L?L[1]:"",s=isFinite(parseInt(a)),m=isFinite(parseInt(C));s&&b.push(`width="${a}"`),m&&b.push(`height="${C}"`)}return{href:l,dimensions:b}}e.parseHrefAndDimensions=y}),define(pe[79],ve([0,1,24]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new f.LRUCache(1e4);function k(P){return _(P,"NFC",t)}e.normalizeNFC=k;const D=new f.LRUCache(1e4);function T(P){return _(P,"NFD",D)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function _(P,R,y){if(!P)return P;const l=y.get(P);if(l)return l;let b;return I.test(P)?b=P.normalize(R):b=P,y.set(P,b),b}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(R){return T(R).replace(P,"")}}()}),define(pe[47],ve([0,1,8]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const D="error",T="warning",I="warn",_="info",P="ignore";function R(l){return l?f.equalsIgnoreCase(D,l)?k.Error:f.equalsIgnoreCase(T,l)||f.equalsIgnoreCase(I,l)?k.Warning:f.equalsIgnoreCase(_,l)?k.Info:k.Ignore:k.Ignore}k.fromValue=R;function y(l){switch(l){case k.Error:return D;case k.Warning:return T;case k.Info:return _;default:return P}}k.toString=y}(t||(t={})),e.default=t}),define(pe[13],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(d){return Array.isArray(d)}e.isArray=f;function t(d){return typeof d=="string"}e.isString=t;function k(d){return Array.isArray(d)&&d.every(h=>t(h))}e.isStringArray=k;function D(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=D;function T(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=T;function I(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=I;function _(d){return d===!0||d===!1}e.isBoolean=_;function P(d){return typeof d=="undefined"}e.isUndefined=P;function R(d){return!y(d)}e.isDefined=R;function y(d){return P(d)||d===null}e.isUndefinedOrNull=y;function l(d,h){if(!d)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}e.assertType=l;function b(d){if(y(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=b;function p(...d){const h=[];for(let v=0;v<d.length;v++){const w=d[v];if(y(w))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);h.push(w)}return h}e.assertAllDefined=p;const g=Object.prototype.hasOwnProperty;function E(d){if(!D(d))return!1;for(let h in d)if(g.call(d,h))return!1;return!0}e.isEmptyObject=E;function L(d){return typeof d=="function"}e.isFunction=L;function C(...d){return d.length>0&&d.every(L)}e.areFunctions=C;function a(d,h){const v=Math.min(d.length,h.length);for(let w=0;w<v;w++)s(d[w],h[w])}e.validateConstraints=a;function s(d,h){if(t(h)){if(typeof d!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(L(h)){try{if(d instanceof h)return}catch{}if(!y(d)&&d.constructor===h||h.length===1&&h.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function m(d){let h=[],v=Object.getPrototypeOf(d);for(;Object.prototype!==v;)h=h.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return h}e.getAllPropertyNames=m;function o(d){const h=[];for(const v of m(d))typeof d[v]=="function"&&h.push(v);return h}e.getAllMethodNames=o;function S(d,h){const v=A=>function(){const O=Array.prototype.slice.call(arguments,0);return h(A,O)};let w={};for(const A of d)w[A]=v(A);return w}e.createProxyObject=S;function r(d){return d===null?void 0:d}e.withNullAsUndefined=r;function i(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=i;function n(d){return class{constructor(){return new Proxy({},{get(h,v){if(h[v])return h[v];throw new Error(`Not Implemented: ${d}->${String(v)}`)}})}}}e.NotImplementedProxy=n;function u(d,h="Unreachable"){throw new Error(h)}e.assertNever=u;function c(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=c}),define(pe[29],ve([0,1,9,12,8,13]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(n){return n===47||n===92}e.isPathSeparator=T;function I(n){return n.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=I;function _(n){return n.indexOf("/")===-1&&(n=I(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=_;function P(n,u=f.posix.sep){if(!n)return"";const c=n.length,d=n.charCodeAt(0);if(T(d)){if(T(n.charCodeAt(1))&&!T(n.charCodeAt(2))){let v=3;const w=v;for(;v<c&&!T(n.charCodeAt(v));v++);if(w!==v&&!T(n.charCodeAt(v+1))){for(v+=1;v<c;v++)if(T(n.charCodeAt(v)))return n.slice(0,v+1).replace(/[\\/]/g,u)}}return u}else if(L(d)&&n.charCodeAt(1)===58)return T(n.charCodeAt(2))?n.slice(0,2)+u:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(T(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=P;function R(n){if(!t.isWindows||!n||n.length<5)return!1;let u=n.charCodeAt(0);if(u!==92||(u=n.charCodeAt(1),u!==92))return!1;let c=2;const d=c;for(;c<n.length&&(u=n.charCodeAt(c),u!==92);c++);return!(d===c||(u=n.charCodeAt(c+1),isNaN(u)||u===92))}e.isUNC=R;const y=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(n,u=t.isWindows){const c=u?y:l;return!(!n||n.length===0||/^\s+$/.test(n)||(c.lastIndex=0,c.test(n))||u&&b.test(n)||n==="."||n===".."||u&&n[n.length-1]==="."||u&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=p;function g(n,u,c){const d=n===u;return!c||d?d:!n||!u?!1:(0,k.equalsIgnoreCase)(n,u)}e.isEqual=g;function E(n,u,c,d=f.sep){if(n===u)return!0;if(!n||!u||u.length>n.length)return!1;if(c){if(!(0,k.startsWithIgnoreCase)(n,u))return!1;if(u.length===n.length)return!0;let v=u.length;return u.charAt(u.length-1)===d&&v--,n.charAt(v)===d}return u.charAt(u.length-1)!==d&&(u+=d),n.indexOf(u)===0}e.isEqualOrParent=E;function L(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=L;function C(n,u){return t.isWindows&&n.endsWith(":")&&(n+=f.sep),(0,f.isAbsolute)(n)||(n=(0,f.join)(u,n)),n=(0,f.normalize)(n),t.isWindows?(n=(0,k.rtrim)(n,f.sep),n.endsWith(":")&&(n+=f.sep)):(n=(0,k.rtrim)(n,f.sep),n||(n=f.sep)),n}e.sanitizeFilePath=C;function a(n){const u=(0,f.normalize)(n);return t.isWindows?n.length>3?!1:s(u)&&(n.length===2||u.charCodeAt(2)===92):u===f.posix.sep}e.isRootOrDriveLetter=a;function s(n,u){return(u!==void 0?u:t.isWindows)?L(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function m(n){return s(n)?n[0]:void 0}e.getDriveLetter=m;function o(n,u,c){return u.length>n.length?-1:n===u?0:(c&&(n=n.toLowerCase(),u=u.toLowerCase()),n.indexOf(u))}e.indexOfPath=o;function S(n){const u=n.split(":");let c,d,h;for(const v of u){const w=Number(v);(0,D.isNumber)(w)?d===void 0?d=w:h===void 0&&(h=w):c=c?[c,v].join(":"):v}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:h!==void 0?h:d!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(n,u,c=8){let d="";for(let v=0;v<c;v++)d+=r.charAt(Math.floor(Math.random()*r.length));let h;return u?h=`${u}-${d}`:h=d,n?(0,f.join)(n,h):h}e.randomPath=i}),define(pe[25],ve([0,1,13]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(L=>{g[L]&&typeof g[L]=="object"?E[L]=t(g[L]):E[L]=g[L]}),E}e.deepClone=t;function k(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const L=E.shift();Object.freeze(L);for(const C in L)if(D.call(L,C)){const a=L[C];typeof a=="object"&&!Object.isFrozen(a)&&E.push(a)}}return g}e.deepFreeze=k;const D=Object.prototype.hasOwnProperty;function T(g,E){return I(g,E,new Set)}e.cloneAndChange=T;function I(g,E,L){if((0,f.isUndefinedOrNull)(g))return g;const C=E(g);if(typeof C!="undefined")return C;if((0,f.isArray)(g)){const a=[];for(const s of g)a.push(I(s,E,L));return a}if((0,f.isObject)(g)){if(L.has(g))throw new Error("Cannot clone recursive data-structure");L.add(g);const a={};for(let s in g)D.call(g,s)&&(a[s]=I(g[s],E,L));return L.delete(g),a}return g}function _(g,E,L=!0){return(0,f.isObject)(g)?((0,f.isObject)(E)&&Object.keys(E).forEach(C=>{C in g?L&&((0,f.isObject)(g[C])&&(0,f.isObject)(E[C])?_(g[C],E[C],L):g[C]=E[C]):g[C]=E[C]}),g):E}e.mixin=_;function P(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let L,C;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(L=0;L<g.length;L++)if(!P(g[L],E[L]))return!1}else{const a=[];for(C in g)a.push(C);a.sort();const s=[];for(C in E)s.push(C);if(s.sort(),!P(a,s))return!1;for(L=0;L<a.length;L++)if(!P(g[a[L]],E[a[L]]))return!1}return!0}e.equals=P;function R(g){const E=new Set;return JSON.stringify(g,(L,C)=>{if((0,f.isObject)(C)||Array.isArray(C)){if(E.has(C))return"[Circular]";E.add(C)}return C})}e.safeStringify=R;function y(g,E,L){const C=E(g);return typeof C=="undefined"?L:C}e.getOrDefault=y;function l(g,E){const L=Object.create(null);return!g||!E||Object.keys(E).forEach(a=>{const s=g[a],m=E[a];P(s,m)||(L[a]=m)}),L}e.distinct=l;function b(g,E){const L=E.toLowerCase(),C=Object.keys(g).find(a=>a.toLowerCase()===L);return C?g[C]:g[E]}e.getCaseInsensitive=b;function p(g,E){const L=Object.create(null);for(const[C,a]of Object.entries(g))E(C,a)&&(L[C]=a);return L}e.filter=p}),define(pe[100],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function t(D){return D<0?0:D>255?255:D|0}e.toUint8=t;function k(D){return D<0?0:D>4294967295?4294967295:D|0}e.toUint32=k}),define(pe[2],ve([0,1,9,12]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,D=/^\//,T=/^\/\//;function I(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!D.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(r,i){return!r&&!i?"file":r}function P(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const R="",y="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(i,n,u,c,d,h=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=_(i,h),this.authority=n||R,this.path=P(this.scheme,u||R),this.query=c||R,this.fragment=d||R,I(this,h))}static isUri(i){return i instanceof b?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:n,authority:u,path:c,query:d,fragment:h}=i;return n===void 0?n=this.scheme:n===null&&(n=R),u===void 0?u=this.authority:u===null&&(u=R),c===void 0?c=this.path:c===null&&(c=R),d===void 0?d=this.query:d===null&&(d=R),h===void 0?h=this.fragment:h===null&&(h=R),n===this.scheme&&u===this.authority&&c===this.path&&d===this.query&&h===this.fragment?this:new g(n,u,c,d,h)}static parse(i,n=!1){const u=l.exec(i);return u?new g(u[2]||R,S(u[4]||R),S(u[5]||R),S(u[7]||R),S(u[9]||R),n):new g(R,R,R,R,R)}static file(i){let n=R;if(t.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const u=i.indexOf(y,2);u===-1?(n=i.substring(2),i=y):(n=i.substring(2,u),i=i.substring(u)||y)}return new g("file",n,i,R,R)}static from(i){const n=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return I(n,!0),n}static joinPath(i,...n){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&i.scheme==="file"?u=b.file(f.win32.join(a(i,!0),...n)).path:u=f.posix.join(i.path,...n),i.with({path:u})}toString(i=!1){return s(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof b)return i;{const n=new g(i);return n._formatted=i.external,n._fsPath=i._sep===p?i.fsPath:null,n}}else return i}}e.URI=b;const p=t.isWindows?1:void 0;class g extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function L(r,i){let n,u=-1;for(let c=0;c<r.length;c++){const d=r.charCodeAt(c);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)u!==-1&&(n+=encodeURIComponent(r.substring(u,c)),u=-1),n!==void 0&&(n+=r.charAt(c));else{n===void 0&&(n=r.substr(0,c));const h=E[d];h!==void 0?(u!==-1&&(n+=encodeURIComponent(r.substring(u,c)),u=-1),n+=h):u===-1&&(u=c)}}return u!==-1&&(n+=encodeURIComponent(r.substring(u))),n!==void 0?n:r}function C(r){let i;for(let n=0;n<r.length;n++){const u=r.charCodeAt(n);u===35||u===63?(i===void 0&&(i=r.substr(0,n)),i+=E[u]):i!==void 0&&(i+=r[n])}return i!==void 0?i:r}function a(r,i){let n;return r.authority&&r.path.length>1&&r.scheme==="file"?n=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?n=r.path.substr(1):n=r.path[1].toLowerCase()+r.path.substr(2):n=r.path,t.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=a;function s(r,i){const n=i?C:L;let u="",{scheme:c,authority:d,path:h,query:v,fragment:w}=r;if(c&&(u+=c,u+=":"),(d||c==="file")&&(u+=y,u+=y),d){let A=d.indexOf("@");if(A!==-1){const O=d.substr(0,A);d=d.substr(A+1),A=O.indexOf(":"),A===-1?u+=n(O,!1):(u+=n(O.substr(0,A),!1),u+=":",u+=n(O.substr(A+1),!1)),u+="@"}d=d.toLowerCase(),A=d.indexOf(":"),A===-1?u+=n(d,!1):(u+=n(d.substr(0,A),!1),u+=d.substr(A))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const A=h.charCodeAt(1);A>=65&&A<=90&&(h=`/${String.fromCharCode(A+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const A=h.charCodeAt(0);A>=65&&A<=90&&(h=`${String.fromCharCode(A+32)}:${h.substr(2)}`)}u+=n(h,!0)}return v&&(u+="?",u+=n(v,!1)),w&&(u+="#",u+=i?w:L(w,!1)),u}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(r){return r.match(o)?r.replace(o,i=>m(i)):r}}),define(pe[59],ve([0,1,22,8,2]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(R){return JSON.stringify(R,_)}e.stringify=D;function T(R){let y=JSON.parse(R);return y=P(y),y}e.parse=T;var I;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext",R[R.Date=14]="Date"})(I=e.MarshalledId||(e.MarshalledId={}));function _(R,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function P(R,y=0){if(!R||y>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return k.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof f.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let l=0;l<R.length;++l)R[l]=P(R[l],y+1);else for(const l in R)Object.hasOwnProperty.call(R,l)&&(R[l]=P(R[l],y+1))}return R}e.revive=P}),define(pe[10],ve([0,1,12,2]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(k=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,P,R){this._hosts[_]=P,this._ports[_]=R}setConnectionToken(_,P){this._connectionTokens[_]=P}rewrite(_){if(this._delegate)return this._delegate(_);const P=_.authority;let R=this._hosts[P];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const y=this._ports[P],l=this._connectionTokens[P];let b=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(b+=`&tkn=${encodeURIComponent(l)}`),t.URI.from({scheme:f.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${R}:${y}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new D;class T{asBrowserUri(_,P){const R=this.toUri(_,P);return R.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===k.file&&(f.isNative||typeof f.globals.importScripts=="function"&&f.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?R.with({scheme:k.vscodeFileResource,authority:R.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(_,P){const R=this.toUri(_,P);return R.scheme===k.vscodeFileResource?R.with({scheme:k.file,authority:R.authority!==T.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(_,P){return t.URI.isUri(_)?_:t.URI.parse(P.toUrl(_))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(pe[23],ve([0,1,29,10,9,12,8,2]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(b){return(0,I.uriToFsPath)(b,!0)}e.originalFSPath=_;class P{constructor(p){this._ignorePathCasing=p}compare(p,g,E=!1){return p===g?0:(0,T.compare)(this.getComparisonKey(p,E),this.getComparisonKey(g,E))}isEqual(p,g,E=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,E)===this.getComparisonKey(g,E)}getComparisonKey(p,g=!1){return p.with({path:this._ignorePathCasing(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this._ignorePathCasing(p)}isEqualOrParent(p,g,E=!1){if(p.scheme===g.scheme){if(p.scheme===t.Schemas.file)return f.isEqualOrParent(_(p),_(g),this._ignorePathCasing(p))&&p.query===g.query&&(E||p.fragment===g.fragment);if((0,e.isEqualAuthority)(p.authority,g.authority))return f.isEqualOrParent(p.path,g.path,this._ignorePathCasing(p),"/")&&p.query===g.query&&(E||p.fragment===g.fragment)}return!1}joinPath(p,...g){return I.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return k.posix.basename(p.path)}extname(p){return k.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===t.Schemas.file?g=I.URI.file(k.dirname(_(p))).path:(g=k.posix.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===t.Schemas.file?g=I.URI.file(k.normalize(_(p))).path:g=k.posix.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.isEqualAuthority)(p.authority,g.authority))return;if(p.scheme===t.Schemas.file){const C=k.relative(_(p),_(g));return D.isWindows?f.toSlashes(C):C}let E=p.path||"/",L=g.path||"/";if(this._ignorePathCasing(p)){let C=0;for(const a=Math.min(E.length,L.length);C<a&&!(E.charCodeAt(C)!==L.charCodeAt(C)&&E.charAt(C).toLowerCase()!==L.charAt(C).toLowerCase());C++);E=L.substr(0,C)+E.substr(C)}return k.posix.relative(E,L)}resolvePath(p,g){if(p.scheme===t.Schemas.file){const E=I.URI.file(k.resolve(_(p),g));return p.with({authority:E.authority,path:E.path})}return g=f.toPosixPath(g),p.with({path:k.posix.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,T.equalsIgnoreCase)(p,g)}hasTrailingPathSeparator(p,g=k.sep){if(p.scheme===t.Schemas.file){const E=_(p);return E.length>f.getRoot(E).length&&E[E.length-1]===g}else{const E=p.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=k.sep){return(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=k.sep){let E=!1;if(p.scheme===t.Schemas.file){const L=_(p);E=L!==void 0&&L.length===f.getRoot(L).length&&L[L.length-1]===g}else{g="/";const L=p.path;E=L.length===1&&L.charCodeAt(L.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(p,g)?p.with({path:p.path+"/"}):p}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(b=>b.scheme===t.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new P(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(b,p){const g=[];for(let E=0;E<b.length;E++){const L=p(b[E]);b.some((C,a)=>a===E?!1:(0,e.isEqualOrParent)(L,p(C)))||g.push(b[E])}return g}e.distinctParents=R;var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(a=>{const[s,m]=a.split(":");s&&m&&E.set(s,m)});const C=g.path.substring(0,g.path.indexOf(";"));return C&&E.set(b.META_DATA_MIME,C),E}b.parseMetaData=p})(y=e.DataUri||(e.DataUri={}));function l(b,p,g){if(p){let E=b.path;return E&&E[0]!==k.posix.sep&&(E=k.posix.sep+E),b.with({scheme:g,authority:p,path:E})}return b.with({scheme:g})}e.toLocalResource=l}),define(pe[18],ve([0,1,21,16,3,6,23,12]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(K){return!!K&&typeof K.then=="function"}e.isThenable=_;function P(K){const Q=new f.CancellationTokenSource,ae=K(Q.token),fe=new Promise((be,Me)=>{const ze=Q.token.onCancellationRequested(()=>{ze.dispose(),Q.dispose(),Me(new t.CancellationError)});Promise.resolve(ae).then(Ge=>{ze.dispose(),Q.dispose(),be(Ge)},Ge=>{ze.dispose(),Q.dispose(),Me(Ge)})});return new class{cancel(){Q.cancel()}then(be,Me){return fe.then(be,Me)}catch(be){return this.then(void 0,be)}finally(be){return fe.finally(be)}}}e.createCancelablePromise=P;function R(K,Q,ae){return new Promise((fe,be)=>{const Me=Q.onCancellationRequested(()=>{Me.dispose(),fe(ae)});K.then(fe,be).finally(()=>Me.dispose())})}e.raceCancellation=R;function y(K,Q){return new Promise((ae,fe)=>{const be=Q.onCancellationRequested(()=>{be.dispose(),fe(new t.CancellationError)});K.then(ae,fe).finally(()=>be.dispose())})}e.raceCancellationError=y;async function l(K){let Q=-1;const ae=K.map((be,Me)=>be.then(ze=>(Q=Me,ze))),fe=await Promise.race(ae);return K.forEach((be,Me)=>{Me!==Q&&be.cancel()}),fe}e.raceCancellablePromises=l;function b(K,Q,ae){let fe;const be=setTimeout(()=>{fe?.(void 0),ae?.()},Q);return Promise.race([K.finally(()=>clearTimeout(be)),new Promise(Me=>fe=Me)])}e.raceTimeout=b;function p(K){return new Promise((Q,ae)=>{const fe=K();_(fe)?fe.then(Q,ae):Q(fe)})}e.asPromise=p;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const ae=()=>{this.queuedPromise=null;const fe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,fe};this.queuedPromise=new Promise(fe=>{this.activePromise.then(ae,ae).then(fe)})}return new Promise((ae,fe)=>{this.queuedPromise.then(ae,fe)})}return this.activePromise=Q(),new Promise((ae,fe)=>{this.activePromise.then(be=>{this.activePromise=null,ae(be)},be=>{this.activePromise=null,fe(be)})})}}e.Throttler=g;class E{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=E;class L{constructor(){this.promiseMap=new Map}queue(Q,ae){const be=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.promiseMap.get(Q)===be&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,be),be}}e.SequencerByKey=L;const C=(K,Q)=>{let ae=!0;const fe=setTimeout(()=>{ae=!1,Q()},K);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(fe),ae=!1}}},a=K=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,K())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,ae=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((be,Me)=>{this.doResolve=be,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const be=this.task;return this.task=null,be()}}));const fe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ae===e.MicrotaskDelay?a(fe):C(ae,fe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class m{constructor(Q){this.delayer=new s(Q),this.throttler=new g}trigger(Q,ae){return this.delayer.trigger(()=>this.throttler.queue(Q),ae)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class o{constructor(){this._isOpen=!1,this._promise=new Promise((Q,ae)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class S extends o{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function r(K,Q){return Q?new Promise((ae,fe)=>{const be=setTimeout(()=>{Me.dispose(),ae()},K),Me=Q.onCancellationRequested(()=>{clearTimeout(be),Me.dispose(),fe(new t.CancellationError)})}):P(ae=>r(K,ae))}e.timeout=r;function i(K,Q=0){const ae=setTimeout(K,Q);return(0,D.toDisposable)(()=>clearTimeout(ae))}e.disposableTimeout=i;function n(K){const Q=[];let ae=0;const fe=K.length;function be(){return ae<fe?K[ae++]():null}function Me(ze){ze!=null&&Q.push(ze);const Ge=be();return Ge?Ge.then(Me):Promise.resolve(Q)}return Promise.resolve(null).then(Me)}e.sequence=n;function u(K,Q=fe=>!!fe,ae=null){let fe=0;const be=K.length,Me=()=>{if(fe>=be)return Promise.resolve(ae);const ze=K[fe++];return Promise.resolve(ze()).then(Je=>Q(Je)?Promise.resolve(Je):Me())};return Me()}e.first=u;function c(K,Q=fe=>!!fe,ae=null){if(K.length===0)return Promise.resolve(ae);let fe=K.length;const be=()=>{fe=-1;for(const Me of K)Me.cancel?.()};return new Promise((Me,ze)=>{for(const Ge of K)Ge.then(Je=>{--fe>=0&&Q(Je)?(be(),Me(Je)):fe===0&&Me(ae)}).catch(Je=>{--fe>=0&&(be(),ze(Je))})})}e.firstParallel=c;class d{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((ae,fe)=>{this.outstandingPromises.push({factory:Q,c:ae,e:fe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const ae=Q.factory();ae.then(Q.c,Q.e),ae.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class h extends d{constructor(){super(1)}}e.Queue=h;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new W;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,ae=T.extUri){const fe=ae.getComparisonKey(Q);let be=this.queues.get(fe);return be||(be=new h,k.Event.once(be.onFinished)(()=>{be?.dispose(),this.queues.delete(fe),this.onDidQueueFinish()}),this.queues.set(fe,be)),be}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class w{constructor(Q,ae){this._token=-1,typeof Q=="function"&&typeof ae=="number"&&this.setIfNotSet(Q,ae)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,ae){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},ae)}setIfNotSet(Q,ae){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},ae))}}e.TimeoutTimer=w;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,ae){this.cancel(),this._token=setInterval(()=>{Q()},ae)}}e.IntervalTimer=A;class O{constructor(Q,ae){this.timeoutToken=-1,this.runner=Q,this.timeout=ae,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class N{constructor(Q,ae){ae%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=ae,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class F extends O{constructor(Q,ae){super(Q,ae);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class M extends D.Disposable{constructor(Q,ae){super();this.options=Q,this.handler=ae,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,I.setTimeout0)(()=>{if(Q)return;const ae=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(K,Q)=>{const ae=requestIdleCallback(K,typeof Q=="number"?{timeout:Q}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(ae))}}}}();class V{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function $(K,Q,ae){let fe;for(let be=0;be<ae;be++)try{return await K()}catch(Me){fe=Me,await r(Q)}throw fe}e.retry=$;class U{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,ae,fe){return this._pending={taskId:Q,cancel:()=>fe?.(),promise:ae},ae.then(()=>this.donePending(Q),()=>this.donePending(Q)),ae}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let ae,fe;const be=new Promise((Me,ze)=>{ae=Me,fe=ze});this._next={run:Q,promise:be,promiseResolve:ae,promiseReject:fe}}return this._next.promise}}e.TaskSequentializer=U;class B{constructor(Q,ae=()=>Date.now()){this.interval=Q,this.nowFn=ae,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,ae)=>{this.completeCallback=Q,this.errorCallback=ae})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(ae=>{this.completeCallback(Q),this.resolved=!0,ae()})}error(Q){return new Promise(ae=>{this.errorCallback(Q),this.rejected=!0,ae()})}cancel(){new Promise(Q=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=W;var H;(function(K){async function Q(fe){let be;const Me=await Promise.all(fe.map(ze=>ze.then(Ge=>Ge,Ge=>{be||(be=Ge)})));if(typeof be!="undefined")throw be;return Me}K.settled=Q;function ae(fe){return new Promise(async(be,Me)=>{try{await fe(be,Me)}catch(ze){Me(ze)}})}K.withAsyncBody=ae})(H=e.Promises||(e.Promises={}));var x;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(x||(x={}));class J{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const ae={emitOne:fe=>this.emitOne(fe),emitMany:fe=>this.emitMany(fe),reject:fe=>this.reject(fe)};try{await Promise.resolve(Q(ae)),this.resolve()}catch(fe){this.reject(fe)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}static fromArray(Q){return new J(ae=>{ae.emitMany(Q)})}static fromPromise(Q){return new J(async ae=>{ae.emitMany(await Q)})}static fromPromises(Q){return new J(async ae=>{await Promise.all(Q.map(async fe=>ae.emitOne(await fe)))})}static merge(Q){return new J(async ae=>{await Promise.all(Q.map(async fe=>{for await(const be of fe)ae.emitOne(be)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,ae){return new J(async fe=>{for await(const be of Q)fe.emitOne(ae(be))})}map(Q){return J.map(this,Q)}static filter(Q,ae){return new J(async fe=>{for await(const be of Q)ae(be)&&fe.emitOne(be)})}filter(Q){return J.filter(this,Q)}static coalesce(Q){return J.filter(Q,ae=>!!ae)}coalesce(){return J.coalesce(this)}static async toPromise(Q){const ae=[];for await(const fe of Q)ae.push(fe);return ae}toPromise(){return J.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ne extends J{constructor(Q,ae){super(ae);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function se(K){const Q=new f.CancellationTokenSource,ae=K(Q.token);return new ne(Q,async fe=>{const be=Q.token.onCancellationRequested(()=>{be.dispose(),Q.dispose(),fe.reject(new t.CancellationError)});try{for await(const Me of ae){if(Q.token.isCancellationRequested)return;fe.emitOne(Me)}be.dispose(),Q.dispose()}catch(Me){be.dispose(),Q.dispose(),fe.reject(Me)}})}e.createCancelableAsyncIterable=se}),define(pe[101],ve([0,1,18,9]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new f.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),D=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(h,v,w=!1){const A=h||"",O=v||"",N=k.value.collator.compare(A,O);return k.value.collatorIsNumeric&&N===0&&A!==O?A<O?-1:1:N}e.compareFileNames=I;function _(h,v){const w=D.value.collator;return h=h||"",v=v||"",m(w,h,v)}e.compareFileNamesDefault=_;function P(h,v){const w=D.value.collator;return h=h||"",v=v||"",i(h,v)||m(w,h,v)}e.compareFileNamesUpper=P;function R(h,v){const w=D.value.collator;return h=h||"",v=v||"",r(h,v)||m(w,h,v)}e.compareFileNamesLower=R;function y(h,v){return h=h||"",v=v||"",h===v?0:h<v?-1:1}e.compareFileNamesUnicode=y;function l(h,v,w=!1){w||(h=h&&h.toLowerCase(),v=v&&v.toLowerCase());const[A,O]=a(h),[N,F]=a(v);return A!==N?A<N?-1:1:O===F?0:O<F?-1:1}e.noIntlCompareFileNames=l;function b(h,v){const[w,A]=a(h),[O,N]=a(v);let F=k.value.collator.compare(A,N);if(F===0){if(k.value.collatorIsNumeric&&A!==N)return A<N?-1:1;if(F=k.value.collator.compare(w,O),k.value.collatorIsNumeric&&F===0&&w!==O)return w<O?-1:1}return F}e.compareFileExtensions=b;function p(h,v){h=h||"",v=v||"";const w=s(h),A=s(v),O=D.value.collator,N=T.value.collator;return m(N,w,A)||m(O,h,v)}e.compareFileExtensionsDefault=p;function g(h,v){h=h||"",v=v||"";const w=s(h),A=s(v),O=D.value.collator,N=T.value.collator;return m(N,w,A)||i(h,v)||m(O,h,v)}e.compareFileExtensionsUpper=g;function E(h,v){h=h||"",v=v||"";const w=s(h),A=s(v),O=D.value.collator,N=T.value.collator;return m(N,w,A)||r(h,v)||m(O,h,v)}e.compareFileExtensionsLower=E;function L(h,v){h=h||"",v=v||"";const w=s(h).toLowerCase(),A=s(v).toLowerCase();return w!==A?w<A?-1:1:h!==v?h<v?-1:1:0}e.compareFileExtensionsUnicode=L;const C=/^(.*?)(\.([^.]*))?$/;function a(h,v=!1){const w=h?C.exec(h):[];let A=[w&&w[1]||"",w&&w[3]||""];return v&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function s(h){const v=h?C.exec(h):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function m(h,v,w){let A=h.compare(v,w);return A!==0?A:v.length!==w.length?v.length<w.length?-1:1:0}function o(h){const v=h.charAt(0);return v.toLocaleUpperCase()!==v}function S(h){const v=h.charAt(0);return v.toLocaleLowerCase()!==v}function r(h,v){return o(h)&&S(v)?-1:S(h)&&o(v)?1:0}function i(h,v){return S(h)&&o(v)?-1:o(h)&&S(v)?1:0}function n(h,v,w=!1){return w||(h=h&&h.toLowerCase(),v=v&&v.toLowerCase()),h===v?0:h<v?-1:1}function u(h,v,w=!1){const A=h.split(t.sep),O=v.split(t.sep),N=A.length-1,F=O.length-1;let M,V;for(let $=0;;$++){if(M=N===$,V=F===$,M&&V)return I(A[$],O[$],w);if(M)return-1;if(V)return 1;const U=n(A[$],O[$],w);if(U!==0)return U}}e.comparePaths=u;function c(h,v,w){const A=h.toLowerCase(),O=v.toLowerCase(),N=d(h,v,w);if(N)return N;const F=A.endsWith(w),M=O.endsWith(w);if(F!==M)return F?-1:1;const V=I(A,O);return V!==0?V:A.localeCompare(O)}e.compareAnything=c;function d(h,v,w){const A=h.toLowerCase(),O=v.toLowerCase(),N=A.startsWith(w),F=O.startsWith(w);if(N!==F)return N?-1:1;if(N&&F){if(A.length<O.length)return-1;if(A.length>O.length)return 1}return 0}e.compareByPrefix=d}),define(pe[102],ve([0,1,101,98,58,9,12,8]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,P=[_,[]];function R(U,B,W,H){if(!U||!B)return P;const x=U.length,J=B.length;if(x<J)return P;const ne=U.toLowerCase();return y(B,W,J,U,ne,x,H)}e.scoreFuzzy=R;function y(U,B,W,H,x,J,ne){const se=[],K=[];for(let be=0;be<W;be++){const Me=be*J,ze=Me-J,Ge=be>0,Je=U[be],q=B[be];for(let te=0;te<J;te++){const G=te>0,X=Me+te,oe=X-1,me=ze+te-1,Ie=G?se[oe]:0,xe=Ge&&G?se[me]:0,Ye=Ge&&G?K[me]:0;let it;!xe&&Ge?it=0:it=l(Je,q,H,x,te,Ye),it&&xe+it>=Ie&&(ne||Ge||x.startsWith(B,te))?(K[X]=Ye+1,se[X]=xe+it):(K[X]=_,se[X]=Ie)}}const Q=[];let ae=W-1,fe=J-1;for(;ae>=0&&fe>=0;){const be=ae*J+fe;K[be]===_||(Q.push(fe),ae--),fe--}return[se[W*J-1],Q.reverse()]}function l(U,B,W,H,x,J){let ne=0;if(!b(B,H[x]))return ne;if(ne+=1,J>0&&(ne+=J*5),U===W[x]&&(ne+=1),x===0)ne+=8;else{const se=p(W.charCodeAt(x-1));se?ne+=se:(0,t.isUpper)(W.charCodeAt(x))&&J===0&&(ne+=2)}return ne}function b(U,B){return U===B?!0:U==="/"||U==="\\"?B==="/"||B==="\\":!1}function p(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function E(U,B,W=0,H=0){const x=B;return x.values&&x.values.length>1?L(U,x.values,W,H):C(U,B,W,H)}e.scoreFuzzy2=E;function L(U,B,W,H){let x=0;const J=[];for(const ne of B){const[se,K]=C(U,ne,W,H);if(typeof se!="number")return g;x+=se,J.push(...K)}return[x,d(J)]}function C(U,B,W,H){const x=(0,t.fuzzyScore)(B.original,B.originalLowercase,W,U,U.toLowerCase(),H,!0);return x?[x[0],(0,t.createMatches)(x)]:g}const a=Object.freeze({score:0}),s=1<<18,m=1<<17,o=1<<16;function S(U,B,W,H){const x=H.values?H.values:[H];return(0,k.hash)({[H.normalized]:{values:x.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:U,description:B,allowNonContiguousMatches:W}})}function r(U,B,W,H,x){if(!U||!B.normalized)return a;const J=H.getItemLabel(U);if(!J)return a;const ne=H.getItemDescription(U),se=S(J,ne,W,B),K=x[se];if(K)return K;const Q=i(J,ne,H.getItemPath(U),B,W);return x[se]=Q,Q}e.scoreItemFuzzy=r;function i(U,B,W,H,x){const J=!W||!H.containsPathSeparator;return W&&(T.isLinux?H.pathNormalized===W:(0,I.equalsIgnoreCase)(H.pathNormalized,W))?{score:s,labelMatch:[{start:0,end:U.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:H.values&&H.values.length>1?n(U,B,W,H.values,J,x):u(U,B,W,H,J,x)}function n(U,B,W,H,x,J){let ne=0;const se=[],K=[];for(const Q of H){const{score:ae,labelMatch:fe,descriptionMatch:be}=u(U,B,W,Q,x,J);if(ae===_)return a;ne+=ae,fe&&se.push(...fe),be&&K.push(...be)}return{score:ne,labelMatch:d(se),descriptionMatch:d(K)}}function u(U,B,W,H,x,J){if(x||!B){const[ne,se]=R(U,H.normalized,H.normalizedLowercase,J&&!H.expectContiguousMatch);if(ne){const K=(0,t.matchesPrefix)(H.normalized,U);let Q;return K?(Q=m,Q+=Math.round(H.normalized.length/U.length*100)):Q=o,{score:Q+ne,labelMatch:K||c(se)}}}if(B){let ne=B;W&&(ne=`${B}${D.sep}`);const se=ne.length,K=`${ne}${U}`,[Q,ae]=R(K,H.normalized,H.normalizedLowercase,J&&!H.expectContiguousMatch);if(Q){const fe=c(ae),be=[],Me=[];return fe.forEach(ze=>{ze.start<se&&ze.end>se?(be.push({start:0,end:ze.end-se}),Me.push({start:ze.start,end:se})):ze.start>=se?be.push({start:ze.start-se,end:ze.end-se}):Me.push(ze)}),{score:Q,labelMatch:be,descriptionMatch:Me}}}return a}function c(U){const B=[];if(!U)return B;let W;for(const H of U)W&&W.end===H?W.end+=1:(W={start:H,end:H+1},B.push(W));return B}function d(U){const B=U.sort((x,J)=>x.start-J.start),W=[];let H;for(const x of B)!H||!h(H,x)?(H=x,W.push(x)):(H.start=Math.min(H.start,x.start),H.end=Math.max(H.end,x.end));return W}function h(U,B){return!(U.end<B.start||B.end<U.start)}function v(U,B,W,H,x,J){const ne=r(U,W,H,x,J),se=r(B,W,H,x,J),K=ne.score,Q=se.score;if((K===s||Q===s)&&K!==Q)return K===s?-1:1;if(K>o||Q>o){if(K!==Q)return K>Q?-1:1;if(K<m&&Q<m){const Je=A(ne.labelMatch,se.labelMatch);if(Je!==0)return Je}const ze=x.getItemLabel(U)||"",Ge=x.getItemLabel(B)||"";if(ze.length!==Ge.length)return ze.length-Ge.length}if(K!==Q)return K>Q?-1:1;const ae=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,fe=Array.isArray(se.labelMatch)&&se.labelMatch.length>0;if(ae&&!fe)return-1;if(fe&&!ae)return 1;const be=w(U,ne,x),Me=w(B,se,x);return be&&Me&&be!==Me?Me>be?-1:1:O(U,B,W,x)}e.compareItemsByFuzzyScore=v;function w(U,B,W){let H=-1,x=-1;if(B.descriptionMatch&&B.descriptionMatch.length?H=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(H=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(x=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const J=W.getItemDescription(U);J&&(x+=J.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(x=B.descriptionMatch[B.descriptionMatch.length-1].end);return x-H}function A(U,B){if(!U&&!B||(!U||!U.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!U||!U.length)return 1;const W=U[0].start,x=U[U.length-1].end-W,J=B[0].start,se=B[B.length-1].end-J;return x===se?0:se<x?1:-1}function O(U,B,W,H){const x=H.getItemLabel(U)||"",J=H.getItemLabel(B)||"",ne=H.getItemDescription(U),se=H.getItemDescription(B),K=x.length+(ne?ne.length:0),Q=J.length+(se?se.length:0);if(K!==Q)return K-Q;const ae=H.getItemPath(U),fe=H.getItemPath(B);return ae&&fe&&ae.length!==fe.length?ae.length-fe.length:x!==J?(0,f.compareAnything)(x,J,W.normalized):ne&&se&&ne!==se?(0,f.compareAnything)(ne,se,W.normalized):ae&&fe&&ae!==fe?(0,f.compareAnything)(ae,fe,W.normalized):0}function N(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function M(U){typeof U!="string"&&(U="");const B=U.toLowerCase(),{pathNormalized:W,normalized:H,normalizedLowercase:x}=V(U),J=W.indexOf(D.sep)>=0,ne=N(U);let se;const K=U.split(F);if(K.length>1)for(const Q of K){const ae=N(Q),{pathNormalized:fe,normalized:be,normalizedLowercase:Me}=V(Q);be&&(se||(se=[]),se.push({original:Q,originalLowercase:Q.toLowerCase(),pathNormalized:fe,normalized:be,normalizedLowercase:Me,expectContiguousMatch:ae}))}return{original:U,originalLowercase:B,pathNormalized:W,normalized:H,normalizedLowercase:x,values:se,containsPathSeparator:J,expectContiguousMatch:ne}}e.prepareQuery=M;function V(U){let B;T.isWindows?B=U.replace(/\//g,D.sep):B=U.replace(/\\/g,D.sep);const W=(0,I.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:W,normalizedLowercase:W.toLowerCase()}}function $(U){return Array.isArray(U)?M(U.map(B=>B.original).join(F)):M(U.original)}e.pieceToQuery=$}),define(pe[32],ve([0,1,18,29,24,9,8]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const _="[/\\\\]",P="[^/\\\\]",R=/\//g;function y(B){switch(B){case 0:return"";case 1:return`${P}*?`;default:return`(?:${_}|${P}+${_}|${_}${P}+)*?`}}function l(B,W){if(!B)return[];const H=[];let x=!1,J=!1,ne="";for(const se of B){switch(se){case W:if(!x&&!J){H.push(ne),ne="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":J=!0;break;case"]":J=!1;break}ne+=se}return ne&&H.push(ne),H}e.splitGlobAware=l;function b(B){if(!B)return"";let W="";const H=l(B,e.GLOB_SPLIT);if(H.every(x=>x===e.GLOBSTAR))W=".*";else{let x=!1;H.forEach((J,ne)=>{if(J===e.GLOBSTAR){x||(W+=y(2),x=!0);return}let se=!1,K="",Q=!1,ae="";for(const fe of J){if(fe!=="}"&&se){K+=fe;continue}if(Q&&(fe!=="]"||!ae)){let be;fe==="-"?be=fe:(fe==="^"||fe==="!")&&!ae?be="^":fe===e.GLOB_SPLIT?be="":be=T.escapeRegExpCharacters(fe),ae+=be;continue}switch(fe){case"{":se=!0;continue;case"[":Q=!0;continue;case"}":{W+=`(?:${l(K,",").map(ze=>b(ze)).join("|")})`,se=!1,K="";break}case"]":W+="["+ae+"]",Q=!1,ae="";break;case"?":W+=P;continue;case"*":W+=y(1);continue;default:W+=T.escapeRegExpCharacters(fe)}}ne<H.length-1&&(H[ne+1]!==e.GLOBSTAR||ne+2<H.length)&&(W+=_),x=!1})}return W}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,L=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new k.LRUCache(1e4),m=function(){return!1},o=function(){return null};function S(B,W){if(!B)return o;let H;typeof B!="string"?H=B.pattern:H=B,H=H.trim();const x=`${H}_${!!W.trimForExclusions}`;let J=s.get(x);if(J)return r(J,B);let ne;if(p.test(H)){const se=H.substr(4);J=function(K,Q){return typeof K=="string"&&K.endsWith(se)?H:null}}else(ne=g.exec(i(H,W)))?J=n(ne[1],H):(W.trimForExclusions?L:E).test(H)?J=u(H,W):(ne=C.exec(i(H,W)))?J=c(ne[1].substr(1),H,!0):(ne=a.exec(i(H,W)))?J=c(ne[1],H,!1):J=d(H);return s.set(x,J),r(J,B)}function r(B,W){return typeof W=="string"?B:function(H,x){return t.isEqualOrParent(H,W.base)?B(D.relative(W.base,H),x):null}}function i(B,W){return W.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function n(B,W){const H=`/${B}`,x=`\\${B}`,J=function(se,K){return typeof se!="string"?null:K?K===B?W:null:se===B||se.endsWith(H)||se.endsWith(x)?W:null},ne=[B];return J.basenames=ne,J.patterns=[W],J.allBasenames=ne,J}function u(B,W){const H=U(B.slice(1,-1).split(",").map(K=>S(K,W)).filter(K=>K!==o),B),x=H.length;if(!x)return o;if(x===1)return H[0];const J=function(K,Q){for(let ae=0,fe=H.length;ae<fe;ae++)if(H[ae](K,Q))return B;return null},ne=H.find(K=>!!K.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=H.reduce((K,Q)=>Q.allPaths?K.concat(Q.allPaths):K,[]);return se.length&&(J.allPaths=se),J}function c(B,W,H){const x=D.sep===D.posix.sep,J=x?B:B.replace(R,D.sep),ne=D.sep+J,se=D.posix.sep+B,K=H?function(Q,ae){return typeof Q=="string"&&(Q===J||Q.endsWith(ne)||!x&&(Q===B||Q.endsWith(se)))?W:null}:function(Q,ae){return typeof Q=="string"&&(Q===J||!x&&Q===B)?W:null};return K.allPaths=[(H?"*/":"./")+B],K}function d(B){try{const W=new RegExp(`^${b(B)}$`);return function(H){return W.lastIndex=0,typeof H=="string"&&W.test(H)?B:null}}catch{return o}}function h(B,W,H){return!B||typeof W!="string"?!1:v(B)(W,void 0,H)}e.match=h;function v(B,W={}){if(!B)return m;if(typeof B=="string"||N(B)){const H=S(B,W);if(H===o)return m;const x=function(J,ne){return!!H(J,ne)};return H.allBasenames&&(x.allBasenames=H.allBasenames),H.allPaths&&(x.allPaths=H.allPaths),x}return V(B,W)}e.parse=v;function w(B){if(!B)return;let W;return H=>(W||(W=(B()||Promise.resolve([])).then(x=>x?O(x):{})),W.then(x=>!!x[H]))}e.hasSiblingPromiseFn=w;function A(B){if(!B)return;let W;return H=>{if(!W){const x=B();W=x?O(x):{}}return!!W[H]}}e.hasSiblingFn=A;function O(B){const W={};for(const H of B)W[H]=!0;return W}function N(B){const W=B;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=N;function F(B){return B.allBasenames||[]}e.getBasenameTerms=F;function M(B){return B.allPaths||[]}e.getPathTerms=M;function V(B,W){const H=U(Object.getOwnPropertyNames(B).map(K=>$(K,B[K],W)).filter(K=>K!==o)),x=H.length;if(!x)return o;if(!H.some(K=>!!K.requiresSiblings)){if(x===1)return H[0];const K=function(fe,be){for(let Me=0,ze=H.length;Me<ze;Me++){const Ge=H[Me](fe,be);if(Ge)return Ge}return null},Q=H.find(fe=>!!fe.allBasenames);Q&&(K.allBasenames=Q.allBasenames);const ae=H.reduce((fe,be)=>be.allPaths?fe.concat(be.allPaths):fe,[]);return ae.length&&(K.allPaths=ae),K}const J=function(K,Q,ae){let fe;for(let be=0,Me=H.length;be<Me;be++){const ze=H[be];ze.requiresSiblings&&ae&&(Q||(Q=D.basename(K)),fe||(fe=Q.substr(0,Q.length-D.extname(K).length)));const Ge=ze(K,Q,fe,ae);if(Ge)return Ge}return null},ne=H.find(K=>!!K.allBasenames);ne&&(J.allBasenames=ne.allBasenames);const se=H.reduce((K,Q)=>Q.allPaths?K.concat(Q.allPaths):K,[]);return se.length&&(J.allPaths=se),J}function $(B,W,H){if(W===!1)return o;const x=S(B,H);if(x===o)return o;if(typeof W=="boolean")return x;if(W){const J=W.when;if(typeof J=="string"){const ne=(se,K,Q,ae)=>{if(!ae||!x(se,K))return null;const fe=J.replace("$(basename)",Q),be=ae(fe);return(0,f.isThenable)(be)?be.then(Me=>Me?B:null):be?B:null};return ne.requiresSiblings=!0,ne}}return x}function U(B,W){const H=B.filter(K=>!!K.basenames);if(H.length<2)return B;const x=H.reduce((K,Q)=>{const ae=Q.basenames;return ae?K.concat(ae):K},[]);let J;if(W){J=[];for(let K=0,Q=x.length;K<Q;K++)J.push(W)}else J=H.reduce((K,Q)=>{const ae=Q.patterns;return ae?K.concat(ae):K},[]);const ne=function(K,Q){if(typeof K!="string")return null;if(!Q){let fe;for(fe=K.length;fe>0;fe--){const be=K.charCodeAt(fe-1);if(be===47||be===92)break}Q=K.substr(fe)}const ae=x.indexOf(Q);return ae!==-1?J[ae]:null};ne.basenames=x,ne.patterns=J,ne.allBasenames=x;const se=B.filter(K=>!K.basenames);return se.push(ne),se}}),define(pe[80],ve([0,1,29,10,9,12,23,8,2]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,n,u){if(typeof i=="string"&&(i=_.URI.file(i)),u){const d=u.getWorkspaceFolder(i);if(d){const h=u.getWorkspace().folders.length>1;let v;if((0,T.isEqual)(d.uri,i)?v="":v=(0,T.relativePath)(d.uri,i),h){const w=d.name?d.name:(0,T.basename)(d.uri);v=v?w+" \u2022 "+v:w}return v}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(i.fsPath))return(0,k.normalize)(y(i.fsPath));let c=(0,k.normalize)(i.fsPath);return!D.isWindows&&n?.userHome&&(c=b(c,n.userHome.fsPath)),c}e.getPathLabel=P;function R(i){if(!i)return;typeof i=="string"&&(i=_.URI.file(i));const n=(0,T.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,f.isRootOrDriveLetter)(n)?y(n):n}e.getBaseLabel=R;function y(i,n){return(0,f.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let l=Object.create(null);function b(i,n){if(D.isWindows||!i||!n)return i;let u=l.original===n?l.normalized:void 0;return u||(u=`${(0,I.rtrim)(n,k.posix.sep)}${k.posix.sep}`,l={original:n,normalized:u}),(D.isLinux?i.startsWith(u):(0,I.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=b;function p(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=p;const g="\u2026",E="\\\\",L="~";function C(i,n=k.sep){const u=new Array(i.length);let c=!1;for(let d=0;d<i.length;d++){let h=i[d];if(h===""){u[d]=`.${n}`;continue}if(!h){u[d]=h;continue}c=!0;let v="";h.indexOf(E)===0?(v=h.substr(0,h.indexOf(E)+E.length),h=h.substr(h.indexOf(E)+E.length)):h.indexOf(n)===0?(v=h.substr(0,h.indexOf(n)+n.length),h=h.substr(h.indexOf(n)+n.length)):h.indexOf(L)===0&&(v=h.substr(0,h.indexOf(L)+L.length),h=h.substr(h.indexOf(L)+L.length));const w=h.split(n);for(let A=1;c&&A<=w.length;A++)for(let O=w.length-A;c&&O>=0;O--){c=!1;let N=w.slice(O,O+A).join(n);for(let F=0;!c&&F<i.length;F++)if(F!==d&&i[F]&&i[F].indexOf(N)>-1){const M=O+A===w.length,V=O>0&&i[F].indexOf(n)>-1?n+N:N,$=i[F].endsWith(V);c=!M||$}if(!c){let F="";(w[0].endsWith(":")||v!=="")&&(O===1&&(O=0,A++,N=w[0]+n+N),O>0&&(F=w[0]+n),F=v+F),O>0&&(F=F+g+n),F=F+N,O+A<w.length&&(F=F+n+g),u[d]=F}}c&&(u[d]=h)}return u}e.shorten=C;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function s(i,n=Object.create(null)){const u=[];let c=!1,d="";for(const h of i)if(h==="$"||c&&h==="{")d&&u.push({value:d,type:a.TEXT}),d="",c=!0;else if(h==="}"&&c){const v=n[d];if(typeof v=="string")v.length&&u.push({value:v,type:a.VARIABLE});else if(v){const w=u[u.length-1];(!w||w.type!==a.SEPARATOR)&&u.push({value:v.label,type:a.SEPARATOR})}d="",c=!1}else d+=h;return d&&!c&&u.push({value:d,type:a.TEXT}),u.filter((h,v)=>{if(h.type===a.SEPARATOR){const w=u[v-1],A=u[v+1];return[w,A].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=s;function m(i,n){return D.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function o(i,n){return D.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function r(i){const n=i.indexOf("/")!==-1?k.posix:k.win32,u=n.basename(i),c=n.dirname(i);return u.length?{name:u,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(pe[103],ve([0,1,2]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class k{constructor(y){this._uriTransformer=y}transformIncoming(y){const l=this._uriTransformer.transformIncoming(y);return l===y?y:t(f.URI.from(l))}transformOutgoing(y){const l=this._uriTransformer.transformOutgoing(y);return l===y?y:t(f.URI.from(l))}transformOutgoingURI(y){const l=this._uriTransformer.transformOutgoing(y);return l===y?y:f.URI.from(l)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function D(R,y,l){if(!R||l>200)return null;if(typeof R=="object"){if(R instanceof f.URI)return y.transformOutgoing(R);for(let b in R)if(Object.hasOwnProperty.call(R,b)){const p=D(R[b],y,l+1);p!==null&&(R[b]=p)}}return null}function T(R,y){const l=D(R,y,0);return l===null?R:l}e.transformOutgoingURIs=T;function I(R,y,l,b){if(!R||b>200)return null;if(typeof R=="object"){if(R.$mid===1)return l?f.URI.revive(y.transformIncoming(R)):y.transformIncoming(R);for(let p in R)if(Object.hasOwnProperty.call(R,p)){const g=I(R[p],y,l,b+1);g!==null&&(R[p]=g)}}return null}function _(R,y){const l=I(R,y,!1,0);return l===null?R:l}e.transformIncomingURIs=_;function P(R,y){const l=I(R,y,!0,0);return l===null?R:l}e.transformAndReviveIncomingURIs=P}),define(pe[33],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(_){return f.test(_)}e.isUUID=t;const k=new Uint8Array(16),D=[];for(let _=0;_<256;_++)D.push(_.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(_){for(let P=0;P<_.length;P++)_[P]=Math.floor(Math.random()*256);return _};function I(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let _=0,P="";return P+=D[k[_++]],P+=D[k[_++]],P+=D[k[_++]],P+=D[k[_++]],P+="-",P+=D[k[_++]],P+=D[k[_++]],P+="-",P+=D[k[_++]],P+=D[k[_++]],P+="-",P+=D[k[_++]],P+=D[k[_++]],P+="-",P+=D[k[_++]],P+=D[k[_++]],P+=D[k[_++]],P+=D[k[_++]],P+=D[k[_++]],P+=D[k[_++]],P}e.generateUuid=I}),define(pe[143],ve([0,1,104]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(D="utf8"){this.stringDecoder=new f.StringDecoder(D),this.remaining=null}write(D){const T=[],I=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(I.length<1)return T;let _=0,P,R=_;for(;R<I.length;)if(P=I.charCodeAt(R),P===13||P===10){if(T.push(I.substring(_,R)),R++,R<I.length){const y=P;P=I.charCodeAt(R),(y===13&&P===10||y===10&&P===13)&&R++}_=R}else R++;return this.remaining=_<I.length?I.substr(_):null,T}end(){return this.remaining}}e.LineDecoder=t}),define(pe[30],ve([0,1,60,81,291,18,29,79,9,12,23,2]),function(Z,e,f,t,k,D,T,I,_,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var l;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(l=e.RimRafMode||(e.RimRafMode={}));async function b(M,V=l.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return V===l.UNLINK?g(M):p(M)}async function p(M){try{const V=(0,T.randomPath)((0,t.tmpdir)());try{await f.promises.rename(M,V)}catch{return g(M)}g(V).catch($=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function g(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function E(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");f.rmdirSync(M,{recursive:!0})}e.rimrafSync=E;async function L(M,V){return s(await(V?C(M):(0,k.promisify)(f.readdir)(M)))}async function C(M){try{return await(0,k.promisify)(f.readdir)(M,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const V=[],$=await L(M);for(const U of $){let B=!1,W=!1,H=!1;try{const x=await e.Promises.lstat((0,_.join)(M,U));B=x.isFile(),W=x.isDirectory(),H=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}V.push({name:U,isFile:()=>B,isDirectory:()=>W,isSymbolicLink:()=>H})}return V}function a(M){return s(f.readdirSync(M))}e.readdirSync=a;function s(M){return M.map(V=>typeof V=="string"?P.isMacintosh?(0,I.normalizeNFC)(V):V:(V.name=P.isMacintosh?(0,I.normalizeNFC)(V.name):V.name,V))}async function m(M){const V=await L(M),$=[];for(const U of V)await S.existsDirectory((0,_.join)(M,U))&&$.push(U);return $}function o(M,V=1e3){return new Promise($=>{let U=!1;const B=setInterval(()=>{U||(U=!0,f.access(M,W=>{U=!1,W&&(clearInterval(B),$(void 0))}))},V)})}e.whenDeleted=o;var S;(function(M){async function V(B){let W;try{if(W=await e.Promises.lstat(B),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(P.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw x}throw H}}M.stat=V;async function $(B){try{const{stat:W,symbolicLink:H}=await M.stat(B);return W.isFile()&&H?.dangling!==!0}catch{}return!1}M.existsFile=$;async function U(B){try{const{stat:W,symbolicLink:H}=await M.stat(B);return W.isDirectory()&&H?.dangling!==!0}catch{}return!1}M.existsDirectory=U})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function i(M,V,$){return r.queueFor(y.URI.file(M),R.extUriBiasedIgnorePathCase).queue(()=>{const U=d($);return new Promise((B,W)=>u(M,V,U,H=>H?W(H):B()))})}let n=!0;function u(M,V,$,U){if(!n)return f.writeFile(M,V,{mode:$.mode,flag:$.flag},U);f.open(M,$.flag,$.mode,(B,W)=>{if(B)return U(B);f.writeFile(W,V,H=>{if(H)return f.close(W,()=>U(H));f.fdatasync(W,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),n=!1),f.close(W,J=>U(J))))})})}function c(M,V,$){const U=d($);if(!n)return f.writeFileSync(M,V,{mode:U.mode,flag:U.flag});const B=f.openSync(M,U.flag,U.mode);try{f.writeFileSync(B,V);try{f.fdatasyncSync(B)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),n=!1}}finally{f.closeSync(B)}}e.writeFileSync=c;function d(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function h(M,V){if(M===V)return;async function $(U){try{const B=await e.Promises.lstat(U);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(U,B.atime,new Date)}catch{}}try{await e.Promises.rename(M,V),await $(V)}catch(U){if(M.toLowerCase()!==V.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await v(M,V,{preserveSymlinks:!1}),await b(M,l.MOVE),await $(V);else throw U}}async function v(M,V,$){return A(M,V,{root:{source:M,target:V},options:$,handledSourcePaths:new Set})}const w=511;async function A(M,V,$){if($.handledSourcePaths.has(M))return;$.handledSourcePaths.add(M);const{stat:U,symbolicLink:B}=await S.stat(M);if(B){if($.options.preserveSymlinks)try{return await F(M,V,$)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(B.dangling)return}return U.isDirectory()?O(M,V,U.mode&w,$):N(M,V,U.mode&w)}async function O(M,V,$,U){await e.Promises.mkdir(V,{recursive:!0,mode:$});const B=await L(M);for(const W of B)await A((0,_.join)(M,W),(0,_.join)(V,W),U)}async function N(M,V,$){await e.Promises.copyFile(M,V),await e.Promises.chmod(V,$)}async function F(M,V,$){let U=await e.Promises.readlink(M);(0,T.isEqualOrParent)(U,$.root.source,!P.isLinux)&&(U=(0,_.join)($.root.target,U.substr($.root.source.length+1))),await e.Promises.symlink(U,V)}e.Promises=new class{get access(){return(0,k.promisify)(f.access)}get stat(){return(0,k.promisify)(f.stat)}get lstat(){return(0,k.promisify)(f.lstat)}get utimes(){return(0,k.promisify)(f.utimes)}get read(){return(M,V,$,U,B)=>new Promise((W,H)=>{f.read(M,V,$,U,B,(x,J,ne)=>x?H(x):W({bytesRead:J,buffer:ne}))})}get readFile(){return(0,k.promisify)(f.readFile)}get write(){return(M,V,$,U,B)=>new Promise((W,H)=>{f.write(M,V,$,U,B,(x,J,ne)=>x?H(x):W({bytesWritten:J,buffer:ne}))})}get appendFile(){return(0,k.promisify)(f.appendFile)}get fdatasync(){return(0,k.promisify)(f.fdatasync)}get truncate(){return(0,k.promisify)(f.truncate)}get rename(){return(0,k.promisify)(f.rename)}get copyFile(){return(0,k.promisify)(f.copyFile)}get open(){return(0,k.promisify)(f.open)}get close(){return(0,k.promisify)(f.close)}get symlink(){return(0,k.promisify)(f.symlink)}get readlink(){return(0,k.promisify)(f.readlink)}get chmod(){return(0,k.promisify)(f.chmod)}get mkdir(){return(0,k.promisify)(f.mkdir)}get unlink(){return(0,k.promisify)(f.unlink)}get rmdir(){return(0,k.promisify)(f.rmdir)}get realpath(){return(0,k.promisify)(f.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return L}get readDirsInDir(){return m}get writeFile(){return i}get rm(){return b}get move(){return h}get copy(){return v}}}),define(pe[105],ve([0,1,60,9,12,8,30]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(l){if(k.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(0,T.readdirSync)(b).filter(L=>L.toLowerCase()===p);if(E.length===1){const L=I(b);if(L)return(0,t.join)(L,E[0])}else if(E.length>1){const L=E.indexOf(p);if(L>=0){const C=I(b);if(C)return(0,t.join)(C,E[L])}}}catch{}return null}e.realcaseSync=I;async function _(l){if(k.isLinux)return l;const b=(0,t.dirname)(l);if(l===b)return l;const p=((0,t.basename)(l)||l).toLowerCase();try{const E=(await T.Promises.readdir(b)).filter(L=>L.toLowerCase()===p);if(E.length===1){const L=await _(b);if(L)return(0,t.join)(L,E[0])}else if(E.length>1){const L=E.indexOf(p);if(L>=0){const C=await _(b);if(C)return(0,t.join)(C,E[L])}}}catch{}return null}e.realcase=_;async function P(l){try{return await T.Promises.realpath(l)}catch{const p=y(l);return await T.Promises.access(p,f.constants.R_OK),p}}e.realpath=P;function R(l){try{return f.realpathSync(l)}catch{const p=y(l);return f.accessSync(p,f.constants.R_OK),p}}e.realpathSync=R;function y(l){return(0,D.rtrim)((0,t.normalize)(l),t.sep)}});var je=this&&this.__decorate||function(Z,e,f,t){var k=arguments.length,D=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,f):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(Z,e,f,t);else for(var I=Z.length-1;I>=0;I--)(T=Z[I])&&(D=(k<3?T(D):k>3?T(e,f,D):T(e,f))||D);return k>3&&D&&Object.defineProperty(e,f,D),D};define(pe[106],ve([0,1,17,18,22,21,56,16,3,6,59,8,13]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function p(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var L;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(L||(L={}));class C{constructor(H){this.buffer=H,this.pos=0}read(H){const x=this.buffer.slice(this.pos,this.pos+H);return this.pos+=x.byteLength,x}}class a{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(H){this.buffers.push(H)}}var s;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(s||(s={}));function m(W){const H=k.VSBuffer.alloc(4);return H.writeUInt32BE(W,0),H}function o(W){return W.read(4).readUInt32BE(0)}function S(W){const H=k.VSBuffer.alloc(1);return H.writeUInt8(W,0),H}const r={Undefined:S(s.Undefined),String:S(s.String),Buffer:S(s.Buffer),VSBuffer:S(s.VSBuffer),Array:S(s.Array),Object:S(s.Object)},i=typeof Buffer!="undefined";function n(W,H){if(typeof H=="undefined")W.write(r.Undefined);else if(typeof H=="string"){const x=k.VSBuffer.fromString(H);W.write(r.String),W.write(m(x.byteLength)),W.write(x)}else if(i&&Buffer.isBuffer(H)){const x=k.VSBuffer.wrap(H);W.write(r.Buffer),W.write(m(x.byteLength)),W.write(x)}else if(H instanceof k.VSBuffer)W.write(r.VSBuffer),W.write(m(H.byteLength)),W.write(H);else if(Array.isArray(H)){W.write(r.Array),W.write(m(H.length));for(const x of H)n(W,x)}else{const x=k.VSBuffer.fromString(JSON.stringify(H));W.write(r.Object),W.write(m(x.byteLength)),W.write(x)}}function u(W){switch(W.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return W.read(o(W)).toString();case s.Buffer:return W.read(o(W)).buffer;case s.VSBuffer:return W.read(o(W));case s.Array:{const x=o(W),J=[];for(let ne=0;ne<x;ne++)J.push(u(W));return J}case s.Object:return JSON.parse(W.read(o(W)).toString())}}class c{constructor(H,x,J=null,ne=1e3){this.protocol=H,this.ctx=x,this.logger=J,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(H,x){this.channels.set(H,x),setTimeout(()=>this.flushPendingRequests(H),0)}sendResponse(H){switch(H.type){case 200:{const x=this.send([H.type]);this.logger&&this.logger.logOutgoing(x,0,1,E(H.type));return}case 201:case 202:case 204:case 203:{const x=this.send([H.type,H.id],H.data);this.logger&&this.logger.logOutgoing(x,H.id,1,E(H.type),H.data);return}}}send(H,x=void 0){const J=new a;return n(J,H),n(J,x),this.sendBuffer(J.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onRawMessage(H){const x=new C(H),J=u(x),ne=u(x),se=J[0];switch(se){case 100:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}: ${J[2]}.${J[3]}`,ne),this.onPromise({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}: ${J[2]}.${J[3]}`,ne),this.onEventListen({type:se,id:J[1],channelName:J[2],name:J[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:J[1]});case 103:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],1,`${p(se)}`),this.disposeActiveRequest({type:se,id:J[1]})}}onPromise(H){const x=this.channels.get(H.channelName);if(!x){this.collectPendingRequest(H);return}const J=new D.CancellationTokenSource;let ne;try{ne=x.call(this.ctx,H.name,H.arg,J.token)}catch(Q){ne=Promise.reject(Q)}const se=H.id;ne.then(Q=>{this.sendResponse({id:se,data:Q,type:201}),this.activeRequests.delete(H.id)},Q=>{Q instanceof Error?this.sendResponse({id:se,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:se,data:Q,type:203}),this.activeRequests.delete(H.id)});const K=(0,P.toDisposable)(()=>J.cancel());this.activeRequests.set(H.id,K)}onEventListen(H){const x=this.channels.get(H.channelName);if(!x){this.collectPendingRequest(H);return}const J=H.id,se=x.listen(this.ctx,H.name,H.arg)(K=>this.sendResponse({id:J,data:K,type:204}));this.activeRequests.set(H.id,se)}disposeActiveRequest(H){const x=this.activeRequests.get(H.id);x&&(x.dispose(),this.activeRequests.delete(H.id))}collectPendingRequest(H){let x=this.pendingRequests.get(H.channelName);x||(x=[],this.pendingRequests.set(H.channelName,x));const J=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.sendResponse({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:H,timeoutTimer:J})}flushPendingRequests(H){const x=this.pendingRequests.get(H);if(x){for(const J of x)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(H)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var d;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(H,x=null){this.protocol=H,this.isDisposed=!1,this.state=L.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=x}getChannel(H){const x=this;return{call(J,ne,se){return x.isDisposed?Promise.reject(I.canceled()):x.requestPromise(H,J,ne,se)},listen(J,ne){return x.isDisposed?Promise.reject(I.canceled()):x.requestEvent(H,J,ne)}}}requestPromise(H,x,J,ne=D.CancellationToken.None){const se=this.lastRequestId++,Q={id:se,type:100,channelName:H,name:x,arg:J};if(ne.isCancellationRequested)return Promise.reject(I.canceled());let ae;return new Promise((be,Me)=>{if(ne.isCancellationRequested)return Me(I.canceled());const ze=()=>{const te=G=>{switch(G.type){case 201:this.handlers.delete(se),be(G.data);break;case 202:{this.handlers.delete(se);const X=new Error(G.data.message);X.stack=G.data.stack,X.name=G.data.name,Me(X);break}case 203:this.handlers.delete(se),Me(G.data);break}};this.handlers.set(se,te),this.sendRequest(Q)};let Ge=null;this.state===L.Idle?ze():(Ge=(0,t.createCancelablePromise)(te=>this.whenInitialized()),Ge.then(()=>{Ge=null,ze()}));const Je=()=>{Ge?(Ge.cancel(),Ge=null):this.sendRequest({id:se,type:101}),Me(I.canceled())},q=ne.onCancellationRequested(Je);ae=(0,P.combinedDisposable)((0,P.toDisposable)(Je),q),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(H,x,J){const ne=this.lastRequestId++,K={id:ne,type:102,channelName:H,name:x,arg:J};let Q=null;const ae=new _.Emitter({onFirstListenerAdd:()=>{Q=(0,t.createCancelablePromise)(be=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ae),this.sendRequest(K)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ae),this.sendRequest({id:ne,type:103}))}}),fe=be=>ae.fire(be.data);return this.handlers.set(ne,fe),ae.event}sendRequest(H){switch(H.type){case 100:case 102:{const x=this.send([H.type,H.id,H.channelName,H.name],H.arg);this.logger&&this.logger.logOutgoing(x,H.id,0,`${p(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const x=this.send([H.type,H.id]);this.logger&&this.logger.logOutgoing(x,H.id,0,p(H.type));return}}}send(H,x=void 0){const J=new a;return n(J,H),n(J,x),this.sendBuffer(J.buffer)}sendBuffer(H){try{return this.protocol.send(H),H.byteLength}catch{return 0}}onBuffer(H){const x=new C(H),J=u(x),ne=u(x),se=J[0];switch(se){case 200:return this.logger&&this.logger.logIncoming(H.byteLength,0,0,E(se)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(H.byteLength,J[1],0,E(se),ne),this.onResponse({type:J[0],id:J[1],data:ne})}}onResponse(H){if(H.type===200){this.state=L.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(H.id);x&&x(H)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===L.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(H=>H.dispose()),this.activeRequests.clear()}}je([T.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class v{constructor(H){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,H(({protocol:x,onDidClientDisconnect:J})=>{_.Event.once(x.onMessage)(se=>{const K=new C(se),Q=u(K),ae=new c(x,Q),fe=new h(x);this.channels.forEach((Me,ze)=>ae.registerChannel(ze,Me));const be={channelServer:ae,channelClient:fe,ctx:Q};this._connections.add(be),this._onDidAddConnection.fire(be),J(()=>{ae.dispose(),fe.dispose(),this._connections.delete(be),this._onDidRemoveConnection.fire(be)})})})}get connections(){const H=[];return this._connections.forEach(x=>H.push(x)),H}getChannel(H,x){const J=this;return{call(ne,se,K){let Q;if((0,l.isFunction)(x)){let fe=(0,f.getRandomElement)(J.connections.filter(x));Q=fe?Promise.resolve(fe):_.Event.toPromise(_.Event.filter(J.onDidAddConnection,x))}else Q=x.routeCall(J,ne,se);const ae=Q.then(fe=>fe.channelClient.getChannel(H));return A(ae).call(ne,se,K)},listen(ne,se){if((0,l.isFunction)(x))return J.getMulticastEvent(H,x,ne,se);const K=x.routeEvent(J,ne,se).then(Q=>Q.channelClient.getChannel(H));return A(K).listen(ne,se)}}}getMulticastEvent(H,x,J,ne){const se=this;let K=new P.DisposableStore;const Q=new _.Emitter({onFirstListenerAdd:()=>{K=new P.DisposableStore;const ae=new _.EventMultiplexer,fe=new Map,be=ze=>{const Je=ze.channelClient.getChannel(H).listen(J,ne),q=ae.add(Je);fe.set(ze,q)},Me=ze=>{const Ge=fe.get(ze);!Ge||(Ge.dispose(),fe.delete(ze))};se.connections.filter(x).forEach(be),_.Event.filter(se.onDidAddConnection,x)(be,void 0,K),se.onDidRemoveConnection(Me,void 0,K),ae.event(Q.fire,Q,K),K.add(ae)},onLastListenerRemove:()=>{K.dispose()}});return Q.event}registerChannel(H,x){this.channels.set(H,x),this._connections.forEach(J=>{J.channelServer.registerChannel(H,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class w{constructor(H,x,J=null){const ne=new a;n(ne,x),H.send(ne.buffer),this.channelClient=new h(H,J),this.channelServer=new c(H,x,J)}getChannel(H){return this.channelClient.getChannel(H)}registerChannel(H,x){this.channelServer.registerChannel(H,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=w;function A(W){return{call(H,x,J){return W.then(ne=>ne.call(H,x,J))},listen(H,x){const J=new _.Relay;return W.then(ne=>J.input=ne.listen(H,x)),J.event}}}e.getDelayedChannel=A;function O(W){let H=!1;return{call(x,J,ne){return H?W.call(x,J,ne):(0,t.timeout)(0).then(()=>H=!0).then(()=>W.call(x,J,ne))},listen(x,J){if(H)return W.listen(x,J);const ne=new _.Relay;return(0,t.timeout)(0).then(()=>H=!0).then(()=>ne.input=W.listen(x,J)),ne.event}}}e.getNextTickChannel=O;class N{constructor(H){this.fn=H}routeCall(H){return this.route(H)}routeEvent(H){return this.route(H)}async route(H){for(const x of H.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await _.Event.toPromise(H.onDidAddConnection),await this.route(H)}}e.StaticRouter=N;var F;(function(W){function H(se,K){const Q=se,ae=K&&K.disableMarshalling,fe=new Map;for(const be in Q)J(be)&&fe.set(be,_.Event.buffer(Q[be],!0));return new class{listen(be,Me,ze){const Ge=fe.get(Me);if(Ge)return Ge;if(ne(Me)){const Je=Q[Me];if(typeof Je=="function")return Je.call(Q,ze)}throw new Error(`Event not found: ${Me}`)}call(be,Me,ze){const Ge=Q[Me];if(typeof Ge=="function"){if(!ae&&Array.isArray(ze))for(let Je=0;Je<ze.length;Je++)ze[Je]=(0,R.revive)(ze[Je]);return Ge.apply(Q,ze)}throw new Error(`Method not found: ${Me}`)}}}W.fromService=H;function x(se,K){const Q=K&&K.disableMarshalling;return new Proxy({},{get(ae,fe){if(typeof fe=="string")return K?.properties?.has(fe)?K.properties.get(fe):ne(fe)?function(be){return se.listen(fe,be)}:J(fe)?se.listen(fe):async function(...be){let Me;K&&!(0,l.isUndefinedOrNull)(K.context)?Me=[K.context,...be]:Me=be;const ze=await se.call(fe,Me);return Q?ze:(0,R.revive)(ze)};throw new Error(`Property not found: ${String(fe)}`)}})}W.toService=x;function J(se){return se[0]==="o"&&se[1]==="n"&&y.isUpperAsciiLetter(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&y.isUpperAsciiLetter(se.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let H=W.toString();if(H!=="[object Object]")return H}return W}function $(W){return Array.isArray(W)?W.map(V):V(W)}function U(W,H,x,J,ne,se,K){K=$(K);const Q=M[ne],ae=Q[J%Q.length];let fe=[`%c[${W}]%c[${String(H).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(se)?(fe=fe.concat(K),fe.push(")")):fe.push(K),console.log.apply(console,fe)}e.logWithColors=U;class B{constructor(H,x){this._outgoingPrefix=H,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(H,x,J,ne,se){this._totalOutgoing+=H,U(this._outgoingPrefix,this._totalOutgoing,H,x,J,ne,se)}logIncoming(H,x,J,ne,se){this._totalIncoming+=H,U(this._incomingPrefix,this._totalIncoming,H,x,J,ne,se)}}e.IPCLogger=B}),define(pe[107],ve([0,1,22,3,6,106]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let u=0;function c(h,v){if(!n.has(h)){const w=String(++u);n.set(h,w)}return n.get(h)}function d(h,v,w,A){if(!i.enableDiagnostics)return;const O=c(h,v);if(A instanceof f.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const N=f.VSBuffer.alloc(A.byteLength);N.set(A),i.records.push({timestamp:Date.now(),id:O,label:v,type:w,buff:N})}else i.records.push({timestamp:Date.now(),id:O,label:v,type:w,data:A})}i.traceSocketEvent=d})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var _;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function R(){return P||(P=f.VSBuffer.alloc(0)),P}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,u){if(n===0)return R();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const v=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=n),v}if(this._chunks[0].byteLength>n){const v=this._chunks[0].slice(0,n);return u&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),v}let c=f.VSBuffer.alloc(n),d=0,h=0;for(;n>0;){const v=this._chunks[h];if(v.byteLength>n){const w=v.slice(0,n);c.set(w,d),d+=n,u&&(this._chunks[h]=v.slice(n),this._totalLength-=n),n-=n}else c.set(v,d),d+=v.byteLength,u?(this._chunks.shift(),this._totalLength-=v.byteLength):h++,n-=v.byteLength}return c}}e.ChunkStream=y;var l;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(l||(l={}));function b(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(n,u,c,d){this.type=n,this.id=u,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends k.Disposable{constructor(n){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,d=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new g(c,d,h,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class L{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=f.VSBuffer.alloc(13);u.writeUInt8(n.type,0),u.writeUInt32BE(n.id,1),u.writeUInt32BE(n.ack,5),u.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(u,n.data)}_bufferAdd(n,u){const c=this._totalLength===0;return this._data.push(n,u),this._totalLength+=n.byteLength+u.byteLength,c}_bufferTake(){const n=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,u){this._bufferAdd(n,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class C extends k.Disposable{constructor(n){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new L(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new g(1,0,0,n))}}e.Protocol=C;class a extends D.IPCClient{constructor(n,u,c=null){super(n,u,c);this.protocol=n}static fromSocket(n,u){return new a(new C(n),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=a;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class m{constructor(n){this.data=n,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],u=0,c=this._first;for(;c;)n[u++]=c.data,c=c.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const u=new m(n);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class S{constructor(){this.lastRuns=[];const n=Date.now();for(let u=0;u<S._HISTORY_LENGTH;u++)this.lastRuns[u]=n-1e3*u;setInterval(()=>{for(let u=S._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const n=Date.now(),u=(1+S._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<S._HISTORY_LENGTH;d++)n-this.lastRuns[d]<=u&&c++;return 1-c/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class r{constructor(n,u=null,c=S.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new g(5,0,0,R());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new g(7,0,0,R());this._socketWriter.write(n)}sendResume(){const n=new g(8,0,0,R());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,u){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new L(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,R());this._socketWriter.write(n);const u=this._outgoingUnackMsg.toArray();for(let c=0,d=u.length;c<d;c++)this._socketWriter.write(u[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new g(6,0,0,R())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let c=0,d=u.length;c<d;c++)this._socketWriter.write(u[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new g(1,u,this._incomingAckId,n);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(n){const u=new g(2,0,0,n);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),u=Date.now()-n.writtenTime,c=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&c>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-u,2e4-c,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,R());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(pe[108],ve([0,1,100]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(I){const _=(0,f.toUint8)(I);this._defaultValue=_,this._asciiMap=t._createAsciiMap(_),this._map=new Map}static _createAsciiMap(I){const _=new Uint8Array(256);for(let P=0;P<256;P++)_[P]=I;return _}set(I,_){const P=(0,f.toUint8)(_);I>=0&&I<256?this._asciiMap[I]=P:this._map.set(I,P)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=t;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class D{constructor(){this._actual=new t(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=D}),define(pe[144],ve([0,1,108]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends f.CharacterClassifier{constructor(I){super(0);for(let _=0,P=I.length;_<P;_++)this.set(I.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function D(T){const I={};return _=>(I.hasOwnProperty(_)||(I[_]=T(_)),I[_])}e.getMapForWordSeparators=D(T=>new k(T))}),define(pe[48],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(k,D){this.lineNumber=k,this.column=D}with(k=this.lineNumber,D=this.column){return k===this.lineNumber&&D===this.column?this:new f(k,D)}delta(k=0,D=0){return this.with(this.lineNumber+k,this.column+D)}equals(k){return f.equals(this,k)}static equals(k,D){return!k&&!D?!0:!!k&&!!D&&k.lineNumber===D.lineNumber&&k.column===D.column}isBefore(k){return f.isBefore(this,k)}static isBefore(k,D){return k.lineNumber<D.lineNumber?!0:D.lineNumber<k.lineNumber?!1:k.column<D.column}isBeforeOrEqual(k){return f.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,D){return k.lineNumber<D.lineNumber?!0:D.lineNumber<k.lineNumber?!1:k.column<=D.column}static compare(k,D){const T=k.lineNumber|0,I=D.lineNumber|0;if(T===I){const _=k.column|0,P=D.column|0;return _-P}return T-I}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new f(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=f}),define(pe[41],ve([0,1,48]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(D,T,I,_){D>I||D===I&&T>_?(this.startLineNumber=I,this.startColumn=_,this.endLineNumber=D,this.endColumn=T):(this.startLineNumber=D,this.startColumn=T,this.endLineNumber=I,this.endColumn=_)}isEmpty(){return t.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return t.containsPosition(this,D)}static containsPosition(D,T){return!(T.lineNumber<D.startLineNumber||T.lineNumber>D.endLineNumber||T.lineNumber===D.startLineNumber&&T.column<D.startColumn||T.lineNumber===D.endLineNumber&&T.column>D.endColumn)}static strictContainsPosition(D,T){return!(T.lineNumber<D.startLineNumber||T.lineNumber>D.endLineNumber||T.lineNumber===D.startLineNumber&&T.column<=D.startColumn||T.lineNumber===D.endLineNumber&&T.column>=D.endColumn)}containsRange(D){return t.containsRange(this,D)}static containsRange(D,T){return!(T.startLineNumber<D.startLineNumber||T.endLineNumber<D.startLineNumber||T.startLineNumber>D.endLineNumber||T.endLineNumber>D.endLineNumber||T.startLineNumber===D.startLineNumber&&T.startColumn<D.startColumn||T.endLineNumber===D.endLineNumber&&T.endColumn>D.endColumn)}strictContainsRange(D){return t.strictContainsRange(this,D)}static strictContainsRange(D,T){return!(T.startLineNumber<D.startLineNumber||T.endLineNumber<D.startLineNumber||T.startLineNumber>D.endLineNumber||T.endLineNumber>D.endLineNumber||T.startLineNumber===D.startLineNumber&&T.startColumn<=D.startColumn||T.endLineNumber===D.endLineNumber&&T.endColumn>=D.endColumn)}plusRange(D){return t.plusRange(this,D)}static plusRange(D,T){let I,_,P,R;return T.startLineNumber<D.startLineNumber?(I=T.startLineNumber,_=T.startColumn):T.startLineNumber===D.startLineNumber?(I=T.startLineNumber,_=Math.min(T.startColumn,D.startColumn)):(I=D.startLineNumber,_=D.startColumn),T.endLineNumber>D.endLineNumber?(P=T.endLineNumber,R=T.endColumn):T.endLineNumber===D.endLineNumber?(P=T.endLineNumber,R=Math.max(T.endColumn,D.endColumn)):(P=D.endLineNumber,R=D.endColumn),new t(I,_,P,R)}intersectRanges(D){return t.intersectRanges(this,D)}static intersectRanges(D,T){let I=D.startLineNumber,_=D.startColumn,P=D.endLineNumber,R=D.endColumn,y=T.startLineNumber,l=T.startColumn,b=T.endLineNumber,p=T.endColumn;return I<y?(I=y,_=l):I===y&&(_=Math.max(_,l)),P>b?(P=b,R=p):P===b&&(R=Math.min(R,p)),I>P||I===P&&_>R?null:new t(I,_,P,R)}equalsRange(D){return t.equalsRange(this,D)}static equalsRange(D,T){return!!D&&!!T&&D.startLineNumber===T.startLineNumber&&D.startColumn===T.startColumn&&D.endLineNumber===T.endLineNumber&&D.endColumn===T.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(D){return new f.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(D){return new f.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,T){return new t(this.startLineNumber,this.startColumn,D,T)}setStartPosition(D,T){return new t(D,T,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(D){return new t(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}static fromPositions(D,T=D){return new t(D.lineNumber,D.column,T.lineNumber,T.column)}static lift(D){return D?new t(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,T){return!(D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<T.startColumn||T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<D.startColumn)}static areIntersecting(D,T){return!(D.endLineNumber<T.startLineNumber||D.endLineNumber===T.startLineNumber&&D.endColumn<=T.startColumn||T.endLineNumber<D.startLineNumber||T.endLineNumber===D.startLineNumber&&T.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,T){if(D&&T){const P=D.startLineNumber|0,R=T.startLineNumber|0;if(P===R){const y=D.startColumn|0,l=T.startColumn|0;if(y===l){const b=D.endLineNumber|0,p=T.endLineNumber|0;if(b===p){const g=D.endColumn|0,E=T.endColumn|0;return g-E}return b-p}return y-l}return P-R}return(D?1:0)-(T?1:0)}static compareRangesUsingEnds(D,T){return D.endLineNumber===T.endLineNumber?D.endColumn===T.endColumn?D.startLineNumber===T.startLineNumber?D.startColumn-T.startColumn:D.startLineNumber-T.startLineNumber:D.endColumn-T.endColumn:D.endLineNumber-T.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}}e.Range=t}),define(pe[145],ve([0,1,48,41]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class D extends t.Range{constructor(I,_,P,R){super(I,_,P,R);this.selectionStartLineNumber=I,this.selectionStartColumn=_,this.positionLineNumber=P,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return D.selectionsEqual(this,I)}static selectionsEqual(I,_){return I.selectionStartLineNumber===_.selectionStartLineNumber&&I.selectionStartColumn===_.selectionStartColumn&&I.positionLineNumber===_.positionLineNumber&&I.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,_){return this.getDirection()===0?new D(this.startLineNumber,this.startColumn,I,_):new D(I,_,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new f.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(I,_){return this.getDirection()===0?new D(I,_,this.endLineNumber,this.endColumn):new D(this.endLineNumber,this.endColumn,I,_)}static fromPositions(I,_=I){return new D(I.lineNumber,I.column,_.lineNumber,_.column)}static fromRange(I,_){return _===0?new D(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):new D(I.endLineNumber,I.endColumn,I.startLineNumber,I.startColumn)}static liftSelection(I){return new D(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,_){if(I&&!_||!I&&_)return!1;if(!I&&!_)return!0;if(I.length!==_.length)return!1;for(let P=0,R=I.length;P<R;P++)if(!this.selectionsEqual(I[P],_[P]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,_,P,R,y){return y===0?new D(I,_,P,R):new D(P,R,I,_)}}e.Selection=D}),define(pe[146],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let _=0,P=I.notIn.length;_<P;_++)switch(I.notIn[_]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,_){if(I.getTokenCount()===0)return!0;const P=I.findTokenIndexAtOffset(_-2),R=I.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(I,_){for(let P=I;P<=_;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class k{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of I)D(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),D(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),D(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),D(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&D(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=k;function D(T,I,_){T.has(I)?T.get(I).push(_):T.set(I,[_])}}),define(pe[82],ve([0,1,32,9]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(D,T,I,_){if(Array.isArray(D)){let P=0;for(const R of D){const y=k(R,T,I,_);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof D=="string")return _?D==="*"?5:D===I?10:0:0;if(D){const{language:P,pattern:R,scheme:y,hasAccessToAllModels:l}=D;if(!_&&!l)return 0;let b=0;if(y)if(y===T.scheme)b=10;else if(y==="*")b=5;else return 0;if(P)if(P===I)b=10;else if(P==="*")b=Math.max(b,5);else return 0;if(R){let p;if(typeof R=="string"?p=R:p={...R,base:(0,t.normalize)(R.base)},p===T.fsPath||(0,f.match)(p,T.fsPath))b=10;else return 0}return b}else return 0}}e.score=k}),define(pe[147],ve([0,1,108]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(p,g,E){const L=new Uint8Array(p*g);for(let C=0,a=p*g;C<a;C++)L[C]=E;this._data=L,this.rows=p,this.cols=g}get(p,g){return this._data[p*this.cols+g]}set(p,g,E){this._data[p*this.cols+g]=E}}e.Uint8Matrix=k;class D{constructor(p){let g=0,E=0;for(let C=0,a=p.length;C<a;C++){const[s,m,o]=p[C];m>g&&(g=m),s>E&&(E=s),o>E&&(E=o)}g++,E++;const L=new k(E,g,0);for(let C=0,a=p.length;C<a;C++){const[s,m,o]=p[C];L.set(s,m,o)}this._states=L,this._maxCharCode=g}nextState(p,g){return g<0||g>=this._maxCharCode?0:this._states.get(p,g)}}e.StateMachine=D;let T=null;function I(){return T===null&&(T=new D([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var _;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let P=null;function R(){if(P===null){P=new f.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<b.length;g++)P.set(b.charCodeAt(g),1);const p=".,;";for(let g=0;g<p.length;g++)P.set(p.charCodeAt(g),2)}return P}class y{static _createLink(p,g,E,L,C){let a=C-1;do{const s=g.charCodeAt(a);if(p.get(s)!==2)break;a--}while(a>L);if(L>0){const s=g.charCodeAt(L-1),m=g.charCodeAt(a);(s===40&&m===41||s===91&&m===93||s===123&&m===125)&&a--}return{range:{startLineNumber:E,startColumn:L+1,endLineNumber:E,endColumn:a+2},url:g.substring(L,a+1)}}static computeLinks(p,g=I()){const E=R(),L=[];for(let C=1,a=p.getLineCount();C<=a;C++){const s=p.getLineContent(C),m=s.length;let o=0,S=0,r=0,i=1,n=!1,u=!1,c=!1,d=!1;for(;o<m;){let h=!1;const v=s.charCodeAt(o);if(i===13){let w;switch(v){case 40:n=!0,w=0;break;case 41:w=n?0:1;break;case 91:c=!0,u=!0,w=0;break;case 93:c=!1,w=u?0:1;break;case 123:d=!0,w=0;break;case 125:w=d?0:1;break;case 39:w=r===34||r===96?0:1;break;case 34:w=r===39||r===96?0:1;break;case 96:w=r===39||r===34?0:1;break;case 42:w=r===42?1:0;break;case 124:w=r===124?1:0;break;case 32:w=c?0:1;break;default:w=E.get(v)}w===1&&(L.push(y._createLink(E,s,C,S,o)),h=!0)}else if(i===12){let w;v===91?(u=!0,w=0):w=E.get(v),w===1?h=!0:i=13}else i=g.nextState(i,v),i===0&&(h=!0);h&&(i=1,n=!1,u=!1,d=!1,S=o+1,r=v),o++}i===13&&L.push(y._createLink(E,s,C,S,m))}return L}}e.LinkComputer=y;function l(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:y.computeLinks(b)}e.computeLinks=l}),define(pe[148],ve([0,1,3,6]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,_){return this._map.set(I,_),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===_&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,_){this._factories.get(I)?.dispose();const P=new D(this,I,_);return this._factories.set(I,P),(0,t.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==P||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const _=this.get(I);if(_)return _;const P=this._factories.get(I);return!P||P.isResolved?null:(await P.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const P=this._factories.get(I);return!!(!P||P.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=k;class D extends t.Disposable{constructor(I,_,P){super();this._registry=I,this._languageId=_,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(pe[109],ve([0,1,25]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(E){E[E.Left=1]="Left",E[E.Center=2]="Center",E[E.Right=4]="Right",E[E.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(E){E[E.Inline=1]="Inline",E[E.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(E){E[E.Both=0]="Both",E[E.Right=1]="Right",E[E.Left=2]="Left",E[E.None=3]="None"})(D=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var T;(function(E){E[E.TextDefined=0]="TextDefined",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(E){E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(E){E[E.LF=0]="LF",E[E.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(L){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,L.tabSize|0),this.indentSize=L.tabSize|0,this.insertSpaces=Boolean(L.insertSpaces),this.defaultEOL=L.defaultEOL|0,this.trimAutoWhitespace=Boolean(L.trimAutoWhitespace),this.bracketPairColorizationOptions=L.bracketPairColorizationOptions}equals(L){return this.tabSize===L.tabSize&&this.indentSize===L.indentSize&&this.insertSpaces===L.insertSpaces&&this.defaultEOL===L.defaultEOL&&this.trimAutoWhitespace===L.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,L.bracketPairColorizationOptions)}createChangeEvent(L){return{tabSize:this.tabSize!==L.tabSize,indentSize:this.indentSize!==L.indentSize,insertSpaces:this.insertSpaces!==L.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==L.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class R{constructor(L,C){this._findMatchBrand=void 0,this.range=L,this.matches=C}}e.FindMatch=R;var y;(function(E){E[E.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",E[E.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",E[E.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",E[E.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var l;(function(E){E[E.Left=0]="Left",E[E.Right=1]="Right",E[E.None=2]="None"})(l=e.PositionAffinity||(e.PositionAffinity={}));var b;(function(E){E[E.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b=e.ModelConstants||(e.ModelConstants={}));class p{constructor(L,C,a,s,m,o){this.identifier=L,this.range=C,this.text=a,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=m,this._isTracked=o}}e.ValidAnnotatedEditOperation=p;class g{constructor(L,C,a){this.reverseEdits=L,this.changes=C,this.trimAutoWhitespaceLineNumbers=a}}e.ApplyEditsResult=g}),define(pe[149],ve([0,1,8,144,48,41,109]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class _{constructor(a,s,m,o){this.searchString=a,this.isRegex=s,this.matchCase=m,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=P(this.searchString):a=this.searchString.indexOf(`
`)>=0;let s=null;try{s=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!s)return null;let m=!this.isRegex&&!a;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new R(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=_;function P(C){if(!C||C.length===0)return!1;for(let a=0,s=C.length;a<s;a++)if(C.charCodeAt(a)===92){if(a++,a>=s)break;const o=C.charCodeAt(a);if(o===110||o===114||o===87)return!0}return!1}e.isMultilineRegexSource=P;class R{constructor(a,s,m){this.regex=a,this.wordSeparators=s,this.simpleSearch=m}}e.SearchData=R;function y(C,a,s){if(!s)return new T.FindMatch(C,null);const m=[];for(let o=0,S=a.length;o<S;o++)m[o]=a[o];return new T.FindMatch(C,m)}e.createFindMatch=y;class l{constructor(a){const s=[];let m=0;for(let o=0,S=a.length;o<S;o++)a.charCodeAt(o)===10&&(s[m++]=o);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(a){const s=this._lineFeedsOffsets;let m=0,o=s.length-1;if(o===-1||a<=s[0])return 0;for(;m<o;){const S=m+((o-m)/2>>0);s[S]>=a?o=S-1:s[S+1]>=a?(m=S,o=S):m=S+1}return m+1}}class b{static findMatches(a,s,m,o,S){const r=s.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,m,new L(r.wordSeparators,r.regex),o,S):this._doFindMatchesLineByLine(a,m,r,o,S):[]}static _getMultilineMatchRange(a,s,m,o,S,r){let i,n=0;o?(n=o.findLineFeedCountBeforeOffset(S),i=s+S+n):i=s+S;let u;if(o){const v=o.findLineFeedCountBeforeOffset(S+r.length)-n;u=i+r.length+v}else u=i+r.length;const c=a.getPositionAt(i),d=a.getPositionAt(u);return new D.Range(c.lineNumber,c.column,d.lineNumber,d.column)}static _doFindMatchesMultiline(a,s,m,o,S){const r=a.getOffsetAt(s.getStartPosition()),i=a.getValueInRange(s,1),n=a.getEOL()===`\r
`?new l(i):null,u=[];let c=0,d;for(m.reset(0);d=m.next(i);)if(u[c++]=y(this._getMultilineMatchRange(a,r,i,n,d.index,d[0]),d,o),c>=S)return u;return u}static _doFindMatchesLineByLine(a,s,m,o,S){const r=[];let i=0;if(s.startLineNumber===s.endLineNumber){const u=a.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return i=this._findMatchesInLine(m,u,s.startLineNumber,s.startColumn-1,i,r,o,S),r}const n=a.getLineContent(s.startLineNumber).substring(s.startColumn-1);i=this._findMatchesInLine(m,n,s.startLineNumber,s.startColumn-1,i,r,o,S);for(let u=s.startLineNumber+1;u<s.endLineNumber&&i<S;u++)i=this._findMatchesInLine(m,a.getLineContent(u),u,0,i,r,o,S);if(i<S){const u=a.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);i=this._findMatchesInLine(m,u,s.endLineNumber,0,i,r,o,S)}return r}static _findMatchesInLine(a,s,m,o,S,r,i,n){const u=a.wordSeparators;if(!i&&a.simpleSearch){const h=a.simpleSearch,v=h.length,w=s.length;let A=-v;for(;(A=s.indexOf(h,A+v))!==-1;)if((!u||E(u,s,w,A,v))&&(r[S++]=new T.FindMatch(new D.Range(m,A+1+o,m,A+1+v+o),null),S>=n))return S;return S}const c=new L(a.wordSeparators,a.regex);let d;c.reset(0);do if(d=c.next(s),d&&(r[S++]=y(new D.Range(m,d.index+1+o,m,d.index+1+d[0].length+o),d,i),S>=n))return S;while(d);return S}static findNextMatch(a,s,m,o){const S=s.parseSearchRequest();if(!S)return null;const r=new L(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(a,m,r,o):this._doFindNextMatchLineByLine(a,m,r,o)}static _doFindNextMatchMultiline(a,s,m,o){const S=new k.Position(s.lineNumber,1),r=a.getOffsetAt(S),i=a.getLineCount(),n=a.getValueInRange(new D.Range(S.lineNumber,S.column,i,a.getLineMaxColumn(i)),1),u=a.getEOL()===`\r
`?new l(n):null;m.reset(s.column-1);let c=m.next(n);return c?y(this._getMultilineMatchRange(a,r,n,u,c.index,c[0]),c,o):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(a,new k.Position(1,1),m,o):null}static _doFindNextMatchLineByLine(a,s,m,o){const S=a.getLineCount(),r=s.lineNumber,i=a.getLineContent(r),n=this._findFirstMatchInLine(m,i,r,s.column,o);if(n)return n;for(let u=1;u<=S;u++){const c=(r+u-1)%S,d=a.getLineContent(c+1),h=this._findFirstMatchInLine(m,d,c+1,1,o);if(h)return h}return null}static _findFirstMatchInLine(a,s,m,o,S){a.reset(o-1);const r=a.next(s);return r?y(new D.Range(m,r.index+1,m,r.index+1+r[0].length),r,S):null}static findPreviousMatch(a,s,m,o){const S=s.parseSearchRequest();if(!S)return null;const r=new L(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(a,m,r,o):this._doFindPreviousMatchLineByLine(a,m,r,o)}static _doFindPreviousMatchMultiline(a,s,m,o){const S=this._doFindMatchesMultiline(a,new D.Range(1,1,s.lineNumber,s.column),m,o,10*I);if(S.length>0)return S[S.length-1];const r=a.getLineCount();return s.lineNumber!==r||s.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new k.Position(r,a.getLineMaxColumn(r)),m,o):null}static _doFindPreviousMatchLineByLine(a,s,m,o){const S=a.getLineCount(),r=s.lineNumber,i=a.getLineContent(r).substring(0,s.column-1),n=this._findLastMatchInLine(m,i,r,o);if(n)return n;for(let u=1;u<=S;u++){const c=(S+r-u-1)%S,d=a.getLineContent(c+1),h=this._findLastMatchInLine(m,d,c+1,o);if(h)return h}return null}static _findLastMatchInLine(a,s,m,o){let S=null,r;for(a.reset(0);r=a.next(s);)S=y(new D.Range(m,r.index+1,m,r.index+1+r[0].length),r,o);return S}}e.TextModelSearch=b;function p(C,a,s,m,o){if(m===0)return!0;const S=a.charCodeAt(m-1);if(C.get(S)!==0||S===13||S===10)return!0;if(o>0){const r=a.charCodeAt(m);if(C.get(r)!==0)return!0}return!1}function g(C,a,s,m,o){if(m+o===s)return!0;const S=a.charCodeAt(m+o);if(C.get(S)!==0||S===13||S===10)return!0;if(o>0){const r=a.charCodeAt(m+o-1);if(C.get(r)!==0)return!0}return!1}function E(C,a,s,m,o){return p(C,a,s,m,o)&&g(C,a,s,m,o)}e.isValidMatch=E;class L{constructor(a,s){this._wordSeparators=a,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const s=a.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(m=this._searchRegex.exec(a),!m))return null;const o=m.index,S=m[0].length;if(o===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){f.getNextCodePoint(a,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=o,this._prevMatchLength=S,!this._wordSeparators||E(this._wordSeparators,a,s,o,S))return m}while(m);return null}}e.Searcher=L}),define(pe[110],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(I=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)I.indexOf(P)>=0||(_+="\\"+P);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=f();function t(I){let _=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)_=I;else{let P="g";I.ignoreCase&&(P+="i"),I.multiline&&(P+="m"),I.unicode&&(P+="u"),_=new RegExp(I.source,P)}return _.lastIndex=0,_}e.ensureValidWordDefinition=t;const k={maxLen:1e3,windowSize:15,timeBudget:150};function D(I,_,P,R,y=k){if(P.length>y.maxLen){let E=I-y.maxLen/2;return E<0?E=0:R+=E,P=P.substring(E,I+y.maxLen/2),D(I,_,P,R,y)}const l=Date.now(),b=I-1-R;let p=-1,g=null;for(let E=1;!(Date.now()-l>=y.timeBudget);E++){const L=b-y.windowSize*E;_.lastIndex=Math.max(0,L);const C=T(_,P,b,p);if(!C&&g||(g=C,L<=0))break;p=L}if(g){const E={word:g[0],startColumn:R+1+g.index,endColumn:R+1+g.index+g[0].length};return _.lastIndex=0,E}return null}e.getWordAtText=D;function T(I,_,P,R){let y;for(;y=I.exec(_);){const l=y.index||0;if(l<=P&&I.lastIndex>=P)return y;if(R>0&&l>R)return null}return null}}),define(pe[111],ve([0,1,22,12]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(k||(k={}));function D(y){for(let l=0,b=y.length;l<b;l+=4){const p=y[l+0],g=y[l+1],E=y[l+2],L=y[l+3];y[l+0]=L,y[l+1]=E,y[l+2]=g,y[l+3]=p}}function T(y){const l=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return t.isLittleEndian()||D(l),f.VSBuffer.wrap(l)}function I(y){const l=y.buffer;if(t.isLittleEndian()||D(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function _(y){const l=new Uint32Array(P(y));let b=0;if(l[b++]=y.id,y.type==="full")l[b++]=1,l[b++]=y.data.length,l.set(y.data,b),b+=y.data.length;else{l[b++]=2,l[b++]=y.deltas.length;for(const p of y.deltas)l[b++]=p.start,l[b++]=p.deleteCount,p.data?(l[b++]=p.data.length,l.set(p.data,b),b+=p.data.length):l[b++]=0}return T(l)}e.encodeSemanticTokensDto=_;function P(y){let l=0;if(l+=1+1,y.type==="full")l+=1+y.data.length;else{l+=1,l+=(1+1+1)*y.deltas.length;for(const b of y.deltas)b.data&&(l+=b.data.length)}return l}function R(y){const l=I(y);let b=0;const p=l[b++];if(l[b++]===1){const C=l[b++],a=l.subarray(b,b+C);return b+=C,{id:p,type:"full",data:a}}const E=l[b++],L=[];for(let C=0;C<E;C++){const a=l[b++],s=l[b++],m=l[b++];let o;m>0&&(o=l.subarray(b,b+m),b+=m),L[C]={start:a,deleteCount:s,data:o}}return{id:p,type:"delta",deltas:L}}e.decodeSemanticTokensDto=R}),define(pe[112],ve([0,1,17,100]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,P){_=(0,t.toUint32)(_);const R=this.values,y=this.prefixSum,l=P.length;return l===0?!1:(this.values=new Uint32Array(R.length+l),this.values.set(R.subarray(0,_),0),this.values.set(R.subarray(_),_+l),this.values.set(P,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,P){return _=(0,t.toUint32)(_),P=(0,t.toUint32)(P),this.values[_]===P?!1:(this.values[_]=P,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,P){_=(0,t.toUint32)(_),P=(0,t.toUint32)(P);const R=this.values,y=this.prefixSum;if(_>=R.length)return!1;const l=R.length-_;return P>=l&&(P=l),P===0?!1:(this.values=new Uint32Array(R.length-P),this.values.set(R.subarray(0,_),0),this.values.set(R.subarray(_+P),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,t.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),_>=this.values.length&&(_=this.values.length-1);for(let R=P;R<=_;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let P=0,R=this.values.length-1,y=0,l=0,b=0;for(;P<=R;)if(y=P+(R-P)/2|0,l=this.prefixSum[y],b=l-this.values[y],_<b)R=y-1;else if(_>=l)P=y+1;else break;return new T(y,_-b)}}e.PrefixSumComputer=k;class D{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const P=this._indexBySum[_],R=P>0?this._prefixSum[P-1]:0;return new T(P,_-R)}removeValues(_,P){this._values.splice(_,P),this._invalidate(_)}insertValues(_,P){this._values=(0,f.arrayInsert)(this._values,_,P),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,P=this._values.length;_<P;_++){const R=this._values[_],y=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=y+R;for(let l=0;l<R;l++)this._indexBySum[y+l]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,P){this._values[_]!==P&&(this._values[_]=P,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=D;class T{constructor(_,P){this.index=_,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=P}}e.PrefixSumIndexOfResult=T}),define(pe[150],ve([0,1,8,48,112]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class D{constructor(I,_,P,R){this._uri=I,this._lines=_,this._eol=P,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const _=I.changes;for(const P of _)this._acceptDeleteRange(P.range),this._acceptInsertText(new t.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,_=this._lines.length,P=new Uint32Array(_);for(let R=0;R<_;R++)P[R]=this._lines[R].length+I;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(I,_){this._lines[I]=_,this._lineStarts&&this._lineStarts.setValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,_){if(_.length===0)return;const P=(0,f.splitLines)(_);if(P.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}P[P.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+P[0]);const R=new Uint32Array(P.length-1);for(let y=1;y<P.length;y++)this._lines.splice(I.lineNumber+y-1,0,P[y]),R[y-1]=P[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,R)}}e.MirrorTextModel=D}),define(pe[151],ve([19,20]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(pe[152],ve([0,1,151]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,D=k*24,T=D*7,I=D*30,_=D*365;function P(y,l,b){typeof y!="number"&&(y=y.getTime());const p=Math.round((new Date().getTime()-y)/1e3);if(p<-30)return(0,f.localize)(0,null,P(new Date().getTime()+p*1e3,!1));if(p<30)return(0,f.localize)(1,null);let g;return p<t?(g=p,l?g===1?b?(0,f.localize)(2,null,g):(0,f.localize)(3,null,g):b?(0,f.localize)(4,null,g):(0,f.localize)(5,null,g):g===1?b?(0,f.localize)(6,null,g):(0,f.localize)(7,null,g):b?(0,f.localize)(8,null,g):(0,f.localize)(9,null,g)):p<k?(g=Math.floor(p/t),l?g===1?b?(0,f.localize)(10,null,g):(0,f.localize)(11,null,g):b?(0,f.localize)(12,null,g):(0,f.localize)(13,null,g):g===1?b?(0,f.localize)(14,null,g):(0,f.localize)(15,null,g):b?(0,f.localize)(16,null,g):(0,f.localize)(17,null,g)):p<D?(g=Math.floor(p/k),l?g===1?b?(0,f.localize)(18,null,g):(0,f.localize)(19,null,g):b?(0,f.localize)(20,null,g):(0,f.localize)(21,null,g):g===1?b?(0,f.localize)(22,null,g):(0,f.localize)(23,null,g):b?(0,f.localize)(24,null,g):(0,f.localize)(25,null,g)):p<T?(g=Math.floor(p/D),l?g===1?(0,f.localize)(26,null,g):(0,f.localize)(27,null,g):g===1?(0,f.localize)(28,null,g):(0,f.localize)(29,null,g)):p<I?(g=Math.floor(p/T),l?g===1?b?(0,f.localize)(30,null,g):(0,f.localize)(31,null,g):b?(0,f.localize)(32,null,g):(0,f.localize)(33,null,g):g===1?b?(0,f.localize)(34,null,g):(0,f.localize)(35,null,g):b?(0,f.localize)(36,null,g):(0,f.localize)(37,null,g)):p<_?(g=Math.floor(p/I),l?g===1?b?(0,f.localize)(38,null,g):(0,f.localize)(39,null,g):b?(0,f.localize)(40,null,g):(0,f.localize)(41,null,g):g===1?b?(0,f.localize)(42,null,g):(0,f.localize)(43,null,g):b?(0,f.localize)(44,null,g):(0,f.localize)(45,null,g)):(g=Math.floor(p/_),l?g===1?b?(0,f.localize)(46,null,g):(0,f.localize)(47,null,g):b?(0,f.localize)(48,null,g):(0,f.localize)(49,null,g):g===1?b?(0,f.localize)(50,null,g):(0,f.localize)(51,null,g):b?(0,f.localize)(52,null,g):(0,f.localize)(53,null,g))}e.fromNow=P;function R(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(pe[153],ve([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(pe[49],ve([0,1,17,13,153]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(P,R){return R&&(P.stack||P.stacktrace)?k.localize(0,null,I(P),T(P.stack)||T(P.stacktrace)):I(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function I(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function _(P=null,R=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const y=f.coalesce(P),l=_(y[0],R);return y.length>1?k.localize(4,null,l,y.length):l}if(t.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return D(y.error,R);if(y.exception)return D(y.exception,R)}return P.stack?D(P,R):P.message?P.message:k.localize(5,null)}e.toErrorMessage=_}),define(pe[154],ve([19,20]),function(Z,e){return Z.create("vs/base/node/processes",e)}),define(pe[113],ve([0,1,37,29,10,25,9,12,40,96,13,143,30,154]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function p(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(o,S){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};S&&(r.cwd=S);const i=f.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],r);return new Promise(n=>{i.once("error",u=>{n({success:!1,error:u})}),i.once("exit",(u,c)=>{n(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?p(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Z).fsPath;return new Promise(i=>{f.execFile(r,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,u,c)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function E(o){!o||(delete o.DEBUG,I.isMacintosh&&delete o.DYLD_LIBRARY_PATH,I.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function L(o=_.env){return o.comspec||"cmd.exe"}e.getWindowsShell=L;class C{constructor(S,r,i,n){if(r!==void 0&&i!==void 0&&n!==void 0)this.cmd=S,this.args=r,this.shell=i,this.options=n;else{const u=S;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(_.env).forEach(c=>{u[c]=_.env[c]}),Object.keys(this.options.env).forEach(c=>{u[c]=this.options.env[c]}),this.options.env=u}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const r=S.lastIndexOf(T.sep);return r!==-1&&(S=S.substring(r+1)),C.WellKnowCommands[S]?S:"other"}start(S){return I.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(_.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(r=>{let i,n;const u=new Promise((c,d)=>{i=c,n=d});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=f.exec(c,this.options,(d,h,v)=>{this.childProcess=null;const w=d;w&&w.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:v.toString()}):this.handleExec(i,S,d,h,v)})}else{let c=null;const d=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,i,S,n);const v={terminated:this.terminateRequested};R.isNumber(h)&&(v.cmdCode=h),i(v)};if(this.shell&&I.isWindows){const h=D.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let v=!1,w=!1;const A=[];let O=this.ensureQuotes(this.cmd);A.push(O.value),v=O.quoted,this.args&&this.args.forEach(F=>{O=this.ensureQuotes(F),A.push(O.value),w=w&&O.quoted});const N=["/s","/c"];v?w?N.push('"'+A.join(" ")+'"'):A.length>1?N.push('"'+A[0]+'" '+A.slice(1).join(" ")):N.push('"'+A[0]+'"'):N.push(A.join(" ")),c=f.spawn(L(),N,h)}else this.cmd&&(c=f.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(R.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),c.pid&&(this.childProcess.on("close",d),this.handleSpawn(c,i,S,n,!0)))}return u})}handleClose(S,r,i,n){}ensureQuotes(S){return C.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,g(S,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!I.isWindows)return S(!1);const r=f.spawn(L(),["/s","/c"]);r.on("error",i=>S(!0)),r.on("exit",i=>S(!1))})}}e.AbstractProcess=C,C.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},C.regexp=/^[^"].* .*[^"]/;class a extends C{constructor(S,r,i,n){super(S,r,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,r,i,n,u){[n,u].forEach((c,d)=>{const h=new y.LineDecoder;h.write(c).forEach(A=>{r({line:A,source:d===0?0:1})});const w=h.end();w&&r({line:w,source:d===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,r,i,n,u){const c=new y.LineDecoder,d=new y.LineDecoder;S.stdout.on("data",h=>{c.write(h).forEach(w=>i({line:w,source:0}))}),S.stderr.on("data",h=>{d.write(h).forEach(w=>i({line:w,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=d}handleClose(S,r,i,n){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&i({line:u,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&i({line:c,source:1})}}e.LineProcess=a;function s(o){let S=[],r=!1;const i=function(n){if(r){S.push(n);return}(!o.send(n,c=>{if(c&&console.error(c),r=!1,S.length>0){const d=S.slice(0);S=[],d.forEach(h=>i(h))}})||I.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=s;var m;(function(o){async function S(r,i,n){if(T.isAbsolute(r))return r;if(i===void 0&&(i=_.cwd()),T.dirname(r)!=="."||(n===void 0&&R.isString(_.env.PATH)&&(n=_.env.PATH.split(T.delimiter)),n===void 0||n.length===0))return T.join(i,r);async function c(d){if(await l.Promises.exists(d)){let h;try{h=await l.Promises.stat(d)}catch(v){v.message.startsWith("EACCES")&&(h=await l.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(let d of n){let h;if(T.isAbsolute(d)?h=T.join(d,r):h=T.join(i,d,r),await c(h))return h;let v=h+".com";if(await c(v)||(v=h+".exe",await c(v)))return v}return T.join(i,r)}o.findExecutable=S})(m=e.win32||(e.win32={}))}),define(pe[155],ve([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(pe[114],ve([0,1,155,12,110,17,25]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=_;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class R{constructor(ie,Se,re,Ce){this.id=ie,this.name=Se,this.defaultValue=re,this.schema=Ce}applyUpdate(ie,Se){return l(ie,Se)}compute(ie,Se,re){return re}}class y{constructor(ie,Se){this.newValue=ie,this.didChange=Se}}e.ApplyUpdateResult=y;function l(ee,ie){if(typeof ee!="object"||typeof ie!="object"||!ee||!ie)return new y(ie,ee!==ie);if(Array.isArray(ee)||Array.isArray(ie)){const re=Array.isArray(ee)&&Array.isArray(ie)&&D.equals(ee,ie);return new y(ie,re)}let Se=!1;for(const re in ie)if(ie.hasOwnProperty(re)){const Ce=l(ee[re],ie[re]);Ce.didChange&&(ee[re]=Ce.newValue,Se=!0)}return new y(ee,Se)}class b{constructor(ie){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0}applyUpdate(ie,Se){return l(ie,Se)}validate(ie){return this.defaultValue}}class p{constructor(ie,Se,re,Ce){this.id=ie,this.name=Se,this.defaultValue=re,this.schema=Ce}applyUpdate(ie,Se){return l(ie,Se)}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Se,re){return re}}function g(ee,ie){return typeof ee=="undefined"?ie:ee==="false"?!1:Boolean(ee)}e.boolean=g;class E extends p{constructor(ie,Se,re,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="boolean",Ce.default=re);super(ie,Se,re,Ce)}validate(ie){return g(ie,this.defaultValue)}}function L(ee,ie,Se,re){if(typeof ee=="undefined")return ie;let Ce=parseInt(ee,10);return isNaN(Ce)?ie:(Ce=Math.max(Se,Ce),Ce=Math.min(re,Ce),Ce|0)}e.clampedInt=L;class C extends p{constructor(ie,Se,re,Ce,Fe,qe=void 0){typeof qe!="undefined"&&(qe.type="integer",qe.default=re,qe.minimum=Ce,qe.maximum=Fe);super(ie,Se,re,qe);this.minimum=Ce,this.maximum=Fe}static clampedInt(ie,Se,re,Ce){return L(ie,Se,re,Ce)}validate(ie){return C.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class a extends p{constructor(ie,Se,re,Ce,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=re);super(ie,Se,re,Fe);this.validationFn=Ce}static clamp(ie,Se,re){return ie<Se?Se:ie>re?re:ie}static float(ie,Se){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Se;const re=parseFloat(ie);return isNaN(re)?Se:re}validate(ie){return this.validationFn(a.float(ie,this.defaultValue))}}class s extends p{static string(ie,Se){return typeof ie!="string"?Se:ie}constructor(ie,Se,re,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.default=re);super(ie,Se,re,Ce)}validate(ie){return s.string(ie,this.defaultValue)}}function m(ee,ie,Se){return typeof ee!="string"||Se.indexOf(ee)===-1?ie:ee}e.stringSet=m;class o extends p{constructor(ie,Se,re,Ce,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=Ce,Fe.default=re);super(ie,Se,re,Fe);this._allowedValues=Ce}validate(ie){return m(ie,this.defaultValue,this._allowedValues)}}class S extends R{constructor(ie,Se,re,Ce,Fe,qe,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=Fe,Ve.default=Ce);super(ie,Se,re,Ve);this._allowedValues=Fe,this._convert=qe}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function r(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Se,re){return re===0?ie.accessibilitySupport:re}}class n extends R{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:f.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertSpace:g(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(u=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(ee){switch(ee){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function v(ee){switch(ee){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class w extends b{constructor(){super(128)}compute(ie,Se,re){const Ce=["monaco-editor"];return Se.get(33)&&Ce.push(Se.get(33)),ie.extraEditorClassName&&Ce.push(ie.extraEditorClassName),Se.get(66)==="default"?Ce.push("mouse-default"):Se.get(66)==="copy"&&Ce.push("mouse-copy"),Se.get(100)&&Ce.push("showUnused"),Se.get(126)&&Ce.push("showDeprecated"),Ce.join(" ")}}class A extends E{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(ie,Se,re){return re&&ie.emptySelectionClipboard}}class O extends R{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:f.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:f.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{cursorMoveOnType:g(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":m(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":m(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Se.loop,this.defaultValue.loop)}}}class N extends R{constructor(){super(45,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?N.OFF:ie==="true"?N.ON:ie:Boolean(ie)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class F extends b{constructor(){super(44)}compute(ie,Se,re){return ie.fontInfo}}class M extends p{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(ie){const Se=a.float(ie,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Se,6,100)}compute(ie,Se,re){return ie.fontInfo.fontSize}}class V extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(C.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class $ extends R{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:re,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:re,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:re,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:re,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:re,description:f.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{multiple:m(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??m(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??m(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??m(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??m(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??m(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends R{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,minimum:0,maximum:1e4,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:f.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:f.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),delay:C.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:g(Se.sticky,this.defaultValue.sticky),above:g(Se.above,this.defaultValue.above)}}}var B;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class W extends b{constructor(){super(131)}compute(ie,Se,re){return W.computeLayout(Se,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Se=ie.height/ie.lineHeight,re=ie.scrollBeyondLastLine?Se-1:0,Ce=(ie.viewLineCount+re)/(ie.pixelRatio*ie.height),Fe=Math.floor(ie.viewLineCount/Ce);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:re,desiredRatio:Ce,minimapLineCount:Fe}}static _computeMinimapLayout(ie,Se){const re=ie.outerWidth,Ce=ie.outerHeight,Fe=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*Ce),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ce};const qe=Se.stableMinimapLayoutInput,Ve=qe&&ie.outerHeight===qe.outerHeight&&ie.lineHeight===qe.lineHeight&&ie.typicalHalfwidthCharacterWidth===qe.typicalHalfwidthCharacterWidth&&ie.pixelRatio===qe.pixelRatio&&ie.scrollBeyondLastLine===qe.scrollBeyondLastLine&&ie.minimap.enabled===qe.minimap.enabled&&ie.minimap.side===qe.minimap.side&&ie.minimap.size===qe.minimap.size&&ie.minimap.showSlider===qe.minimap.showSlider&&ie.minimap.renderCharacters===qe.minimap.renderCharacters&&ie.minimap.maxColumn===qe.minimap.maxColumn&&ie.minimap.scale===qe.minimap.scale&&ie.verticalScrollbarWidth===qe.verticalScrollbarWidth&&ie.isViewportWrapping===qe.isViewportWrapping,ut=ie.lineHeight,Re=ie.typicalHalfwidthCharacterWidth,Ae=ie.scrollBeyondLastLine,De=ie.minimap.renderCharacters;let ce=Fe>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const de=ie.minimap.maxColumn,we=ie.minimap.size,ye=ie.minimap.side,Oe=ie.verticalScrollbarWidth,Ke=ie.viewLineCount,We=ie.remainingWidth,Ze=ie.isViewportWrapping,lt=De?2:3;let ct=Math.floor(Fe*Ce);const $e=ct/Fe;let Ee=!1,_e=!1,he=lt*ce,Y=ce/Fe,ke=1;if(we==="fill"||we==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:wt,desiredRatio:bt,minimapLineCount:Ut}=W.computeContainedMinimapLineCount({viewLineCount:Ke,scrollBeyondLastLine:Ae,height:Ce,lineHeight:ut,pixelRatio:Fe});if(Ke/Ut>1)Ee=!0,_e=!0,ce=1,he=1,Y=ce/Fe;else{let Ft=!1,kt=ce+1;if(we==="fit"){const yt=Math.ceil((Ke+wt)*he);Ze&&Ve&&We<=Se.stableFitRemainingWidth?(Ft=!0,kt=Se.stableFitMaxMinimapScale):Ft=yt>ct}if(we==="fill"||Ft){Ee=!0;const yt=ce;he=Math.min(ut*Fe,Math.max(1,Math.floor(1/bt))),Ze&&Ve&&We<=Se.stableFitRemainingWidth&&(kt=Se.stableFitMaxMinimapScale),ce=Math.min(kt,Math.max(1,Math.floor(he/lt))),ce>yt&&(ke=Math.min(2,ce/yt)),Y=ce/Fe/ke,ct=Math.ceil(Math.max(ft,Ke+wt)*he),Ze?(Se.stableMinimapLayoutInput=ie,Se.stableFitRemainingWidth=We,Se.stableFitMaxMinimapScale=ce):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Ne=Math.floor(de*Y),Xe=Math.min(Ne,Math.max(0,Math.floor((We-Oe-2)*Y/(Re+Y)))+e.MINIMAP_GUTTER_WIDTH);let Qe=Math.floor(Fe*Xe);const pt=Qe/Fe;Qe=Math.floor(Qe*ke);const St=De?1:2,Ct=ye==="left"?0:re-Xe-Oe;return{renderMinimap:St,minimapLeft:Ct,minimapWidth:Xe,minimapHeightIsEditorHeight:Ee,minimapIsSampling:_e,minimapScale:ce,minimapLineHeight:he,minimapCanvasInnerWidth:Qe,minimapCanvasInnerHeight:ct,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:$e}}static computeLayout(ie,Se){const re=Se.outerWidth|0,Ce=Se.outerHeight|0,Fe=Se.lineHeight|0,qe=Se.lineNumbersDigitCount|0,Ve=Se.typicalHalfwidthCharacterWidth,ut=Se.maxDigitWidth,Re=Se.pixelRatio,Ae=Se.viewLineCount,De=ie.get(123),ce=De==="inherit"?ie.get(122):De,de=ce==="inherit"?ie.get(118):ce,we=ie.get(121),ye=ie.get(2),Oe=Se.isDominatedByLongLines,Ke=ie.get(50),We=ie.get(60).renderType!==0,Ze=ie.get(61),lt=ie.get(94),ct=ie.get(65),$e=ie.get(92),Ee=$e.verticalScrollbarSize,_e=$e.verticalHasArrows,he=$e.arrowSize,Y=$e.horizontalScrollbarSize,ke=ie.get(58),Ne=ie.get(37);let Xe;if(typeof ke=="string"&&/^\d+(\.\d+)?ch$/.test(ke)){const Et=parseFloat(ke.substr(0,ke.length-2));Xe=C.clampedInt(Et*Ve,0,0,1e3)}else Xe=C.clampedInt(ke,0,0,1e3);Ne&&(Xe+=16);let Qe=0;if(We){const Et=Math.max(qe,Ze);Qe=Math.round(Et*ut)}let pt=0;Ke&&(pt=Fe);let St=0,Ct=St+pt,ft=Ct+Qe,wt=ft+Xe;const bt=re-pt-Qe-Xe;let Ut=!1,Pt=!1,Ft=-1;ye!==2&&(ce==="inherit"&&Oe?(Ut=!0,Pt=!0):de==="on"||de==="bounded"?Pt=!0:de==="wordWrapColumn"&&(Ft=we));const kt=W._computeMinimapLayout({outerWidth:re,outerHeight:Ce,lineHeight:Fe,typicalHalfwidthCharacterWidth:Ve,pixelRatio:Re,scrollBeyondLastLine:lt,minimap:ct,verticalScrollbarWidth:Ee,viewLineCount:Ae,remainingWidth:bt,isViewportWrapping:Pt},Se.memory||new P);kt.renderMinimap!==0&&kt.minimapLeft===0&&(St+=kt.minimapWidth,Ct+=kt.minimapWidth,ft+=kt.minimapWidth,wt+=kt.minimapWidth);const yt=bt-kt.minimapWidth,Qt=Math.max(1,Math.floor((yt-Ee-2)/Ve)),Vt=_e?he:0;return Pt&&(Ft=Math.max(1,Qt),de==="bounded"&&(Ft=Math.min(Ft,we))),{width:re,height:Ce,glyphMarginLeft:St,glyphMarginWidth:pt,lineNumbersLeft:Ct,lineNumbersWidth:Qe,decorationsLeft:ft,decorationsWidth:Xe,contentLeft:wt,contentWidth:yt,minimap:kt,viewportColumn:Qt,isWordWrapMinified:Ut,isViewportWrapping:Pt,wrappingColumn:Ft,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:Y,overviewRuler:{top:Vt,width:Ee,height:Ce-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=W;class H extends R{constructor(){const ie={enabled:!0};super(57,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:f.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:g(ie.enabled,this.defaultValue.enabled)}}}class x extends R{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:f.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:f.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:f.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),fontSize:C.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class J extends a{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>a.clamp(ie,0,150),{markdownDescription:f.localize(47,null)})}compute(ie,Se,re){return ie.fontInfo.lineHeight}}class ne extends R{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:f.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(49,null),f.localize(50,null),f.localize(51,null)],default:ie.size,description:f.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:f.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:f.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:f.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:f.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),size:m(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(Se.side,this.defaultValue.side,["right","left"]),showSlider:m(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Se.renderCharacters,this.defaultValue.renderCharacters),scale:C.clampedInt(Se.scale,1,1,3),maxColumn:C.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function se(ee){return ee==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class K extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{top:C.clampedInt(Se.top,0,0,1e3),bottom:C.clampedInt(Se.bottom,0,0,1e3)}}}class Q extends R{constructor(){const ie={enabled:!0,cycle:!1};super(76,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:f.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:f.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),cycle:g(Se.cycle,this.defaultValue.cycle)}}}class ae extends b{constructor(){super(129)}compute(ie,Se,re){return ie.pixelRatio}}class fe extends R{constructor(){const ie={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:f.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:f.localize(63,null)},other:{type:"boolean",default:ie.other,description:f.localize(64,null)}}}],default:ie,description:f.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Se=ie,re={other:g(Se.other,this.defaultValue.other),comments:g(Se.comments,this.defaultValue.comments),strings:g(Se.strings,this.defaultValue.strings)};return re.other&&re.comments&&re.strings?!0:!re.other&&!re.comments&&!re.strings?!1:re}return this.defaultValue}}var be;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null),f.localize(69,null)],default:"on",description:f.localize(70,null)})}validate(ie){let Se=this.defaultValue.renderType,re=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Se=4,re=ie):ie==="interval"?Se=3:ie==="relative"?Se=2:ie==="on"?Se=1:Se=0),{renderType:Se,renderFn:re}}}function ze(ee){const ie=ee.get(87);return ie==="editable"?ee.get(81):ie!=="on"}e.filterValidationDecorations=ze;class Ge extends R{constructor(){const ie=[],Se={type:"number",description:f.localize(71,null)};super(91,"rulers",ie,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:f.localize(72,null),format:"color-hex"}}}]},default:ie,description:f.localize(73,null)})}validate(ie){if(Array.isArray(ie)){const Se=[];for(let re of ie)if(typeof re=="number")Se.push({column:C.clampedInt(re,0,0,1e4),color:null});else if(re&&typeof re=="object"){const Ce=re;Se.push({column:C.clampedInt(Ce.column,0,0,1e4),color:Ce.color})}return Se.sort((re,Ce)=>re.column-Ce.column),Se}return this.defaultValue}}function Je(ee,ie){if(typeof ee!="string")return ie;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends R{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(74,null),f.localize(75,null),f.localize(76,null)],default:"auto",description:f.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(78,null),f.localize(79,null),f.localize(80,null)],default:"auto",description:f.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:f.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:f.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie,re=C.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ce=C.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:C.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Je(Se.vertical,this.defaultValue.vertical),horizontal:Je(Se.horizontal,this.defaultValue.horizontal),useShadows:g(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:re,horizontalSliderSize:C.clampedInt(Se.horizontalSliderSize,re,0,1e3),verticalScrollbarSize:Ce,verticalSliderSize:C.clampedInt(Se.verticalSliderSize,Ce,0,1e3),scrollByPage:g(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class te extends R{constructor(){const ie={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ie,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.nonBasicASCII,description:f.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ie.invisibleCharacters,description:f.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ie.ambiguousCharacters,description:f.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeComments,description:f.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeStrings,description:f.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ie.allowedCharacters,description:f.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ie.allowedLocales,description:f.localize(91,null)}})}applyUpdate(ie,Se){let re=!1;Se.allowedCharacters&&(T.equals(ie.allowedCharacters,Se.allowedCharacters)||(ie={...ie,allowedCharacters:Se.allowedCharacters},re=!0)),Se.allowedLocales&&(T.equals(ie.allowedLocales,Se.allowedLocales)||(ie={...ie,allowedLocales:Se.allowedLocales},re=!0));const Ce=super.applyUpdate(ie,Se);return re?new y(Ce.newValue,!0):Ce}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{nonBasicASCII:me(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ie.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ie.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ie,Se){if(typeof ie!="object"||!ie)return Se;const re={};for(const[Ce,Fe]of Object.entries(ie))Fe===!0&&(re[Ce]=!0);return re}}class G extends R{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:f.localize(92,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{enabled:g(Se.enabled,this.defaultValue.enabled),mode:m(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class X extends R{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:f.localize(93,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:g(ie.enabled,this.defaultValue.enabled)}}}class oe extends R{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(94,null),f.localize(95,null),f.localize(96,null)],default:ie.bracketPairs,description:f.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[f.localize(98,null),f.localize(99,null),f.localize(100,null)],default:ie.bracketPairsHorizontal,description:f.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:f.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:f.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:f.localize(104,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{bracketPairs:me(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:g(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function me(ee,ie,Se){const re=Se.indexOf(ee);return re===-1?ie:Se[re]}class Ie extends R{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(105,null),f.localize(106,null)],default:ie.insertMode,description:f.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:f.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:f.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:f.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:f.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:f.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:f.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:f.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:f.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(146,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Se=ie;return{insertMode:m(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(Se.showIcons,this.defaultValue.showIcons),showStatusBar:g(Se.showStatusBar,this.defaultValue.showStatusBar),preview:g(Se.preview,this.defaultValue.preview),previewMode:m(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Se.showMethods,this.defaultValue.showMethods),showFunctions:g(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:g(Se.showFields,this.defaultValue.showFields),showVariables:g(Se.showVariables,this.defaultValue.showVariables),showClasses:g(Se.showClasses,this.defaultValue.showClasses),showStructs:g(Se.showStructs,this.defaultValue.showStructs),showInterfaces:g(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Se.showModules,this.defaultValue.showModules),showProperties:g(Se.showProperties,this.defaultValue.showProperties),showEvents:g(Se.showEvents,this.defaultValue.showEvents),showOperators:g(Se.showOperators,this.defaultValue.showOperators),showUnits:g(Se.showUnits,this.defaultValue.showUnits),showValues:g(Se.showValues,this.defaultValue.showValues),showConstants:g(Se.showConstants,this.defaultValue.showConstants),showEnums:g(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Se.showKeywords,this.defaultValue.showKeywords),showWords:g(Se.showWords,this.defaultValue.showWords),showColors:g(Se.showColors,this.defaultValue.showColors),showFiles:g(Se.showFiles,this.defaultValue.showFiles),showReferences:g(Se.showReferences,this.defaultValue.showReferences),showFolders:g(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Se.showSnippets,this.defaultValue.showSnippets),showUsers:g(Se.showUsers,this.defaultValue.showUsers),showIssues:g(Se.showIssues,this.defaultValue.showIssues)}}}class xe extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(147,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ye extends b{constructor(){super(130)}compute(ie,Se,re){return Se.get(81)?!0:ie.tabFocusMode}}var it;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(it=e.WrappingIndent||(e.WrappingIndent={}));function st(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ot extends b{constructor(){super(132)}compute(ie,Se,re){const Ce=Se.get(131);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ce.isWordWrapMinified,isViewportWrapping:Ce.isViewportWrapping,wrappingColumn:Ce.wrappingColumn}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?rt:t.isLinux?gt:tt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ue(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var It;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=41]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=43]="fontFamily",ee[ee.fontInfo=44]="fontInfo",ee[ee.fontLigatures=45]="fontLigatures",ee[ee.fontSize=46]="fontSize",ee[ee.fontWeight=47]="fontWeight",ee[ee.formatOnPaste=48]="formatOnPaste",ee[ee.formatOnType=49]="formatOnType",ee[ee.glyphMargin=50]="glyphMargin",ee[ee.gotoLocation=51]="gotoLocation",ee[ee.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ee[ee.hover=53]="hover",ee[ee.inDiffEditor=54]="inDiffEditor",ee[ee.inlineSuggest=55]="inlineSuggest",ee[ee.letterSpacing=56]="letterSpacing",ee[ee.lightbulb=57]="lightbulb",ee[ee.lineDecorationsWidth=58]="lineDecorationsWidth",ee[ee.lineHeight=59]="lineHeight",ee[ee.lineNumbers=60]="lineNumbers",ee[ee.lineNumbersMinChars=61]="lineNumbersMinChars",ee[ee.linkedEditing=62]="linkedEditing",ee[ee.links=63]="links",ee[ee.matchBrackets=64]="matchBrackets",ee[ee.minimap=65]="minimap",ee[ee.mouseStyle=66]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=68]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=70]="multiCursorModifier",ee[ee.multiCursorPaste=71]="multiCursorPaste",ee[ee.occurrencesHighlight=72]="occurrencesHighlight",ee[ee.overviewRulerBorder=73]="overviewRulerBorder",ee[ee.overviewRulerLanes=74]="overviewRulerLanes",ee[ee.padding=75]="padding",ee[ee.parameterHints=76]="parameterHints",ee[ee.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=79]="quickSuggestions",ee[ee.quickSuggestionsDelay=80]="quickSuggestionsDelay",ee[ee.readOnly=81]="readOnly",ee[ee.renameOnType=82]="renameOnType",ee[ee.renderControlCharacters=83]="renderControlCharacters",ee[ee.renderFinalNewline=84]="renderFinalNewline",ee[ee.renderLineHighlight=85]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=87]="renderValidationDecorations",ee[ee.renderWhitespace=88]="renderWhitespace",ee[ee.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ee[ee.roundedSelection=90]="roundedSelection",ee[ee.rulers=91]="rulers",ee[ee.scrollbar=92]="scrollbar",ee[ee.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=94]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=95]="scrollPredominantAxis",ee[ee.selectionClipboard=96]="selectionClipboard",ee[ee.selectionHighlight=97]="selectionHighlight",ee[ee.selectOnLineNumbers=98]="selectOnLineNumbers",ee[ee.showFoldingControls=99]="showFoldingControls",ee[ee.showUnused=100]="showUnused",ee[ee.snippetSuggestions=101]="snippetSuggestions",ee[ee.smartSelect=102]="smartSelect",ee[ee.smoothScrolling=103]="smoothScrolling",ee[ee.stickyTabStops=104]="stickyTabStops",ee[ee.stopRenderingLineAfter=105]="stopRenderingLineAfter",ee[ee.suggest=106]="suggest",ee[ee.suggestFontSize=107]="suggestFontSize",ee[ee.suggestLineHeight=108]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ee[ee.suggestSelection=110]="suggestSelection",ee[ee.tabCompletion=111]="tabCompletion",ee[ee.tabIndex=112]="tabIndex",ee[ee.unicodeHighlighting=113]="unicodeHighlighting",ee[ee.unusualLineTerminators=114]="unusualLineTerminators",ee[ee.useShadowDOM=115]="useShadowDOM",ee[ee.useTabStops=116]="useTabStops",ee[ee.wordSeparators=117]="wordSeparators",ee[ee.wordWrap=118]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=121]="wordWrapColumn",ee[ee.wordWrapOverride1=122]="wordWrapOverride1",ee[ee.wordWrapOverride2=123]="wordWrapOverride2",ee[ee.wrappingIndent=124]="wrappingIndent",ee[ee.wrappingStrategy=125]="wrappingStrategy",ee[ee.showDeprecated=126]="showDeprecated",ee[ee.inlayHints=127]="inlayHints",ee[ee.editorClassName=128]="editorClassName",ee[ee.pixelRatio=129]="pixelRatio",ee[ee.tabFocusMode=130]="tabFocusMode",ee[ee.layoutInfo=131]="layoutInfo",ee[ee.wrappingInfo=132]="wrappingInfo"})(It=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new E(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(148,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(149,null),""],markdownDescription:f.localize(150,null)})),accessibilitySupport:Ue(new i),accessibilityPageSize:Ue(new C(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(151,null)})),ariaLabel:Ue(new s(4,"ariaLabel",f.localize(152,null))),autoClosingBrackets:Ue(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(153,null),f.localize(154,null),""],description:f.localize(155,null)})),autoClosingDelete:Ue(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(156,null),""],description:f.localize(157,null)})),autoClosingOvertype:Ue(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(158,null),""],description:f.localize(159,null)})),autoClosingQuotes:Ue(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(160,null),f.localize(161,null),""],description:f.localize(162,null)})),autoIndent:Ue(new S(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[f.localize(163,null),f.localize(164,null),f.localize(165,null),f.localize(166,null),f.localize(167,null)],description:f.localize(168,null)})),automaticLayout:Ue(new E(10,"automaticLayout",!1)),autoSurround:Ue(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(169,null),f.localize(170,null),f.localize(171,null),""],description:f.localize(172,null)})),bracketPairColorization:Ue(new X),bracketPairGuides:Ue(new oe),stickyTabStops:Ue(new E(104,"stickyTabStops",!1,{description:f.localize(173,null)})),codeLens:Ue(new E(14,"codeLens",!0,{description:f.localize(174,null)})),codeLensFontFamily:Ue(new s(15,"codeLensFontFamily","",{description:f.localize(175,null)})),codeLensFontSize:Ue(new C(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(176,null)})),colorDecorators:Ue(new E(17,"colorDecorators",!0,{description:f.localize(177,null)})),columnSelection:Ue(new E(18,"columnSelection",!1,{description:f.localize(178,null)})),comments:Ue(new n),contextmenu:Ue(new E(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new E(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(179,null)})),cursorBlinking:Ue(new S(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:f.localize(180,null)})),cursorSmoothCaretAnimation:Ue(new E(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(181,null)})),cursorStyle:Ue(new S(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:f.localize(182,null)})),cursorSurroundingLines:Ue(new C(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(183,null)})),cursorSurroundingLinesStyle:Ue(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(184,null),f.localize(185,null)],description:f.localize(186,null)})),cursorWidth:Ue(new C(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(187,null)})),disableLayerHinting:Ue(new E(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new E(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new E(30,"domReadOnly",!1)),dragAndDrop:Ue(new E(31,"dragAndDrop",!0,{description:f.localize(188,null)})),emptySelectionClipboard:Ue(new A),extraEditorClassName:Ue(new s(33,"extraEditorClassName","")),fastScrollSensitivity:Ue(new a(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:f.localize(189,null)})),find:Ue(new O),fixedOverflowWidgets:Ue(new E(36,"fixedOverflowWidgets",!1)),folding:Ue(new E(37,"folding",!0,{description:f.localize(190,null)})),foldingStrategy:Ue(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(191,null),f.localize(192,null)],description:f.localize(193,null)})),foldingHighlight:Ue(new E(39,"foldingHighlight",!0,{description:f.localize(194,null)})),foldingImportsByDefault:Ue(new E(40,"foldingImportsByDefault",!1,{description:f.localize(195,null)})),foldingMaximumRegions:Ue(new C(41,"foldingMaximumRegions",5e3,10,65e3,{description:f.localize(196,null)})),unfoldOnClickAfterEndOfLine:Ue(new E(42,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(197,null)})),fontFamily:Ue(new s(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(198,null)})),fontInfo:Ue(new F),fontLigatures2:Ue(new N),fontSize:Ue(new M),fontWeight:Ue(new V),formatOnPaste:Ue(new E(48,"formatOnPaste",!1,{description:f.localize(199,null)})),formatOnType:Ue(new E(49,"formatOnType",!1,{description:f.localize(200,null)})),glyphMargin:Ue(new E(50,"glyphMargin",!0,{description:f.localize(201,null)})),gotoLocation:Ue(new $),hideCursorInOverviewRuler:Ue(new E(52,"hideCursorInOverviewRuler",!1,{description:f.localize(202,null)})),hover:Ue(new U),inDiffEditor:Ue(new E(54,"inDiffEditor",!1)),letterSpacing:Ue(new a(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>a.clamp(ee,-5,20),{description:f.localize(203,null)})),lightbulb:Ue(new H),lineDecorationsWidth:Ue(new p(58,"lineDecorationsWidth",10)),lineHeight:Ue(new J),lineNumbers:Ue(new Me),lineNumbersMinChars:Ue(new C(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new E(62,"linkedEditing",!1,{description:f.localize(204,null)})),links:Ue(new E(63,"links",!0,{description:f.localize(205,null)})),matchBrackets:Ue(new o(64,"matchBrackets","always",["always","near","never"],{description:f.localize(206,null)})),minimap:Ue(new ne),mouseStyle:Ue(new o(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new a(67,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:f.localize(207,null)})),mouseWheelZoom:Ue(new E(68,"mouseWheelZoom",!1,{markdownDescription:f.localize(208,null)})),multiCursorMergeOverlapping:Ue(new E(69,"multiCursorMergeOverlapping",!0,{description:f.localize(209,null)})),multiCursorModifier:Ue(new S(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],se,{markdownEnumDescriptions:[f.localize(210,null),f.localize(211,null)],markdownDescription:f.localize(212,null)})),multiCursorPaste:Ue(new o(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(213,null),f.localize(214,null)],markdownDescription:f.localize(215,null)})),occurrencesHighlight:Ue(new E(72,"occurrencesHighlight",!0,{description:f.localize(216,null)})),overviewRulerBorder:Ue(new E(73,"overviewRulerBorder",!0,{description:f.localize(217,null)})),overviewRulerLanes:Ue(new C(74,"overviewRulerLanes",3,0,3)),padding:Ue(new K),parameterHints:Ue(new Q),peekWidgetDefaultFocus:Ue(new o(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(218,null),f.localize(219,null)],description:f.localize(220,null)})),definitionLinkOpensInPeek:Ue(new E(78,"definitionLinkOpensInPeek",!1,{description:f.localize(221,null)})),quickSuggestions:Ue(new fe),quickSuggestionsDelay:Ue(new C(80,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(222,null)})),readOnly:Ue(new E(81,"readOnly",!1)),renameOnType:Ue(new E(82,"renameOnType",!1,{description:f.localize(223,null),markdownDeprecationMessage:f.localize(224,null)})),renderControlCharacters:Ue(new E(83,"renderControlCharacters",!0,{description:f.localize(225,null),restricted:!0})),renderFinalNewline:Ue(new E(84,"renderFinalNewline",!0,{description:f.localize(226,null)})),renderLineHighlight:Ue(new o(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(227,null)],description:f.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Ue(new E(86,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(229,null)})),renderValidationDecorations:Ue(new o(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(230,null),f.localize(231,null),f.localize(232,null),""],description:f.localize(233,null)})),revealHorizontalRightPadding:Ue(new C(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ue(new E(90,"roundedSelection",!0,{description:f.localize(234,null)})),rulers:Ue(new Ge),scrollbar:Ue(new q),scrollBeyondLastColumn:Ue(new C(93,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(235,null)})),scrollBeyondLastLine:Ue(new E(94,"scrollBeyondLastLine",!0,{description:f.localize(236,null)})),scrollPredominantAxis:Ue(new E(95,"scrollPredominantAxis",!0,{description:f.localize(237,null)})),selectionClipboard:Ue(new E(96,"selectionClipboard",!0,{description:f.localize(238,null),included:t.isLinux})),selectionHighlight:Ue(new E(97,"selectionHighlight",!0,{description:f.localize(239,null)})),selectOnLineNumbers:Ue(new E(98,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(240,null),f.localize(241,null)],description:f.localize(242,null)})),showUnused:Ue(new E(100,"showUnused",!0,{description:f.localize(243,null)})),showDeprecated:Ue(new E(126,"showDeprecated",!0,{description:f.localize(244,null)})),inlayHints:Ue(new x),snippetSuggestions:Ue(new o(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null),f.localize(248,null)],description:f.localize(249,null)})),smartSelect:Ue(new xe),smoothScrolling:Ue(new E(103,"smoothScrolling",!1,{description:f.localize(250,null)})),stopRenderingLineAfter:Ue(new C(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new Ie),inlineSuggest:Ue(new G),suggestFontSize:Ue(new C(107,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(251,null)})),suggestLineHeight:Ue(new C(108,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(252,null)})),suggestOnTriggerCharacters:Ue(new E(109,"suggestOnTriggerCharacters",!0,{description:f.localize(253,null)})),suggestSelection:Ue(new o(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(254,null),f.localize(255,null),f.localize(256,null)],description:f.localize(257,null)})),tabCompletion:Ue(new o(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),tabIndex:Ue(new C(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new te),unusualLineTerminators:Ue(new o(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(262,null),f.localize(263,null),f.localize(264,null)],description:f.localize(265,null)})),useShadowDOM:Ue(new E(115,"useShadowDOM",!0)),useTabStops:Ue(new E(116,"useTabStops",!0,{description:f.localize(266,null)})),wordSeparators:Ue(new s(117,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:f.localize(267,null)})),wordWrap:Ue(new o(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(268,null),f.localize(269,null),f.localize(270,null),f.localize(271,null)],description:f.localize(272,null)})),wordWrapBreakAfterCharacters:Ue(new s(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new s(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new C(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(273,null)})),wordWrapOverride1:Ue(new o(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ue(new S(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],st,{enumDescriptions:[f.localize(274,null),f.localize(275,null),f.localize(276,null),f.localize(277,null)],description:f.localize(278,null)})),wrappingStrategy:Ue(new o(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(279,null),f.localize(280,null)],description:f.localize(281,null)})),editorClassName:Ue(new w),pixelRatio:Ue(new ae),tabFocusMode:Ue(new Ye),layoutInfo:Ue(new W),wrappingInfo:Ue(new ot)}}),define(pe[156],ve([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[157],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[158],ve([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[159],ve([19,20]),function(Z,e){return Z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[160],ve([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(pe[161],ve([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(pe[162],ve([19,20]),function(Z,e){return Z.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[163],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[164],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[165],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[166],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[167],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[168],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[169],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[170],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[171],ve([19,20]),function(Z,e){return Z.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[172],ve([19,20]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(pe[173],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[174],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[175],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[176],ve([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[177],ve([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[178],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var f;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var t;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[179],ve([0,1,158]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function D(l){return l=l.trim(),l==="*"||t.test(l)}e.isValidVersionStr=D;function T(l){if(!D(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=l.match(t);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=T;function I(l){if(!l)return null;let b=l.majorBase,p=l.majorMustEqual,g=l.minorBase,E=l.minorMustEqual,L=l.patchBase,C=l.patchMustEqual;l.hasCaret&&(b===0||(E=!1),C=!1);let a=0;if(l.preRelease){const s=k.exec(l.preRelease);if(s){const[,m,o,S]=s;a=Date.UTC(Number(m),Number(o)-1,Number(S))}}return{majorBase:b,majorMustEqual:p,minorBase:g,minorMustEqual:E,patchBase:L,patchMustEqual:C,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=I;function _(l,b,p){let g;typeof l=="string"?g=I(T(l)):g=l;let E;b instanceof Date?E=b.getTime():typeof b=="string"&&(E=new Date(b).getTime());let L;if(typeof p=="string"?L=I(T(p)):L=p,!g||!L)return!1;let C=g.majorBase,a=g.minorBase,s=g.patchBase,m=L.majorBase,o=L.minorBase,S=L.patchBase,r=L.notBefore,i=L.majorMustEqual,n=L.minorMustEqual,u=L.patchMustEqual;return L.isMinimum?C>m?!0:C<m?!1:a>o?!0:a<o||E&&E<r?!1:s>=S:(C===1&&m===0&&(!i||!n||!u)&&(m=1,o=0,S=0,i=!0,n=!1,u=!1),C<m?!1:C>m?!i:a<o?!1:a>o?!n:s<S?!1:s>S?!u:!(E&&E<r))}e.isValidVersion=_;function P(l,b,p,g){return p.isBuiltin||typeof p.main=="undefined"?!0:y(l,b,p.engines.vscode,g)}e.isValidExtensionVersion=P;function R(l,b,p){return l==="*"||y(b,p,l)}e.isEngineValid=R;function y(l,b,p,g=[]){let E=I(T(p));if(!E)return g.push(f.localize(0,null,p)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(f.localize(1,null,p)),!1}else if(!E.majorMustEqual)return g.push(f.localize(2,null,p)),!1;return _(l,b,E)?!0:(g.push(f.localize(3,null,l,p)),!1)}}),define(pe[115],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(k,D=[],T=!1){this.ctor=k,this.staticArguments=D,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=f}),define(pe[61],ve([0,1,115]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function k(T,I,_){I instanceof f.SyncDescriptor||(I=new f.SyncDescriptor(I,[],_)),t.push([T,I])}e.registerSingleton=k;function D(){return t}e.getSingletonServiceDescriptors=D}),define(pe[180],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=f;class t{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let T of this._nodes.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const I=this.lookupOrInsertNode(D),_=this.lookupOrInsertNode(T);I.outgoing.set(this._hashFn(T),_),_.incoming.set(this._hashFn(D),I)}removeNode(D){const T=this._hashFn(D);this._nodes.delete(T);for(let I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(D){const T=this._hashFn(D);let I=this._nodes.get(T);return I||(I=new f(D),this._nodes.set(T,I)),I}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[T,I]of this._nodes)D.push(`${T}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,T]of this._nodes){const I=new Set([D]),_=this._findCycle(T,I);if(_)return _}}_findCycle(D,T){for(let[I,_]of D.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const P=this._findCycle(_,T);if(P)return P;T.delete(I)}}}e.Graph=t}),define(pe[4],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(_){return _[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(f=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(T,I,_,P){I[f.DI_TARGET]===I?I[f.DI_DEPENDENCIES].push({id:T,index:_,optional:P}):(I[f.DI_DEPENDENCIES]=[{id:T,index:_,optional:P}],I[f.DI_TARGET]=I)}function k(T){if(f.serviceIds.has(T))return f.serviceIds.get(T);const I=function(_,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,_,R,!1)};return I.toString=()=>T,f.serviceIds.set(T,I),I}e.createDecorator=k;function D(T){return T}e.refineServiceDecorator=D}),define(pe[181],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,f.createDecorator)("modelService");function t(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(pe[182],ve([0,1,3,6,82,181]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function T(_){return typeof _=="string"?!1:Array.isArray(_)?_.every(T):!!_.exclusive}class I{constructor(){this._clock=0,this._entries=[],this._onDidChange=new f.Emitter}get onDidChange(){return this._onDidChange.event}register(P,R){let y={selector:P,provider:R,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(y){const l=this._entries.indexOf(y);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(P){return this.all(P).length>0}all(P){if(!P)return[];this._updateScores(P);const R=[];for(let y of this._entries)y._score>0&&R.push(y.provider);return R}ordered(P){const R=[];return this._orderedForEach(P,y=>R.push(y.provider)),R}orderedGroups(P){const R=[];let y,l;return this._orderedForEach(P,b=>{y&&l===b._score?y.push(b.provider):(l=b._score,y=[b.provider],R.push(y))}),R}_orderedForEach(P,R){if(!!P){this._updateScores(P);for(const y of this._entries)y._score>0&&R(y)}}_updateScores(P){const R={uri:P.uri.toString(),language:P.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let y of this._entries)if(y._score=(0,k.score)(y.selector,P.uri,P.getLanguageId(),(0,D.shouldSynchronizeModel)(P)),T(y.selector)&&y._score>0){for(let l of this._entries)l._score=0;y._score=1e3;break}this._entries.sort(I._compareByScoreAndTime)}}static _compareByScoreAndTime(P,R){return P._score<R._score?1:P._score>R._score?-1:P._time<R._time?1:P._time>R._time?-1:0}}e.LanguageFeatureRegistry=I}),define(pe[83],ve([0,1,2,41,182,148,74]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(w){w[w.Null=0]="Null",w[w.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var _;(function(w){w[w.NotSet=-1]="NotSet",w[w.None=0]="None",w[w.Italic=1]="Italic",w[w.Bold=2]="Bold",w[w.Underline=4]="Underline",w[w.Strikethrough=8]="Strikethrough"})(_=e.FontStyle||(e.FontStyle={}));var P;(function(w){w[w.None=0]="None",w[w.DefaultForeground=1]="DefaultForeground",w[w.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var R;(function(w){w[w.Other=0]="Other",w[w.Comment=1]="Comment",w[w.String=2]="String",w[w.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var y;(function(w){w[w.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",w[w.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",w[w.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",w[w.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",w[w.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",w[w.ITALIC_MASK=1024]="ITALIC_MASK",w[w.BOLD_MASK=2048]="BOLD_MASK",w[w.UNDERLINE_MASK=4096]="UNDERLINE_MASK",w[w.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",w[w.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",w[w.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",w[w.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",w[w.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",w[w.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",w[w.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",w[w.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",w[w.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",w[w.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",w[w.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",w[w.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(y=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&768)>>>8}static getFontStyle(A){return(A&15360)>>>10}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){const O=this.getForeground(A);let N="mtk"+O;const F=this.getFontStyle(A);return F&1&&(N+=" mtki"),F&2&&(N+=" mtkb"),F&4&&(N+=" mtku"),F&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(A,O){const N=this.getForeground(A),F=this.getFontStyle(A);let M=`color: ${O[N]};`;F&1&&(M+="font-style: italic;"),F&2&&(M+="font-weight: bold;");let V="";return F&4&&(V+=" underline"),F&8&&(V+=" line-through"),V&&(M+=`text-decoration:${V};`),M}static getPresentationFromMetadata(A){const O=this.getForeground(A),N=this.getFontStyle(A);return{foreground:O,italic:Boolean(N&1),bold:Boolean(N&2),underline:Boolean(N&4),strikethrough:Boolean(N&8)}}}e.TokenMetadata=l;var b;(function(w){w[w.Method=0]="Method",w[w.Function=1]="Function",w[w.Constructor=2]="Constructor",w[w.Field=3]="Field",w[w.Variable=4]="Variable",w[w.Class=5]="Class",w[w.Struct=6]="Struct",w[w.Interface=7]="Interface",w[w.Module=8]="Module",w[w.Property=9]="Property",w[w.Event=10]="Event",w[w.Operator=11]="Operator",w[w.Unit=12]="Unit",w[w.Value=13]="Value",w[w.Constant=14]="Constant",w[w.Enum=15]="Enum",w[w.EnumMember=16]="EnumMember",w[w.Keyword=17]="Keyword",w[w.Text=18]="Text",w[w.Color=19]="Color",w[w.File=20]="File",w[w.Reference=21]="Reference",w[w.Customcolor=22]="Customcolor",w[w.Folder=23]="Folder",w[w.TypeParameter=24]="TypeParameter",w[w.User=25]="User",w[w.Issue=26]="Issue",w[w.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var p;(function(w){const A=new Map;A.set(0,T.Codicon.symbolMethod),A.set(1,T.Codicon.symbolFunction),A.set(2,T.Codicon.symbolConstructor),A.set(3,T.Codicon.symbolField),A.set(4,T.Codicon.symbolVariable),A.set(5,T.Codicon.symbolClass),A.set(6,T.Codicon.symbolStruct),A.set(7,T.Codicon.symbolInterface),A.set(8,T.Codicon.symbolModule),A.set(9,T.Codicon.symbolProperty),A.set(10,T.Codicon.symbolEvent),A.set(11,T.Codicon.symbolOperator),A.set(12,T.Codicon.symbolUnit),A.set(13,T.Codicon.symbolValue),A.set(15,T.Codicon.symbolEnum),A.set(14,T.Codicon.symbolConstant),A.set(15,T.Codicon.symbolEnum),A.set(16,T.Codicon.symbolEnumMember),A.set(17,T.Codicon.symbolKeyword),A.set(27,T.Codicon.symbolSnippet),A.set(18,T.Codicon.symbolText),A.set(19,T.Codicon.symbolColor),A.set(20,T.Codicon.symbolFile),A.set(21,T.Codicon.symbolReference),A.set(22,T.Codicon.symbolCustomColor),A.set(23,T.Codicon.symbolFolder),A.set(24,T.Codicon.symbolTypeParameter),A.set(25,T.Codicon.account),A.set(26,T.Codicon.issues);function O(M){let V=A.get(M);return V||(console.info("No codicon found for CompletionItemKind "+M),V=T.Codicon.symbolProperty),V}w.toIcon=O;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function F(M,V){let $=N.get(M);return typeof $=="undefined"&&!V&&($=9),$}w.fromString=F})(p=e.CompletionItemKinds||(e.CompletionItemKinds={}));var g;(function(w){w[w.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(w){w[w.KeepWhitespace=1]="KeepWhitespace",w[w.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var L;(function(w){w[w.Invoke=0]="Invoke",w[w.TriggerCharacter=1]="TriggerCharacter",w[w.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(w){w[w.Automatic=0]="Automatic",w[w.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(w){w[w.Invoke=1]="Invoke",w[w.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(w){return w&&f.URI.isUri(w.uri)&&t.Range.isIRange(w.range)&&(t.Range.isIRange(w.originSelectionRange)||t.Range.isIRange(w.targetSelectionRange))}e.isLocationLink=o;var S;(function(w){w[w.File=0]="File",w[w.Module=1]="Module",w[w.Namespace=2]="Namespace",w[w.Package=3]="Package",w[w.Class=4]="Class",w[w.Method=5]="Method",w[w.Property=6]="Property",w[w.Field=7]="Field",w[w.Constructor=8]="Constructor",w[w.Enum=9]="Enum",w[w.Interface=10]="Interface",w[w.Function=11]="Function",w[w.Variable=12]="Variable",w[w.Constant=13]="Constant",w[w.String=14]="String",w[w.Number=15]="Number",w[w.Boolean=16]="Boolean",w[w.Array=17]="Array",w[w.Object=18]="Object",w[w.Key=19]="Key",w[w.Null=20]="Null",w[w.EnumMember=21]="EnumMember",w[w.Struct=22]="Struct",w[w.Event=23]="Event",w[w.Operator=24]="Operator",w[w.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var r;(function(w){w[w.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(w){const A=new Map;A.set(0,T.Codicon.symbolFile),A.set(1,T.Codicon.symbolModule),A.set(2,T.Codicon.symbolNamespace),A.set(3,T.Codicon.symbolPackage),A.set(4,T.Codicon.symbolClass),A.set(5,T.Codicon.symbolMethod),A.set(6,T.Codicon.symbolProperty),A.set(7,T.Codicon.symbolField),A.set(8,T.Codicon.symbolConstructor),A.set(9,T.Codicon.symbolEnum),A.set(10,T.Codicon.symbolInterface),A.set(11,T.Codicon.symbolFunction),A.set(12,T.Codicon.symbolVariable),A.set(13,T.Codicon.symbolConstant),A.set(14,T.Codicon.symbolString),A.set(15,T.Codicon.symbolNumber),A.set(16,T.Codicon.symbolBoolean),A.set(17,T.Codicon.symbolArray),A.set(18,T.Codicon.symbolObject),A.set(19,T.Codicon.symbolKey),A.set(20,T.Codicon.symbolNull),A.set(21,T.Codicon.symbolEnumMember),A.set(22,T.Codicon.symbolStruct),A.set(23,T.Codicon.symbolEvent),A.set(24,T.Codicon.symbolOperator),A.set(25,T.Codicon.symbolTypeParameter);function O(N){let F=A.get(N);return F||(console.info("No codicon found for SymbolKind "+N),F=T.Codicon.symbolProperty),F}w.toIcon=O})(i=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(A){this.value=A}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var u;(function(w){function A(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}w.is=A})(u=e.Command||(e.Command={}));var c;(function(w){w[w.Collapsed=0]="Collapsed",w[w.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(w){w[w.Editing=0]="Editing",w[w.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var h;(function(w){w[w.Other=0]="Other",w[w.Type=1]="Type",w[w.Parameter=2]="Parameter"})(h=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new D.TokenizationRegistry;var v;(function(w){w[w.None=0]="None",w[w.Option=1]="Option",w[w.Default=2]="Default",w[w.Preferred=3]="Preferred"})(v=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[116],ve([0,1,13,2,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function D(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationOverrides=D;function T(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||f.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=_;function P(E,L){const C=Object.create(null);for(let a in E)R(C,a,E[a],L);return C}e.toValuesTree=P;function R(E,L,C,a){const s=L.split("."),m=s.pop();let o=E;for(let S=0;S<s.length;S++){let r=s[S],i=o[r];switch(typeof i){case"undefined":i=o[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${L} as ${s.slice(0,S+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[m]=C}catch{a(`Ignoring ${L} as ${s.join(".")} is ${JSON.stringify(o)}`)}else a(`Ignoring ${L} as ${s.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=R;function y(E,L){const C=L.split(".");l(E,C)}e.removeFromValueTree=y;function l(E,L){const C=L.shift();if(L.length===0){delete E[C];return}if(Object.keys(E).indexOf(C)!==-1){const a=E[C];typeof a=="object"&&!Array.isArray(a)&&(l(a,L),Object.keys(a).length===0&&delete E[C])}}function b(E,L,C){function a(o,S){let r=o;for(const i of S){if(typeof r!="object"||r===null)return;r=r[i]}return r}const s=L.split("."),m=a(E,s);return typeof m=="undefined"?C:m}e.getConfigurationValue=b;function p(E,L,C){Object.keys(L).forEach(a=>{a!=="__proto__"&&(a in E?f.isObject(E[a])&&f.isObject(L[a])?p(E[a],L[a],C):C&&(E[a]=L[a]):E[a]=L[a])})}e.merge=p;function g(E,L,C){const a=E.inspect(L),s=E.inspect(C);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:a.defaultValue}e.getMigratedSettingValue=g}),define(pe[62],ve([0,1,12,8,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let D=f.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",f.isMacintosh),T.set("isLinux",f.isLinux),T.set("isWindows",f.isWindows),T.set("isWeb",f.isWeb),T.set("isMacNative",f.isMacintosh&&!f.isWeb),T.set("isEdge",D.indexOf("Edg/")>=0),T.set("isFirefox",D.indexOf("Firefox")>=0),T.set("isChrome",D.indexOf("Chrome")>=0),T.set("isSafari",D.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var _;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return l.INSTANCE}static true(){return b.INSTANCE}static has(F){return p.create(F)}static equals(F,M){return g.create(F,M)}static notEquals(F,M){return C.create(F,M)}static regex(F,M){return i.create(F,M)}static in(F,M){return E.create(F,M)}static not(F){return a.create(F)}static and(...F){return c.create(F,null)}static or(...F){return d.create(F,null,!0)}static greater(F,M){return m.create(F,M)}static greaterEquals(F,M){return o.create(F,M)}static smaller(F,M){return S.create(F,M)}static smallerEquals(F,M){return r.create(F,M)}static deserialize(F,M=!1){if(!!F)return this._deserializeOrExpression(F,M)}static _deserializeOrExpression(F,M){let V=F.split("||");return d.create(V.map($=>this._deserializeAndExpression($,M)),null,!0)}static _deserializeAndExpression(F,M){let V=F.split("&&");return c.create(V.map($=>this._deserializeOne($,M)),null)}static _deserializeOne(F,M){if(F=F.trim(),F.indexOf("!=")>=0){let V=F.split("!=");return C.create(V[0].trim(),this._deserializeValue(V[1],M))}if(F.indexOf("==")>=0){let V=F.split("==");return g.create(V[0].trim(),this._deserializeValue(V[1],M))}if(F.indexOf("=~")>=0){let V=F.split("=~");return i.create(V[0].trim(),this._deserializeRegexValue(V[1],M))}if(F.indexOf(" in ")>=0){let V=F.split(" in ");return E.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const V=F.split(">=");return o.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const V=F.split(">");return m.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const V=F.split("<=");return r.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const V=F.split("<");return S.create(V[0].trim(),V[1].trim())}return/^\!\s*/.test(F)?a.create(F.substr(1).trim()):p.create(F)}static _deserializeValue(F,M){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let V=/^'([^']*)'$/.exec(F);return V?V[1].trim():F}static _deserializeRegexValue(F,M){if((0,t.isFalsyOrWhitespace)(F)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let V=F.indexOf("/"),$=F.lastIndexOf("/");if(V===$||V<0){if(M)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let U=F.slice(V+1,$),B=F[$+1]==="i"?"i":"";try{return new RegExp(U,B)}catch(W){if(M)throw new Error(`bad regexp-value '${F}', parse error: ${W}`);return console.warn(`bad regexp-value '${F}', parse error: ${W}`),null}}}e.ContextKeyExpr=P;function R(N,F){const M=N?N.substituteConstants():void 0,V=F?F.substituteConstants():void 0;return!M&&!V?!0:!M||!V?!1:M.equals(V)}e.expressionsAreEqualWithConstantSubstitution=R;function y(N,F){return N.cmp(F)}class l{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class b{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class p{constructor(F,M){this.key=F,this.negated=M,this.type=2}static create(F,M=null){const V=T.get(F);return typeof V=="boolean"?V?b.INSTANCE:l.INSTANCE:new p(F,M)}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class g{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=4}static create(F,M,V=null){if(typeof M=="boolean")return M?p.create(F,V):a.create(F,V);const $=T.get(F);return typeof $=="boolean"?M===($?"true":"false")?b.INSTANCE:l.INSTANCE:new g(F,M,V)}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const M=F?"true":"false";return this.value===M?b.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class E{constructor(F,M){this.key=F,this.valueKey=M,this.type=10,this.negated=null}static create(F,M){return new E(F,M)}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const M=F.getValue(this.valueKey),V=F.getValue(this.key);return Array.isArray(M)?M.indexOf(V)>=0:typeof V=="string"&&typeof M=="object"&&M!==null?I.call(M,V):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this)),this.negated}}e.ContextKeyInExpr=E;class L{constructor(F){this._actual=F,this.type=11}static create(F){return new L(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new L(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=L;class C{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=5}static create(F,M,V=null){if(typeof M=="boolean")return M?a.create(F,V):p.create(F,V);const $=T.get(F);return typeof $=="boolean"?M===($?"true":"false")?l.INSTANCE:b.INSTANCE:new C(F,M,V)}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=T.get(this.key);if(typeof F=="boolean"){const M=F?"true":"false";return this.value===M?l.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=C;class a{constructor(F,M){this.key=F,this.negated=M,this.type=3}static create(F,M=null){const V=T.get(F);return typeof V=="boolean"?V?l.INSTANCE:b.INSTANCE:new a(F,M)}cmp(F){return F.type!==this.type?this.type-F.type:v(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=T.get(this.key);return typeof F=="boolean"?F?l.INSTANCE:b.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=a;function s(N,F){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?F(N):l.INSTANCE}class m{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=12}static create(F,M,V=null){return s(M,$=>new m(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=m;class o{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=13}static create(F,M,V=null){return s(M,$=>new o(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class S{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=14}static create(F,M,V=null){return s(M,$=>new S(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=S;class r{constructor(F,M,V){this.key=F,this.value=M,this.negated=V,this.type=15}static create(F,M,V=null){return s(M,$=>new r(F,$,V))}cmp(F){return F.type!==this.type?this.type-F.type:w(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(F,M){this.key=F,this.regexp=M,this.type=7,this.negated=null}static create(F,M){return new i(F,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const M=this.regexp?this.regexp.source:"",V=F.regexp?F.regexp.source:"";return M<V?-1:M>V?1:0}equals(F){if(F.type===this.type){const M=this.regexp?this.regexp.source:"",V=F.regexp?F.regexp.source:"";return this.key===F.key&&M===V}return!1}substituteConstants(){return this}evaluate(F){let M=F.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{constructor(F){this._actual=F,this.type=8}static create(F){return new n(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new n(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function u(N){let F=null;for(let M=0,V=N.length;M<V;M++){const $=N[M].substituteConstants();if(N[M]!==$&&F===null){F=[];for(let U=0;U<M;U++)F[U]=N[U]}F!==null&&(F[M]=$)}return F===null?N:F}class c{constructor(F,M){this.expr=F,this.negated=M,this.type=6}static create(F,M){return c._normalizeArr(F,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let M=0,V=this.expr.length;M<V;M++){const $=y(this.expr[M],F.expr[M]);if($!==0)return $}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].equals(F.expr[M]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:c.create(F,this.negated)}evaluate(F){for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].evaluate(F))return!1;return!0}static _normalizeArr(F,M){const V=[];let $=!1;for(const U of F)if(!!U){if(U.type===1){$=!0;continue}if(U.type===0)return l.INSTANCE;if(U.type===6){V.push(...U.expr);continue}V.push(U)}if(V.length===0&&$)return b.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(y);for(let U=1;U<V.length;U++)V[U-1].equals(V[U])&&(V.splice(U,1),U--);if(V.length===1)return V[0];for(;V.length>1;){const U=V[V.length-1];if(U.type!==9)break;V.pop();const B=V.pop(),W=V.length===0,H=d.create(U.expr.map(x=>c.create([x,B],null)),null,W);H&&(V.push(H),V.sort(y))}return V.length===1?V[0]:new c(V,M)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let M of this.expr)F.push(...M.keys());return F}map(F){return new c(this.expr.map(M=>M.map(F)),null)}negate(){if(!this.negated){const F=[];for(let M of this.expr)F.push(M.negate());this.negated=d.create(F,this,!0)}return this.negated}}class d{constructor(F,M){this.expr=F,this.negated=M,this.type=9}static create(F,M,V){return d._normalizeArr(F,M,V)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let M=0,V=this.expr.length;M<V;M++){const $=y(this.expr[M],F.expr[M]);if($!==0)return $}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let M=0,V=this.expr.length;M<V;M++)if(!this.expr[M].equals(F.expr[M]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:d.create(F,this.negated,!1)}evaluate(F){for(let M=0,V=this.expr.length;M<V;M++)if(this.expr[M].evaluate(F))return!0;return!1}static _normalizeArr(F,M,V){let $=[],U=!1;if(F){for(let B=0,W=F.length;B<W;B++){const H=F[B];if(!!H){if(H.type===0){U=!0;continue}if(H.type===1)return b.INSTANCE;if(H.type===9){$=$.concat(H.expr);continue}$.push(H)}}if($.length===0&&U)return l.INSTANCE;$.sort(y)}if($.length!==0){if($.length===1)return $[0];for(let B=1;B<$.length;B++)$[B-1].equals($[B])&&($.splice(B,1),B--);if($.length===1)return $[0];if(V){for(let B=0;B<$.length;B++)for(let W=B+1;W<$.length;W++)A($[B],$[W])&&($.splice(W,1),W--);if($.length===1)return $[0]}return new d($,M)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let M of this.expr)F.push(...M.keys());return F}map(F){return new d(this.expr.map(M=>M.map(F)),null)}negate(){if(!this.negated){let F=[];for(let M of this.expr)F.push(M.negate());for(;F.length>1;){const M=F.shift(),V=F.shift(),$=[];for(const B of O(M))for(const W of O(V))$.push(c.create([B,W],null));const U=F.length===0;F.unshift(d.create($,null,U))}this.negated=F[0]}return this.negated}}class h extends p{constructor(F,M,V){super(F,null);this._defaultValue=M,typeof V=="object"?h._info.push({...V,key:F}):V!==!0&&h._info.push({key:F,description:V,type:M!=null?typeof M:void 0})}static all(){return h._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return g.create(this.key,F)}notEqualsTo(F){return C.create(this.key,F)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(N,F){return N<F?-1:N>F?1:0}function w(N,F,M,V){return N<M?-1:N>M?1:F<V?-1:F>V?1:0}function A(N,F){if(F.type===6&&N.type!==9&&N.type!==6){for(const $ of F.expr)if(N.equals($))return!0}const M=N.negate(),V=O(M).concat(O(F));V.sort(y);for(let $=0;$<V.length;$++){const B=V[$].negate();for(let W=$+1;W<V.length;W++){const H=V[W];if(B.equals(H))return!0}}return!1}e.implies=A;function O(N){return N.type===9?N.expr:[N]}}),define(pe[183],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[184],ve([0,1,10,157,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var D;(function(a){a.WIN32_X64="win32-x64",a.WIN32_IA32="win32-ia32",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function T(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function I(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function _(a,s){switch(a){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function P(a,s){return s==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function R(a,s,m){return P(s,m)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===m?!0:y(m).includes(a)}e.isTargetPlatformCompatible=R;function y(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function l(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=l;var b;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var g;(function(a){a.Install="install",a.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var E;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var L;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(L=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(s,m){super(s);this.code=m,this.name=m}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=f.FileAccess.asBrowserUri("./media/defaultIcon.png",Z).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(pe[185],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(pe[186],ve([0,1,37,10,9,12,96,30,113,159,185]),function(Z,e,f,t,k,D,T,I,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=P.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends l{openTerminal(s,m){return this.spawnTerminal(f,s,_.getWindowsShell(),m)}spawnTerminal(s,m,o,S){const r=m.windowsExec||b.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=k.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return s.spawn(r,S?[S]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),(i==="wt"||i==="wt.exe")&&n.push("-d ."),new Promise((u,c)=>{const d=E(process),h=s.spawn(o,n,{cwd:S,env:d});h.on("error",c),h.on("exit",()=>u())})}runInTerminal(s,m,o,S,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:b.getDefaultTerminalWindows();return new Promise((n,u)=>{const c=`"${m} - ${y}"`,d=`""${o.join('" "')}" & pause"`,h=["/c","start",c,"/wait",i,"/c",d],v=Object.assign({},E(process),S);Object.keys(v).filter(O=>v[O]===null).forEach(O=>delete v[O]);const w={cwd:m,env:v,windowsVerbatimArguments:!0};f.spawn(b.CMD,h,w).on("error",O=>{u(L(O))}),n(void 0)})}static getDefaultTerminalWindows(){if(!b._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return b._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=b,b.CMD="cmd.exe";class p extends l{openTerminal(s,m){return this.spawnTerminal(f,s,m)}runInTerminal(s,m,o,S,r){const i=r.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((n,u)=>{if(i===R.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const c=i===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Z).fsPath,"-t",s||y,"-w",m];for(let A of o)h.push("-a"),h.push(A);if(S){const A=Object.assign({},E(process),S);for(let O in A){const N=A[O];N===null?(h.push("-u"),h.push(O)):(h.push("-e"),h.push(`${O}=${N}`))}}let v="";const w=f.spawn(p.OSASCRIPT,h);w.on("error",A=>{u(L(A))}),w.stderr.on("data",A=>{v+=A.toString()}),w.on("exit",A=>{if(A===0)n(void 0);else if(v){const O=v.split(`
`,1);u(new Error(O[0]))}else u(new Error(P.localize(1,null,c,A)))})}else u(new Error(P.localize(2,null,i)))})}spawnTerminal(s,m,o){const S=m.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const n=["-a",S];o&&n.push(o);const u=E(process),c=s.spawn("/usr/bin/open",n,{cwd:o,env:u});c.on("error",i),c.on("exit",()=>r())})}}e.MacExternalTerminalService=p,p.OSASCRIPT="/usr/bin/osascript";class g extends l{openTerminal(s,m){return this.spawnTerminal(f,s,m)}runInTerminal(s,m,o,S,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((n,u)=>{let c=[];i.then(d=>{d.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const h=`${C(o)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;c.push(`''${h}''`);const v=Object.assign({},E(process),S);Object.keys(v).filter(N=>v[N]===null).forEach(N=>delete v[N]);const w={cwd:m,env:v};let A="";const O=f.spawn(d,c,w);O.on("error",N=>{u(L(N))}),O.stderr.on("data",N=>{A+=N.toString()}),O.on("exit",N=>{if(N===0)n(void 0);else if(A){const F=A.split(`
`,1);u(new Error(F[0]))}else u(new Error(P.localize(4,null,d,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await I.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{s?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,m,o){const S=m.linuxExec?Promise.resolve(m.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{S.then(n=>{const u=E(process),c=s.spawn(n,[],{cwd:o,env:u});c.on("error",i),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=P.localize(3,null);function E(a){const s={...a.env};return(0,T.sanitizeProcessEnvironment)(s),s}function L(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(P.localize(5,null,a.path)):a}function C(a){let s="";for(let m of a)m.indexOf(" ")>=0?s+='"'+m+'"':s+=m,s+=" ";return s}}),define(pe[42],ve([0,1,24,9,8,13,2,160,4]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function P($){return $.create===!0}e.isFileOpenForWriteOptions=P;var R;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var y;(function($){$[$.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var l;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b($){return!!($.capabilities&2)}e.hasReadWriteCapability=b;function p($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=p;function g($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=E;function L($){return b($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=L;var C;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(U,B){super(U);this.code=B}}e.FileSystemProviderError=a;function s($,U){const B=new a($.toString(),U);return o(B,U),B}e.createFileSystemProviderError=s;function m($){return $||s((0,I.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=m;function o($,U){return $.name=U?`${U} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=o;function S($){if(!$)return C.Unknown;if($ instanceof a)return $.code;const U=/^(.+) \(FileSystemError\)$/.exec($.name);if(!U)return C.Unknown;switch(U[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=S;function r($){if($ instanceof h)return $.fileOperationResult;switch(S($)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(U,B,W){this.resource=U,this.operation=B,this.target=W}isOperation(U){return this.operation===U}}e.FileOperationEvent=n;var u;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(U,B){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const W=new Map;for(const H of U){const x=W.get(H.type);switch(x?x.push([H.resource,H]):W.set(H.type,[[H.resource,H]]),H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}}for(const[H,x]of W)switch(H){case 1:this.added=f.TernarySearchTree.forUris(()=>B),this.added.fill(x);break;case 0:this.updated=f.TernarySearchTree.forUris(()=>B),this.updated.fill(x);break;case 2:this.deleted=f.TernarySearchTree.forUris(()=>B),this.deleted.fill(x);break}}contains(U,...B){return this.doContains(U,{includeChildren:!1},...B)}affects(U,...B){return this.doContains(U,{includeChildren:!0},...B)}doContains(U,B,...W){if(!U)return!1;const H=W.length>0;return!!((!H||W.includes(1))&&(this.added?.get(U)||B.includeChildren&&this.added?.findSuperstr(U))||(!H||W.includes(0))&&(this.updated?.get(U)||B.includeChildren&&this.updated?.findSuperstr(U))||(!H||W.includes(2))&&(this.deleted?.findSubstr(U)||B.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function d($,U,B){return!$||!U||$===U||U.length>$.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),B?(0,k.startsWithIgnoreCase)($,U):$.indexOf(U)===0)}e.isParent=d;class h extends Error{constructor(U,B,W){super(U);this.fileOperationResult=B,this.options=W}}e.FileOperationError=h;class v extends h{constructor(U,B,W){super(U,2,W);this.stat=B}}e.NotModifiedSinceFileOperationError=v;var w;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=O;async function N($,U){if(!U.hasProvider(T.URI.from({scheme:$.scheme})))return new Promise(B=>{const W=U.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===$.scheme&&H.added&&(W.dispose(),B())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(U){return(0,D.isNumber)(U)||(U=0),U<F.KB?(0,I.localize)(1,null,U.toFixed(0)):U<F.MB?(0,I.localize)(2,null,(U/F.KB).toFixed(2)):U<F.GB?(0,I.localize)(3,null,(U/F.MB).toFixed(2)):U<F.TB?(0,I.localize)(4,null,(U/F.GB).toFixed(2)):(0,I.localize)(5,null,(U/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var M;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function V($){return{maxFileSize:$===0?300*F.MB:16*F.GB,maxHeapSize:$===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=V}),define(pe[84],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...k){this._entries=new Map;for(let[D,T]of k)this.set(D,T)}set(k,D){const T=this._entries.get(k);return this._entries.set(k,D),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=f}),define(pe[187],ve([0,1,18,16,115,180,4,84]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const _=!1;class P extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class R{constructor(p=new I.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=p,this._strict=g,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(p){return new R(p,this._strict,this)}invokeFunction(p,...g){let E=l.traceInvocation(p),L=!1;try{return p({get:a=>{if(L)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(a,E);if(!s)throw new Error(`[invokeFunction] unknown service '${a}'`);return s}},...g)}finally{L=!0,E.stop()}}createInstance(p,...g){let E,L;return p instanceof k.SyncDescriptor?(E=l.traceCreation(p.ctor),L=this._createInstance(p.ctor,p.staticArguments.concat(g),E)):(E=l.traceCreation(p),L=this._createInstance(p,g,E)),E.stop(),L}_createInstance(p,g=[],E){let L=T._util.getServiceDependencies(p).sort((s,m)=>s.index-m.index),C=[];for(const s of L){let m=this._getOrCreateServiceInstance(s.id,E);if(!m&&this._strict&&!s.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${s.id}.`);C.push(m)}let a=L.length>0?L[0].index:g.length;if(g.length!==a){console.warn(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${g.length} static arguments`);let s=a-g.length;s>0?g=g.concat(new Array(s)):g=g.slice(0,a)}return new p(...[...g,...C])}_setServiceInstance(p,g){if(this._services.get(p)instanceof k.SyncDescriptor)this._services.set(p,g);else if(this._parent)this._parent._setServiceInstance(p,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let g=this._services.get(p);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):g}_getOrCreateServiceInstance(p,g){let E=this._getServiceInstanceOrDescriptor(p);return E instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,E,g.branch(p,!0)):(g.branch(p,!1),E)}_safeCreateAndCacheServiceInstance(p,g,E){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,g,E)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,g,E){const L=new D.Graph(s=>s.id.toString());let C=0;const a=[{id:p,desc:g,_trace:E}];for(;a.length;){const s=a.pop();if(L.lookupOrInsertNode(s),C++>1e3)throw new P(L);for(let m of T._util.getServiceDependencies(s.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(m.id);if(!o&&!m.optional&&console.warn(`[createInstance] ${p} depends on ${m.id} which is NOT registered.`),o instanceof k.SyncDescriptor){const S={id:m.id,desc:o,_trace:s._trace.branch(m.id,!0)};L.insertEdge(s,S),a.push(S)}}}for(;;){const s=L.roots();if(s.length===0){if(!L.isEmpty())throw new P(L);break}for(const{data:m}of s){if(this._getServiceInstanceOrDescriptor(m.id)instanceof k.SyncDescriptor){const S=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,S)}L.removeNode(m)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,g,E=[],L,C){if(this._services.get(p)instanceof k.SyncDescriptor)return this._createServiceInstance(g,E,L,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,g,E,L,C);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(p,g=[],E,L){if(E){const C=new f.IdleValue(()=>this._createInstance(p,g,L));return new Proxy(Object.create(null),{get(a,s){if(s in a)return a[s];let m=C.value,o=m[s];return typeof o!="function"||(o=o.bind(m),a[s]=o),o},set(a,s,m){return C.value[s]=m,!0}})}else return this._createInstance(p,g,L)}}e.InstantiationService=R;var y;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(y||(y={}));class l{constructor(p,g){this.type=p,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return _?new l(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(p){return _?new l(0,p.name):l._None}branch(p,g){let E=new l(2,p.toString());return this._dep.push([p,g,E]),E}stop(){let p=Date.now()-this._start;l._totals+=p;let g=!1;function E(C,a){let s=[],m=new Array(C+1).join("	");for(const[o,S,r]of a._dep)if(S&&r){g=!0,s.push(`${m}CREATES -> ${o}`);let i=E(C+1,r);i&&s.push(i)}else s.push(`${m}uses -> ${o}`);return s.join(`
`)}let L=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(p>2||g)&&console.log(L.join(`
`))}}e.Trace=l,l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(pe[11],ve([0,1,49,3,6,12,4]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function I(){return new Date().toISOString()}var _;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function P(S,r,i){switch(r){case _.Trace:S.trace(i);break;case _.Debug:S.debug(i);break;case _.Info:S.info(i);break;case _.Warning:S.warn(i);break;case _.Error:S.error(i);break;case _.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function R(S){let r="";for(let i=0;i<S.length;i++){let n=S[i];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}r+=(i>0?" ":"")+n}return r}e.format=R;class y extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class l extends y{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(_.Trace)&&this.log(_.Trace,R([r,...i]))}debug(r,...i){this.checkLogLevel(_.Debug)&&this.log(_.Debug,R([r,...i]))}info(r,...i){this.checkLogLevel(_.Info)&&this.log(_.Info,R([r,...i]))}warn(r,...i){this.checkLogLevel(_.Warning)&&this.log(_.Warning,R([r,...i]))}error(r,...i){if(this.checkLogLevel(_.Error))if(r instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=r.stack,this.log(_.Error,R(n))}else this.log(_.Error,R([r,...i]))}critical(r,...i){this.checkLogLevel(_.Critical)&&this.log(_.Critical,R([r,...i]))}flush(){}}e.AbstractMessageLogger=l;class b extends y{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!D.isWindows}trace(r,...i){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}debug(r,...i){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}info(r,...i){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}warn(r,...i){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...i):console.warn(`[main ${I()}]`,r,...i))}error(r,...i){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}critical(r,...i){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class p extends y{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=p;class g extends y{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,f.toErrorMessage)(r,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class E extends y{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const n of this.logServices)n.trace(r,...i)}debug(r,...i){for(const n of this.logServices)n.debug(r,...i)}info(r,...i){for(const n of this.logServices)n.info(r,...i)}warn(r,...i){for(const n of this.logServices)n.warn(r,...i)}error(r,...i){for(const n of this.logServices)n.error(r,...i)}critical(r,...i){for(const n of this.logServices)n.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=E;class L extends k.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=L;class C extends k.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(n))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let n=this.loggers.get(r.toString());return n||(n=this.doCreateLogger(r,i?.always?_.Trace:this.logLevel,i),this.loggers.set(r.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class a{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return _.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=a;function s(S){if(S.verbose)return _.Trace;if(typeof S.logLevel=="string"){const r=m(S.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function m(S){switch(S){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=m;function o(S){switch(S){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=o}),define(pe[188],ve([0,1,42,11]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(I,_,P,R,y){try{const l=await new Promise((p,g)=>{Z(["spdlog"],p,g)});l.setFlushOn(t.LogLevel.Trace);const b=await l.createAsyncRotatingLogger(I,_,P,R);return y&&b.clearFormatters(),b}catch(l){console.error(l)}return null}function D(I,_,P){switch(_){case t.LogLevel.Trace:I.trace(P);break;case t.LogLevel.Debug:I.debug(P);break;case t.LogLevel.Info:I.info(P);break;case t.LogLevel.Warning:I.warn(P);break;case t.LogLevel.Error:I.error(P);break;case t.LogLevel.Critical:I.critical(P);break;default:throw new Error("Invalid log level")}}class T extends t.AbstractMessageLogger{constructor(_,P,R,y,l){super();this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(_,P,R,y),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}async _createSpdLogLogger(_,P,R,y){const l=R?6:1,b=30/l*f.ByteSize.MB,p=await k(_,P,b,l,y);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:g,message:E}of this.buffer)D(this._logger,g,E);this.buffer=[]}}log(_,P){this._logger?D(this._logger,_,P):this.getLevel()<=_&&this.buffer.push({level:_,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(pe[117],ve([0,1,47,161,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var T;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function P(p,g){return g-p}_.compare=P;const R=Object.create(null);R[_.Error]=(0,t.localize)(0,null),R[_.Warning]=(0,t.localize)(1,null),R[_.Info]=(0,t.localize)(2,null);function y(p){return R[p]||""}_.toString=y;function l(p){switch(p){case f.default.Error:return _.Error;case f.default.Warning:return _.Warning;case f.default.Info:return _.Info;case f.default.Ignore:return _.Hint}}_.fromSeverity=l;function b(p){switch(p){case _.Error:return f.default.Error;case _.Warning:return f.default.Warning;case _.Info:return f.default.Info;case _.Hint:return f.default.Ignore}}_.toSeverity=b}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(_){const P="";function R(l){return y(l,!0)}_.makeKey=R;function y(l,b){let p=[P];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(P),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(P),l.severity!==void 0&&l.severity!==null?p.push(T.toString(l.severity)):p.push(P),l.message&&b?p.push(l.message.replace("\xA6","\\\xA6")):p.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(P),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(P),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(P),p.push(P),p.join("\xA6")}_.makeKeyOptionalMessage=y})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(pe[189],ve([0,1,3,47,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var D;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new _,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class _{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=_}),define(pe[190],ve([0,1,6,8,2,4]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function T(_,P){return k.URI.isUri(_)?(0,t.equalsIgnoreCase)(_.scheme,P):(0,t.startsWithIgnoreCase)(_,P+":")}e.matchesScheme=T;function I(_,...P){return P.some(R=>T(_,R))}e.matchesSomeScheme=I}),define(pe[191],ve([0,1,10,12,40,23]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const I=t.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Z?.__$__nodeRequire=="function"){const I=(0,D.dirname)(f.FileAccess.asFileUri("",Z));T=Z.__$__nodeRequire((0,D.joinPath)(I,"product.json").fsPath);const _=Z.__$__nodeRequire((0,D.joinPath)(I,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:_.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var He=this&&this.__param||function(Z,e){return function(f,t){e(f,t,Z)}};define(pe[118],ve([0,1,18,21,6,4]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,D.createDecorator)("progressService");var T;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let _=class extends k.Disposable{constructor(y,l){super();this.deferred=new f.DeferredPromise,l.withProgress(y,b=>(this.reporter=b,this.lastStep&&b.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};_=je([He(1,e.IProgressService)],_),e.UnmanagedProgress=_;class P extends k.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(y){this.stop();const l=++this.currentOperationId,b=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>b.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:b.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,D.createDecorator)("editorProgressService")}),define(pe[50],ve([0,1,55,13]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,I){f.ok(t.isString(T)),f.ok(t.isObject(I)),f.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(pe[192],ve([0,1,3,50]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class D{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,P){this.schemasById[k(_)]=P,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new D;t.Registry.add(e.Extensions.JSONContribution,T)}),define(pe[119],ve([0,1,17,3,13,156,192,50]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=I.Registry.as(T.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(m,o=!0){this.registerConfigurations([m],o)}registerConfigurations(m,o=!0){const S=this.doRegisterConfigurations(m,o);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(m){const o=this.doDeregisterConfigurations(m);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:m,remove:o}){const S=[];S.push(...this.doDeregisterConfigurations(o)),S.push(...this.doRegisterConfigurations(m,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,f.distinct)(S)})}registerDefaultConfigurations(m){const o=[],S=[];for(const{overrides:r,source:i}of m)for(const n in r)if(o.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const u={...this.configurationDefaultsOverrides.get(n)?.value||{},...r[n]};this.configurationDefaultsOverrides.set(n,{source:i,value:u});const c={type:"object",default:u,description:D.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:k.isString(i)?void 0:i};S.push(...p(n)),this.configurationProperties[n]=c,this.defaultLanguageConfigurationOverridesNode.properties[n]=c}else{this.configurationDefaultsOverrides.set(n,{value:r[n],source:i});const u=this.configurationProperties[n];u&&(this.updatePropertyDefaultValue(n,u),this.updateSchema(n,u))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(m){const o=[];for(const{overrides:S,source:r}of m)for(const i in S){const n=this.configurationDefaultsOverrides.get(i),u=k.isString(r)?r:r?.id,c=k.isString(n?.source)?n?.source:n?.source?.id;if(u===c)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const d=this.configurationProperties[i];d&&(this.updatePropertyDefaultValue(i,d),this.updateSchema(i,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const o of m)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(m,o){const S=[];return m.forEach(r=>{S.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),S}doDeregisterConfigurations(m){const o=[],S=r=>{if(r.properties)for(const i in r.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>S(i))};for(const r of m){S(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(m,o=!0,S,r,i=3){i=k.isUndefinedOrNull(m.scope)?i:m.scope;let n=[],u=m.properties;if(u)for(let d in u){if(o&&C(d)){delete u[d];continue}const h=u[d];if(h.source=S,h.defaultDefaultValue=u[d].default,this.updatePropertyDefaultValue(d,h),e.OVERRIDE_PROPERTY_REGEX.test(d)?h.scope=void 0:(h.scope=k.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=k.isUndefinedOrNull(h.restricted)?!!r?.includes(d):h.restricted),u[d].hasOwnProperty("included")&&!u[d].included){this.excludedConfigurationProperties[d]=u[d],delete u[d];continue}else this.configurationProperties[d]=u[d];!u[d].deprecationMessage&&u[d].markdownDeprecationMessage&&(u[d].deprecationMessage=u[d].markdownDeprecationMessage),n.push(d)}let c=m.allOf;if(c)for(let d of c)n.push(...this.validateAndRegisterProperties(d,o,S,r,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(m){const o=S=>{let r=S.properties;if(r)for(const n in r)this.updateSchema(n,r[n]);let i=S.allOf;i&&i.forEach(o)};o(m)}updateSchema(m,o){switch(e.allSettings.properties[m]=o,o.scope){case 1:e.applicationSettings.properties[m]=o;break;case 2:e.machineSettings.properties[m]=o;break;case 6:e.machineOverridableSettings.properties[m]=o;break;case 3:e.windowSettings.properties[m]=o;break;case 4:e.resourceSettings.properties[m]=o;break;case 5:e.resourceSettings.properties[m]=o,this.resourceLanguageSettingsSchema.properties[m]=o;break}}removeFromSchema(m,o){switch(delete e.allSettings.properties[m],o.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m],delete this.resourceLanguageSettingsSchema.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const o=`[${m}]`,S={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,S),e.allSettings.properties[o]=S,e.applicationSettings.properties[o]=S,e.machineSettings.properties[o]=S,e.machineOverridableSettings.properties[o]=S,e.windowSettings.properties[o]=S,e.resourceSettings.properties[o]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const m={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,o){const S=this.configurationDefaultsOverrides.get(m);let r=S?.value,i=S?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,i=void 0),k.isUndefined(r)&&(r=E(o.type)),o.default=r,o.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",b=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(s){const m=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let o=b.exec(s);for(;o?.length;){const S=o[1].trim();S&&m.push(S),o=b.exec(s)}}return(0,f.distinct)(m)}e.overrideIdentifiersFromKey=p;function g(s){return s.reduce((m,o)=>`${m}[${o}]`,"")}e.keyFromOverrideIdentifiers=g;function E(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const L=new y;I.Registry.add(e.Extensions.Configuration,L);function C(s){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?D.localize(7,null,s):L.getConfigurationProperties()[s]!==void 0?D.localize(8,null,s):null:D.localize(6,null)}e.validateProperty=C;function a(){const s=[],m=L.getConfigurationProperties();for(const o of Object.keys(m))s.push([o,m[o].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=a}),define(pe[193],ve([0,1,17,3,57,6,24,25,13,2,116,119,50]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(r={},i=[],n=[]){this._contents=r,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const n=this.getContentsForOverrideIdentifer(i);return n?r?(0,R.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return f.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return f.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),n=I.deepClone(this.overrides),u=[...this.keys];for(const c of r){this.mergeContents(i,c.contents);for(const d of c.overrides){const[h]=n.filter(v=>f.equals(v.identifiers,d.identifiers));h?(this.mergeContents(h.contents,d.contents),h.keys.push(...d.keys),h.keys=f.distinct(h.keys)):n.push(I.deepClone(d))}for(const d of c.keys)u.indexOf(d)===-1&&u.push(d)}return new b(i,u,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const u of f.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[u],d=i[u];d&&(typeof c=="object"&&typeof d=="object"?(c=I.deepClone(c),this.mergeContents(c,d)):c=d),n[u]=c}return new b(n,this.keys,this.overrides)}mergeContents(r,i){for(const n of Object.keys(i)){if(n in r&&_.isObject(r[n])&&_.isObject(i[n])){this.mergeContents(r[n],i[n]);continue}r[n]=I.deepClone(i[n])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,n=null;const u=c=>{c&&(n?this.mergeContents(n,c):n=I.deepClone(c))};for(const c of this.overrides)f.equals(c.identifiers,[r])?i=c.contents:c.identifiers.includes(r)&&u(c.contents);return u(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,R.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class p extends b{constructor(r={}){const i=l.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(i),u=Object.create(null),c=[];for(const d in i){const h=r[d],v=h!==void 0?h:i[d].default;(0,R.addToValueTree)(u,d,v,w=>console.error(`Conflict in default settings: ${w}`))}for(const d of Object.keys(u))y.OVERRIDE_PROPERTY_REGEX.test(d)&&c.push({identifiers:(0,y.overrideIdentifiersFromKey)(d),keys:Object.keys(u[d]),contents:(0,R.toValuesTree)(u[d],h=>console.error(`Conflict in default settings file: ${h}`))});super(u,n,c)}}e.DefaultConfigurationModel=p;class g{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!_.isUndefinedOrNull(r)){const n=this.doParseContent(r);this.parseRaw(n,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:n,keys:u,overrides:c,restricted:d}=this.doParseRaw(r,i);this._configurationModel=new b(n,u,c),this._restrictedConfigurations=d||[]}doParseContent(r){let i={},n=null,u=[],c=[],d=[];function h(w){Array.isArray(u)?u.push(w):n!==null&&(u[n]=w)}let v={onObjectBegin:()=>{let w={};h(w),c.push(u),u=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{let w=[];h(w),c.push(u),u=w,n=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:h,onError:(w,A,O)=>{d.push({error:w,offset:A,length:O})}};if(r)try{k.visit(r,v),i=u[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return i}doParseRaw(r,i){const n=l.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),u=this.filter(r,n,!0,i);r=u.raw;const c=(0,R.toValuesTree)(r,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),d=Object.keys(r),h=this.toOverrides(r,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:c,keys:d,overrides:h,restricted:u.restricted}}filter(r,i,n,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:r,restricted:[]};const c={},d=[];for(let h in r)if(y.OVERRIDE_PROPERTY_REGEX.test(h)&&n){const v=this.filter(r[h],i,!1,u);c[h]=v.raw,d.push(...v.restricted)}else{const v=i[h],w=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&d.push(h),(w===void 0||u.scopes===void 0||u.scopes.includes(w))&&(u.skipRestricted&&v?.restricted||(c[h]=r[h]))}return{raw:c,restricted:d}}toOverrides(r,i){const n=[];for(const u of Object.keys(r))if(y.OVERRIDE_PROPERTY_REGEX.test(u)){const c={};for(const d in r[u])c[d]=r[u][d];n.push({identifiers:(0,y.overrideIdentifiersFromKey)(u),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,i)})}return n}}e.ConfigurationModelParser=g;class E extends D.Disposable{constructor(r,i,n,u){super();this.userSettingsResource=r,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class L{constructor(r,i,n=new b,u=new b,c=new T.ResourceMap,d=new b,h=new T.ResourceMap,v=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=u,this._folderConfigurations=c,this._memoryConfiguration=d,this._memoryConfigurationByResource=h,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(r,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(r)}updateValue(r,i,n={}){let u;n.resource?(u=this._memoryConfigurationByResource.get(n.resource),u||(u=new b,this._memoryConfigurationByResource.set(n.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(r):u.setValue(r,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,n){const u=this.getConsolidateConfigurationModel(i,n),c=this.getFolderConfigurationModelForResource(i.resource,n),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),v=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),w=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),O=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,N=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(r):c.freeze().getValue(r):void 0,F=i.overrideIdentifier?d.override(i.overrideIdentifier).getValue(r):d.getValue(r),M=u.getValue(r),V=f.distinct(f.flatten(u.overrides.map($=>$.identifiers))).filter($=>u.getOverrideValue(r,$)!==void 0);return{defaultValue:h,userValue:v,userLocalValue:w,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:N,memoryValue:F,value:M,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:c?.freeze().getValue(r),override:i.overrideIdentifier?c?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:d.getValue(r),override:i.overrideIdentifier?d.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:u,updated:c,removed:d}=m(this._defaultConfiguration,r);i=[...u,...c,...d]}for(const u of i)for(const c of(0,y.overrideIdentifiersFromKey)(u)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=r.getKeysForOverrideIdentifier(c),v=[...h.filter(w=>d.indexOf(w)===-1),...d.filter(w=>h.indexOf(w)===-1),...d.filter(w=>!I.equals(this._defaultConfiguration.override(c).getValue(w),r.override(c).getValue(w)))];n.push([c,v])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:u,overrides:c}=m(this.localUserConfiguration,r),d=[...i,...n,...u];return d.length&&this.updateLocalUserConfiguration(r),{keys:d,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:u,overrides:c}=m(this.remoteUserConfiguration,r);let d=[...i,...n,...u];return d.length&&this.updateRemoteUserConfiguration(r),{keys:d,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:u,overrides:c}=m(this.workspaceConfiguration,r);let d=[...i,...n,...u];return d.length&&this.updateWorkspaceConfiguration(r),{keys:d,overrides:c}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:u,updated:c,removed:d,overrides:h}=m(n,i);let v=[...u,...c,...d];return(v.length||!n)&&this.updateFolderConfiguration(r,i),{keys:v,overrides:h}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:u,removed:c,overrides:d}=m(i,void 0);return{keys:[...n,...u,...c],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let n=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?n.override(r.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:r},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const u=i.getFolder(r);u&&(n=this.getFolderConsolidatedConfiguration(u.uri)||n);const c=this._memoryConfigurationByResource.get(r);c&&(n=n.merge(c))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(r);u?(i=n.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=n}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:n,overrides:u,keys:c}=this._folderConfigurations.get(i);return r.push([i,{contents:n,overrides:u,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),n=this.parseConfigurationModel(r.user),u=this.parseConfigurationModel(r.workspace),c=r.folders.reduce((d,h)=>(d.set(P.URI.revive(h[0]),this.parseConfigurationModel(h[1])),d),new T.ResourceMap);return new L(i,n,new b,u,c,new b,new T.ResourceMap,!1)}static parseConfigurationModel(r){return new b(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=L;function C(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const r=new Set,i=new Map;for(const u of S)u.keys.forEach(c=>r.add(c)),u.overrides.forEach(([c,d])=>{const h=(0,T.getOrSet)(i,c,new Set);d.forEach(v=>h.add(v))});const n=[];return i.forEach((u,c)=>n.push([c,[...u.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=C;class a{constructor(r,i,n,u){this.change=r,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=u,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(h=>c.add(h)),r.overrides.forEach(([,h])=>h.forEach(v=>c.add(v))),this.affectedKeys=[...c.values()];const d=new b;this.affectedKeys.forEach(h=>d.setValue(h,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=L.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(n,u)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let n=(0,R.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof n=="object"&&(u=Object.keys(n)[0]);){if(r=r[u],!r)return!1;n=n[u]}return!0}}e.ConfigurationChangeEvent=a;class s extends a{constructor(r,i,n,u){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=n,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=s;function m(S,r){const{added:i,removed:n,updated:u}=o(r,S),c=[],d=S?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const v=h.filter(w=>!d.includes(w));for(const w of v)c.push([w,r.getKeysForOverrideIdentifier(w)])}if(S){const v=d.filter(w=>!h.includes(w));for(const w of v)c.push([w,S.getKeysForOverrideIdentifier(w)])}if(r&&S){for(const v of d)if(h.includes(v)){const w=o({contents:S.getOverrideValue(void 0,v)||{},keys:S.getKeysForOverrideIdentifier(v)},{contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)});c.push([v,[...w.added,...w.removed,...w.updated]])}}return{added:i,removed:n,updated:u,overrides:c}}function o(S,r){const i=S?r?S.keys.filter(c=>r.keys.indexOf(c)===-1):[...S.keys]:[],n=r?S?r.keys.filter(c=>S.keys.indexOf(c)===-1):[...r.keys]:[],u=[];if(S&&r){for(const c of r.keys)if(S.keys.indexOf(c)!==-1){const d=(0,R.getConfigurationValue)(r.contents,c),h=(0,R.getConfigurationValue)(S.contents,c);I.equals(d,h)||u.push(c)}}return{added:i,removed:n,updated:u}}}),define(pe[120],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var t;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,I=t.Unknown,_){super(T);this._message=T,this._code=I,this._detail=_,this.isHandled=I===t.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===t.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===t.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(pe[63],ve([0,1,10]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(P){return P.scheme===f.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=t;function k(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=k;function D(P){return P.scheme!==f.Schemas.file&&P.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=D;function T(P){if(P.folders.length)return P.folders.every(R=>D(R.uri))?P.folders[0].uri:void 0;if(P.configuration&&D(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=T;function I(P){return T(P)?.scheme}e.getVirtualWorkspaceScheme=I;function _(P){return T(P)!==void 0}e.isVirtualWorkspace=_}),define(pe[27],ve([0,1,8,4,63]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=D;function T(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class _{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,p){if(typeof b=="undefined"||b===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof b=="string"||typeof p=="string"){let g=typeof b=="string"?b:b.value,E=typeof p=="string"?p:p.value;return f.equalsIgnoreCase(g,E)}return b._lower===p._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=_;function P(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function R(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function y(l,b){if(b){const p=`onResolveRemoteAuthority:${(0,k.getRemoteName)(b)}`;return l.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[194],ve([0,1,8,27]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(p,g){return p.uuid&&g.uuid?p.uuid===g.uuid:p.id===g.id?!0:(0,f.compareIgnoreCase)(p.id,g.id)===0}e.areSameExtensions=k;class D{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof D?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=D;function T(p,g){return`${p}.${g}`}e.getExtensionId=T;function I(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function _(p,g){return I(T(p,g))}e.getGalleryExtensionId=_;function P(p,g){const E=[],L=C=>{for(const a of E)if(a.some(s=>k(g(s),g(C))))return a;return null};for(const C of p){const a=L(C);a?a.push(C):E.push([C])}return E}e.groupByExtension=P;function R(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function y(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function l(p){const g=new Set;if(p.malicious)for(const E of p.malicious)g.add(E.id);return g}e.getMaliciousExtensionsSet=l;function b(p,g){const E=[],L=g.manifest.extensionDependencies?.slice(0)??[];for(;L.length;){const C=L.shift();if(C&&E.every(a=>!k(a.identifier,{id:C}))){const a=p.filter(s=>k(s.identifier,{id:C}));a.length===1&&(E.push(a[0]),L.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=b}),define(pe[121],ve([0,1,3,12,4,11]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(p){p.Http="http",p.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=y;function l(p,g){return g?g!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=l;let b=class{constructor(g){this.logService=g,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g){return this._tunnelProvider=g,g?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],E=Array.from(this._tunnels.values());for(let L of E){const C=Array.from(L.values());for(let a of C){const s=await a.value;s&&g.push(s)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(L=>L?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,L,C,a=!1,s=I.Private,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${L} on local port ${C}.`),!g)return;E||(E="localhost");const o=this.retainOrCreateTunnel(g,E,L,C,a,s,m);return o?o.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,L);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(S);return(S.tunnelRemoteHost!==E||S.tunnelRemotePort!==L)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const L=E.get(g.tunnelRemotePort);L&&(L.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,L))}}}}async tryDisposeTunnel(g,E,L){if(L.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const C=L.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),C}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const L=this._tunnels.get(g);if(L&&L.has(E)){const C=L.get(E);C.refcount=0,await this.tryDisposeTunnel(g,E,C)}}addTunnelToMap(g,E,L){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:L})}async removeEmptyTunnelFromMap(g,E){const L=this._tunnels.get(g);L&&(await L.get(E)||L.delete(E),L.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let L=[g];R(g)?(L.push(...e.LOCALHOST_ADDRESSES),L.push(...e.ALL_INTERFACES_ADDRESSES)):y(g)&&L.push(...e.ALL_INTERFACES_ADDRESSES);const C=L.map(a=>this._tunnels.get(a));for(const a of C){const s=a?.get(E);if(s)return s}}canTunnel(g){return!!P(g)}createWithProvider(g,E,L,C,a,s,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${L} on local port ${C}.`);const S={elevationRequired:a?l(C===void 0?L:C):!1},r={remoteAddress:{host:E,port:L},localAddressPort:C,privacy:s,public:s!==I.Private,protocol:m},i=g.forwardPort(r,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(E,L,i),i}};b=je([He(0,D.ILogService)],b),e.AbstractTunnelService=b}),define(pe[195],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{constructor(){this.validators=new Map}vsda(){return new Promise((k,D)=>Z(["vsda"],k,D))}async createNewMessage(k){try{const D=await this.vsda(),T=new D.validator;if(T){const I=String(f._nextId++);return this.validators.set(I,T),{id:I,data:T.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,D){if(!k.id)return!0;const T=this.validators.get(k.id);if(!T)return!1;this.validators.delete(k.id);try{return T.validate(D)==="ok"}catch{return!1}}async sign(k){try{const D=await this.vsda(),T=new D.signer;if(T)return T.sign(k)}catch{}return k}}e.SignService=f,f._nextId=1}),define(pe[196],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,D,T=5){let I;return I=D(_=>{const P=typeof _=="string"?_:_.data;let R=this._terminalBufferMap.get(k);if(R){R.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(k),T);R={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(k),I.dispose()}},this._terminalBufferMap.set(k,R)}),I}stopBuffering(k){const D=this._terminalBufferMap.get(k);D&&D.dispose()}flushBuffer(k){const D=this._terminalBufferMap.get(k);D&&(this._terminalBufferMap.delete(k),this._callback(k,D.data.join("")))}}e.TerminalDataBufferer=f}),define(pe[197],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(pe[85],ve([0,1,74,3,6,4,50,197]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var _;(function(E){function L(C){return C&&typeof C=="object"&&typeof C.id=="string"}E.isThemeColor=L})(_=e.ThemeColor||(e.ThemeColor={}));function P(E){return{id:E}}e.themeColorFromId=P;var R;(function(E){function L(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||_.isThemeColor(i.color))}E.isThemeIcon=L;const C=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function a(i){const n=C.exec(i);if(!n)return;let[,u]=n;return{id:u}}E.fromString=a;function s(i){return{id:i}}E.fromId=s;function m(i,n){let u=i.id;const c=u.lastIndexOf("~");return c!==-1&&(u=u.substring(0,c)),n&&(u=`${u}~${n}`),{id:u}}E.modify=m;function o(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}E.getModifier=o;function S(i,n){return i.id===n.id&&i.color?.id===n.color?.id}E.isEqual=S;function r(i,n){return{id:i.id,color:n?P(n):void 0}}E.asThemeIcon=r,E.asClassNameArray=f.CSSIcon.asClassNameArray,E.asClassName=f.CSSIcon.asClassName,E.asCSSSelector=f.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function y(E){switch(E){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(L){return this.themingParticipants.push(L),this.onThemingParticipantAddedEmitter.fire(L),(0,k.toDisposable)(()=>{const C=this.themingParticipants.indexOf(L);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new l;T.Registry.add(e.Extensions.ThemingContribution,b);function p(E){return b.onColorThemeChange(E)}e.registerThemingParticipant=p;class g extends k.Disposable{constructor(L){super();this.themeService=L,this.theme=L.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(L){this.theme=L,this.updateStyles()}updateStyles(){}getColor(L,C){let a=this.theme.getColor(L);return a&&C&&(a=C(a,this.theme)),a?a.toString():null}}e.Themable=g}),define(pe[43],ve([0,1,24,23,2,4]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var T;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function I(l){const b=l;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=I;function _(l){const b=l;return!!(b&&typeof b=="object"&&k.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=_;class P{constructor(b,p,g,E,L){this._id=b,this._transient=g,this._configuration=E,this._ignorePathCasing=L,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=p}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class R{constructor(b,p){this.raw=p,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,t.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function y(l){return new R({uri:l,index:0,name:(0,t.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=y}),define(pe[198],ve([0,1,29,57,140,80,10,9,12,23,2,162,4,63,43]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(U){return(typeof U=="string"?(0,I.extname)(U):(0,P.extname)(U))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function L(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=L;function C(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=C;function a(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=a;function s(U){return U&&U.hasOwnProperty("folderUri")}e.isFolderBackupInfo=s;function m(U){return U&&U.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=m;function o(U){const B=U;return typeof B?.id=="string"&&R.URI.isUri(B.uri)}e.isSingleFolderWorkspaceIdentifier=o;function S(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=S;function r(U){const B=U;return typeof B?.id=="string"&&R.URI.isUri(B.configPath)}e.isWorkspaceIdentifier=r;function i(U){const B=U;if(B?.uri)return{id:B.id,uri:R.URI.revive(B.uri)};const W=U;if(W?.configPath)return{id:W.id,configPath:R.URI.revive(W.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=i;function n(U,B){return P.extUriBiasedIgnorePathCase.isEqualOrParent(U,B.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function u(U){return c(U)||d(U)}e.isStoredWorkspaceFolder=u;function c(U){const B=U;return typeof B?.path=="string"&&(!B.name||typeof B.name=="string")}e.isRawFileWorkspaceFolder=c;function d(U){const B=U;return typeof B?.uri=="string"&&(!B.name||typeof B.name=="string")}e.isRawUriWorkspaceFolder=d;function h(U,B,W,H,x=!_.isWindows,J){if(U.scheme!==H.scheme)return{name:W,uri:U.toString(!0)};let ne=B?void 0:J.relativePath(H,U);if(ne!==void 0)ne.length===0?ne=".":_.isWindows&&U.scheme===T.Schemas.file&&!x&&(ne=ne.replace(/\//g,"\\"));else if(U.scheme===T.Schemas.file)ne=U.fsPath,_.isWindows&&(ne=(0,D.normalizeDriveLetter)(ne),x&&(ne=(0,f.toSlashes)(ne)));else{if(!J.isEqualAuthority(U.authority,H.authority))return{name:W,uri:U.toString(!0)};ne=U.path}return{name:W,path:ne}}e.getStoredWorkspaceFolder=h;function v(U,B,W){let H=[],x=new Set;const J=W.dirname(B);for(let ne of U){let se;if(c(ne))ne.path&&(se=W.resolvePath(J,ne.path));else if(d(ne))try{se=R.URI.parse(ne.uri),se.path[0]!=="/"&&(se=se.with({path:"/"+se.path}))}catch(K){console.warn(K)}if(se){let K=W.getComparisonKey(se);if(!x.has(K)){x.add(K);const Q=ne.name||W.basenameOrAuthority(se);H.push(new p.WorkspaceFolder({uri:se,name:Q,index:H.length},ne))}}}return H}e.toWorkspaceFolders=v;function w(U,B,W,H,x){let J=A(B,U);const ne=x.dirname(B),se=x.dirname(H),K=[],Q=O(J.folders);for(const Me of J.folders){const ze=c(Me)?x.resolvePath(ne,Me.path):R.URI.parse(Me.uri);let Ge;W?Ge=!1:Ge=!c(Me)||(0,I.isAbsolute)(Me.path),K.push(h(ze,Ge,Me.name,se,Q,x))}const ae={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},fe=k.setProperty(U,["folders"],K,ae);let be=k.applyEdits(U,fe);return(0,P.isEqualAuthority)(J.remoteAuthority,(0,b.getRemoteAuthority)(H))&&(be=k.applyEdits(be,k.removeProperty(be,["remoteAuthority"],ae))),be}e.rewriteWorkspaceFileForNewLocation=w;function A(U,B){let W=t.parse(B);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(H=>u(H));else throw new Error(`${U} looks like an invalid workspace file.`);return W}function O(U){return _.isWindows?U.some(B=>c(B)&&B.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function N(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function F(U){return typeof U.folderUri=="string"}function M(U){return typeof U.fileUri=="string"}function V(U,B){const W={workspaces:[],files:[]};if(U){const H=function(J,ne){for(let se=0;se<J.length;se++)try{ne(J[se],se)}catch(K){B.warn(`Error restoring recent entry ${JSON.stringify(J[se])}: ${K.toString()}. Skip entry.`)}},x=U;if(Array.isArray(x.entries))H(x.entries,J=>{const ne=J.label,se=J.remoteAuthority;N(J)?W.workspaces.push({label:ne,remoteAuthority:se,workspace:{id:J.workspace.id,configPath:R.URI.parse(J.workspace.configPath)}}):F(J)?W.workspaces.push({label:ne,remoteAuthority:se,folderUri:R.URI.parse(J.folderUri)}):M(J)&&W.files.push({label:ne,remoteAuthority:se,fileUri:R.URI.parse(J.fileUri)})});else{const J=U;Array.isArray(J.workspaces3)&&H(J.workspaces3,(ne,se)=>{const K=Array.isArray(J.workspaceLabels)&&J.workspaceLabels[se]||void 0;typeof ne=="object"&&typeof ne.id=="string"&&typeof ne.configURIPath=="string"?W.workspaces.push({label:K,workspace:{id:ne.id,configPath:R.URI.parse(ne.configURIPath)}}):typeof ne=="string"&&W.workspaces.push({label:K,folderUri:R.URI.parse(ne)})}),Array.isArray(J.files2)&&H(J.files2,(ne,se)=>{const K=Array.isArray(J.fileLabels)&&J.fileLabels[se]||void 0;typeof ne=="string"&&W.files.push({label:K,fileUri:R.URI.parse(ne)})})}}return W}e.restoreRecentlyOpened=V;function $(U){const B={entries:[]};for(const W of U.workspaces)C(W)?B.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):B.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of U.files)B.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return B}e.toStoreData=$}),define(pe[86],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const D=this._idPool++;return this._data.set(D,k),this.logDebugInfo(),D}get(k,D){return this._data.has(k)?this._data.get(k)[D]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(pe[44],ve([0,1,10,23,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const _=this._providerInfo.get(I.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(I,_){_===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,_)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(pe[199],ve([0,1,18]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(T,I,_){this._deferredPromises=new Map,this._id=T,this._shared=I,this._storage=_,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const y of P.values())y.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,I){let _=this._value[T];return typeof _=="undefined"&&(_=I),_}update(T,I){this._value[T]=I;let _=this._deferredPromises.get(T);if(_!==void 0)return _.p;const P=new f.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class k extends t{constructor(T,I){super(T.identifier.value,!0,I);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(pe[200],ve([0,1,3,2,11]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let D=class{constructor(I,_){this._logService=I,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,_,P){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(_.value,P)}$acceptDirtyStateChanged(I,_){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptDirty(_)}$acceptModelSaved(I){const _=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(I,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,_);const P=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));P.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};D=je([He(0,k.ILogService)],D),e.ExtHostNotebookDocuments=D}),define(pe[14],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class t{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[201],ve([0,1,27,3]),function(Z,e,f,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class D{constructor(I,_){k.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(I.identifier),nt(this,k,_,"f"),Le(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(I){return Le(this,k,"f").get(this._id,I)}store(I,_){return Le(this,k,"f").store(this._id,I,_)}delete(I){return Le(this,k,"f").delete(this._id,I)}}e.ExtensionSecrets=D,k=new WeakMap}),define(pe[122],ve([0,1,4,3]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(pe[64],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(C){C[C.Upsert=0]="Upsert",C[C.RemoveChild=1]="RemoveChild",C[C.Invalidated=2]="Invalidated",C[C.SetProp=3]="SetProp",C[C.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,k=(C,a)=>{const s={controllerId:a};return t.set(C,s),s};e.createPrivateApiFor=k;const D=C=>t.get(C);e.getPrivateApiFor=D;const T=(C,a,s,m)=>{let o=s;return{enumerable:!0,configurable:!1,get(){return o},set(S){if(!m(o,S)){const r=o;o=S,C.listener?.({op:3,key:a,value:S,previous:r})}}}},I=(C,a)=>C===a,_={range:(C,a)=>C===a?!0:!C||!a?!1:C.isEqual(a),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(C,a)=>!(C.length!==a.length||C.some(s=>!a.find(m=>s.id===m.id)))},P=Object.keys(_),R=(C,a)=>({range:T(C,"range",void 0,_.range),label:T(C,"label",a,_.label),description:T(C,"description",void 0,_.description),canResolveChildren:T(C,"canResolveChildren",!1,_.canResolveChildren),busy:T(C,"busy",!1,_.busy),error:T(C,"error",void 0,_.error),tags:T(C,"tags",[],_.tags)}),y=(C,a)=>{const s=new Map;for(const m of P)_[m](C[m],a[m])||s.set(m,a[m]);return s};e.diffTestItems=y;class l extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=l;class b extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class p extends Error{constructor(a,s,m){super(`TestItem with ID "${a}" is from controller "${s}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=p;const g=C=>{const a=(0,e.getPrivateApiFor)(C);let s=new Map;return{get size(){return s.size},forEach(m,o){for(const S of s.values())m.call(o,S,this)},replace(m){const o=new Map,S=new Set(s.keys()),r={op:4,ops:[]};for(const i of m){if(!(i instanceof E))throw new b(i.id);const n=(0,e.getPrivateApiFor)(i).controllerId;if(n!==a.controllerId)throw new p(i.id,n,a.controllerId);if(o.has(i.id))throw new l(i.id);o.set(i.id,i),S.delete(i.id),r.ops.push({op:0,item:i})}for(const i of S.keys())r.ops.push({op:1,id:i});a.listener?.(r),s=o},add(m){if(!(m instanceof E))throw new b(m.id);s.set(m.id,m),a.listener?.({op:0,item:m})},delete(m){s.delete(m)&&a.listener?.({op:1,id:m})},get(m){return s.get(m)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class E{constructor(a,s,m,o){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const S=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof L?void 0:S.parent}},children:{value:g(this),enumerable:!0,writable:!1},...R(S,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=E;class L extends E{constructor(a,s){super(a,a,s,void 0)}}e.TestItemRootImpl=L}),define(pe[51],ve([0,1,4,121,3,14]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(_){function P(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:y.protocol}}_.fromApiTunnel=P;function R(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==t.TunnelPrivacyId.ConstantPrivate&&y.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}_.fromServiceTunnel=R})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let I=class{constructor(P){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,y,l,b){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=je([He(0,D.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[7],ve([0,1,17,16,99,24,95,8,13,2,33,42,120]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l){"use strict";var b,p,g,E,L,C,a,s,m,o,S,r,i,n,u,c,d,h,v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(j){function z(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(z,j),Object.setPrototypeOf(z.prototype,j.prototype),z}let O=L=class{constructor(z){b.set(this,void 0),nt(this,b,z,"f")}static from(...z){let ue=z;return new L(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}dispose(){typeof Le(this,b,"f")=="function"&&(Le(this,b,"f").call(this),nt(this,b,void 0,"f"))}};b=new WeakMap,O=L=je([A],O),e.Disposable=O;let N=C=class{constructor(z,ue){if(z<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=z,this._character=ue}static Min(...z){if(z.length===0)throw new TypeError;let ue=z[0];for(let Pe=1;Pe<z.length;Pe++){const et=z[Pe];et.isBefore(ue)&&(ue=et)}return ue}static Max(...z){if(z.length===0)throw new TypeError;let ue=z[0];for(let Pe=1;Pe<z.length;Pe++){const et=z[Pe];et.isAfter(ue)&&(ue=et)}return ue}static isPosition(z){if(!z)return!1;if(z instanceof C)return!0;let{line:ue,character:Pe}=z;return typeof ue=="number"&&typeof Pe=="number"}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,ue=0){if(z===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=0:typeof z=="number"?Pe=z:(Pe=typeof z.lineDelta=="number"?z.lineDelta:0,ue=typeof z.characterDelta=="number"?z.characterDelta:0),Pe===0&&ue===0?this:new C(this.line+Pe,this.character+ue)}with(z,ue=this.character){if(z===null||ue===null)throw(0,t.illegalArgument)();let Pe;return typeof z=="undefined"?Pe=this.line:typeof z=="number"?Pe=z:(Pe=typeof z.line=="number"?z.line:this.line,ue=typeof z.character=="number"?z.character:this.character),Pe===this.line&&ue===this.character?this:new C(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};N=C=je([A],N),e.Position=N;let F=a=class{constructor(z,ue,Pe,et){let at,dt;if(typeof z=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new N(z,ue),dt=new N(Pe,et)):z instanceof N&&ue instanceof N&&(at=z,dt=ue),!at||!dt)throw new Error("Invalid arguments");at.isBefore(dt)?(this._start=at,this._end=dt):(this._start=dt,this._end=at)}static isRange(z){return z instanceof a?!0:z?N.isPosition(z.start)&&N.isPosition(z.end):!1}get start(){return this._start}get end(){return this._end}contains(z){return z instanceof a?this.contains(z._start)&&this.contains(z._end):z instanceof N?!(z.isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const ue=N.Max(z.start,this._start),Pe=N.Min(z.end,this._end);if(!ue.isAfter(Pe))return new a(ue,Pe)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ue=N.Min(z.start,this._start),Pe=N.Max(z.end,this.end);return new a(ue,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,ue=this.end){if(z===null||ue===null)throw(0,t.illegalArgument)();let Pe;return z?N.isPosition(z)?Pe=z:(Pe=z.start||this.start,ue=z.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ue.isEqual(this.end)?this:new a(Pe,ue)}toJSON(){return[this.start,this.end]}};F=a=je([A],F),e.Range=F;let M=s=class extends F{constructor(z,ue,Pe,et){let at,dt;if(typeof z=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"?(at=new N(z,ue),dt=new N(Pe,et)):z instanceof N&&ue instanceof N&&(at=z,dt=ue),!at||!dt)throw new Error("Invalid arguments");super(at,dt);this._anchor=at,this._active=dt}static isSelection(z){return z instanceof s?!0:z?F.isRange(z)&&N.isPosition(z.anchor)&&N.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=s=je([A],M),e.Selection=M;class V{constructor(z,ue,Pe){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Pe!="undefined"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(ue),this.connectionToken=Pe}}e.ResolvedAuthority=V;class $ extends Error{constructor(z,ue=l.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(z);this._message=z,this._code=ue,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(z,ue){return new $(z,l.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(z){return new $(z,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var U;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var B;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=m=class{constructor(z,ue){this._range=z,this._newText=ue}static isTextEdit(z){return z instanceof m?!0:z?F.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ue){return new m(z,ue)}static insert(z,ue){return m.replace(new F(z,z),ue)}static delete(z){return m.replace(z,"")}static setEndOfLine(z){const ue=new m(new F(new N(0,0),new N(0,0)),"");return ue.newEol=z,ue}get range(){return this._range}set range(z){if(z&&!F.isRange(z))throw(0,t.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,t.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,t.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=m=je([A],W),e.TextEdit=W;var H;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let x=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,ue,Pe,et){this._edits.push({_type:1,from:z,to:ue,options:Pe,metadata:et})}createFile(z,ue,Pe){this._edits.push({_type:1,from:void 0,to:z,options:ue,metadata:Pe})}deleteFile(z,ue,Pe){this._edits.push({_type:1,from:z,to:void 0,options:ue,metadata:Pe})}replaceNotebookMetadata(z,ue,Pe){this._edits.push({_type:3,metadata:Pe,uri:z,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(z,ue,Pe,et,at){let dt,mt,At=[],Lt;if($t.isNotebookRange(ue)&&Bt.isNotebookCellDataArray(Pe)&&!Bt.isNotebookCellDataArray(et)?(dt=ue.start,mt=ue.end,At=Pe,Lt=et):typeof ue=="number"&&typeof Pe=="number"&&Bt.isNotebookCellDataArray(et)&&(dt=ue,mt=Pe,At=et,Lt=at),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||At.length>0)&&this._edits.push({_type:5,uri:z,index:dt,count:mt-dt,cells:At,metadata:Lt})}replaceNotebookCellMetadata(z,ue,Pe,et){this._edits.push({_type:3,metadata:et,uri:z,edit:{editType:8,index:ue,metadata:Pe}})}replace(z,ue,Pe,et){this._edits.push({_type:2,uri:z,edit:new W(ue,Pe),metadata:et})}insert(z,ue,Pe,et){this.replace(z,new F(ue,ue),Pe,et)}delete(z,ue,Pe){this.replace(z,ue,"",Pe)}has(z){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===z.toString())}set(z,ue){if(ue)for(const Pe of ue)Pe&&this._edits.push({_type:2,uri:z,edit:Pe});else{for(let Pe=0;Pe<this._edits.length;Pe++){const et=this._edits[Pe];et._type===2&&et.uri.toString()===z.toString()&&(this._edits[Pe]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(z){const ue=[];for(let Pe of this._edits)Pe._type===2&&Pe.uri.toString()===z.toString()&&ue.push(Pe.edit);return ue}entries(){const z=new D.ResourceMap;for(let ue of this._edits)if(ue._type===2){let Pe=z.get(ue.uri);Pe||(Pe=[ue.uri,[]],z.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};x=je([A],x),e.WorkspaceEdit=x;let J=o=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof o?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=o._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ue=this._tabstop++){if(typeof z=="function"){const Pe=new o;Pe._tabstop=this._tabstop,z(Pe),this._tabstop=Pe._tabstop,z=Pe.value}else z=o._escape(z);return this.value+="${",this.value+=ue,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ue=this._tabstop++){const Pe=z.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(z,ue){if(typeof ue=="function"){const Pe=new o;Pe._tabstop=this._tabstop,ue(Pe),this._tabstop=Pe._tabstop,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};J=o=je([A],J),e.SnippetString=J;var ne;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ne=e.DiagnosticTag||(e.DiagnosticTag={}));var se;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=S=class{constructor(z,ue){if(this.uri=z,ue)if(ue instanceof F)this.range=ue;else if(ue instanceof N)this.range=new F(ue,ue);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof S?!0:z?F.isRange(z.range)&&P.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=S=je([A],K),e.Location=K;let Q=class{constructor(z,ue){this.location=z,this.message=ue}static is(z){return z?typeof z.message=="string"&&z.location&&F.isRange(z.location.range)&&P.URI.isUri(z.location.uri):!1}static isEqual(z,ue){return z===ue?!0:!z||!ue?!1:z.message===ue.message&&z.location.range.isEqual(ue.location.range)&&z.location.uri.toString()===ue.location.uri.toString()}};Q=je([A],Q),e.DiagnosticRelatedInformation=Q;let ae=class{constructor(z,ue,Pe=se.Error){if(!F.isRange(z))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=z,this.message=ue,this.severity=Pe}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ue){return z===ue?!0:!z||!ue?!1:z.message===ue.message&&z.severity===ue.severity&&z.code===ue.code&&z.severity===ue.severity&&z.source===ue.source&&z.range.isEqual(ue.range)&&(0,f.equals)(z.tags,ue.tags)&&(0,f.equals)(z.relatedInformation,ue.relatedInformation,Q.isEqual)}};ae=je([A],ae),e.Diagnostic=ae;let fe=class{constructor(z,ue){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ue}};fe=je([A],fe),e.Hover=fe;var be;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Me=class{constructor(z,ue=be.Text){this.range=z,this.kind=ue}toJSON(){return{range:this.range,kind:be[this.kind]}}};Me=je([A],Me),e.DocumentHighlight=Me;var ze;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var Ge;(function(j){j[j.Deprecated=1]="Deprecated"})(Ge=e.SymbolTag||(e.SymbolTag={}));let Je=r=class{constructor(z,ue,Pe,et,at){this.name=z,this.kind=ue,this.containerName=at,typeof Pe=="string"&&(this.containerName=Pe),et instanceof K?this.location=et:Pe instanceof F&&(this.location=new K(et,Pe)),r.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};Je=r=je([A],Je),e.SymbolInformation=Je;let q=i=class{constructor(z,ue,Pe,et,at){this.name=z,this.detail=ue,this.kind=Pe,this.range=et,this.selectionRange=at,this.children=[],i.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children&&z.children.forEach(i.validate)}};q=i=je([A],q),e.DocumentSymbol=q;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(z,ue){this.title=z,this.kind=ue}};G=je([A],G),e.CodeAction=G;let X=n=class{constructor(z){this.value=z}append(z){return new n(this.value?this.value+n.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+n.sep)}};X.sep=".",X=n=je([A],X),e.CodeActionKind=X,X.Empty=new X(""),X.QuickFix=X.Empty.append("quickfix"),X.Refactor=X.Empty.append("refactor"),X.RefactorExtract=X.Refactor.append("extract"),X.RefactorInline=X.Refactor.append("inline"),X.RefactorRewrite=X.Refactor.append("rewrite"),X.Source=X.Empty.append("source"),X.SourceOrganizeImports=X.Source.append("organizeImports"),X.SourceFixAll=X.Source.append("fixAll");let oe=class{constructor(z,ue){if(this.range=z,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=je([A],oe),e.SelectionRange=oe;class me{constructor(z,ue,Pe,et,at,dt){this.kind=z,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.CallHierarchyItem=me;class Ie{constructor(z,ue){this.fromRanges=ue,this.from=z}}e.CallHierarchyIncomingCall=Ie;class xe{constructor(z,ue){this.fromRanges=ue,this.to=z}}e.CallHierarchyOutgoingCall=xe;var Ye;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ye=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let it=class{constructor(z,ue){this.range=z,this.command=ue}get isResolved(){return!!this.command}};it=je([A],it),e.CodeLens=it;let st=u=class{constructor(z,ue=!1){p.set(this,void 0),nt(this,p,new k.MarkdownString(z,{supportThemeIcons:ue}),"f")}static isMarkdownString(z){return z instanceof u?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Le(this,p,"f").value}set value(z){Le(this,p,"f").value=z}get isTrusted(){return Le(this,p,"f").isTrusted}set isTrusted(z){Le(this,p,"f").isTrusted=z}get supportThemeIcons(){return Le(this,p,"f").supportThemeIcons}set supportThemeIcons(z){Le(this,p,"f").supportThemeIcons=z}get supportHtml(){return Le(this,p,"f").supportHtml}set supportHtml(z){Le(this,p,"f").supportHtml=z}appendText(z){return Le(this,p,"f").appendText(z),this}appendMarkdown(z){return Le(this,p,"f").appendMarkdown(z),this}appendCodeblock(z,ue){return Le(this,p,"f").appendCodeblock(ue??"",z),this}};p=new WeakMap,st=u=je([A],st),e.MarkdownString=st;let ot=class{constructor(z,ue){this.label=z,this.documentation=ue}};ot=je([A],ot),e.ParameterInformation=ot;let tt=class{constructor(z,ue){this.label=z,this.documentation=ue,this.parameters=[]}};tt=je([A],tt),e.SignatureInformation=tt;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=je([A],rt),e.SignatureHelp=rt;var gt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(gt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ue;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ue=e.InlayHintKind||(e.InlayHintKind={}));let It=class{constructor(z){this.label=z}toString(){return this.label}};It=je([A],It),e.InlayHintLabelPart=It;let ee=class{constructor(z,ue,Pe){this.label=z,this.position=ue,this.kind=Pe}};ee=je([A],ee),e.InlayHint=ee;var ie;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ie=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(j){j[j.Deprecated=1]="Deprecated"})(re=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(z,ue){this.label=z,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=je([A],Ce),e.CompletionItem=Ce;let Fe=class{constructor(z=[],ue=!1){this.items=z,this.isIncomplete=ue}};Fe=je([A],Fe),e.CompletionList=Fe;let qe=class{constructor(z,ue,Pe){this.text=z,this.range=ue,this.command=Pe}};qe=je([A],qe),e.InlineSuggestion=qe;let Ve=class{constructor(z){this.items=z}};Ve=je([A],Ve),e.InlineSuggestions=Ve;var ut;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ut=e.ViewColumn||(e.ViewColumn={}));var Re;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ce;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var de;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var we;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(we=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ye;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(ye=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function z(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(de=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Oe=class{constructor(z,ue){if(ue&&!P.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!F.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.target=ue}};Oe=je([A],Oe),e.DocumentLink=Oe;let Ke=class{constructor(z,ue,Pe,et){this.red=z,this.green=ue,this.blue=Pe,this.alpha=et}};Ke=je([A],Ke),e.Color=Ke;let We=class{constructor(z,ue){if(ue&&!(ue instanceof Ke))throw(0,t.illegalArgument)("color");if(!F.isRange(z)||z.isEmpty)throw(0,t.illegalArgument)("range");this.range=z,this.color=ue}};We=je([A],We),e.ColorInformation=We;let Ze=class{constructor(z){if(!z||typeof z!="string")throw(0,t.illegalArgument)("label");this.label=z}};Ze=je([A],Ze),e.ColorPresentation=Ze;var lt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(lt=e.ColorFormat||(e.ColorFormat={}));var ct;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class $e{constructor(z,ue,Pe){if(this.startIndex=z,this.length=ue,this.tooltip=Pe,typeof z!="number"||z<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=$e;var Ee;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ee=e.TerminalLocation||(e.TerminalLocation={}));class _e{constructor(z){this.options=z,typeof z!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=_e;var he;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=c=class{constructor(z,ue){if(this.label=ue,typeof z!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};ke.Clean=new c("clean","Clean"),ke.Build=new c("build","Build"),ke.Rebuild=new c("rebuild","Rebuild"),ke.Test=new c("test","Test"),ke=c=je([A],ke),e.TaskGroup=ke;function Ne(j){let z="";for(let ue=0;ue<j.length;ue++)z+=j[ue].replace(/,/g,",,")+",";return z}let Xe=class{constructor(z,ue,Pe){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=z,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Pe):this._options=ue)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,t.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(let ue of this._args)z.push(ue);return Ne(z)}};Xe=je([A],Xe),e.ProcessExecution=Xe;let Qe=class{constructor(z,ue,Pe){if(this._args=[],Array.isArray(ue)){if(!z)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z,this._args=ue,this._options=Pe}else{if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,t.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ue of this._args)z.push(typeof ue=="string"?ue:ue.value);return Ne(z)}};Qe=je([A],Qe),e.ShellExecution=Qe;var pt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class Ct{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=Ct;let ft=d=class{constructor(z,ue,Pe,et,at,dt){this.__deprecated=!1,this._definition=this.definition=z;let mt;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Pe,this.execution=et,mt=at,this.__deprecated=!0):ue===St.Global||ue===St.Workspace?(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt):(this.target=ue,this._name=this.name=Pe,this._source=this.source=et,this.execution=at,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const ue=this._definition.type;(d.EmptyType===ue||d.ProcessType===ue||d.ShellType===ue||d.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=d=je([A],ft),e.Task=ft;var wt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(z,ue=Ut.None){this.collapsibleState=ue,P.URI.isUri(z)?this.resourceUri=z:this.label=z}};bt=je([A],bt),e.TreeItem=bt;var Ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Pt=class{constructor(z){this._value=z}async asString(){return JSON.stringify(this._value)}};Pt=je([A],Pt),e.TreeDataTransferItem=Pt;let Ft=class{constructor(){this._items=new Map}get(z){return this._items.get(z)}set(z,ue){this._items.set(z,ue)}forEach(z){this._items.forEach(z)}};Ft=je([A],Ft),e.TreeDataTransfer=Ft;let kt=class{constructor(z,ue){this.id=z,this.color=ue}};kt=je([A],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let yt=class{constructor(z){this.id=z}};yt=je([A],yt),e.ThemeColor=yt;var Qt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(z,ue){if(typeof z!="string"&&(!z||!P.URI.isUri(z)&&!P.URI.isUri(z.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof z=="string"?this.baseUri=P.URI.file(z):P.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ue}get base(){return this._base}set base(z){this._base=z,this._baseUri=P.URI.file(z)}get baseUri(){return this._baseUri}set baseUri(z){this._baseUri=z,this._base=z.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=je([A],Vt),e.RelativePattern=Vt;let Et=class{constructor(z,ue,Pe,et){this.enabled=typeof z=="boolean"?z:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Et=je([A],Et),e.Breakpoint=Et;let Xt=class extends Et{constructor(z,ue,Pe,et,at){super(ue,Pe,et,at);if(z===null)throw(0,t.illegalArgument)("location");this.location=z}};Xt=je([A],Xt),e.SourceBreakpoint=Xt;let qt=class extends Et{constructor(z,ue,Pe,et,at){super(ue,Pe,et,at);this.functionName=z}};qt=je([A],qt),e.FunctionBreakpoint=qt;let Yt=class extends Et{constructor(z,ue,Pe,et,at,dt,mt){super(et,at,dt,mt);if(!ue)throw(0,t.illegalArgument)("dataId");this.label=z,this.dataId=ue,this.canPersist=Pe}};Yt=je([A],Yt),e.DataBreakpoint=Yt;let ai=class{constructor(z,ue,Pe){this.command=z,this.args=ue||[],this.options=Pe}};ai=je([A],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(z,ue){this.port=z,this.host=ue}};Rt=je([A],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(z){this.path=z}};Jt=je([A],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(z){this.implementation=z}};li=je([A],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(z,ue){this.range=z,this.expression=ue}};jt=je([A],jt),e.EvaluatableExpression=jt;var Zt;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let vt=class{constructor(z,ue){this.range=z,this.text=ue}};vt=je([A],vt),e.InlineValueText=vt;let ci=class{constructor(z,ue,Pe=!0){this.range=z,this.variableName=ue,this.caseSensitiveLookup=Pe}};ci=je([A],ci),e.InlineValueVariableLookup=ci;let Ot=class{constructor(z,ue){this.range=z,this.expression=ue}};Ot=je([A],Ot),e.InlineValueEvaluatableExpression=Ot;let Wt=class{constructor(z,ue){this.frameId=z,this.stoppedLocation=ue}};Wt=je([A],Wt),e.InlineValueContext=Wt;var vi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=h=class extends Error{constructor(z,ue=y.FileSystemProviderErrorCode.Unknown,Pe){super(P.URI.isUri(z)?z.toString(!0):z);this.code=Pe?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists(z){return new h(z,y.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(z){return new h(z,y.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(z){return new h(z,y.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(z){return new h(z,y.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(z){return new h(z,y.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(z){return new h(z,y.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};ui=h=je([A],ui),e.FileSystemError=ui;let ei=class{constructor(z,ue,Pe){this.start=z,this.end=ue,this.kind=Pe}};ei=je([A],ei),e.FoldingRange=ei;var yi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(yi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(z,ue=[]){this.tokenTypes=z,this.tokenModifiers=ue}}e.SemanticTokensLegend=Di;function di(j){return typeof j=="undefined"||(0,_.isStringArray)(j)}class Gt{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let ue=0,Pe=z.tokenTypes.length;ue<Pe;ue++)this._tokenTypeStrToInt.set(z.tokenTypes[ue],ue);for(let ue=0,Pe=z.tokenModifiers.length;ue<Pe;ue++)this._tokenModifierStrToInt.set(z.tokenModifiers[ue],ue)}}push(z,ue,Pe,et,at){if(typeof z=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof et=="number"&&(typeof at=="number"||typeof at=="undefined"))return typeof at=="undefined"&&(at=0),this._pushEncoded(z,ue,Pe,et,at);if(F.isRange(z)&&typeof ue=="string"&&di(Pe))return this._push(z,ue,Pe);throw(0,t.illegalArgument)()}_push(z,ue,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const et=z.start.line,at=z.start.character,dt=z.end.character-z.start.character,mt=this._tokenTypeStrToInt.get(ue);let At=0;if(Pe)for(const Lt of Pe){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Lt);At|=1<<Nt>>>0}this._pushEncoded(et,at,dt,mt,At)}_pushEncoded(z,ue,Pe,et,at){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Lt=0,Nt=0;for(let xt=0;xt<At;xt++){let Ht=this._data[5*xt],gi=this._data[5*xt+1];Ht===0?(Ht=Lt,gi+=Nt):Ht+=Lt,this._data[5*xt]=Ht,this._data[5*xt+1]=gi,Lt=Ht,Nt=gi}}let dt=z,mt=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=et,this._data[this._dataLen++]=at,this._prevLine=z,this._prevChar=ue}static _sortAndDeltaEncode(z){let ue=[];const Pe=z.length/5|0;for(let mt=0;mt<Pe;mt++)ue[mt]=mt;ue.sort((mt,At)=>{const Lt=z[5*mt],Nt=z[5*At];if(Lt===Nt){const xt=z[5*mt+1],Ht=z[5*At+1];return xt-Ht}return Lt-Nt});const et=new Uint32Array(z.length);let at=0,dt=0;for(let mt=0;mt<Pe;mt++){const At=5*ue[mt],Lt=z[At+0],Nt=z[At+1],xt=z[At+2],Ht=z[At+3],gi=z[At+4],zi=Lt-at,Ji=zi===0?Nt-dt:Nt,pi=5*mt;et[pi+0]=zi,et[pi+1]=Ji,et[pi+2]=xt,et[pi+3]=Ht,et[pi+4]=gi,at=Lt,dt=Nt}return et}build(z){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),z):new hi(Gt._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=Gt;class hi{constructor(z,ue){this.resultId=ue,this.data=z}}e.SemanticTokens=hi;class ki{constructor(z,ue,Pe){this.start=z,this.deleteCount=ue,this.data=Pe}}e.SemanticTokensEdit=ki;class Kt{constructor(z,ue){this.resultId=ue,this.edits=z}}e.SemanticTokensEdits=Kt;var Ii;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new kt("arrow-left")},ii=je([A],ii),e.QuickInputButtons=ii;var Ai;(function(j){j[j.Separator=-1]="Separator",j[j.Default=1]="Default"})(Ai=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(z,ue,Pe){this.badge=z,this.tooltip=ue,this.color=Pe}static validate(z){if(z.badge){let ue=(0,I.nextCharLength)(z.badge,0);if(ue<z.badge.length&&(ue+=(0,I.nextCharLength)(z.badge,ue)),z.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(z){this.kind=z}};ni=je([A],ni),e.ColorTheme=ni;var Be;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(Be=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(z,ue){if(z<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");z<=ue?(this._start=z,this._end=ue):(this._start=ue,this._end=z)}static isNotebookRange(z){return z instanceof $t?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let ue=this._start,Pe=this._end;return z.start!==void 0&&(ue=z.start),z.end!==void 0&&(Pe=z.end),ue===this._start&&Pe===this._end?this:new $t(ue,Pe)}}e.NotebookRange=$t;class Bt{constructor(z,ue,Pe,et,at,dt,mt){this.kind=z,this.value=ue,this.languageId=Pe,this.mime=et,this.outputs=at??[],this.metadata=dt,this.executionSummary=mt,Bt.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ue=>Bt.isNotebookCellData(ue))}static isNotebookCellData(z){return!0}}e.NotebookCellData=Bt;class _t{constructor(z){this.cells=z}}e.NotebookData=_t;class Mt{constructor(z,ue){this.data=z,this.mime=ue;const Pe=(0,T.normalizeMimeType)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem(z){return z instanceof Mt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ue={name:z.name,message:z.message,stack:z.stack};return Mt.json(ue,"application/vnd.code.notebook.error")}static stdout(z){return Mt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Mt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ue="application/octet-stream"){return new Mt(z,ue)}static text(z,ue=T.Mimes.text){const Pe=Le(Mt,g,"f",E).encode(String(z));return new Mt(Pe,ue)}static json(z,ue="application/json"){const Pe=JSON.stringify(z,void 0,"	");return Mt.text(Pe,ue)}}e.NotebookCellOutputItem=Mt,g=Mt,E={value:new TextEncoder};class ri{constructor(z,ue,Pe){this.items=ri.ensureUniqueMimeTypes(z,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=ue??Pe)}static isNotebookCellOutput(z){return z instanceof ri?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,_.isArray)(z.items)}static ensureUniqueMimeTypes(z,ue=!1){const Pe=new Set,et=new Set;for(let at=0;at<z.length;at++){const dt=z[at],mt=(0,T.normalizeMimeType)(dt.mime);if(!Pe.has(mt)){Pe.add(mt);continue}et.add(at),ue&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return et.size===0?z:z.filter((at,dt)=>!et.has(dt))}}e.NotebookCellOutput=ri;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ti;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ti=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Li{constructor(z,ue){this.text=z,this.alignment=ue}}e.NotebookCellStatusBarItem=Li;var Fi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Fi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(z,ue=[]){this.uri=z,this.provides=(0,f.asArray)(ue)}}e.NotebookRendererScript=_i;let mi=class{constructor(z,ue){this.label=z,this.timestamp=ue}};mi=je([A],mi),e.TimelineItem=mi;var Mi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Mi=e.ExtensionMode||(e.ExtensionMode={}));var Oi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(z,ue){this.ranges=z,this.wordPattern=ue}}e.LinkedEditingRanges=Ui;class le{constructor(z,ue){this._port=z,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=le;var ge;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ge=e.TestResultState||(e.TestResultState={}));var Te;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Te=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ht=class{constructor(z=void 0,ue=void 0,Pe=void 0){this.include=z,this.exclude=ue,this.profile=Pe}};ht=je([A],ht),e.TestRunRequest=ht;let Dt=v=class{constructor(z){this.message=z}static diff(z,ue,Pe){const et=new v(z);return et.expectedOutput=ue,et.actualOutput=Pe,et}};Dt=v=je([A],Dt),e.TestMessage=Dt;let Tt=class{constructor(z){this.id=z}};Tt=je([A],Tt),e.TestTag=Tt;let si=class{constructor(z,ue){this.covered=z,this.total=ue}};si=je([A],si),e.CoveredCount=si;let Bi=w=class{constructor(z,ue,Pe,et){this.uri=z,this.statementCoverage=ue,this.branchCoverage=Pe,this.functionCoverage=et}static fromDetails(z,ue){const Pe=new si(0,0),et=new si(0,0),at=new si(0,0);for(const mt of ue)if("branches"in mt){Pe.total+=1,Pe.covered+=mt.executionCount>0?1:0;for(const At of mt.branches)et.total+=1,et.covered+=At.executionCount>0?1:0}else at.total+=1,at.covered+=mt.executionCount>0?1:0;const dt=new w(z,Pe,et.total>0?et:void 0,at.total>0?at:void 0);return dt.detailedCoverage=ue,dt}};Bi=w=je([A],Bi),e.FileCoverage=Bi;let xi=class{constructor(z,ue,Pe=[]){this.executionCount=z,this.location=ue,this.branches=Pe}};xi=je([A],xi),e.StatementCoverage=xi;let Wi=class{constructor(z,ue){this.executionCount=z,this.location=ue}};Wi=je([A],Wi),e.BranchCoverage=Wi;let $i=class{constructor(z,ue){this.executionCount=z,this.location=ue}};$i=je([A],$i),e.FunctionCoverage=$i;var Ki;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(z,ue,Pe,et,at,dt){this.kind=z,this.name=ue,this.detail=Pe,this.uri=et,this.range=at,this.selectionRange=dt}}e.TypeHierarchyItem=Yi}),define(pe[123],ve([0,1,55,10,8,150,110,7,17]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(p,g){g?P.set(p,g):P.delete(p)}e.setWordDefinitionFor=R;function y(p){return P.get(p)}e.getWordDefinitionFor=y;class l extends D.MirrorTextModel{constructor(g,E,L,C,a,s,m,o){super(E,L,C,a);this._proxy=g,this._languageId=s,this._isDirty=m,this._notebook=o,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,_.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(E){return E?g._getTextInRange(E):g.getText()},get eol(){return g._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(E){return g._lineAt(E)},offsetAt(E){return g._offsetAt(E)},positionAt(E){return g._positionAt(E)},validateRange(E){return g._validateRange(E)},validatePosition(E){return g._validatePosition(E)},getWordRangeAtPosition(E,L){return g._getWordRangeAtPosition(E,L)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,f.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,f.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const E=this._validateRange(g);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const L=this._eol,C=E.start.line,a=E.end.line,s=[];s.push(this._lines[C].substring(E.start.character));for(let m=C+1;m<a;m++)s.push(this._lines[m]);return s.push(this._lines[a].substring(0,E.end.character)),s.join(L)}_lineAt(g){let E;if(g instanceof I.Position?E=g.line:typeof g=="number"&&(E=g),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new b(E,this._lines[E],E===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(g),L=this._lines[E.index].length;return new I.Position(E.index,Math.min(E.remainder,L))}_validateRange(g){if(!(g instanceof I.Range))throw new Error("Invalid argument");const E=this._validatePosition(g.start),L=this._validatePosition(g.end);return E===g.start&&L===g.end?g:new I.Range(E.line,E.character,L.line,L.character)}_validatePosition(g){if(!(g instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:E,character:L}=g,C=!1;if(E<0)E=0,L=0,C=!0;else if(E>=this._lines.length)E=this._lines.length-1,L=this._lines[E].length,C=!0;else{const a=this._lines[E].length;L<0?(L=0,C=!0):L>a&&(L=a,C=!0)}return C?new I.Position(E,L):g}_getWordRangeAtPosition(g,E){const L=this._validatePosition(g);if(!E)E=y(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const C=(0,T.getWordAtText)(L.character+1,(0,T.ensureValidWordDefinition)(E),this._lines[L.line],0);if(C)return new I.Range(L.line,C.startColumn-1,L.line,C.endColumn-1)}}e.ExtHostDocumentData=l;class b{constructor(g,E,L){this._line=g,this._text=E,this._isLastLine=L}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(pe[202],ve([0,1,7,3,112,6,82,24,2,33]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(l,b,p,g){this._notebook=p,this._selector=g,this._disposables=new D.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(b.onDidChangeDocument(L=>{const C=this._cellUris.get(L.document.uri);C!==void 0&&(this._cellLengths.setValue(C,this._cells[C].document.getText().length+1),this._cellLines.setValue(C,this._cells[C].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=L=>{L===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(L=>E(L.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const l=[],b=[];for(const p of this._notebook.getCells())p.kind===f.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,p.document.uri,p.document.languageId,!0))&&(this._cellUris.set(p.document.uri,this._cells.length),this._cells.push(p),l.push(p.document.getText().length+1),b.push(p.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(b))}get version(){return this._versionId}getText(l){if(!l){let C="";for(const a of this._cells)C+=a.document.getText()+`
`;return C=C.slice(0,-1),C}if(l.isEmpty)return"";const b=this.locationAt(l.start),p=this.locationAt(l.end),g=this._cellUris.get(b.uri),E=this._cellUris.get(p.uri);if(g===void 0||E===void 0)return"";if(g===E)return this._cells[g].document.getText(new f.Range(b.range.start,p.range.end));const L=[this._cells[g].document.getText(new f.Range(b.range.start,new f.Position(this._cells[g].document.lineCount,0)))];for(let C=g+1;C<E;C++)L.push(this._cells[C].document.getText());return L.push(this._cells[E].document.getText(new f.Range(new f.Position(0,0),p.range.end))),L.join(`
`)}offsetAt(l){const b=this._cellLines.getIndexOf(l.line),p=this._cellLengths.getPrefixSum(b.index-1),g=this._cells[b.index].document.offsetAt(l.with(b.remainder));return p+g}positionAt(l){if(typeof l=="number"){const p=this._cellLengths.getIndexOf(l),g=this._cellLines.getPrefixSum(p.index-1);return this._cells[p.index].document.positionAt(p.remainder).translate(g)}const b=this._cellUris.get(l.uri);if(b!==void 0){const p=this._cellLines.getPrefixSum(b-1);return new f.Position(p+l.range.start.line,l.range.start.character)}return new f.Position(0,0)}locationAt(l){f.Range.isRange(l)||(l=new f.Range(l,l));const b=this._cellLines.getIndexOf(l.start.line);let p=b;l.isEmpty||(p=this._cellLines.getIndexOf(l.end.line));const g=new f.Position(b.remainder,l.start.character),E=new f.Position(p.remainder,l.end.character),L=new f.Range(g,E),C=this._cells[b.index];return new f.Location(C.document.uri,C.document.validateRange(L))}contains(l){return this._cellUris.has(l)}validateRange(l){const b=this.validatePosition(l.start),p=this.validatePosition(l.end);return l.with(b,p)}validatePosition(l){const b=this._cellLines.getIndexOf(l.line),p=new f.Position(b.remainder,l.character),g=this._cells[b.index].document.validatePosition(p),E=this._cellLines.getPrefixSum(b.index-1);return new f.Position(E+g.line,g.character)}}e.ExtHostNotebookConcatDocument=R}),define(pe[203],ve([0,1,7,14,3]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let D=class{constructor(I){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let _=I==="light"?f.ColorThemeKind.Light:I==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};D=je([He(0,t.IExtHostRpcService)],D),e.ExtHostTheming=D}),define(pe[65],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class t{constructor(D){D?(this.transformIncoming=D.transformIncoming.bind(D),this.transformOutgoing=D.transformOutgoing.bind(D),this.transformOutgoingURI=D.transformOutgoingURI.bind(D),this.transformOutgoingScheme=D.transformOutgoingScheme.bind(D)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=t}),define(pe[204],ve([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(_){let P=this.buffers.indexOf(_);return P<0&&(P=this.buffers.length,this.buffers.push(_)),P}}function k(I,_){if(_.serializeBuffersForPostMessage){const P=new t,R=(b,p)=>{if(p instanceof ArrayBuffer){const g=P.add(p);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(p)){const g=D(p);if(g){const E=P.add(p.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}}return p},y=JSON.stringify(I,R),l=P.buffers.map(b=>{const p=new Uint8Array(b);return f.VSBuffer.wrap(p)});return{message:y,buffers:l}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=k;function D(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(I,_){const P=_.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),R=_.length?(l,b)=>{if(typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:g}=p,E=P[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(E,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return b}:void 0;return{message:JSON.parse(I,R),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(pe[205],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(t){function k(T){const I=new Map;return T.types.forEach((_,P)=>{I.set(_,{asString:async()=>T.items[P].asString})}),I}t.toITreeDataTransfer=k;async function D(T){const I={types:[],items:[]},_=Array.from(T.entries());for(const P of _)I.types.push(P[0]),I.items.push({asString:await P[1].asString()});return I}t.toTreeDataTransferDTO=D})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[87],ve([0,1,10,2]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(I,_){return I.scheme===f.Schemas.http||I.scheme===f.Schemas.https?I:(_&&_.authority&&_.isRemote&&I.scheme===f.Schemas.file&&(I=t.URI.from({scheme:f.Schemas.vscodeRemote,authority:_.authority,path:I.path})),t.URI.from({scheme:f.Schemas.https,authority:`${I.scheme}+${D(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=k;function D(I){return I.replace(/./g,_=>{const P=_.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?_:"-"+P.toString(16).padStart(4,"0")})}function T(I){return I.replace(/-([0-9a-f]{4})/g,(_,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=T}),define(pe[206],ve([0,1,3,6,87]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(I,_,P){this._proxy=I,this._editors=_,this._initData=P,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const R=_.getVisibleTextEditors();for(const y of this._insets.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,_,P,R,y){let l;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===I){l=a;break}if(!l)throw new Error("not a visible editor");const b=this,p=this._handlePool++,g=new f.Emitter,E=new f.Emitter,L=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,k.asWebviewUri)(a,b._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(a){this._options=a,b._proxy.$setOptions(p,a)}get options(){return this._options}set html(a){this._html=a,b._proxy.$setHtml(p,a)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(a){return b._proxy.$postMessage(p,a)}},C=new class{constructor(){this.editor=I,this.line=_,this.height=P,this.webview=L,this.onDidDispose=E.event}dispose(){b._insets.has(p)&&(b._insets.delete(p),b._proxy.$disposeEditorInset(p),E.fire(),E.dispose(),g.dispose())}};return this._proxy.$createEditorInset(p,l.id,l.value.document.uri,_+1,P,R||{},y.identifier,y.extensionLocation),this._insets.set(p,{editor:I,inset:C,onDidReceiveMessage:g}),C}$onDidDispose(I){const _=this._insets.get(I);_&&_.inset.dispose()}$onDidReceiveMessage(I,_){const P=this._insets.get(I);P&&P.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=D}),define(pe[207],ve([0,1,172,13,2,6,4,62,50,42,17,10]),function(Z,e,f,t,k,D,T,I,_,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,f.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,f.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,f.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,f.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,f.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,f.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,f.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,f.localize)(22,null)),e.EditorTabsVisibleContext=new I.RawContextKey("editorTabsVisible",!0,(0,f.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(F,M,V){for(const $ of V.visibleEditorPanes)if($.group.id===M&&F.matches($.input))return $.getViewState()}e.findViewStateForEditor=l;function b(F){if(m(F))return!1;const M=F;return k.URI.isUri(M?.resource)}e.isResourceEditorInput=b;function p(F){if(m(F))return!1;const M=F;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=p;function g(F){if(m(F)||p(F))return!1;const M=F;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function E(F){if(m(F))return!1;const M=F;return M?M.resource===void 0||M.resource.scheme===y.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var L;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(L=e.Verbosity||(e.Verbosity={}));var C;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(C=e.SaveReason||(e.SaveReason={}));var a;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends D.Disposable{}e.AbstractEditorInput=s;function m(F){return F instanceof s}e.isEditorInput=m;function o(F){const M=F;return k.URI.isUri(M?.preferredResource)}function S(F){const M=F;return m(M?.primary)&&m(M?.secondary)}e.isSideBySideEditorInput=S;function r(F){const M=F;return m(M?.modified)&&m(M?.original)}e.isDiffEditorInput=r;function i(F){return m(F?.editor)}e.isEditorInputWithOptions=i;function n(F){const M=F;return i(F)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function u(F){const M=F;return typeof M?.groupId=="number"&&m(M.editor)}e.isEditorIdentifier=u;var c;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var d;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(d=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var h;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class v{getOriginalUri(M,V){if(!M)return;if(V?.supportSideBySide){const{primary:U,secondary:B}=this.getSideEditors(M);if(U&&B){if(V?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===h.ANY)return this.getOriginalUri(U,{filterByScheme:V.filterByScheme})??this.getOriginalUri(B,{filterByScheme:V.filterByScheme});M=V.supportSideBySide===h.PRIMARY?U:B}}if(p(M)||g(M))return;const $=o(M)?M.preferredResource:M.resource;return!$||!V||!V.filterByScheme?$:this.filterUri($,V.filterByScheme)}getSideEditors(M){return S(M)||g(M)?{primary:M.primary,secondary:M.secondary}:r(M)||p(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,V){if(!M)return;if(V?.supportSideBySide){const{primary:U,secondary:B}=this.getSideEditors(M);if(U&&B){if(V?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===h.ANY)return this.getCanonicalUri(U,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:V.filterByScheme});M=V.supportSideBySide===h.PRIMARY?U:B}}if(p(M)||g(M))return;const $=M.resource;return!$||!V||!V.filterByScheme?$:this.filterUri($,V.filterByScheme)}filterUri(M,V){if(Array.isArray(V)){if(V.some($=>M.scheme===$))return M}else if(V===M.scheme)return M}}e.EditorResourceAccessor=new v;var w;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(w=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const V=this.instantiationService=M.get(T.IInstantiationService);for(const[$,U]of this.editorSerializerConstructors)this.createEditorSerializer($,U,V);this.editorSerializerConstructors.clear()}createEditorSerializer(M,V,$){const U=$.createInstance(V);this.editorSerializerInstances.set(M,U)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,V){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,V,this.instantiationService):this.editorSerializerConstructors.set(M,V),(0,D.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new A);async function O(F,M){if(!F||!F.length)return[];const V=await Promise.all(F.map(async $=>{const U=k.URI.revive($.fileUri);if(!U||!await M.canHandleResource(U))return;let W=$.exists,H=$.type;if(typeof W!="boolean"||typeof H!="number")try{H=(await M.resolve(U)).isDirectory?P.FileType.Directory:P.FileType.Unknown,W=!0}catch{W=!1}if(!W&&$.openOnlyIfExists||H===P.FileType.Directory)return;const x={selection:W?$.selection:void 0,pinned:!0,override:$.editorOverrideId};let J;return W?J={resource:U,options:x}:J={resource:U,options:x,forceUntitled:!0},J}));return(0,R.coalesce)(V)}e.pathsToEditors=O;var N;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(N=e.EditorsOrder||(e.EditorsOrder={}))}),define(pe[124],ve([0,1,3,18,173]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class D{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,_,P,R){const y={command:I};if(_&&Object.keys(_).length>0&&(y.arguments=_),this.internalSend("request",y),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.pendingRequests.get(y.seq);if(b){this.pendingRequests.delete(y.seq);const p={type:"response",seq:0,request_seq:y.seq,success:!1,command:I,message:(0,k.localize)(0,null,R,I)};b(p)}},R)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,_){return I.type!=="event"||_.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":{const _=I,P=this.pendingRequests.get(_.request_seq);P&&(this.pendingRequests.delete(_.request_seq),P(_));break}}}}internalSend(I,_){_.type=I,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((_,P)=>I.set(P,_)),await(0,t.timeout)(500),I.forEach((_,P)=>{_({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=D}),define(pe[208],ve([0,1,8,2,9,25,10]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function _(r,i,n){return r.replace(I,function(u,c){return i&&c.length>0&&c[0]!=="_"?u:n&&n.hasOwnProperty(c)?n[c]:u})}e.formatPII=_;function P(r){const i={};for(const n of Object.keys(r))n.startsWith("!")||(i[n]=r[n]);return i}e.filterExceptionsFromTelemetry=P;function R(r){return r.configuration.request==="attach"&&!y(r)&&(!r.parentSession||R(r.parentSession))}e.isSessionAttach=R;function y(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(i,"extensionhost")||(0,f.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?y(r.parentSession):void 0}e.getExtensionHostDebugSession=y;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function b(r,i,n){let u,c=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=d.exec(r);){const v=h.index+1,w=v+h[0].length;if(v<=i&&w>=n){u=h[0],c=v;break}}if(u){const v=/\w+/g;let w=null;for(;(w=v.exec(u))&&!(w.index+1+c+w[0].length>=n););w&&(u=u.substring(0,v.lastIndex))}return u?{start:c,end:c+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(p))}e.isUri=g;function E(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return t.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function L(r){if(typeof r.path=="object"){const i=t.URI.revive(r.path);if(i)return i.scheme===T.Schemas.file?i.fsPath:i.toString()}return r.path}function C(r,i){const n=i?E:L,u=(0,D.deepClone)(r);return s(u,(c,d)=>{c&&d&&(d.path=n(d))}),u}e.convertToDAPaths=C;function a(r,i){const n=i?E:L,u=(0,D.deepClone)(r);return s(u,(c,d)=>{!c&&d&&(d.path=n(d))}),u}e.convertToVSCPaths=a;function s(r,i){switch(r.type){case"event":{const n=r;switch(n.event){case"output":i(!1,n.body.source);break;case"loadedSource":i(!1,n.body.source);break;case"breakpoint":i(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=r;switch(n.command){case"setBreakpoints":i(!0,n.arguments.source);break;case"breakpointLocations":i(!0,n.arguments.source);break;case"source":i(!0,n.arguments.source);break;case"gotoTargets":i(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(u=>i(!1,u));break;default:break}break}case"response":{const n=r;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(u=>i(!1,u.source));break;case"loadedSources":n.body.sources.forEach(u=>i(!1,u));break;case"scopes":n.body.scopes.forEach(u=>i(!1,u.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(u=>i(!1,u.source));break;case"setBreakpoints":n.body.breakpoints.forEach(u=>i(!1,u.source));break;default:break}break}}}function m(r){return r.filter(i=>!i.presentation?.hidden).sort((i,n)=>i.presentation?n.presentation?i.presentation.group?n.presentation.group?i.presentation.group!==n.presentation.group?i.presentation.group.localeCompare(n.presentation.group):o(i.presentation.order,n.presentation.order):-1:n.presentation.group?1:o(i.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=m;function o(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function S(r,i){const n=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(n!=="none"&&(await i.saveAll(),n==="allEditorsInActiveGroup")){const u=i.activeEditorPane;u&&u.input.resource?.scheme===T.Schemas.untitled&&await i.save({editor:u.input,groupId:u.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(pe[209],ve([0,1,30,37,174,125,9,8,25,12,184,124]),function(Z,e,f,t,k,D,T,I,_,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends y.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(C,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,C.on("data",s=>this.handleData(s))}sendMessage(C){if(this.outputStream){const a=JSON.stringify(C);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${l.TWO_CRLF}${a}`,"utf8")}}handleData(C){for(this.rawData=Buffer.concat([this.rawData,C]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+a))}continue}}else{const a=this.rawData.indexOf(l.TWO_CRLF);if(a!==-1){const m=this.rawData.toString("utf8",0,a).split(l.HEADER_LINESEPARATOR);for(const o of m){const S=o.split(l.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(a+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class b extends l{startSession(){return new Promise((C,a)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),C(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",m=>{s?this._onError.fire(m):a(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=b;class p extends b{constructor(C){super();this.adapterServer=C}createConnection(C){return D.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",C)}}e.SocketDebugAdapter=p;class g extends b{constructor(C){super();this.adapterServer=C}createConnection(C){return D.createConnection(this.adapterServer.path,C)}}e.NamedPipeDebugAdapter=g;class E extends l{constructor(C,a,s){super();this.adapterExecutable=C,this.debugType=a,this.outputService=s}async startSession(){const C=this.adapterExecutable.command,a=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(C)if(T.isAbsolute(C)){if(!await f.Promises.exists(C))throw new Error(k.localize(0,null,C))}else C.indexOf("/")<0&&C.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let m=process.env;if(s.env&&Object.keys(s.env).length>0&&(m=_.mixin(_.deepClone(process.env),s.env)),C==="node")if(Array.isArray(a)&&a.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(r.cwd=s.cwd);const i=t.fork(a[0],a.slice(1),r);if(!i.pid)throw new Error(k.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const S={env:m};s.cwd&&(S.cwd=s.cwd),this.serverProcess=t.spawn(C,a,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,r)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const o=this.outputService;if(o){const S=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=o.getChannel(R.ExtensionsChannelId);i&&i.append(S(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((C,a)=>{const s=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,o,S){if(m)return a(m)});s.on("exit",C),s.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(C,a){if(!C)return;const s=Object.create(null);C.runtime&&(C.runtime.indexOf("./")===0?s.runtime=T.join(a,C.runtime):s.runtime=C.runtime),C.runtimeArgs&&(s.runtimeArgs=C.runtimeArgs),C.program&&(T.isAbsolute(C.program)?s.program=C.program:s.program=T.join(a,C.program)),C.args&&(s.args=C.args);const m=C;return m.win&&(s.win=E.extract(m.win,a)),m.winx86&&(s.winx86=E.extract(m.winx86,a)),m.windows&&(s.windows=E.extract(m.windows,a)),m.osx&&(s.osx=E.extract(m.osx,a)),m.linux&&(s.linux=E.extract(m.linux,a)),s}static platformAdapterExecutable(C,a){let s=Object.create(null);a=a.toLowerCase();for(const n of C)if(n.contributes){const u=n.contributes.debuggers;u&&u.length>0&&u.filter(c=>typeof c.type=="string"&&I.equalsIgnoreCase(c.type,a)).forEach(c=>{const d=E.extract(c,n.extensionLocation.fsPath);s=_.mixin(s,d,n.isBuiltin)})}let m;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=s.winx86||s.win||s.windows:P.isWindows?m=s.win||s.windows:P.isMacintosh?m=s.osx:P.isLinux&&(m=s.linux),m=m||s;const o=m.program||s.program,S=m.args||s.args,r=m.runtime||s.runtime,i=m.runtimeArgs||s.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof o=="string"?[o]:[]).concat(S||[])};if(o)return{type:"executable",command:o,args:S||[]}}}e.ExecutableDebugAdapter=E}),define(pe[210],ve([0,1,37,12,29,186]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(l,b){return new Promise((p,g)=>{let E="";const L=f.spawn(l,b);L.pid&&L.stdout.on("data",C=>{E+=C.toString()}),L.on("error",C=>{g(C)}),L.on("close",C=>{p(E)})})}let I;function _(l,b){if(!I)if(t.isWindows)I=new D.WindowsExternalTerminalService;else if(t.isMacintosh)I=new D.MacExternalTerminalService;else if(t.isLinux)I=new D.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const p=b.getConfiguration("terminal");return I.runInTerminal(l.title,l.cwd,l.args,l.env||{},p.external||{})}e.runInExternalTerminal=_;async function P(l){if(l)if(t.isWindows){const b=await new Promise((p,g)=>{Z(["windows-process-tree"],p,g)});return new Promise(p=>{b.getProcessTree(l,g=>{p(g.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(l)]).then(b=>{const p=b.trim();return!(p.length===0||p.indexOf(" tmux")>=0)},b=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var R;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(R||(R={}));function y(l,b,p,g){l=l.trim().toLowerCase();let E;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?E=1:l.indexOf("cmd.exe")>=0?E=0:l.indexOf("bash")>=0?E=2:t.isWindows?E=0:E=2;let L,C=" ";switch(E){case 1:if(L=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),p){const a=(0,k.getDriveLetter)(p);a&&(C+=`${a}:; `),C+=`cd ${L(p)}; `}if(g)for(const a in g){const s=g[a];s===null?C+=`Remove-Item env:${a}; `:C+=`\${env:${a}}='${s}'; `}if(b.length>0){const a=L(b.shift());C+=a[0]==="'"?`& ${a} `:`${a} `;for(const s of b)C+=`${L(s)} `}break;case 0:if(L=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),p){const a=(0,k.getDriveLetter)(p);a&&(C+=`${a}: && `),C+=`cd ${L(p)} && `}if(g){C+='cmd /C "';for(const a in g){let s=g[a];s===null?C+=`set "${a}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,m=>`^${m}`),C+=`set "${a}=${s}" && `)}}for(const a of b)C+=`${L(a)} `;g&&(C+='"');break;case 2:{L=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const a=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(p&&(C+=`cd ${L(p)} ; `),g){C+="/usr/bin/env";for(const s in g){const m=g[s];m===null?C+=` -u ${a(s)}`:C+=` ${a(`${s}=${m}`)}`}C+=" "}for(const s of b)C+=`${L(s)} `;break}}return C}e.prepareCommand=y}),define(pe[126],ve([0,1,32,78,95,10,9,12,62]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(v){v[v.Markup=1]="Markup",v[v.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",k.Mimes.latex,k.Mimes.markdown,"image/png","image/jpeg",k.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[k.Mimes.latex,k.Mimes.markdown,"application/json",k.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(v){v[v.Running=1]="Running",v[v.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(v){v[v.Pending=2]="Pending",v[v.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(v){v[v.WithHardKernelDependency=0]="WithHardKernelDependency",v[v.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",v[v.Pure=2]="Pure",v[v.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(v){v.Always="always",v.Never="never",v.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(v){v[v.ModelChange=1]="ModelChange",v[v.Move=2]="Move",v[v.ChangeLanguage=5]="ChangeLanguage",v[v.Initialize=6]="Initialize",v[v.ChangeCellMetadata=7]="ChangeCellMetadata",v[v.Output=8]="Output",v[v.OutputItem=9]="OutputItem",v[v.ChangeCellContent=10]="ChangeCellContent",v[v.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",v[v.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",v[v.ChangeCellMime=13]="ChangeCellMime",v[v.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(v){v[v.Handle=0]="Handle",v[v.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var E;(function(v){v[v.Replace=1]="Replace",v[v.Output=2]="Output",v[v.Metadata=3]="Metadata",v[v.CellLanguage=4]="CellLanguage",v[v.DocumentMetadata=5]="DocumentMetadata",v[v.Move=6]="Move",v[v.OutputItems=7]="OutputItems",v[v.PartialMetadata=8]="PartialMetadata",v[v.PartialInternalMetadata=9]="PartialInternalMetadata"})(E=e.CellEditType||(e.CellEditType={}));var L;(function(v){v.scheme=D.Schemas.vscodeNotebookCell;const w=/^ch(\d{7,})/;function A($,U){return $.with({scheme:v.scheme,fragment:`ch${U.toString().padStart(7,"0")}${$.scheme!==D.Schemas.file?$.scheme:""}`})}v.generate=A;function O($){if($.scheme!==v.scheme)return;const U=w.exec($.fragment);return U?{handle:Number(U[1]),notebook:$.with({scheme:$.fragment.substring(U[0].length)||D.Schemas.file,fragment:null})}:void 0}v.parse=O;function N($,U,B){return $.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`ch${U.toString().padStart(7,"0")},${B??""},${$.scheme!==D.Schemas.file?$.scheme:""}`})}v.generateCellOutputUri=N;function F($){if($.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const U=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($.fragment);if(!U)return;const B=Number(U[1]),W=U[2]&&U[2]!==""?U[2]:void 0,H=U[3];return{handle:B,outputId:W,notebook:$.with({scheme:H||D.Schemas.file,fragment:null})}}v.parseCellOutputUri=F;function M($,U,B){return $.with({scheme:B,fragment:`ch${U.toString().padStart(7,"0")}${$.scheme!==D.Schemas.file?$.scheme:""}`})}v.generateCellUri=M;function V($,U){if($.scheme!==U)return;const B=w.exec($.fragment);return B?{handle:Number(B[1]),notebook:$.with({scheme:$.fragment.substring(B[0].length)||D.Schemas.file,fragment:null})}:void 0}v.parseCellUri=V})(L=e.CellUri||(e.CellUri={}));const C=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[k.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function a(v){return C.get(v)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=a;function s(v){return C.get(v)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function m(v){return C.get(v)?.mergeable??!1}e.mimeTypeIsMergeable=m;const o=v=>I.isWindows?v.replace(/\//g,"\\"):v;class S{constructor(w=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(w)].map(O=>({pattern:O,matches:f.parse(o(O))}))}sort(w){const A=new Map(t.Iterable.map(w,N=>[N,o(N)]));let O=[];for(const{matches:N}of this.order)for(const[F,M]of A)if(N(M)){O.push(F),A.delete(F);break}return A.size&&(O=O.concat([...A.keys()].sort((N,F)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(F)))),O}prioritize(w,A){const O=this.findIndex(w);if(O===-1){this.order.unshift({pattern:w,matches:f.parse(o(w))});return}const N=new Set(A.map(M=>this.findIndex(M,O)));N.delete(-1);const F=Array.from(N).sort();this.order.splice(O+1,0,...F.map(M=>this.order[M]));for(let M=F.length-1;M>=0;M--)this.order.splice(F[M],1)}toArray(){return this.order.map(w=>w.pattern)}findIndex(w,A=this.order.length){const O=o(w);for(let N=0;N<A;N++)if(this.order[N].matches(O))return N;return-1}}e.MimeTypeDisplayOrder=S;function r(v,w,A,O=(N,F)=>N===F){const N=[];function F($,U,B){if(U===0&&B.length===0)return;const W=N[N.length-1];W&&W.start+W.deleteCount===$?(W.deleteCount+=U,W.toInsert.push(...B)):N.push({start:$,deleteCount:U,toInsert:B})}let M=0,V=0;for(;;){if(M===v.length){F(M,0,w.slice(V));break}if(V===w.length){F(M,v.length-M,[]);break}const $=v[M],U=w[V];if(O($,U)){M+=1,V+=1;continue}A(U)?(F(M,1,[]),M+=1):(F(M,0,[U]),V+=1)}return N}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(v){v.default="default",v.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(v){const w=v;return!!((typeof w.include=="string"||f.isRelativePattern(w.include))&&(typeof w.exclude=="string"||f.isRelativePattern(w.exclude)))}e.isDocumentExcludePattern=n;function u(v,w,A){if(Array.isArray(v.viewType)&&v.viewType.indexOf(w)>=0||v.viewType===w)return!0;if(v.filenamePattern){const O=n(v.filenamePattern)?v.filenamePattern.include:v.filenamePattern,N=n(v.filenamePattern)?v.filenamePattern.exclude:void 0;if(f.match(O,(0,T.basename)(A.fsPath).toLowerCase()))return!(N&&f.match(N,(0,T.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class c{constructor(w){this.textModel=w}getElements(){const w=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)w[A]=this.textModel.cells[A].getHashValue();return w}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var d;(function(v){v[v.Left=1]="Left",v[v.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class h{static create(w){return`${h._prefix}${w}`}static parse(w){if(w.startsWith(h._prefix))return w.substring(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h,h._prefix="notebook/"}),define(pe[211],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(pe[212],ve([0,1,4,62]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,f.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[213],ve([0,1,176,4,62]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[214],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=f;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t}),define(pe[127],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var f;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(f=e.TestResultState||(e.TestResultState={}));var t;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var D;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(D=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(y,l)=>{l.expand!==void 0&&(y.expand=l.expand),l.item!==void 0&&(y.item=y.item?Object.assign(y.item,l.item):l.item)};e.applyTestItemUpdate=T;var I;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var _;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(l){}update(l){}remove(l,b){}complete(){}}e.IncrementalChangeCollector=P;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const b=this.createChangeCollector();for(const p of l)switch(p[0]){case 0:{const g=p[1];if(g.parent){if(this.items.has(g.parent)){const E=this.items.get(g.parent);E.children.add(g.item.extId);const L=this.createItem(g,E);this.items.set(g.item.extId,L),b.add(L)}}else{const E=this.createItem(g);this.roots.add(E),this.items.set(g.item.extId,E),b.add(E)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=p[1],E=this.items.get(g.extId);if(!E)break;g.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,g),b.update(E);break}case 2:{const g=this.items.get(p[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const E=[[p[1]]];for(;E.length;)for(const L of E.pop()){const C=this.items.get(L);C&&(E.push(C.children),this.items.delete(L),b.remove(C,C!==g),C.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p[1]);break;case 3:this.updatePendingRoots(p[1]);break;case 5:this._tags.set(p[1].id,p[1]);break;case 6:this._tags.delete(p[1]);break}b.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=R}),define(pe[88],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(D){D.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{constructor(T,I=T.length){if(this.path=T,this.viewEnd=I,T.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,I,_=T.parent){if(T.id===I)return new k([I]);let P=[T.id];for(let R=_;R&&R.id!==I;R=R.parent)P.push(R.id);return P.push(I),new k(P.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const I=T.indexOf("\0");return I===-1?T:T.slice(0,I)}static fromString(T){return new k(T.split("\0"))}static join(T,I){return new k([...T.path,I])}static joinToString(T,I){return T.toString()+"\0"+I}static compare(T,I){return T===I?0:I.startsWith(T+"\0")?2:T.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new k(this.path,T)}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let I=0;I<T.viewEnd&&I<this.viewEnd;I++)if(T.path[I]!==this.path[I])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(pe[215],ve([0,1,9,40,13,25,12,80,177]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,l,b){this._contributedVariables=new Map,this._context=y,this._labelService=l,b&&(this._envVariablesPromise=b.then(p=>this.prepareEnv(p)))}prepareEnv(y){if(T.isWindows){const l=Object.create(null);return Object.keys(y).forEach(b=>{l[b.toLowerCase()]=y[b]}),l}return y}resolveWithEnvironment(y,l,b){return this.recursiveResolve(this.prepareEnv(y),l?l.uri:void 0,b)}async resolveAsync(y,l){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,l)}async resolveAnyBase(y,l,b,p){const g=D.deepClone(l);return T.isWindows&&g.windows?Object.keys(g.windows).forEach(E=>g[E]=g.windows[E]):T.isMacintosh&&g.osx?Object.keys(g.osx).forEach(E=>g[E]=g.osx[E]):T.isLinux&&g.linux&&Object.keys(g.linux).forEach(E=>g[E]=g.linux[E]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,g,b,p)}async resolveAnyAsync(y,l,b){return this.resolveAnyBase(y,l,b)}async resolveAnyMap(y,l,b){const p=new Map;return{newConfig:await this.resolveAnyBase(y,l,b,p),resolvedVariables:p}}resolveWithInteractionReplace(y,l,b,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,l,b,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,l){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,l)}recursiveResolve(y,l,b,p,g){if(k.isString(b))return this.resolveString(y,l,b,p,g);if(k.isArray(b))return b.map(E=>this.recursiveResolve(y,l,E,p,g));if(k.isObject(b)){let E=Object.create(null);return Object.keys(b).forEach(L=>{const C=this.resolveString(y,l,L,p,g);E[C]=this.recursiveResolve(y,l,b[L],p,g)}),E}return b}resolveString(y,l,b,p,g){return b.replace(P.VARIABLE_REGEXP,(L,C)=>{if(C.includes(P.VARIABLE_LHS))return L;let a=this.evaluateSingleVariable(y,L,C,l,p);return g&&g.set(C,a),a!==L&&k.isString(a)&&a.match(P.VARIABLE_REGEXP)&&(a=this.resolveString(y,l,a,p,g)),a})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,l,b,p,g){let E;const L=b.split(":");L.length>1&&(b=L[0],E=L[1]);const C=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,_.localize)(0,null,l))},a=()=>{const m=C();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,_.localize)(1,null,l,f.basename(m)))},s=()=>{if(E){const m=this._context.getFolderUri(E);if(m)return m;throw new Error((0,_.localize)(2,null,l,E))}if(p)return p;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(b){case"env":if(E){if(y){const m=y[T.isWindows?E.toLowerCase():E];if(k.isString(m))return m}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(E){const m=this._context.getConfigurationValue(p,E);if(k.isUndefinedOrNull(m))throw new Error((0,_.localize)(6,null,l,E));if(k.isObject(m))throw new Error((0,_.localize)(7,null,l,E));return m}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,E,g,"command");case"input":return this.resolveFromMap(l,E,g,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return p||E?(0,I.normalizeDriveLetter)(this.fsPath(s())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(s()));case"lineNumber":{const m=this._context.getLineNumber();if(m)return m;throw new Error((0,_.localize)(9,null,l))}case"selectedText":{const m=this._context.getSelectedText();if(m)return m;throw new Error((0,_.localize)(10,null,l))}case"file":return C();case"fileWorkspaceFolder":return a();case"relativeFile":return p||E?f.relative(this.fsPath(s()),C()):C();case"relativeFileDirname":{const m=f.dirname(C());if(p||E){const o=f.relative(this.fsPath(s()),m);return o.length===0?".":o}return m}case"fileDirname":return f.dirname(C());case"fileExtname":return f.extname(C());case"fileBasename":return f.basename(C());case"fileBasenameNoExtension":{const m=f.basename(C());return m.slice(0,m.length-f.extname(m).length)}case"fileDirnameBasename":return f.basename(f.dirname(C()));case"execPath":{const m=this._context.getExecPath();return m||l}case"execInstallFolder":{const m=this._context.getAppRoot();return m||l}case"pathSeparator":return f.sep;default:try{const m=E?`${b}:${E}`:b;return this.resolveFromMap(l,m,g,void 0)}catch{return l}}}}resolveFromMap(y,l,b,p){if(l&&b){const g=p===void 0?b[l]:b[p+":"+l];if(typeof g=="string")return g;throw new Error((0,_.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[128],ve([0,1,4,207]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var k;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var D;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(p){p[p.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function P(p){const g=p;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=P;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function l(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=l;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(pe[216],ve([0,1,4,128]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(D){const T=D;return typeof D=="number"||(0,t.isEditorGroup)(T)}e.isPreferredGroup=k}),define(pe[15],ve([0,1,17,22,99,292,59,25,13,2,41,83,178,117,64,126,88,216,7]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Ee){function _e(Y){const{selectionStartLineNumber:ke,selectionStartColumn:Ne,positionLineNumber:Xe,positionColumn:Qe}=Y,pt=new C.Position(ke-1,Ne-1),St=new C.Position(Xe-1,Qe-1);return new C.Selection(pt,St)}Ee.to=_e;function he(Y){const{anchor:ke,active:Ne}=Y;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}Ee.from=he})(a=e.Selection||(e.Selection={}));var s;(function(Ee){function _e(Y){if(!Y)return;const{start:ke,end:Ne}=Y;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}Ee.from=_e;function he(Y){if(!Y)return;const{startLineNumber:ke,startColumn:Ne,endLineNumber:Xe,endColumn:Qe}=Y;return new C.Range(ke-1,Ne-1,Xe-1,Qe-1)}Ee.to=he})(s=e.Range||(e.Range={}));var m;(function(Ee){function _e(he){switch(he){case 1:return C.StandardTokenType.Comment;case 0:return C.StandardTokenType.Other;case 3:return C.StandardTokenType.RegEx;case 2:return C.StandardTokenType.String}}Ee.to=_e})(m=e.TokenType||(e.TokenType={}));var o;(function(Ee){function _e(Y){return new C.Position(Y.lineNumber-1,Y.column-1)}Ee.to=_e;function he(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ee.from=he})(o=e.Position||(e.Position={}));var S;(function(Ee){function _e(ke,Ne){return(0,f.coalesce)((0,f.asArray)(ke).map(Xe=>he(Xe,Ne)))}Ee.from=_e;function he(ke,Ne){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:Y(ke.scheme,Ne),pattern:Se.from(ke.pattern)??void 0,exclusive:ke.exclusive}}function Y(ke,Ne){return Ne&&typeof ke=="string"?Ne.transformOutgoingScheme(ke):ke}})(S=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Ee){function _e(Y){switch(Y){case C.DiagnosticTag.Unnecessary:return 1;case C.DiagnosticTag.Deprecated:return 2}}Ee.from=_e;function he(Y){switch(Y){case 1:return C.DiagnosticTag.Unnecessary;case 2:return C.DiagnosticTag.Deprecated;default:return}}Ee.to=he})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(Ee){function _e(Y){let ke;return Y.code&&((0,_.isString)(Y.code)||(0,_.isNumber)(Y.code)?ke=String(Y.code):ke={value:String(Y.code.value),target:Y.code.target}),{...s.from(Y.range),message:Y.message,source:Y.source,code:ke,severity:u.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(n.from),tags:Array.isArray(Y.tags)?(0,f.coalesce)(Y.tags.map(r.from)):void 0}}Ee.from=_e;function he(Y){const ke=new C.Diagnostic(s.to(Y),Y.message,u.to(Y.severity));return ke.source=Y.source,ke.code=(0,_.isString)(Y.code)?Y.code:Y.code?.value,ke.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(n.to),ke.tags=Y.tags&&(0,f.coalesce)(Y.tags.map(r.to)),ke}Ee.to=he})(i=e.Diagnostic||(e.Diagnostic={}));var n;(function(Ee){function _e(Y){return{...s.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ee.from=_e;function he(Y){return new C.DiagnosticRelatedInformation(new C.Location(Y.resource,s.to(Y)),Y.message)}Ee.to=he})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(Ee){function _e(Y){switch(Y){case C.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case C.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case C.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case C.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}Ee.from=_e;function he(Y){switch(Y){case b.MarkerSeverity.Info:return C.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return C.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return C.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return C.DiagnosticSeverity.Hint;default:return C.DiagnosticSeverity.Error}}Ee.to=he})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(Ee){function _e(Y){return typeof Y=="number"&&Y>=C.ViewColumn.One?Y-1:Y===C.ViewColumn.Beside?L.SIDE_GROUP:L.ACTIVE_GROUP}Ee.from=_e;function he(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=he})(c=e.ViewColumn||(e.ViewColumn={}));function d(Ee){return typeof Ee.range!="undefined"}function h(Ee){return Ee.length===0?!0:!!d(Ee[0])}e.isDecorationOptionsArr=h;var v;(function(Ee){function _e(Qe){return Qe.map(Ee.from)}Ee.fromMany=_e;function he(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function Y(Qe){let pt;if(he(Qe)){const{language:wt,value:bt}=Qe;pt={value:"```"+wt+`
`+bt+"\n```\n"}}else C.MarkdownString.isMarkdownString(Qe)?pt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml}:typeof Qe=="string"?pt={value:Qe}:pt={value:""};const St=Object.create(null);pt.uris=St;const Ct=wt=>{try{let bt=P.URI.parse(wt,!0);bt=bt.with({query:ke(bt.query,St)}),St[wt]=bt}catch{}return""},ft=new D.Renderer;return ft.link=Ct,ft.image=wt=>Ct(k.parseHrefAndDimensions(wt).href),D(pt.value,{renderer:ft}),pt}Ee.from=Y;function ke(Qe,pt){if(!Qe)return Qe;let St;try{St=(0,T.parse)(Qe)}catch{}if(!St)return Qe;let Ct=!1;return St=(0,I.cloneAndChange)(St,ft=>{if(P.URI.isUri(ft)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[wt]=ft,Ct=!0,wt}else return}),Ct?JSON.stringify(St):Qe}function Ne(Qe){const pt=new C.MarkdownString(Qe.value,Qe.supportThemeIcons);return pt.isTrusted=Qe.isTrusted,pt.supportHtml=Qe.supportHtml,pt}Ee.to=Ne;function Xe(Qe){if(!!Qe)return typeof Qe=="string"?Qe:Ee.from(Qe)}Ee.fromStrict=Xe})(v=e.MarkdownString||(e.MarkdownString={}));function w(Ee){return h(Ee)?Ee.map(_e=>({range:s.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?v.fromMany(_e.hoverMessage):_e.hoverMessage?v.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):Ee.map(_e=>({range:s.from(_e)}))}e.fromRangeOrRangeWithMessage=w;function A(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?P.URI.file(Ee):Ee}e.pathOrURIToURI=A;var O;(function(Ee){function _e(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?A(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Ee.from=_e})(O=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Ee){function _e(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}Ee.from=_e})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(Ee){function _e(he){if(typeof he=="undefined")return he;switch(he){case C.DecorationRangeBehavior.OpenOpen:return 0;case C.DecorationRangeBehavior.ClosedClosed:return 1;case C.DecorationRangeBehavior.OpenClosed:return 2;case C.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=_e})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(Ee){function _e(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?F.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?N.from(he.light):void 0,dark:he.dark?N.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?A(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?O.from(he.before):void 0,after:he.after?O.from(he.after):void 0}}Ee.from=_e})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ee){function _e(Y){return{text:Y.newText,eol:Y.newEol&&gt.from(Y.newEol),range:s.from(Y.range)}}Ee.from=_e;function he(Y){const ke=new C.TextEdit(s.to(Y.range),Y.text);return ke.newEol=typeof Y.eol=="undefined"?void 0:gt.to(Y.eol),ke}Ee.to=he})(V=e.TextEdit||(e.TextEdit={}));var $;(function(Ee){function _e(Y,ke,Ne){const Xe={edits:[]};if(Y instanceof C.WorkspaceEdit)for(let Qe of Y._allEntries())if(Qe._type===1)Xe.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const pt=ke?.getDocument(Qe.uri);Xe.edits.push({_type:2,resource:Qe.uri,edit:V.from(Qe.edit),modelVersionId:pt?.version,metadata:Qe.metadata})}else Qe._type===3?Xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Ne?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version}):Qe._type===5&&Xe.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Ne?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(ut.from)}});return Xe}Ee.from=_e;function he(Y){const ke=new C.WorkspaceEdit;for(const Ne of Y.edits)Ne.edit?ke.replace(P.URI.revive(Ne.resource),s.to(Ne.edit.range),Ne.edit.text):ke.renameFile(P.URI.revive(Ne.oldUri),P.URI.revive(Ne.newUri),Ne.options);return ke}Ee.to=he})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(Ee){const _e=Object.create(null);_e[C.SymbolKind.File]=0,_e[C.SymbolKind.Module]=1,_e[C.SymbolKind.Namespace]=2,_e[C.SymbolKind.Package]=3,_e[C.SymbolKind.Class]=4,_e[C.SymbolKind.Method]=5,_e[C.SymbolKind.Property]=6,_e[C.SymbolKind.Field]=7,_e[C.SymbolKind.Constructor]=8,_e[C.SymbolKind.Enum]=9,_e[C.SymbolKind.Interface]=10,_e[C.SymbolKind.Function]=11,_e[C.SymbolKind.Variable]=12,_e[C.SymbolKind.Constant]=13,_e[C.SymbolKind.String]=14,_e[C.SymbolKind.Number]=15,_e[C.SymbolKind.Boolean]=16,_e[C.SymbolKind.Array]=17,_e[C.SymbolKind.Object]=18,_e[C.SymbolKind.Key]=19,_e[C.SymbolKind.Null]=20,_e[C.SymbolKind.EnumMember]=21,_e[C.SymbolKind.Struct]=22,_e[C.SymbolKind.Event]=23,_e[C.SymbolKind.Operator]=24,_e[C.SymbolKind.TypeParameter]=25;function he(ke){return typeof _e[ke]=="number"?_e[ke]:6}Ee.from=he;function Y(ke){for(const Ne in _e)if(_e[Ne]===ke)return Number(Ne);return C.SymbolKind.Property}Ee.to=Y})(U=e.SymbolKind||(e.SymbolKind={}));var B;(function(Ee){function _e(Y){switch(Y){case C.SymbolTag.Deprecated:return 1}}Ee.from=_e;function he(Y){switch(Y){case 1:return C.SymbolTag.Deprecated}}Ee.to=he})(B=e.SymbolTag||(e.SymbolTag={}));var W;(function(Ee){function _e(Y){return{name:Y.name,kind:U.from(Y.kind),tags:Y.tags&&Y.tags.map(B.from),containerName:Y.containerName,location:se.from(Y.location)}}Ee.from=_e;function he(Y){const ke=new C.SymbolInformation(Y.name,U.to(Y.kind),Y.containerName,se.to(Y.location));return ke.tags=Y.tags&&Y.tags.map(B.to),ke}Ee.to=he})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(Ee){function _e(Y){const ke={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),kind:U.from(Y.kind),tags:Y.tags?.map(B.from)??[]};return Y.children&&(ke.children=Y.children.map(_e)),ke}Ee.from=_e;function he(Y){const ke=new C.DocumentSymbol(Y.name,Y.detail,U.to(Y.kind),s.to(Y.range),s.to(Y.selectionRange));return(0,f.isNonEmptyArray)(Y.tags)&&(ke.tags=Y.tags.map(B.to)),Y.children&&(ke.children=Y.children.map(he)),ke}Ee.to=he})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var x;(function(Ee){function _e(Y){const ke=new C.CallHierarchyItem(U.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),s.to(Y.range),s.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}Ee.to=_e;function he(Y,ke,Ne){if(ke=ke??Y._sessionId,Ne=Ne??Y._itemId,ke===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ne,name:Y.name,detail:Y.detail,kind:U.from(Y.kind),uri:Y.uri,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ee.from=he})(x=e.CallHierarchyItem||(e.CallHierarchyItem={}));var J;(function(Ee){function _e(he){return new C.CallHierarchyIncomingCall(x.to(he.from),he.fromRanges.map(Y=>s.to(Y)))}Ee.to=_e})(J=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Ee){function _e(he){return new C.CallHierarchyOutgoingCall(x.to(he.to),he.fromRanges.map(Y=>s.to(Y)))}Ee.to=_e})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var se;(function(Ee){function _e(Y){return{range:Y.range&&s.from(Y.range),uri:Y.uri}}Ee.from=_e;function he(Y){return new C.Location(P.URI.revive(Y.uri),s.to(Y.range))}Ee.to=he})(se=e.location||(e.location={}));var K;(function(Ee){function _e(Y){const ke=Y,Ne=Y;return{originSelectionRange:ke.originSelectionRange?s.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ne.uri,range:s.from(ke.targetRange?ke.targetRange:Ne.range),targetSelectionRange:ke.targetSelectionRange?s.from(ke.targetSelectionRange):void 0}}Ee.from=_e;function he(Y){return{targetUri:P.URI.revive(Y.uri),targetRange:s.to(Y.range),targetSelectionRange:Y.targetSelectionRange?s.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?s.to(Y.originSelectionRange):void 0}}Ee.to=he})(K=e.DefinitionLink||(e.DefinitionLink={}));var Q;(function(Ee){function _e(Y){return{range:s.from(Y.range),contents:v.fromMany(Y.contents)}}Ee.from=_e;function he(Y){return new C.Hover(Y.contents.map(v.to),s.to(Y.range))}Ee.to=he})(Q=e.Hover||(e.Hover={}));var ae;(function(Ee){function _e(Y){return{range:s.from(Y.range),expression:Y.expression}}Ee.from=_e;function he(Y){return new C.EvaluatableExpression(s.to(Y.range),Y.expression)}Ee.to=he})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var fe;(function(Ee){function _e(Y){if(Y instanceof C.InlineValueText)return{type:"text",range:s.from(Y.range),text:Y.text};if(Y instanceof C.InlineValueVariableLookup)return{type:"variable",range:s.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof C.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=_e;function he(Y){switch(Y.type){case"text":return{range:s.to(Y.range),text:Y.text};case"variable":return{range:s.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:s.to(Y.range),expression:Y.expression}}}Ee.to=he})(fe=e.InlineValue||(e.InlineValue={}));var be;(function(Ee){function _e(Y){return{frameId:Y.frameId,stoppedLocation:s.from(Y.stoppedLocation)}}Ee.from=_e;function he(Y){return new C.InlineValueContext(Y.frameId,s.to(Y.stoppedLocation))}Ee.to=he})(be=e.InlineValueContext||(e.InlineValueContext={}));var Me;(function(Ee){function _e(Y){return{range:s.from(Y.range),kind:Y.kind}}Ee.from=_e;function he(Y){return new C.DocumentHighlight(s.to(Y.range),Y.kind)}Ee.to=he})(Me=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(Ee){function _e(he){switch(he){case 1:return C.CompletionTriggerKind.TriggerCharacter;case 2:return C.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return C.CompletionTriggerKind.Invoke}}Ee.to=_e})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(Ee){function _e(he){return{triggerKind:ze.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Ee.to=_e})(Ge=e.CompletionContext||(e.CompletionContext={}));var Je;(function(Ee){function _e(Y){switch(Y){case C.CompletionItemTag.Deprecated:return 1}}Ee.from=_e;function he(Y){switch(Y){case 1:return C.CompletionItemTag.Deprecated}}Ee.to=he})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(Ee){const _e=new Map([[C.CompletionItemKind.Method,0],[C.CompletionItemKind.Function,1],[C.CompletionItemKind.Constructor,2],[C.CompletionItemKind.Field,3],[C.CompletionItemKind.Variable,4],[C.CompletionItemKind.Class,5],[C.CompletionItemKind.Interface,7],[C.CompletionItemKind.Struct,6],[C.CompletionItemKind.Module,8],[C.CompletionItemKind.Property,9],[C.CompletionItemKind.Unit,12],[C.CompletionItemKind.Value,13],[C.CompletionItemKind.Constant,14],[C.CompletionItemKind.Enum,15],[C.CompletionItemKind.EnumMember,16],[C.CompletionItemKind.Keyword,17],[C.CompletionItemKind.Snippet,27],[C.CompletionItemKind.Text,18],[C.CompletionItemKind.Color,19],[C.CompletionItemKind.File,20],[C.CompletionItemKind.Reference,21],[C.CompletionItemKind.Folder,23],[C.CompletionItemKind.Event,10],[C.CompletionItemKind.Operator,11],[C.CompletionItemKind.TypeParameter,24],[C.CompletionItemKind.Issue,26],[C.CompletionItemKind.User,25]]);function he(Ne){return _e.get(Ne)??9}Ee.from=he;const Y=new Map([[0,C.CompletionItemKind.Method],[1,C.CompletionItemKind.Function],[2,C.CompletionItemKind.Constructor],[3,C.CompletionItemKind.Field],[4,C.CompletionItemKind.Variable],[5,C.CompletionItemKind.Class],[7,C.CompletionItemKind.Interface],[6,C.CompletionItemKind.Struct],[8,C.CompletionItemKind.Module],[9,C.CompletionItemKind.Property],[12,C.CompletionItemKind.Unit],[13,C.CompletionItemKind.Value],[14,C.CompletionItemKind.Constant],[15,C.CompletionItemKind.Enum],[16,C.CompletionItemKind.EnumMember],[17,C.CompletionItemKind.Keyword],[27,C.CompletionItemKind.Snippet],[18,C.CompletionItemKind.Text],[19,C.CompletionItemKind.Color],[20,C.CompletionItemKind.File],[21,C.CompletionItemKind.Reference],[23,C.CompletionItemKind.Folder],[10,C.CompletionItemKind.Event],[11,C.CompletionItemKind.Operator],[24,C.CompletionItemKind.TypeParameter],[25,C.CompletionItemKind.User],[26,C.CompletionItemKind.Issue]]);function ke(Ne){return Y.get(Ne)??C.CompletionItemKind.Property}Ee.to=ke})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(Ee){function _e(he,Y){const ke=new C.CompletionItem(he.label);return ke.insertText=he.insertText,ke.kind=q.to(he.kind),ke.tags=he.tags?.map(Je.to),ke.detail=he.detail,ke.documentation=k.isMarkdownString(he.documentation)?v.to(he.documentation):he.documentation,ke.sortText=he.sortText,ke.filterText=he.filterText,ke.preselect=he.preselect,ke.commitCharacters=he.commitCharacters,R.Range.isIRange(he.range)?ke.range=s.to(he.range):typeof he.range=="object"&&(ke.range={inserting:s.to(he.range.insert),replacing:s.to(he.range.replace)}),ke.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?ke.insertText=new C.SnippetString(he.insertText):(ke.insertText=he.insertText,ke.textEdit=ke.range instanceof C.Range?new C.TextEdit(ke.range,ke.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ke.additionalTextEdits=he.additionalTextEdits.map(Ne=>V.to(Ne))),ke.command=Y&&he.command?Y.fromInternal(he.command):void 0,ke}Ee.to=_e})(te=e.CompletionItem||(e.CompletionItem={}));var G;(function(Ee){function _e(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0}}Ee.from=_e;function he(Y){return{label:Y.label,documentation:k.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation}}Ee.to=he})(G=e.ParameterInformation||(e.ParameterInformation={}));var X;(function(Ee){function _e(Y){return{label:Y.label,documentation:Y.documentation?v.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.from):[],activeParameter:Y.activeParameter}}Ee.from=_e;function he(Y){return{label:Y.label,documentation:k.isMarkdownString(Y.documentation)?v.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(G.to):[],activeParameter:Y.activeParameter}}Ee.to=he})(X=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(Ee){function _e(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(X.from):[]}}Ee.from=_e;function he(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(X.to):[]}}Ee.to=he})(oe=e.SignatureHelp||(e.SignatureHelp={}));var me;(function(Ee){function _e(he,Y){const ke=new C.InlayHint(typeof Y.label=="string"?Y.label:Y.label.map(Ie.to.bind(void 0,he)),o.to(Y.position),xe.to(Y.kind));return ke.tooltip=k.isMarkdownString(Y.tooltip)?v.to(Y.tooltip):Y.tooltip,ke.whitespaceAfter=Y.whitespaceAfter,ke.whitespaceBefore=Y.whitespaceBefore,ke}Ee.to=_e})(me=e.InlayHint||(e.InlayHint={}));var Ie;(function(Ee){function _e(he,Y){const ke=new C.InlayHintLabelPart(Y.label);return ke.collapsible=Y.collapsible,y.Command.is(Y.action)?ke.action=he.fromInternal(Y.action):Y.action&&(ke.action=se.to(Y.action)),ke}Ee.to=_e})(Ie=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var xe;(function(Ee){function _e(Y){return Y}Ee.from=_e;function he(Y){return Y}Ee.to=he})(xe=e.InlayHintKind||(e.InlayHintKind={}));var Ye;(function(Ee){function _e(Y){return{range:s.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ee.from=_e;function he(Y){let ke;if(Y.url)try{ke=typeof Y.url=="string"?P.URI.parse(Y.url,!0):P.URI.revive(Y.url)}catch{}return new C.DocumentLink(s.to(Y.range),ke)}Ee.to=he})(Ye=e.DocumentLink||(e.DocumentLink={}));var it;(function(Ee){function _e(Y){const ke=new C.ColorPresentation(Y.label);return Y.textEdit&&(ke.textEdit=V.to(Y.textEdit)),Y.additionalTextEdits&&(ke.additionalTextEdits=Y.additionalTextEdits.map(Ne=>V.to(Ne))),ke}Ee.to=_e;function he(Y){return{label:Y.label,textEdit:Y.textEdit?V.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(ke=>V.from(ke)):void 0}}Ee.from=he})(it=e.ColorPresentation||(e.ColorPresentation={}));var st;(function(Ee){function _e(Y){return new C.Color(Y[0],Y[1],Y[2],Y[3])}Ee.to=_e;function he(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ee.from=he})(st=e.Color||(e.Color={}));var ot;(function(Ee){function _e(Y){return{range:s.from(Y.range)}}Ee.from=_e;function he(Y){return new C.SelectionRange(s.to(Y.range))}Ee.to=he})(ot=e.SelectionRange||(e.SelectionRange={}));var tt;(function(Ee){function _e(he){switch(he){case 2:return C.TextDocumentSaveReason.AfterDelay;case 1:return C.TextDocumentSaveReason.Manual;case 3:case 4:return C.TextDocumentSaveReason.FocusOut}}Ee.to=_e})(tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var rt;(function(Ee){function _e(Y){switch(Y){case C.TextEditorLineNumbersStyle.Off:return 0;case C.TextEditorLineNumbersStyle.Relative:return 2;case C.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=_e;function he(Y){switch(Y){case 0:return C.TextEditorLineNumbersStyle.Off;case 2:return C.TextEditorLineNumbersStyle.Relative;case 1:default:return C.TextEditorLineNumbersStyle.On}}Ee.to=he})(rt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var gt;(function(Ee){function _e(Y){if(Y===C.EndOfLine.CRLF)return 1;if(Y===C.EndOfLine.LF)return 0}Ee.from=_e;function he(Y){if(Y===1)return C.EndOfLine.CRLF;if(Y===0)return C.EndOfLine.LF}Ee.to=he})(gt=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(Ee){function _e(he){if(typeof he=="object")return he.viewId;switch(he){case C.ProgressLocation.SourceControl:return 3;case C.ProgressLocation.Window:return 10;case C.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=_e})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var It;(function(Ee){function _e(he){const Y={start:he.start+1,end:he.end+1};return he.kind&&(Y.kind=ee.from(he.kind)),Y}Ee.from=_e})(It=e.FoldingRange||(e.FoldingRange={}));var ee;(function(Ee){function _e(he){if(he)switch(he){case C.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case C.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case C.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}Ee.from=_e})(ee=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ie;(function(Ee){function _e(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?s.from(he.selection):void 0,override:typeof he.override=="boolean"?l.EditorResolution.DISABLED:void 0}}Ee.from=_e})(ie=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(Ee){function _e(Ne){return Ne instanceof C.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:he(Ne)||Y(Ne)?new C.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}Ee.from=_e;function he(Ne){const Xe=Ne;return Xe?P.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Y(Ne){const Xe=Ne;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function ke(Ne){return typeof Ne=="string"?Ne:new C.RelativePattern(P.URI.revive(Ne.baseUri),Ne.pattern)}Ee.to=ke})(Se=e.GlobPattern||(e.GlobPattern={}));var re;(function(Ee){function _e(he){if(he){if(Array.isArray(he))return he.map(_e);if(typeof he=="string")return he;{const Y=he;return{language:Y.language,scheme:Y.scheme,pattern:Se.from(Y.pattern),exclusive:Y.exclusive}}}else return}Ee.from=_e})(re=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(Ee){function _e(Y){return{start:Y.start,end:Y.end}}Ee.from=_e;function he(Y){return new C.NotebookRange(Y.start,Y.end)}Ee.to=he})(Ce=e.NotebookRange||(e.NotebookRange={}));var Fe;(function(Ee){function _e(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ee.to=_e;function he(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ee.from=he})(Fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(Ee){function _e(Y){switch(Y){case C.NotebookCellKind.Markup:return g.CellKind.Markup;case C.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=_e;function he(Y){switch(Y){case g.CellKind.Markup:return C.NotebookCellKind.Markup;case g.CellKind.Code:default:return C.NotebookCellKind.Code}}Ee.to=he})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(Ee){function _e(Y){const ke={metadata:Y.metadata??Object.create(null),cells:[]};for(let Ne of Y.cells)C.NotebookCellData.validate(Ne),ke.cells.push(ut.from(Ne));return ke}Ee.from=_e;function he(Y){const ke=new C.NotebookData(Y.cells.map(ut.to));return(0,_.isEmptyObject)(Y.metadata)||(ke.metadata=Y.metadata),ke}Ee.to=he})(Ve=e.NotebookData||(e.NotebookData={}));var ut;(function(Ee){function _e(Y){return{cellKind:qe.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:Fe.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Ae.from):[]}}Ee.from=_e;function he(Y){return new C.NotebookCellData(qe.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Ae.to):void 0,Y.metadata,Y.internalMetadata?Fe.to(Y.internalMetadata):void 0)}Ee.to=he})(ut=e.NotebookCellData||(e.NotebookCellData={}));var Re;(function(Ee){function _e(Y){return{mime:Y.mime,valueBytes:t.VSBuffer.wrap(Y.data)}}Ee.from=_e;function he(Y){return new C.NotebookCellOutputItem(Y.valueBytes.buffer,Y.mime)}Ee.to=he})(Re=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(Ee){function _e(Y){return{outputId:Y.id,items:Y.items.map(Re.from),metadata:Y.metadata}}Ee.from=_e;function he(Y){const ke=Y.items.map(Re.to);return new C.NotebookCellOutput(ke,Y.outputId,Y.metadata)}Ee.to=he})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(Ee){function _e(ke){return Y(ke)?{include:(0,_.withNullAsUndefined)(Se.from(ke.include)),exclude:(0,_.withNullAsUndefined)(Se.from(ke.exclude))}:(0,_.withNullAsUndefined)(Se.from(ke))}Ee.from=_e;function he(ke){return Y(ke)?{include:Se.to(ke.include),exclude:Se.to(ke.exclude)}:Se.to(ke)}Ee.to=he;function Y(ke){const Ne=ke;return Ne?!!Ne.include&&!!Ne.exclude:!1}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ce;(function(Ee){function _e(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?O.from(he.top):void 0}}Ee.from=_e})(ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var de;(function(Ee){function _e(he,Y,ke){const Ne=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===C.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Ne,ke),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Ee.from=_e})(de=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var we;(function(Ee){function _e(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}Ee.from=_e})(we=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ye;(function(Ee){function _e(Y){return{uri:Y.uri,provides:Y.provides}}Ee.from=_e;function he(Y){return new C.NotebookRendererScript(P.URI.revive(Y.uri),Y.provides)}Ee.to=he})(ye=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Oe;(function(Ee){function _e(Y){return{message:v.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,location:Y.location?se.from(Y.location):void 0}}Ee.from=_e;function he(Y){const ke=new C.TestMessage(typeof Y.message=="string"?Y.message:v.to(Y.message));return ke.actualOutput=Y.actual,ke.expectedOutput=Y.expected,ke.location=Y.location?se.to(Y.location):void 0,ke}Ee.to=he})(Oe=e.TestMessage||(e.TestMessage={}));var Ke;(function(Ee){let _e;(function(he){he.Delimiter="\0"})(_e||(_e={})),Ee.namespace=(he,Y)=>he+"\0"+Y,Ee.denamespace=he=>{const Y=he.indexOf("\0");return{ctrlId:he.slice(0,Y),tagId:he.slice(Y+1)}}})(Ke=e.TestTag||(e.TestTag={}));var We;(function(Ee){function _e(Ne){const Xe=(0,p.getPrivateApiFor)(Ne).controllerId;return{extId:E.TestId.fromExtHostTestItem(Ne,Xe).toString(),label:Ne.label,uri:Ne.uri,tags:Ne.tags.map(Qe=>Ke.namespace(Xe,Qe.id)),range:s.from(Ne.range)||null,description:Ne.description||null,error:Ne.error&&v.fromStrict(Ne.error)||null}}Ee.from=_e;function he(Ne){return{parent:void 0,error:void 0,id:E.TestId.fromString(Ne.extId).localId,label:Ne.label,uri:P.URI.revive(Ne.uri),tags:(Ne.tags||[]).map(Xe=>{const{tagId:Qe}=Ke.denamespace(Xe);return new C.TestTag(Qe)}),range:s.to(Ne.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ne.description||void 0}}Ee.toPlain=he;function Y(Ne){const Xe=E.TestId.fromString(Ne.extId),Qe=new p.TestItemImpl(Xe.controllerId,Xe.localId,Ne.label,P.URI.revive(Ne.uri));return Qe.range=s.to(Ne.range||void 0),Qe.description=Ne.description||void 0,Qe}function ke(Ne){let Xe;for(const Qe of Ne.tests){const pt=Y(Qe.item);(0,p.getPrivateApiFor)(pt).parent=Xe,Xe=pt}return Xe}Ee.toItemFromContext=ke})(We=e.TestItem||(e.TestItem={})),function(Ee){function _e(Y){return{id:Y.id}}Ee.from=_e;function he(Y){return new C.TestTag(Y.id)}Ee.to=he}(Ke=e.TestTag||(e.TestTag={}));var Ze;(function(Ee){const _e=(Y,ke)=>{const Ne={...We.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(Qe=>Qe.type===0).map(Oe.to)})),children:Y.children.map(Xe=>ke.get(Xe)).filter(_.isDefined).map(Xe=>_e(Xe,ke))};for(const Xe of Ne.children)Xe.parent=Ne;return Ne};function he(Y){const ke=[],Ne=new Map;for(const Xe of Y.items)Ne.set(Xe.item.extId,Xe),Y.request.targets.some(Qe=>Qe.controllerId===Xe.controllerId&&Qe.testIds.includes(Xe.item.extId))&&ke.push(Xe);return{completedAt:Y.completedAt,results:ke.map(Xe=>_e(Xe,Ne))}}Ee.to=he})(Ze=e.TestResults||(e.TestResults={}));var lt;(function(Ee){function _e(Ne){return{covered:Ne.covered,total:Ne.covered}}function he(Ne){return"line"in Ne?o.from(Ne):s.from(Ne)}function Y(Ne){return"branches"in Ne?{count:Ne.executionCount,location:he(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&he(Xe.location)})):void 0}:{type:0,count:Ne.executionCount,location:he(Ne.location)}}Ee.fromDetailed=Y;function ke(Ne){return{uri:Ne.uri,statement:_e(Ne.statementCoverage),branch:Ne.branchCoverage&&_e(Ne.branchCoverage),function:Ne.functionCoverage&&_e(Ne.functionCoverage),details:Ne.detailedCoverage?.map(Y)}}Ee.fromFile=ke})(lt=e.TestCoverage||(e.TestCoverage={}));var ct;(function(Ee){function _e(he){switch(he){case 1:return C.CodeActionTriggerKind.Invoke;case 2:return C.CodeActionTriggerKind.Automatic}}Ee.to=_e})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var $e;(function(Ee){function _e(Y){const ke=new C.TypeHierarchyItem(U.to(Y.kind),Y.name,Y.detail||"",P.URI.revive(Y.uri),s.to(Y.range),s.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}Ee.to=_e;function he(Y,ke,Ne){if(ke=ke??Y._sessionId,Ne=Ne??Y._itemId,ke===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ne,kind:U.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:s.from(Y.range),selectionRange:s.from(Y.selectionRange),tags:Y.tags?.map(B.from)}}Ee.from=he})($e=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[217],ve([0,1,2,16,7,15,93]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(P,R,y,l={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=y,this._thresholds=l,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,y,l)=>{const p={dispose:this._callbacks.push([R,y,P])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(P,R){const y=f.URI.revive(P);let l=!1;const b=setTimeout(()=>l=!0,this._thresholds.timeout),p=[];try{for(let g of[...this._callbacks]){if(l)break;const E=this._documents.getDocument(y),L=await this._deliverEventAsyncAndBlameBadListeners(g,{document:E,reason:D.TextDocumentSaveReason.to(R)});p.push(L)}}finally{clearTimeout(b)}return p}_deliverEventAsyncAndBlameBadListeners([P,R,y],l){const b=this._badListeners.get(P);return typeof b=="number"&&b>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,R,l).then(()=>!0,p=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this._badListeners.get(P);this._badListeners.set(P,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,y,l){const b=[],p=Date.now(),{document:g,reason:E}=l,{version:L}=g,C=Object.freeze({document:g,reason:E,waitUntil(a){if(Object.isFrozen(b))throw(0,t.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(a))}});try{R.apply(y,[C])}catch(a){return Promise.reject(a)}return Object.freeze(b),new Promise((a,s)=>{const m=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(b).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(m),a(o)}).catch(o=>{clearTimeout(m),s(o)})}).then(a=>{const s={edits:[]};for(const m of a)if(Array.isArray(m)&&m.every(o=>o instanceof k.TextEdit))for(const{newText:o,newEol:S,range:r}of m)s.edits.push({_type:2,resource:g.uri,edit:{range:r&&D.Range.from(r),text:o,eol:S&&D.EndOfLine.from(S)}});if(s.edits.length!==0)return L===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(pe[218],ve([0,1,10,25,2,15,126]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(y,l,b,p){this.start=y,this.deletedCount=l,this.deletedItems=b,this.items=p}static asApiEvents(y){return y.map(l=>({start:l.start,deletedCount:l.deletedCount,deletedItems:l.deletedItems,items:l.items.map(b=>b.apiCell)}))}}class _{constructor(y,l,b){this.notebook=y,this._extHostDocument=l,this._cellData=b,this.handle=b.handle,this.uri=k.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}static asModelAddData(y,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return y._mime},set mime(b){y._mime=b},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}})}return this._apiCell}setOutputs(y){this._outputs=y.map(D.NotebookCellOutput.to)}setOutputItems(y,l,b){const p=b.map(D.NotebookCellOutputItem.to),g=this._outputs.find(E=>E.id===y);g&&(l||(g.items.length=0),g.items.push(...p))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=_;class P{constructor(y,l,b,p,g,E){this._proxy=y,this._textDocumentsAndEditors=l,this._textDocuments=b,this._emitter=p,this.uri=g,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=E.viewType,this._metadata=Object.freeze(E.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,E.cells]],!0),this._versionId=E.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this;this._notebook={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===f.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(l){return l=y._validateIndex(l),y._cells[l].apiCell},getCells(l){return(l?y._getCells(l):y._cells).map(p=>p.apiCell)},save(){return y._save()}}}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,l){this._versionId=y.versionId,this._isDirty=l;for(const b of y.rawEvents)b.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(b.changes,!1):b.kind===T.NotebookCellsChangeType.Move?this._moveCell(b.index,b.newIdx):b.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(b.index,b.outputs):b.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(b.index,b.outputId,b.append,b.outputItems):b.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(b.index,b.language):b.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(b.index,b.mime):b.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(b.index,b.metadata):b.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(b.index,b.internalMetadata)}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let l=y.start|0,b=y.end|0;return l<0&&(l=0),b>this._cells.length&&(b=this._cells.length),y.with({start:l,end:b})}_getCells(y){y=this._validateRange(y);const l=[];for(let b=y.start;b<y.end;b++)l.push(this._cells[b]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,l){if(this._disposed)return;const b=[],p=[],g=[];y.reverse().forEach(E=>{const C=E[2].map(m=>{const o=new _(this,this._textDocumentsAndEditors,m);return l||p.push(_.asModelAddData(this.apiNotebook,m)),o}),a=new I(E[0],E[1],[],C),s=this._cells.splice(E[0],E[1],...C);for(const m of s)g.push(m.uri),a.deletedItems.push(m.apiCell);b.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:g}),l||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(b)}))}_moveCell(y,l){const b=this._cells.splice(y,1);this._cells.splice(l,0,...b);const p=[new I(y,1,b.map(g=>g.apiCell),[]),new I(l,0,[],b)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:I.asApiEvents(p)}))}_setCellOutputs(y,l){const b=this._cells[y];b.setOutputs(l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_setCellOutputItems(y,l,b,p){const g=this._cells[y];g.setOutputItems(l,b,p),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(y,l){const b=this._cells[y];b.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(b.uri,l)}_changeCellMime(y,l){const b=this._cells[y];b.apiCell.mime=l}_changeCellMetadata(y,l){const b=this._cells[y],p=b.apiCell.metadata;b.setMetadata(l);const g=b.apiCell.metadata;(0,t.equals)(p,g)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:b.apiCell}))}_changeCellInternalMetadata(y,l){this._cells[y].setInternalMetadata(l)}getCellFromApiCell(y){return this._cells.find(l=>l.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(l=>l.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(pe[129],ve([0,1,7,15,16]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:P})}replaceCells(_,P,R){this._throwIfFinalized(),!(_===P&&R.length===0)&&this._collectedEdits.push({editType:1,index:_,count:P-_,cells:R.map(t.NotebookCellData.from)})}}class T{constructor(_,P,R,y,l,b){this.id=_,this._proxy=P,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=y,this._viewColumn=b}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(P){if(!Array.isArray(P)||!P.every(f.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");_._selections=P,_._trySetSelections(P)},get visibleRanges(){return _._visibleRanges},revealRange(P,R){_._proxy.$tryRevealRange(_.id,t.NotebookRange.from(P),R??f.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(P){const R=new D(this.document.version);return P(R),_._applyEdit(R.finalize())},setDecorations(P,R){return _.setDecorations(P,R)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(t.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const P=[];let R=-1;for(let y=0;y<_.cellEdits.length;y++){if(R<0){P.push(_.cellEdits[y]),R++;continue}const b=P[R],p=_.cellEdits[y];if(b.editType===1&&p.editType===1&&b.index===p.index){b.cells.push(..._.cellEdits[y].cells),b.count+=_.cellEdits[y].count;continue}P.push(_.cellEdits[y]),R++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,P)}setDecorations(_,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return P.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(P),_.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(pe[219],ve([0,1,15,118,165,21,56,16]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,b,p){const g=this._handles++,{title:E,location:L,cancellable:C}=b,a={label:(0,k.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(g,{location:f.ProgressLocation.from(L),title:E,source:a,cancellable:C},l.isUnderDevelopment?void 0:l.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(g,p,!!C)}_withProgress(l,b,p){let g;p&&(g=new D.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,g));const E=C=>{this._proxy.$progressEnd(C),this._mapHandleToCancellationSource.delete(C),g&&g.dispose()};let L;try{L=b(new R(this._proxy,l),p&&g?g.token:D.CancellationToken.None)}catch(C){throw E(l),C}return L.then(C=>E(l),C=>E(l)),L}$acceptProgressCanceled(l){const b=this._mapHandleToCancellationSource.get(l);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=_;function P(y,l){return y.message=l.message,typeof l.increment=="number"&&(typeof y.increment=="number"?y.increment+=l.increment:y.increment=l.increment),y}class R extends t.Progress{constructor(l,b){super(p=>this.throttledReport(p));this._proxy=l,this._handle=b}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}je([(0,T.throttle)(100,(y,l)=>P(y,l),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(pe[130],ve([0,1,55,16,77,15,7]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(l,b,p){const g=I._Keys.nextId();l.$registerTextEditorDecorationType(b.identifier,g,D.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){l.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=I,I._Keys=new k.IdGenerator("TextEditorDecorationType");class _{constructor(l,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,b){this._throwIfFinalized();let p=null;if(l instanceof T.Position)p=new T.Range(l,l);else if(l instanceof T.Range)p=l;else throw new Error("Unrecognized location");this._pushEdit(p,b,!1)}insert(l,b){this._throwIfFinalized(),this._pushEdit(new T.Range(l,l),b,!0)}delete(l){this._throwIfFinalized();let b=null;if(l instanceof T.Range)b=l;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(l,b,p){const g=this._document.validateRange(l);this._collectedEdits.push({range:g,text:b,forceMoveMarkers:p})}setEndOfLine(l){if(this._throwIfFinalized(),l!==T.EndOfLine.LF&&l!==T.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class P{constructor(l,b,p,g){this._proxy=l,this._id=b,this._accept(p),this._logService=g;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(L){E._setTabSize(L)},get insertSpaces(){return E._insertSpaces},set insertSpaces(L){E._setInsertSpaces(L)},get cursorStyle(){return E._cursorStyle},set cursorStyle(L){E._setCursorStyle(L)},get lineNumbers(){return E._lineNumbers},set lineNumbers(L){E._setLineNumbers(L)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=D.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(l){const b=this._validateTabSize(l);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const b=this._validateInsertSpaces(l);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:D.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let p=!1;if(typeof l.tabSize!="undefined"){const g=this._validateTabSize(l.tabSize);g==="auto"?(p=!0,b.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,p=!0,b.tabSize=g)}if(typeof l.insertSpaces!="undefined"){const g=this._validateInsertSpaces(l.insertSpaces);g==="auto"?(p=!0,b.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,p=!0,b.insertSpaces=g)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,p=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,p=!0,b.lineNumbers=D.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(l,b){b.catch(p=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(p)})}}e.ExtHostTextEditorOptions=P;class R{constructor(l,b,p,g,E,L,C,a){this.id=l,this._proxy=b,this._logService=p,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new P(this._proxy,this.id,L,p),this._visibleRanges=C,this._viewColumn=a;const s=this;this.value=Object.freeze({get document(){return g.getValue()},set document(m){throw(0,t.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(m){if(!(m instanceof T.Selection))throw(0,t.illegalArgument)("selection");s._selections=[m],s._trySetSelection()},get selections(){return s._selections},set selections(m){if(!Array.isArray(m)||m.some(o=>!(o instanceof T.Selection)))throw(0,t.illegalArgument)("selections");s._selections=m,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(m){throw(0,t.readonly)("visibleRanges")},get options(){return s._options.value},set options(m){s._disposed||s._options.assign(m)},get viewColumn(){return s._viewColumn},set viewColumn(m){throw(0,t.readonly)("viewColumn")},edit(m,o={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new _(g.getValue(),o);return m(S),s._applyEdit(S)},insertSnippet(m,o,S={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=s._selections.map(i=>D.Range.from(i));else if(o instanceof T.Position){const{lineNumber:i,column:n}=D.Position.from(o);r=[{startLineNumber:i,startColumn:n,endLineNumber:i,endColumn:n}]}else if(o instanceof T.Range)r=[D.Range.from(o)];else{r=[];for(const i of o)if(i instanceof T.Range)r.push(D.Range.from(i));else{const{lineNumber:n,column:u}=D.Position.from(i);r.push({startLineNumber:n,startColumn:u,endLineNumber:n,endColumn:u})}}return b.$tryInsertSnippet(l,m.value,r,S)},setDecorations(m,o){const S=o.length===0;S&&!s._hasDecorationsForKey.has(m.key)||(S?s._hasDecorationsForKey.delete(m.key):s._hasDecorationsForKey.add(m.key),s._runOnProxy(()=>{if(D.isDecorationOptionsArr(o))return b.$trySetDecorations(l,m.key,D.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let i=0,n=o.length;i<n;i++){const u=o[i];r[4*i]=u.start.line+1,r[4*i+1]=u.start.character+1,r[4*i+2]=u.end.line+1,r[4*i+3]=u.end.character+1}return b.$trySetDecorationsFast(l,m.key,r)}}))},revealRange(m,o){s._runOnProxy(()=>b.$tryRevealRange(l,D.Range.from(m),o||T.TextEditorRevealType.Default))},show(m){b.$tryShowEditor(l,D.ViewColumn.from(m))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,f.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,f.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,f.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,f.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(D.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(E=>E.range);p.sort((E,L)=>E.end.line===L.end.line?E.end.character===L.end.character?E.start.line===L.start.line?E.start.character-L.start.character:E.start.line-L.start.line:E.end.character-L.end.character:E.end.line-L.end.line);for(let E=0,L=p.length-1;E<L;E++){const C=p[E].end;if(p[E+1].start.isBefore(C))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(E=>({range:D.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?D.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=R}),define(pe[220],ve([0,1,18,3,6,13,64,15,127,88]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends k.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const b of this.tree.values())this.updateExpandability(b)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const b=this.diff[this.diff.length-1];if(b&&l[0]===1){if(b[0]===1&&b[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(b[1],l[1]);return}if(b[0]===0&&b[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(b[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,b){const p=this.tree.get(l);if(!!p){if((p.expandLevels===void 0||b>p.expandLevels)&&(p.expandLevels=b),p.expand===1){const g=this.resolveChildren(p);return g.isOpen()?this.expandChildren(p,b-1):g.wait().then(()=>this.expandChildren(p,b-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.expandChildren(p,b-1)):this.expandChildren(p,b-1)}}dispose(){for(const l of this.tree.values())(0,T.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,b){switch(b.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(l.fullId,b.id));break;case 0:this.upsertItem(b.item,l);break;case 4:for(const p of b.ops)this.onTestItemEvent(l,p);break;case 3:{const{key:p,value:g,previous:E}=b,L=l.fullId.toString();switch(p){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(g,E,L);break;case"range":this.pushDiff([1,{extId:L,item:{range:I.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:L,item:{error:I.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:L,item:{[p]:g??null}}]);break}break}default:(0,D.assertNever)(b)}}upsertItem(l,b){if(!(l instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const p=P.TestId.fromExtHostTestItem(l,this.root.id,b?.actual),g=(0,T.getPrivateApiFor)(l);g.parent&&g.parent!==b?.actual&&g.parent.children.delete(l.id);let E=this.tree.get(p.toString());if(!E){E={fullId:p,actual:l,parent:b?p.parentId:null,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(E.fullId.toString(),E),this.setItemParent(l,b),this.pushDiff([0,{parent:E.parent&&E.parent.toString(),controllerId:this.controllerId,expand:E.expand,item:I.TestItem.from(l)}]),this.connectItemAndChildren(l,E,b);return}if(E.actual===l){this.connectItem(l,E,b);return}const L=E.actual.children,C=E.actual,a=(0,T.diffTestItems)(C,l);(0,T.getPrivateApiFor)(C).listener=void 0,E.actual=l,E.expand=0;for(const[s,m]of a)this.onTestItemEvent(E,{op:3,key:s,value:m,previous:C[s]});this.connectItemAndChildren(l,E,b);for(const s of L)l.children.get(s.id)||this.removeItem(P.TestId.joinToString(p,s.id))}diffTagRefs(l,b,p){const g=new Set(b.map(E=>E.id));for(const E of l)g.delete(E.id)||this.incrementTagRefs(E);this.pushDiff([1,{extId:p,item:{tags:l.map(E=>I.TestTag.namespace(this.controllerId,E.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const b=this.tags.get(l.id);b?b.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const b=this.tags.get(l);b&&!--b.refCount&&(this.tags.delete(l),this.pushDiff([6,I.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,b){(0,T.getPrivateApiFor)(l).parent=b&&b.actual!==this.root?b.actual:void 0}connectItem(l,b,p){this.setItemParent(l,p);const g=(0,T.getPrivateApiFor)(l);g.parent=p?.actual,g.listener=E=>this.onTestItemEvent(b,E),this.updateExpandability(b)}connectItemAndChildren(l,b,p){this.connectItem(l,b,p);for(const g of l.children)this.upsertItem(g,b)}updateExpandability(l){let b;this._resolveHandler?l.resolveBarrier?b=l.resolveBarrier.isOpen()?3:2:b=l.actual.canResolveChildren?1:0:b=0,b!==l.expand&&(l.expand=b,this.pushDiff([1,{extId:l.fullId.toString(),expand:b}]),b===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,b){if(b<0)return;const p=[];for(const g of l.actual.children){const E=this.expand(P.TestId.joinToString(l.fullId,g.id),b);(0,f.isThenable)(E)&&p.push(E)}if(p.length)return Promise.all(p).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const E=new f.Barrier;return E.open(),E}l.expand=2,this.pushExpandStateUpdate(l);const b=l.resolveBarrier=new f.Barrier,p=E=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=E.stack||E.message||String(E))};let g;try{g=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(E){p(E)}return(0,f.isThenable)(g)?g.catch(p).then(()=>{b.open(),this.updateExpandability(l)}):(b.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const b=this.tree.get(l);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const p=[b];for(;p.length;){const g=p.pop();if(!!g){(0,T.getPrivateApiFor)(g.actual).listener=void 0;for(const E of g.actual.tags)this.decrementTagRefs(E.id);this.tree.delete(g.fullId.toString());for(const E of g.actual.children)p.push(this.tree.get(P.TestId.joinToString(g.fullId,E.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=R}),define(pe[221],ve([0,1,4,183]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(t.IEnvironmentService)}),define(pe[222],ve([0,1,27,3,9]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class D{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=D;class T{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let y of R.activationEvents)y==="onUri"&&(y=`onUri:${f.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(R)}}keepOnly(R){const y=new Set;R.forEach(l=>y.add(f.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>y.has(f.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,y){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const l=T._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(l.map(b=>b.identifier)),y.length>0){const b=new Set;y.forEach(p=>b.add(f.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>!b.has(f.ExtensionIdentifier.toKey(p.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new D(l)}static _findLoopingExtensions(R){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,L){this.addNode(E),this.addNode(L),this._arcs.has(E)?this._arcs.get(E).push(L):this._arcs.set(E,[L])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,L){const C=y.getArcs(E);for(let a=0;a<C.length;a++)if(!L.has(C[a]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let E of R){const L=f.ExtensionIdentifier.toKey(E.identifier);if(l.set(L,E),E.extensionDependencies)for(let C of E.extensionDependencies){const a=f.ExtensionIdentifier.toKey(C);y.addArc(L,a)}}let b=new Set;y.getNodes().filter(E=>y.getArcs(E).length===0).forEach(E=>b.add(E));let p=y.getNodes().filter(E=>!b.has(E)),g;do{g=!1;for(let E=0;E<p.length;E++){const L=p[E];y.hasOnlyGoodArcs(L,b)&&(p.splice(E,1),E--,b.add(L),g=!0)}}while(g);return p.map(E=>l.get(E))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const y=this._activationMap.get(R);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const y=this._extensionsMap.get(f.ExtensionIdentifier.toKey(R));return y||void 0}}e.ExtensionDescriptionRegistry=T;var I;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(I||(I={}));function _(P,R){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(y!==l)return y-l;const b=k.posix.basename(P.extensionLocation.path),p=k.posix.basename(R.extensionLocation.path);return b<p?-1:b>p?1:0}}),define(pe[223],ve([0,1,22]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function D(I){const _=f.VSBuffer.alloc(1);switch(I){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=D;function T(I,_){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=T}),define(pe[28],ve([0,1,3,2,4,27,194]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new D.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var I;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class P{constructor(m){this.dependency=m}}e.MissingExtensionDependency=P;var R;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;function l(s,m){return s.enabledApiProposals?s.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=l;function b(s,m){if(!l(s,m))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=b;class p{constructor(m,o,S,r){this.codeLoadingTime=m,this.activateCallTime=o,this.activateResolvedTime=S,this.activationReason=r}}e.ActivationTimes=p;class g{constructor(m,o){this.description=m,this.value=o}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var E;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(E=e.ActivationKind||(e.ActivationKind={}));function L(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=L;function C(s,m){return{identifier:new D.ExtensionIdentifier((0,T.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!m,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=C;class a{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(m){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,o){return Promise.resolve()}_onWillActivateExtension(m){}_onDidActivateExtension(m,o,S,r,i){}_onDidActivateExtensionError(m,o){}_onExtensionRuntimeError(m,o){}_onExtensionHostExit(m){}}e.NullExtensionService=a}),define(pe[224],ve([0,1,16,27,28,11]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class I{constructor(g,E,L,C){this.startup=g,this.codeLoadingTime=E,this.activateCallTime=L,this.activateResolvedTime=C}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class _{constructor(g){this._startup=g,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(g,E){return g===-1||E===-1?-1:E-g}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class P{constructor(g,E,L,C,a,s){this.activationFailed=g,this.activationFailedError=E,this.activationTimes=L,this.module=C,this.exports=a,this.subscriptions=s}}e.ActivatedExtension=P;class R extends P{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class y extends P{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class l extends P{constructor(g){super(!0,g,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=l;let b=class{constructor(g,E,L,C,a){this._logService=a,this._isDisposed=!1,this._registry=g,this._resolvedExtensionsSet=new Set,E.forEach(s=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,L.forEach(s=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(s),s)),this._host=C,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(g){const E=t.ExtensionIdentifier.toKey(g);return this._activatedExtensions.has(E)}getActivatedExtension(g){const E=t.ExtensionIdentifier.toKey(g),L=this._activatedExtensions.get(E);if(!L)throw new Error("Extension `"+g.value+"` is not known or not activated");return L}activateByEvent(g,E){if(this._alreadyActivatedEvents[g])return T;const L=this._registry.getExtensionDescriptionsForActivationEvent(g);return this._activateExtensions(L.map(C=>({id:C.identifier,reason:{startup:E,extensionId:C.identifier,activationEvent:g}}))).then(()=>{this._alreadyActivatedEvents[g]=!0})}activateById(g,E){const L=this._registry.getExtensionDescription(g);if(!L)throw new Error("Extension `"+g+"` is not known");return this._activateExtensions([{id:L.identifier,reason:E}])}_handleActivateRequest(g,E,L){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(g.id))){E[t.ExtensionIdentifier.toKey(g.id)]=g;return}const C=this._registry.getExtensionDescription(g.id);if(!C){const m=new Error(`Cannot activate unknown extension '${g.id.value}'`);this._host.onExtensionActivationError(g.id,m,new k.MissingExtensionDependency(g.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(g.id),new l(m));return}const a=typeof C.extensionDependencies=="undefined"?[]:C.extensionDependencies;let s=!0;for(let m=0,o=a.length;m<o;m++){const S=a[m];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(S)))continue;const r=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(S));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const c=C.displayName||C.identifier.value,d=this._registry.getExtensionDescription(S),h=d&&d.displayName||S,v=new Error(`Cannot activate the '${c}' extension because its dependency '${h}' failed to activate`);v.detail=r.activationFailedError,this._host.onExtensionActivationError(C.identifier,v,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(C.identifier),new l(v));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(S))){s=!1,E[t.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(S)),reason:g.reason};continue}const i=this._registry.getExtensionDescription(S);if(i){if(!i.main&&!i.browser)continue;s=!1,E[t.ExtensionIdentifier.toKey(S)]={id:i.identifier,reason:g.reason};continue}const n=C.displayName||C.identifier.value,u=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(C.identifier,u,new k.MissingExtensionDependency(S)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(C.identifier),new l(u));return}s?E[t.ExtensionIdentifier.toKey(C.identifier)]=g:L.push(g)}_activateExtensions(g){if(g.length===0||(g=g.filter(a=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(a.id))),g.length===0))return Promise.resolve(void 0);const E=Object.create(null),L=[];for(let a=0,s=g.length;a<s;a++)this._handleActivateRequest(g[a],E,L);for(let a=0,s=L.length;a<s;a++){const m=t.ExtensionIdentifier.toKey(L[a].id);E[m]&&delete E[m]}const C=Object.keys(E).map(a=>E[a]);return L.length===0?Promise.all(C.map(a=>this._activateExtension(a.id,a.reason))).then(a=>{}):this._activateExtensions(C).then(a=>this._activateExtensions(L))}_activateExtension(g,E){const L=t.ExtensionIdentifier.toKey(g);if(this._activatedExtensions.has(L))return Promise.resolve(void 0);const C=this._activatingExtensions.get(L);if(C)return C;const a=this._host.actualActivateExtension(g,E).then(void 0,s=>{const m=new Error;return s&&s.name&&(m.name=s.name),s&&s.message?m.message=`Activating extension '${g.value}' failed: ${s.message}.`:m.message=`Activating extension '${g.value}' failed: ${s}.`,s&&s.stack&&(m.stack=s.stack),this._isDisposed&&f.isCancellationError(s)?new l(s):(this._host.onExtensionActivationError(g,m,null),this._logService.error(`Activating extension ${g.value} failed due to an error:`),this._logService.error(s),new l(s))}).then(s=>{this._activatedExtensions.set(L,s),this._activatingExtensions.delete(L)});return this._activatingExtensions.set(L,a),a}};b=je([He(4,D.ILogService)],b),e.ExtensionsActivator=b}),define(pe[225],ve([0,1,11,26,28]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends f.LogService{constructor(I,_){super(I.createLogger(_.logFile,{name:k.ExtensionHostLogFileName}))}};D=je([He(0,f.ILoggerService),He(1,t.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(pe[226],ve([0,1,16]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,T)=>{this._actualOk=D,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,f.onUnexpectedError)(D))}then(D,T){return this._ensureActual().then(D,T)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=t}),define(pe[52],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(P,R){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=R,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const t=[];function k(_){const P=new f(!0,_);return t[P.nid]=P,P}e.createMainContextProxyIdentifier=k;function D(_){const P=new f(!1,_);return t[P.nid]=P,P}e.createExtHostContextProxyIdentifier=D;function T(_){return t[_].sid}e.getStringIdentifierForProxy=T;class I{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=I}),define(pe[5],ve([0,1,59,2,52]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(a){a.name="$ident";function s(o,S){return Object.defineProperty(o,a.name,{value:S,enumerable:!0}),o}a.mixin=s;function m(o){return o[a.name]}a.of=m})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(s){return s._id=b._n++,s}}e.IdObject=b,b._n=0;var p;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(p=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function L(a){if(a&&a.edits)for(const s of a.edits)typeof s.resource=="object"?s.resource=t.URI.revive(s.resource):(s.newUri=t.URI.revive(s.newUri),s.oldUri=t.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=(0,f.revive)(s.metadata));return a}e.reviveWorkspaceEditDto=L;var C;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,k.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(pe[89],ve([0,1,5,3,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class D{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,_){return this._proxy.$getPassword(I,_)}store(I,_,P){return this._proxy.$setPassword(I,_,P)}delete(I,_){return this._proxy.$deletePassword(I,_)}}e.ExtHostSecretState=D,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(pe[66],ve([0,1,4,11,5,14]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(_,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(k.MainContext.MainThreadTelemetry)}report(_,P,R){const y=this.getUsageKey(_,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:_}))}getUsageKey(_,P){return`${_}-${P.identifier.value}`}};T=je([He(0,D.IExtHostRpcService),He(1,t.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(I,_,P){}})}),define(pe[227],ve([0,1,3,5,7,27]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,P,R,y={}){const l=D.ExtensionIdentifier.toKey(_.identifier),b=this._inFlightRequests.get(l)||[],p=[...R].sort().join(" ");let g=b.find(E=>E.scopes===p);if(g)return g.result;{const E=this._getSession(_,l,P,R,y);g={scopes:p,result:E},b.push(g),this._inFlightRequests.set(l,b);try{await E}finally{const L=b.findIndex(C=>C.scopes===p);L>-1&&(b.splice(L),this._inFlightRequests.set(l,b))}return E}}async _getSession(_,P,R,y,l={}){await this._proxy.$ensureProvider(R);const b=_.displayName||_.name;return this._proxy.$getSession(R,y,P,b,l)}async removeSession(_,P){const R=this._authenticationProviders.get(_);return R?R.provider.removeSession(P):this._proxy.$removeSession(_,P)}registerAuthenticationProvider(_,P,R,y){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:P,provider:R,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(b=>b.id===_)||this._providers.push({id:_,label:P});const l=R.onDidChangeSessions(b=>{this._proxy.$sendDidChangeSessions(_,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,P,y?.supportsMultipleAccounts??!1),new k.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const b=this._providers.findIndex(p=>p.id===_);b>-1&&this._providers.splice(b),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,P){const R=this._authenticationProviders.get(_);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,P){const R=this._authenticationProviders.get(_);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,P){const R=this._authenticationProviders.get(_);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,P){return this._onDidChangeSessions.fire({provider:{id:_,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(pe[228],ve([0,1,5,14,15]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(I,_){this._extHostDocumentsAndEditors=_,this._proxy=I.getProxy(f.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const _=k.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};D=je([He(0,t.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(pe[229],ve([0,1,5]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(D){const T=D.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(I){return T.$writeText(I)}})}}e.ExtHostClipboard=t});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[38],ve([0,1,13,7,15,25,5,17,11,59,41,48,2,6,4,14,64,22,52,49]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(u,c){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,nt(this,s,u.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new o(this,d=>{const h=this._apiCommands.get(d);return h?.result===r.Void?h:void 0},c),this._argumentProcessors=[{processArgument(d){return(0,P.revive)(d)}},{processArgument(d){return(0,D.cloneAndChange)(d,function(h){if(R.Range.isIRange(h))return k.Range.to(h);if(y.Position.isIPosition(h))return k.Position.to(h);if(R.Range.isIRange(h.range)&&l.URI.isUri(h.uri))return k.location.to(h);if(h instanceof L.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const c=this.registerCommand(!1,u.id,async(...d)=>{const h=u.args.map((w,A)=>{if(!w.validate(d[A]))throw new Error(`Invalid argument '${w.name}' when running '${u.id}', received: ${d[A]}`);return w.convert(d[A])}),v=await this.executeCommand(u.internalId,...h);return u.result.convert(v,d,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,c,d,h,v,w){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:d,thisArg:h,description:v,extension:w}),u&&Le(this,s,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&u&&Le(this,s,"f").$unregisterCommand(c)})}executeCommand(u,...c){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,c,!0)}async _doExecuteCommand(u,c,d){if(this._commands.has(u))return this._executeContributedCommand(u,c,!1);{let h=!1;const v=(0,D.cloneAndChange)(c,function(w){if(w instanceof t.Position)return k.Position.from(w);if(w instanceof t.Range)return k.Range.from(w);if(w instanceof t.Location)return k.location.from(w);if(t.NotebookRange.isNotebookRange(w))return k.NotebookRange.from(w);if(w instanceof ArrayBuffer)return h=!0,L.VSBuffer.wrap(new Uint8Array(w));if(w instanceof Uint8Array)return h=!0,L.VSBuffer.wrap(w);if(!Array.isArray(w))return w});try{const w=await Le(this,s,"f").$executeCommand(u,h?new C.SerializableObjectWithBuffers(v):v,d);return(0,P.revive)(w)}catch(w){if(w instanceof Error&&w.message==="$executeCommand:retry")return this._doExecuteCommand(u,c,!1);throw w}}}async _executeContributedCommand(u,c,d){const h=this._commands.get(u);if(!h)throw new Error("Unknown command");let{callback:v,thisArg:w,description:A}=h;if(A)for(let O=0;O<A.args.length;O++)try{(0,f.validateConstraint)(c[O],A.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${A.args[O].name}' - ${A.args[O].description}`)}try{return await v.apply(w,c)}catch(O){if(u===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...c);N&&(u=N.command)}throw this._logService.error(O,u,h.extension?.identifier),d?new class extends Error{constructor(){super((0,a.toErrorMessage)(O));this.id=u,this.source=h.extension?.displayName??h.extension?.name}}:O}}$executeContributedCommand(u,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(c=c.map(d=>this._argumentProcessors.reduce((h,v)=>v.processArgument(h),d)),this._executeContributedCommand(u,c,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),Le(this,s,"f").$getCommands().then(c=>(u&&(c=c.filter(d=>d[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[c,d]of this._commands){let{description:h}=d;h&&(u[c]=h)}return Promise.resolve(u)}};s=new WeakMap,m=je([He(0,g.IExtHostRpcService),He(1,_.ILogService)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class o{constructor(u,c,d){this._commands=u,this._lookupApiCommand=c,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,c){if(!u)return;const d={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return d;const h=this._lookupApiCommand(u.command);if(h)d.id=h.internalId,d.arguments=h.args.map((v,w)=>v.convert(u.arguments&&u.arguments[w]));else if((0,I.isNonEmptyArray)(u.arguments)){const v=++this._cachIdPool;this._cache.set(v,u),c.add((0,b.toDisposable)(()=>{this._cache.delete(v),this._logService.trace("CommandsConverter#DISPOSE",v)})),d.$ident=v,d.id=this.delegatingCommandId,d.arguments=[v],this._logService.trace("CommandsConverter#CREATE",u.command,v)}return d}fromInternal(u){const c=T.ObjectIdentifier.of(u);return typeof c=="number"?this._cache.get(c):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const c=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class S{constructor(u,c,d,h){this.name=u,this.description=c,this.validate=d,this.convert=h}optional(){return new S(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,c){return new S(u??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",n=>l.URI.isUri(n),n=>n),S.Position=new S("position","A position in a text document",n=>t.Position.isPosition(n),k.Position.from),S.Range=new S("range","A range in a text document",n=>t.Range.isRange(n),k.Range.from),S.Selection=new S("selection","A selection in a text document",n=>t.Selection.isSelection(n),k.Selection.from),S.Number=new S("number","",n=>typeof n=="number",n=>n),S.String=new S("string","",n=>typeof n=="string",n=>n),S.CallHierarchyItem=new S("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",n=>n instanceof E.TestItemImpl,k.TestItem.from);class r{constructor(u,c){this.description=u,this.convert=c}}e.ApiCommandResult=r,r.Void=new r("no result",n=>n);class i{constructor(u,c,d,h,v){this.id=u,this.internalId=c,this.description=d,this.args=h,this.result=v}}e.ApiCommand=i}),define(pe[230],ve([0,1,15,7,83,38,17,111]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(f.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,b)=>{if((0,T.isFalsyOrEmpty)(l))return;class p extends t.SymbolInformation{static to(E){const L=new p(E.name,f.SymbolKind.to(E.kind),E.containerName||"",new t.Location(b[0],f.Range.to(E.range)));return L.detail=E.detail,L.range=L.location.range,L.selectionRange=f.Range.to(E.selectionRange),L.children=E.children?E.children.map(p.to):[],L}}return l.map(p.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new D.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(f.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(f.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(f.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(b=>t.Position.isPosition(b)),l=>l.map(f.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(b=>{let p;for(const g of b.reverse())p=new t.SelectionRange(f.Range.to(g),p);return p}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(f.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(f.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:f.Range.to(l.range),placeholder:l.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return f.WorkspaceEdit.to(l)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(f.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,I.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new t.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const b=(0,I.decodeSemanticTokensDto)(l);if(b.type==="full")return new t.SemanticTokens(b.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,b,p)=>{if(!l)return new t.CompletionList([]);const g=l.suggestions.map(E=>f.CompletionItem.to(E,p));return new t.CompletionList(g,l.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return f.SignatureHelp.to(l)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,b,p)=>R(g=>new t.CodeLens(f.Range.to(g.range),g.command&&p.fromInternal(g.command)))(l))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>t.Range.isRange(l),l=>t.Selection.isSelection(l)?f.Selection.from(l):f.Range.from(l)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,b,p)=>R(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(g.command)}else{const E=new t.CodeAction(g.title,g.kind?new t.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=f.WorkspaceEdit.to(g.edit)),g.command&&(E.command=p.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(l))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(b=>new t.ColorInformation(f.Range.to(b.range),f.Color.to(b.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",l=>l instanceof t.Color,f.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:f.Range.from(l.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(f.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(l,b,p)=>l.map(f.InlayHint.to.bind(void 0,p)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(b=>f.NotebookExclusiveDocumentPattern.to(b))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(f.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[f.ViewColumn.from(l),void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[f.ViewColumn.from(l),void 0]:[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[f.ViewColumn.from(l.viewColumn),f.TextEditorOpenOptions.from(l)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(f.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void)];class P{static register(b){_.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=P;function R(l){return b=>{if(Array.isArray(b))return b.map(l)}}function y(l){if(!Array.isArray(l))return;const b=[];for(const p of l)k.isLocationLink(p)?b.push(f.DefinitionLink.to(p)):b.push(f.location.to(p));return b}}),define(pe[231],ve([0,1,18,56,3,6,2,83,27,15,7,28,5]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(p,g,E){const L=p.getProxy(l.MainContext.MainThreadComments);class C{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const u=this._commentControllers.get(n.handle);return u||n}else if(n&&n.$mid===7){const u=this._commentControllers.get(n.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.commentThreadHandle);return c||n}else if(n&&n.$mid===8){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.thread.commentThreadHandle);return c?{thread:c,text:n.text}:n}else if(n&&n.$mid===9){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.thread.commentThreadHandle);if(!c)return n;let d=n.commentUniqueId,h=c.getCommentByUniqueId(d);return h||n}else if(n&&n.$mid===10){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const c=u.getCommentThread(n.thread.commentThreadHandle);if(!c)return n;let d=n.text,h=n.commentUniqueId,v=c.getCommentByUniqueId(h);return v?(v.body=d,v):n}return n}})}createCommentController(n,u,c){const d=C.handlePool++,h=new s(n,d,u,c);this._commentControllers.set(h.handle,h);const v=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(n.identifier))||[];return v.push(h),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(n.identifier),v),h.value}$createCommentThreadTemplate(n,u,c){const d=this._commentControllers.get(n);!d||d.$createCommentThreadTemplate(u,c)}async $updateCommentThreadTemplate(n,u,c){const d=this._commentControllers.get(n);!d||d.$updateCommentThreadTemplate(u,c)}$deleteCommentThread(n,u){const c=this._commentControllers.get(n);c&&c.$deleteCommentThread(u)}$provideCommentingRanges(n,u,c){const d=this._commentControllers.get(n);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const h=E.getDocument(T.URI.revive(u));return(0,f.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(h,c)).then(v=>v?v.map(w=>P.Range.from(w)):void 0)}$toggleReaction(n,u,c,d,h){const v=this._commentControllers.get(n);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const w=v.getCommentThread(u);if(w){const A=w.getCommentByUniqueId(d.uniqueIdInThread);if(v!==void 0&&A&&v.reactionHandler)return v.reactionHandler(A,S(h))}return Promise.resolve(void 0)})}dispose(){}}C.handlePool=0;class a{constructor(n,u,c,d,h,v,w){this._commentControllerHandle=u,this._id=c,this._uri=d,this._range=h,this._comments=v,this.extensionDescription=w,this.handle=a._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputDisposables.value=new D.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),L.$createCommentThread(u,this.handle,this._id,this._uri,P.Range.from(this._range),w.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this._localDisposables.push({dispose:()=>{L.$deleteCommentThread(u,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(O){A.range=O},get comments(){return A.comments},set comments(O){A.comments=O},get collapsibleState(){return A.collapsibleState},set collapsibleState(O){A.collapsibleState=O},get canReply(){return A.canReply},set canReply(O){A.canReply=O},get contextValue(){return A.contextValue},set contextValue(O){A.contextValue=O},get label(){return A.label},set label(O){A.label=O},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new D.DisposableStore);const n=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),u={};n("range")&&(u.range=P.Range.from(this._range)),n("label")&&(u.label=this.label),n("contextValue")&&(u.contextValue=this.contextValue??null),n("comments")&&(u.comments=this._comments.map(c=>m(this,c,this._commentsMap))),n("collapsibleState")&&(u.collapseState=r(this._collapseState)),n("canReply")&&(u.canReply=this.canReply),this.modifications={},L.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(n){for(let u of this._commentsMap){let c=u[0],d=u[1];if(n===d)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}a._handlePool=0,je([(0,t.debounce)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(n,u,c,d){this._extension=n,this._handle=u,this._id=c,this._label=d,this._threads=new Map,L.$registerCommentController(this.handle,c,d);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(v){h.options=v},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(v){h.commentingRangeProvider=v},get reactionHandler(){return h.reactionHandler},set reactionHandler(v){h.reactionHandler=v},createCommentThread(v,w,A){return h.createCommentThread(v,w,A).value},dispose:()=>{h.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{L.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,L.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,L.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,L.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,u,c,d){if(typeof n=="string"){const h=new a(this.id,this.handle,n,u,c,d,this._extension);return this._threads.set(h.handle,h),h}else{const h=new a(this.id,this.handle,void 0,n,u,c,this._extension);return this._threads.set(h.handle,h),h}}$createCommentThreadTemplate(n,u){const c=new a(this.id,this.handle,void 0,T.URI.revive(n),P.Range.to(u),[],this._extension);return c.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(n,u){let c=this._threads.get(n);c&&(c.range=P.Range.to(u))}$deleteCommentThread(n){let u=this._threads.get(n);u&&u.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function m(i,n,u){let c=u.get(n);c||(c=++i.commentHandle,u.set(n,c));const d=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;n.detail&&(0,y.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let h;return n.detail&&typeof n.detail!="string"?h={source:n.detail,$mid:14}:h=n.detail,{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:c,body:P.MarkdownString.from(n.body),userName:n.author.name,userIconPath:d,label:n.label,commentReactions:n.reactions?n.reactions.map(v=>o(v)):void 0,detail:h}}function o(i){return{label:i.label,iconPath:i.iconPath?P.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function S(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?T.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function r(i){if(i!==void 0)switch(i){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new C}e.createExtHostComments=b}),define(pe[131],ve([0,1,2,5,7,4,14,11,17,8,9]),function(Z,e,f,t,k,D,T,I,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Ci{constructor(b,p){this._logService=p,this._provider=new Map,this._proxy=b.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(b,p){const g=Ci._handlePool++;this._provider.set(g,{provider:b,extensionId:p}),this._proxy.$registerDecorationProvider(g,p.value);const E=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(L=>{if(!L){this._proxy.$onDidChange(g,null);return}let C=(0,_.asArray)(L);if(C.length<=Ci._maxEventSize){this._proxy.$onDidChange(g,C);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",p.value,C.length);const a=C.map(o=>({uri:o,rank:(0,P.count)(o.path,"/")})),s=(0,_.groupBy)(a,(o,S)=>o.rank-S.rank||(0,P.compare)(o.uri.path,S.uri.path));let m=[];e:for(let o of s){let S;for(let r of o){let i=(0,R.dirname)(r.uri.path);if(S!==i&&(S=i,m.push(r.uri)>=Ci._maxEventSize))break e}}this._proxy.$onDidChange(g,m)});return new k.Disposable(()=>{E?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(b,p,g){if(!this._provider.has(b))return Object.create(null);const E=Object.create(null),{provider:L,extensionId:C}=this._provider.get(b);return await Promise.all(p.map(async a=>{try{const{uri:s,id:m}=a,o=await Promise.resolve(L.provideFileDecoration(f.URI.revive(s),g));if(!o)return;try{k.FileDecoration.validate(o),E[m]=[o.propagate,o.tooltip,o.badge,o.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${C.value}': ${S}`)}}catch(s){this._logService.error(s)}})),E}};y._handlePool=0,y._maxEventSize=250,y=je([He(0,T.IExtHostRpcService),He(1,I.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,D.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[232],ve([0,1,163,117,2,5,7,15,3,11,24,44]),function(Z,e,f,t,k,D,T,I,_,P,R,y){"use strict";var l,b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(C,a,s,m,o,S){this._name=C,this._owner=a,this._maxDiagnosticsPerFile=s,l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),this._isDisposed=!1,nt(this,p,new R.ResourceMap(r=>m.getComparisonKey(r)),"f"),nt(this,l,o,"f"),nt(this,b,S,"f")}dispose(){this._isDisposed||(Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner),Le(this,p,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(C,a){if(!C){this.clear();return}this._checkDisposed();let s=[];if(k.URI.isUri(C)){if(!a){this.delete(C);return}Le(this,p,"f").set(C,a.slice()),s=[C]}else if(Array.isArray(C)){s=[];let o;C=[...C].sort(g._compareIndexedTuplesByUri);for(const S of C){const[r,i]=S;if((!o||r.toString()!==o.toString())&&(o&&Le(this,p,"f").get(o).length===0&&Le(this,p,"f").delete(o),o=r,s.push(r),Le(this,p,"f").set(r,[])),i){const n=Le(this,p,"f").get(r);n&&n.push(...i)}else{const n=Le(this,p,"f").get(r);n&&(n.length=0)}}}if(Le(this,b,"f").fire(s),!Le(this,l,"f"))return;const m=[];for(let o of s){let S=[];const r=Le(this,p,"f").get(o);if(r)if(r.length>this._maxDiagnosticsPerFile){S=[];const i=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let u of r)if(u.severity===i[n]&&S.push(I.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,f.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=r.map(i=>I.Diagnostic.from(i));m.push([o,S])}Le(this,l,"f").$changeMany(this._owner,m)}delete(C){this._checkDisposed(),Le(this,b,"f").fire([C]),Le(this,p,"f").delete(C),Le(this,l,"f")&&Le(this,l,"f").$changeMany(this._owner,[[C,void 0]])}clear(){this._checkDisposed(),Le(this,b,"f").fire([...Le(this,p,"f").keys()]),Le(this,p,"f").clear(),Le(this,l,"f")&&Le(this,l,"f").$clear(this._owner)}forEach(C,a){this._checkDisposed();for(let s of Le(this,p,"f").keys())C.apply(a,[s,this.get(s),this])}get(C){this._checkDisposed();const a=Le(this,p,"f").get(C);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(C){return this._checkDisposed(),Array.isArray(Le(this,p,"f").get(C))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(C,a){return C[0].toString()<a[0].toString()?-1:C[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=g,l=new WeakMap,b=new WeakMap,p=new WeakMap;let E=class oi{constructor(C,a,s){this._logService=a,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=C.getProxy(D.MainContext.MainThreadDiagnostics)}static _mapper(C){const a=new R.ResourceMap;for(const s of C)a.set(s,s);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(C,a){const{_collections:s,_proxy:m,_onDidChangeDiagnostics:o,_logService:S,_fileSystemInfoService:r}=this,i=new class{$changeMany(c,d){m.$changeMany(c,d),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",C.value,c,d.length===0?"CLEARING":d)}$clear(c){m.$clear(c),S.trace("[DiagnosticCollection] remove all (extension, owner)",C.value,c)}dispose(){m.dispose()}};let n;if(!a)a="_generated_diagnostic_collection_name_#"+oi._idPool++,n=a;else if(!s.has(a))n=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do n=a+oi._idPool++;while(s.has(n))}return new class extends g{constructor(){super(a,n,oi._maxDiagnosticsPerFile,r.extUri,i,o);s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(C){if(C)return this._getDiagnostics(C);{const a=new Map,s=[];for(const m of this._collections.values())m.forEach((o,S)=>{let r=a.get(o.toString());typeof r=="undefined"&&(r=s.length,a.set(o.toString(),r),s.push([o,[]])),s[r][1]=s[r][1].concat(...S)});return s}}_getDiagnostics(C){let a=[];for(let s of this._collections.values())s.has(C)&&(a=a.concat(s.get(C)));return a}$acceptMarkersChange(C){if(!this._mirrorCollection){const a="_generated_mirror",s=new g(a,a,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,s),this._mirrorCollection=s}for(const[a,s]of C)this._mirrorCollection.set(k.URI.revive(a),s.map(I.Diagnostic.to))}};E._idPool=0,E._maxDiagnosticsPerFile=1e3,E=je([He(1,P.ILogService),He(2,y.IExtHostFileSystemInfo)],E),e.ExtHostDiagnostics=E}),define(pe[233],ve([0,1,2,5]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(I=>I?I.map(_=>f.URI.revive(_)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(I=>I?f.URI.revive(I):void 0)}}e.ExtHostDialogs=k}),define(pe[234],ve([0,1,16,2,7,5,10,21,8]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,l,b){this._documentsAndEditors=l,this._logService=b,this._documentContentProviders=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,l){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const b=P._handlePool++;this._documentContentProviders.set(b,l),this._proxy.$registerTextContentProvider(b,y);let p;return typeof l.onDidChange=="function"&&(p=l.onDidChange(g=>{if(g.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(E=>{if(!E&&typeof E!="string")return;const L=this._documentsAndEditors.getDocument(g);if(!L)return;const C=(0,_.splitLines)(E);if(!L.equalLines(C))return this._proxy.$onVirtualDocumentChange(g,E)},f.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(y,l){const b=this._documentContentProviders.get(y);return b?Promise.resolve(b.provideTextDocumentContent(t.URI.revive(l),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(pe[235],ve([0,1,3,6,2,5,123,15,13,25,7]),function(Z,e,f,t,k,D,T,I,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(b,p){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(D.MainContext.MainThreadDocuments),this._documentsAndEditors=p,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const E of g)this._onDidRemoveDocument.fire(E.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const E of g)this._onDidAddDocument.fire(E.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const p=this._documentsAndEditors.getDocument(b);if(p)return p}getDocument(b){const p=this.getDocumentData(b);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return p.document}ensureDocumentData(b){const p=this._documentsAndEditors.getDocument(b);if(p)return Promise.resolve(p);let g=this._documentLoader.get(b.toString());return g||(g=this._proxy.$tryOpenDocument(b).then(E=>{this._documentLoader.delete(b.toString());const L=k.URI.revive(E);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(L))},E=>(this._documentLoader.delete(b.toString()),Promise.reject(E))),this._documentLoader.set(b.toString(),g)),g}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(p=>k.URI.revive(p))}$acceptModelLanguageChanged(b,p){const g=k.URI.revive(b),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");this._onDidRemoveDocument.fire(E.document),E._acceptLanguageId(p),this._onDidAddDocument.fire(E.document)}$acceptModelSaved(b){const p=k.URI.revive(b),g=this._documentsAndEditors.getDocument(p);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(b,p){const g=k.URI.revive(b),E=this._documentsAndEditors.getDocument(g);if(!E)throw new Error("unknown document");E._acceptIsDirty(p),this._onDidChangeDocument.fire({document:E.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,p,g){const E=k.URI.revive(b),L=this._documentsAndEditors.getDocument(E);if(!L)throw new Error("unknown document");L._acceptIsDirty(g),L.onEvents(p);let C;p.isUndoing?C=R.TextDocumentChangeReason.Undo:p.isRedoing&&(C=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:L.document,contentChanges:p.changes.map(a=>({range:I.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:C}))}setWordDefinitionFor(b,p){(0,T.setWordDefinitionFor)(b,p)}}e.ExtHostDocuments=y}),define(pe[45],ve([0,1,55,3,6,2,4,5,123,14,130,15,11,24,10,78,92]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class L{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let C=class{constructor(s,m){this._extHostRpc=s,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const m=[],o=[],S=[];if(s.removedDocuments)for(const r of s.removedDocuments){const i=D.URI.revive(r),n=this._documents.get(i);n?.unref()&&(this._documents.delete(i),m.push(n.value))}if(s.addedDocuments)for(const r of s.addedDocuments){const i=D.URI.revive(r.uri);let n=this._documents.get(i);if(n&&i.scheme!==p.Schemas.vscodeNotebookCell&&i.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);n||(n=new L(new _.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,n),o.push(n.value)),n.ref()}if(s.removedEditors)for(const r of s.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&S.push(i)}if(s.addedEditors)for(const r of s.addedEditors){const i=D.URI.revive(r.documentUri);f.ok(this._documents.has(i),`document '${i}' does not exist`),f.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const n=this._documents.get(i).value,u=new R.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>n.document),r.selections.map(y.Selection.to),r.options,r.visibleRanges.map(c=>y.Range.to(c)),typeof r.editorPosition=="number"?y.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,u)}s.newActiveEditor!==void 0&&(f.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,k.dispose)(m),(0,k.dispose)(S),s.removedDocuments&&this._onDidRemoveDocuments.fire(m),s.addedDocuments&&this._onDidAddDocuments.fire(o),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return s?m:m?.value}allEditors(){return[...this._editors.values()]}};C=je([He(0,P.IExtHostRpcService),He(1,l.ILogService)],C),e.ExtHostDocumentsAndEditors=C,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[53],ve([0,1,15,5,2,3,4,14,18]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");let P=class{constructor(y){this._onDidChangeTabs=new D.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new D.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let l=-1;this._tabs=y.map((p,g)=>(p.isActive&&(l=g),Object.freeze({label:p.label,viewColumn:f.ViewColumn.to(p.viewColumn),index:g,resource:k.URI.revive(p.resource),additionalResourcesAndViewIds:p.additionalResourcesAndViewIds.map(({resource:E,viewId:L})=>({resource:k.URI.revive(E),viewId:L})),viewId:p.editorId,isActive:p.isActive,move:async(E,L)=>{this._proxy.$moveTab(p,E,f.ViewColumn.from(L)),await(0,_.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(p),await(0,_.raceTimeout)(D.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((p,g)=>p.viewColumn===g.viewColumn?p.index-g.index:p.viewColumn-g.viewColumn);const b=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==b&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=je([He(0,I.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(pe[236],ve([0,1,2,5,6,7,15,147,8,22,28]),function(Z,e,f,t,k,D,T,I,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const g=this._schemes.indexOf(p);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),g=[];let E,L,C=14,a=14;for(const s of p){let m=E?(0,_.commonPrefixLength)(E,s):0;for(m===0?L=1:L=a;m<s.length;m++)m+1===s.length?(C=a,a=9):a+=1,g.push([L,s.toUpperCase().charCodeAt(m),a]),g.push([L,s.toLowerCase().charCodeAt(m),a]),L=a;E=s,a=C}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new I.StateMachine(g)}}provideDocumentLinks(p){this._initStateMachine();const g=[],E=I.LinkComputer.computeLinks({getLineContent(L){return p.lineAt(L-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const L of E){const C=T.DocumentLink.to(L);C.target&&g.push(C)}return g}}class l{constructor(p,g){this._extHostLanguageFeatures=g,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(p,g,E,L={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(p,"*",this._linkProvider));const C=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(C,E);let a=2;L.isCaseSensitive&&(a+=1024),L.isReadonly&&(a+=2048),typeof E.copy=="function"&&(a+=8),typeof E.open=="function"&&typeof E.close=="function"&&typeof E.read=="function"&&typeof E.write=="function"&&((0,R.checkProposedApiEnabled)(p,"fsChunks"),a+=4),this._proxy.$registerFileSystemProvider(C,g,a).catch(m=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${g}`),console.error(m)});const s=E.onDidChangeFile(m=>{const o=[];for(const S of m){let{uri:r,type:i}=S;if(r.scheme!==g)continue;let n;switch(i){case D.FileChangeType.Changed:n=0;break;case D.FileChangeType.Created:n=1;break;case D.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:n})}this._proxy.$onFileSystemChange(C,o)});return(0,k.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(C),this._proxy.$unregisterProvider(C)})}static _asIStat(p){const{type:g,ctime:E,mtime:L,size:C,permissions:a}=p;return{type:g,ctime:E,mtime:L,size:C,permissions:a}}$stat(p,g){return Promise.resolve(this._getFsProvider(p).stat(f.URI.revive(g))).then(E=>l._asIStat(E))}$readdir(p,g){return Promise.resolve(this._getFsProvider(p).readDirectory(f.URI.revive(g)))}$readFile(p,g){return Promise.resolve(this._getFsProvider(p).readFile(f.URI.revive(g))).then(E=>P.VSBuffer.wrap(E))}$writeFile(p,g,E,L){return Promise.resolve(this._getFsProvider(p).writeFile(f.URI.revive(g),E.buffer,L))}$delete(p,g,E){return Promise.resolve(this._getFsProvider(p).delete(f.URI.revive(g),E))}$rename(p,g,E,L){return Promise.resolve(this._getFsProvider(p).rename(f.URI.revive(g),f.URI.revive(E),L))}$copy(p,g,E,L){const C=this._getFsProvider(p);if(!C.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(C.copy(f.URI.revive(g),f.URI.revive(E),L))}$mkdir(p,g){return Promise.resolve(this._getFsProvider(p).createDirectory(f.URI.revive(g)))}$watch(p,g,E,L){const C=this._getFsProvider(p).watch(f.URI.revive(E),L);this._watches.set(g,C)}$unwatch(p,g){const E=this._watches.get(g);E&&(E.dispose(),this._watches.delete(g))}$open(p,g,E){const L=this._getFsProvider(p);if(!L.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(L.open(f.URI.revive(g),E))}$close(p,g){const E=this._getFsProvider(p);if(!E.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(E.close(g))}$read(p,g,E,L){const C=this._getFsProvider(p);if(!C.read)throw new Error('FileSystemProvider does not implement "read"');const a=P.VSBuffer.alloc(L);return Promise.resolve(C.read(g,E,a.buffer,0,L)).then(s=>a.slice(0,s))}$write(p,g,E,L){const C=this._getFsProvider(p);if(!C.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(C.write(g,E,L.buffer,0,L.byteLength))}_getFsProvider(p){const g=this._fsProvider.get(p);if(!g){const E=new Error;throw E.name="ENOPRO",E.message="no provider",E}return g}}e.ExtHostFileSystem=l}),define(pe[67],ve([0,1,5,42,7,22,4,14,44,6]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class zt{constructor(l,b){this._fileSystemProvider=new Map,this._proxy=l.getProxy(f.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(g){try{const E=p._fileSystemProvider.get(g.scheme);if(!E)return await p._proxy.$stat(g);await p._proxy.$ensureActivation(g.scheme);const L=await E.stat(g);return{type:L.type,ctime:L.ctime,mtime:L.mtime,size:L.size,permissions:L.permissions}}catch(E){zt._handleError(E)}},async readDirectory(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readDirectory(g)).slice()):await p._proxy.$readdir(g)}catch(E){return zt._handleError(E)}},async createDirectory(g){try{return await p._proxy.$mkdir(g)}catch(E){return zt._handleError(E)}},async readFile(g){try{const E=p._fileSystemProvider.get(g.scheme);return E?(await p._proxy.$ensureActivation(g.scheme),(await E.readFile(g)).slice()):(await p._proxy.$readFile(g)).buffer}catch(E){return zt._handleError(E)}},async writeFile(g,E){try{return await p._proxy.$writeFile(g,D.VSBuffer.wrap(E))}catch(L){return zt._handleError(L)}},async delete(g,E){try{const L=p._fileSystemProvider.get(g.scheme);return L?(await p._proxy.$ensureActivation(g.scheme),await L.delete(g,{recursive:!1,...E})):await p._proxy.$delete(g,{recursive:!1,useTrash:!1,...E})}catch(L){return zt._handleError(L)}},async rename(g,E,L){try{return await p._proxy.$rename(g,E,{overwrite:!1,...L})}catch(C){return zt._handleError(C)}},async copy(g,E,L){try{return await p._proxy.$copy(g,E,{overwrite:!1,...L})}catch(C){return zt._handleError(C)}},isWritableFileSystem(g){const E=b.getCapabilities(g);if(typeof E=="number")return!(E&2048)}})}static _handleError(l){if(l instanceof k.FileSystemError)throw l;if(!(l instanceof Error))throw new k.FileSystemError(String(l));if(l.name==="ENOPRO")throw k.FileSystemError.Unavailable(l.message);switch(l.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(l.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(l.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(l.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(l.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(l.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(l.message);default:throw new k.FileSystemError(l.message,l.name)}}addFileSystemProvider(l,b){return this._fileSystemProvider.set(l,b),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(l))}};R=je([He(0,I.IExtHostRpcService),He(1,_.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[237],ve([0,1,3,32,2,5,15,7]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(y,l,b,p,g,E,L,C){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter;const a=this.ensureWatching(y,b,g);this._config=0,E&&(this._config+=1),L&&(this._config+=2),C&&(this._config+=4);const s=(0,t.parse)(g),m=typeof g=="string",o=p(S=>{if(!E)for(let r of S.created){const i=k.URI.revive(r);s(i.fsPath)&&(!m||l.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!L)for(let r of S.changed){const i=k.URI.revive(r);s(i.fsPath)&&(!m||l.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!C)for(let r of S.deleted){const i=k.URI.revive(r);s(i.fsPath)&&(!m||l.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=I.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(y,l,b){let p=I.Disposable.from();if(typeof b=="string")return p;const g=y.getProxy(D.MainContext.MainThreadFileSystem);let E=!1;(b.pattern.includes(t.GLOBSTAR)||b.pattern.includes(t.GLOB_SPLIT))&&(E=!0);const L=Math.random();return g.$watch(l.identifier.value,L,b.baseUri,{recursive:E,excludes:[]}),I.Disposable.from({dispose:()=>g.$unwatch(L)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(y,l,b){this._mainContext=y,this._logService=l,this._extHostDocumentsAndEditors=b,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,l,b,p,g,E){return new _(this._mainContext,y,l,this._onFileSystemEvent.event,T.GlobPattern.from(b),p,g,E)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,l){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(b=>({oldUri:k.URI.revive(b.source),newUri:k.URI.revive(b.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(b=>k.URI.revive(b.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(b=>k.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,l){return(b,p,g)=>{const E=function(C){b.call(p,C)};return E.extension=y,l.event(E,void 0,g)}}async $onWillRunFileOperation(y,l,b,p){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(g=>({oldUri:k.URI.revive(g.source),newUri:k.URI.revive(g.target)}))},b,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(g=>k.URI.revive(g.target))},b,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(g=>k.URI.revive(g.target))},b,p)}}async _fireWillEvent(y,l,b,p){const g=new Set,E=[];if(await y.fireAsync(l,p,async(C,a)=>{const s=Date.now(),m=await Promise.resolve(C);m instanceof I.WorkspaceEdit&&(E.push(m),g.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-s>b&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),p.isCancellationRequested||E.length===0)return;const L={edits:[]};for(let C of E){let{edits:a}=T.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);L.edits=L.edits.concat(a)}return{edit:L,extensionNames:Array.from(g)}}}e.ExtHostFileSystemEventService=P}),define(pe[238],ve([0,1,2,38]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,I,_,P){this._extHostNotebooks=I,this._textDocumentsAndEditors=_,this._commands=P;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new t.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new t.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new t.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new t.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:f.URI.revive(y.notebookUri),inputUri:f.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(T,I,_,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:_,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(pe[239],ve([0,1,6,5]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,T),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=k}),define(pe[240],ve([0,1,2,25,15,7,5,8,41,17,13,145,21,6,111,77,86,46,16,3,18]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentSymbols(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentSymbols(G,te);if(!(0,P.isFalsyOrEmpty)(X))return X[0]instanceof D.DocumentSymbol?X.map(k.DocumentSymbol.from):m._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((X,oe)=>{let me=X.location.range.start.compareTo(oe.location.range.start);return me===0&&(me=oe.location.range.end.compareTo(X.location.range.end)),me});const te=[],G=[];for(const X of q){const oe={name:X.name||"!!MISSING: name!!",kind:k.SymbolKind.from(X.kind),tags:X.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:k.Range.from(X.location.range),selectionRange:k.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(oe),te.push(oe);break}const me=G[G.length-1];if(_.Range.containsRange(me.range,oe.range)&&!_.Range.equalsRange(me.range,oe.range)){me.children&&me.children.push(oe),G.push(oe);break}G.pop()}}return te}}class o{constructor(q,te,G){this._documents=q,this._commands=te,this._provider=G,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideCodeLenses(G,te);if(!X||te.isCancellationRequested)return;const oe=this._cache.add(X),me=new b.DisposableStore;this._disposables.set(oe,me);const Ie={cacheId:oe,lenses:[]};for(let xe=0;xe<X.length;xe++)Ie.lenses.push({cacheId:[oe,xe],range:k.Range.from(X[xe].range),command:this._commands.toInternal(X[xe].command,me)});return Ie}async resolveCodeLens(q,te){const G=q.cacheId&&this._cache.get(...q.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,te),X||(X=G),te.isCancellationRequested)return;const oe=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!oe)return q.command=this._commands.toInternal(X.command??o._badCmd,oe),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Je){return Array.isArray(Je)?Je.map(k.DefinitionLink.from):Je?[k.DefinitionLink.from(Je)]:[]}class r{constructor(q,te){this._documents=q,this._provider=te}async provideDefinition(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideDefinition(X,oe,G);return S(me)}}class i{constructor(q,te){this._documents=q,this._provider=te}async provideDeclaration(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideDeclaration(X,oe,G);return S(me)}}class n{constructor(q,te){this._documents=q,this._provider=te}async provideImplementation(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideImplementation(X,oe,G);return S(me)}}class u{constructor(q,te){this._documents=q,this._provider=te}async provideTypeDefinition(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideTypeDefinition(X,oe,G);return S(me)}}class c{constructor(q,te){this._documents=q,this._provider=te}async provideHover(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideHover(X,oe,G);if(!(!me||(0,P.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=X.getWordRangeAtPosition(oe)),me.range||(me.range=new D.Range(oe,oe)),k.Hover.from(me)}}class d{constructor(q,te){this._documents=q,this._provider=te}async provideEvaluatableExpression(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideEvaluatableExpression(X,oe,G);if(me)return k.EvaluatableExpression.from(me)}}class h{constructor(q,te){this._documents=q,this._provider=te}async provideInlineValues(q,te,G,X){const oe=this._documents.getDocument(q),me=await this._provider.provideInlineValues(oe,k.Range.to(te),k.InlineValueContext.to(G),X);if(Array.isArray(me))return me.map(Ie=>k.InlineValue.from(Ie))}}class v{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentHighlights(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideDocumentHighlights(X,oe,G);if(Array.isArray(me))return me.map(k.DocumentHighlight.from)}}class w{constructor(q,te){this._documents=q,this._provider=te}async provideLinkedEditingRanges(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.provideLinkedEditingRanges(X,oe,G);if(me&&Array.isArray(me.ranges))return{ranges:(0,P.coalesce)(me.ranges.map(k.Range.from)),wordPattern:me.wordPattern}}}class A{constructor(q,te){this._documents=q,this._provider=te}async provideReferences(q,te,G,X){const oe=this._documents.getDocument(q),me=k.Position.to(te),Ie=await this._provider.provideReferences(oe,me,G,X);if(Array.isArray(Ie))return Ie.map(k.location.from)}}class O{constructor(q,te,G,X,oe,me,Ie){this._documents=q,this._commands=te,this._diagnostics=G,this._provider=X,this._logService=oe,this._extension=me,this._apiDeprecation=Ie,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,te,G,X){const oe=this._documents.getDocument(q),me=y.Selection.isISelection(te)?k.Selection.to(te):k.Range.to(te),Ie=[];for(const tt of this._diagnostics.getDiagnostics(q))if(me.intersection(tt.range)&&Ie.push(tt)>O._maxCodeActionsPerFile)break;const xe={diagnostics:Ie,only:G.only?new D.CodeActionKind(G.only):void 0,triggerKind:k.CodeActionTriggerKind.to(G.trigger)},Ye=await this._provider.provideCodeActions(oe,me,xe,X);if(!(0,P.isNonEmptyArray)(Ye)||X.isCancellationRequested)return;const it=this._cache.add(Ye),st=new b.DisposableStore;this._disposables.set(it,st);const ot=[];for(let tt=0;tt<Ye.length;tt++){const rt=Ye[tt];!rt||(O._isCommand(rt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:rt.title,command:this._commands.toInternal(rt,st)})):(xe.only&&(rt.kind?xe.only.contains(rt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ot.push({cacheId:[it,tt],title:rt.title,command:rt.command&&this._commands.toInternal(rt.command,st),diagnostics:rt.diagnostics&&rt.diagnostics.map(k.Diagnostic.from),edit:rt.edit&&k.WorkspaceEdit.from(rt.edit),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,disabled:rt.disabled?.reason})))}return{cacheId:it,actions:ot}}async resolveCodeAction(q,te){const[G,X]=q,oe=this._cache.get(G,X);if(!oe||O._isCommand(oe)||!this._provider.resolveCodeAction)return;const me=await this._provider.resolveCodeAction(oe,te)??oe;return me?.edit?k.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}O._maxCodeActionsPerFile=1e3;class N{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentFormattingEdits(q,te,G){const X=this._documents.getDocument(q),oe=await this._provider.provideDocumentFormattingEdits(X,te,G);if(Array.isArray(oe))return oe.map(k.TextEdit.from)}}class F{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeFormattingEdits(q,te,G,X){const oe=this._documents.getDocument(q),me=k.Range.to(te),Ie=await this._provider.provideDocumentRangeFormattingEdits(oe,me,G,X);if(Array.isArray(Ie))return Ie.map(k.TextEdit.from)}}class M{constructor(q,te){this._documents=q,this._provider=te,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,te,G,X,oe){const me=this._documents.getDocument(q),Ie=k.Position.to(te),xe=await this._provider.provideOnTypeFormattingEdits(me,Ie,G,X,oe);if(Array.isArray(xe))return xe.map(k.TextEdit.from)}}class V{constructor(q,te){this._provider=q,this._logService=te,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,te){const G=T.IdObject.mixin({symbols:[]}),X=await this._provider.provideWorkspaceSymbols(q,te);if((0,P.isNonEmptyArray)(X))for(const oe of X){if(!oe)continue;if(!oe.name){this._logService.warn("INVALID SymbolInformation, lacks name",oe);continue}const me=T.IdObject.mixin(k.WorkspaceSymbol.from(oe));this._symbolCache.set(me._id,oe),G.symbols.push(me)}return G.symbols.length>0&&this._resultCache.set(G._id,[G.symbols[0]._id,G.symbols[G.symbols.length-1]._id]),G}async resolveWorkspaceSymbol(q,te){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const G=this._symbolCache.get(q._id);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,te);return X&&(0,t.mixin)(q,k.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(q){const te=this._resultCache.get(q);if(te){for(let[G,X]=te;G<=X;G++)this._symbolCache.delete(G);this._resultCache.delete(q)}}}class ${constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,te,G,X){const oe=this._documents.getDocument(q),me=k.Position.to(te);try{const Ie=await this._provider.provideRenameEdits(oe,me,G,X);return Ie?k.WorkspaceEdit.from(Ie):void 0}catch(Ie){const xe=$._asMessage(Ie);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(q,te,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(q),oe=k.Position.to(te);try{const me=await this._provider.prepareRename(X,oe,G);let Ie,xe;if(D.Range.isRange(me)?(Ie=me,xe=X.getText(me)):(0,R.isObject)(me)&&(Ie=me.range,xe=me.placeholder),!Ie||!xe)return;if(Ie.start.line>oe.line||Ie.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Ie),text:xe}}catch(me){const Ie=$._asMessage(me);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(me)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class U{constructor(q,te){this.resultId=q,this.tokens=te}}class B{constructor(q,te){this._documents=q,this._provider=te,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,te,G){const X=this._documents.getDocument(q),oe=te!==0?this._previousResults.get(te):null;let me=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,oe.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return oe&&this._previousResults.delete(te),me?(me=B._fixProvidedSemanticTokens(me),this._send(B._convertToEdits(oe,me),me)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return B._isSemanticTokens(q)?B._isCorrectSemanticTokens(q)?q:new D.SemanticTokens(new Uint32Array(q.data),q.resultId):B._isSemanticTokensEdits(q)?B._isCorrectSemanticTokensEdits(q)?q:new D.SemanticTokensEdits(q.edits.map(te=>new D.SemanticTokensEdit(te.start,te.deleteCount,te.data?new Uint32Array(te.data):te.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const te of q.edits)if(!(te.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,te){if(!B._isSemanticTokens(te)||!q||!q.tokens)return te;const G=q.tokens,X=G.length,oe=te.data,me=oe.length;let Ie=0;const xe=Math.min(X,me);for(;Ie<xe&&G[Ie]===oe[Ie];)Ie++;if(Ie===X&&Ie===me)return new D.SemanticTokensEdits([],te.resultId);let Ye=0;const it=xe-Ie;for(;Ye<it&&G[X-Ye-1]===oe[me-Ye-1];)Ye++;return new D.SemanticTokensEdits([{start:Ie,deleteCount:X-Ie-Ye,data:oe.subarray(Ie,me-Ye)}],te.resultId)}_send(q,te){if(B._isSemanticTokens(q)){const G=this._nextResultId++;return this._previousResults.set(G,new U(q.resultId,q.data)),(0,p.encodeSemanticTokensDto)({id:G,type:"full",data:q.data})}if(B._isSemanticTokensEdits(q)){const G=this._nextResultId++;return B._isSemanticTokens(te)?this._previousResults.set(G,new U(te.resultId,te.data)):this._previousResults.set(G,new U(q.resultId)),(0,p.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(q.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=B;class W{constructor(q,te){this._documents=q,this._provider=te}async provideDocumentRangeSemanticTokens(q,te,G){const X=this._documents.getDocument(q),oe=await this._provider.provideDocumentRangeSemanticTokens(X,k.Range.to(te),G);return oe?this._send(oe):null}_send(q){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=W;class H{constructor(q,te,G,X,oe){this._documents=q,this._commands=te,this._provider=G,this._apiDeprecation=X,this._extension=oe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,te,G,X){const oe=this._documents.getDocument(q),me=k.Position.to(te),Ie=oe.getWordRangeAtPosition(me)||new D.Range(me,me),xe=Ie.with({end:me}),Ye=new L.StopWatch(!0),it=await this._provider.provideCompletionItems(oe,me,X,k.CompletionContext.to(G));if(!it||X.isCancellationRequested)return;const st=Array.isArray(it)?new D.CompletionList(it):it,ot=H.supportsResolving(this._provider)?this._cache.add(st.items):this._cache.add([]),tt=new b.DisposableStore;this._disposables.set(ot,tt);const rt=[],gt={x:ot,b:rt,a:{replace:k.Range.from(Ie),insert:k.Range.from(xe)},c:st.isIncomplete||void 0,d:Ye.elapsed()};for(let Ue=0;Ue<st.items.length;Ue++){const It=st.items[Ue],ee=this._convertCompletionItem(It,[ot,Ue],xe,Ie);rt.push(ee)}return gt}async resolveCompletionItem(q,te){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveCompletionItem(G,te);if(!!X)return this._convertCompletionItem(X,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,te,G,X){const oe=this._disposables.get(te[0]);if(!oe)throw Error("DisposableStore is missing...");const me={x:te,a:q.label,b:q.kind!==void 0?k.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(k.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(q.command,oe)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=q.textEdit.newText):typeof q.insertText=="string"?me.h=q.insertText:q.insertText instanceof D.SnippetString&&(me.h=q.insertText.value,me.i|=4);let Ie;return q.textEdit?Ie=q.textEdit.range:q.range&&(Ie=q.range),D.Range.isRange(Ie)?me.j=k.Range.from(Ie):Ie&&(!G?.isEqual(Ie.inserting)||!X?.isEqual(Ie.replacing))&&(me.j={insert:k.Range.from(Ie.inserting),replace:k.Range.from(Ie.replacing)}),me}}class x{constructor(q,te,G){this._documents=q,this._provider=te,this._commands=G,this._cache=new E.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,te,G,X){const oe=this._documents.getDocument(q),me=k.Position.to(te),Ie=await this._provider.provideInlineCompletionItems(oe,me,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:k.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text,isSnippetText:G.selectedSuggestionInfo.isSnippetText,completionKind:k.CompletionItemKind.to(G.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:G.triggerKind},X);if(!Ie||X.isCancellationRequested)return;const xe=(0,R.isArray)(Ie)?{items:Ie}:Ie,Ye=this._cache.add(xe.items);let it;return{pid:Ye,items:xe.items.map((st,ot)=>{let tt;return st.command&&(it||(it=new b.DisposableStore,this._disposables.set(Ye,it)),tt=this._commands.toInternal(st.command,it)),{text:st.text,range:st.range?k.Range.from(st.range):void 0,command:tt,idx:ot}})}}disposeCompletions(q){this._cache.delete(q);const te=this._disposables.get(q);te&&te.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,te){const G=this._cache.get(q,te);G&&J.get(this._provider).fireOnDidShowCompletionItem({completionItem:G})}}class J{constructor(){this._onDidShowCompletionItemEmitter=new a.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let te=J.map.get(q);return te||(te=new J,J.map.set(q,te)),te}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=J,J.map=new WeakMap;class ne{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("SignatureHelp")}async provideSignatureHelp(q,te,G,X){const oe=this._documents.getDocument(q),me=k.Position.to(te),Ie=this.reviveContext(G),xe=await this._provider.provideSignatureHelp(oe,me,X,Ie);if(xe){const Ye=this._cache.add([xe]);return{...k.SignatureHelp.from(xe),id:Ye}}}reviveContext(q){let te;if(q.activeSignatureHelp){const G=k.SignatureHelp.to(q.activeSignatureHelp),X=this._cache.get(q.activeSignatureHelp.id,0);X?(te=X,te.activeSignature=G.activeSignature,te.activeParameter=G.activeParameter):te=G}return{...q,activeSignatureHelp:te}}releaseSignatureHelp(q){this._cache.delete(q)}}class se{constructor(q,te,G,X,oe){this._documents=q,this._commands=te,this._provider=G,this._logService=X,this._extension=oe,this._cache=new E.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(q,te,G){const X=this._documents.getDocument(q),oe=k.Range.to(te),me=await this._provider.provideInlayHints(X,oe,G);if(!Array.isArray(me)||me.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${te}`);return}if(G.isCancellationRequested)return;const Ie=this._cache.add(me);this._disposables.set(Ie,new b.DisposableStore);const xe={hints:[],cacheId:Ie};for(let Ye=0;Ye<me.length;Ye++)this._isValidInlayHint(me[Ye],oe)&&xe.hints.push(this._convertInlayHint(me[Ye],[Ie,Ye]));return this._logService.trace(`[InlayHints] ${xe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${te}`),xe}async resolveInlayHint(q,te){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveInlayHint(G,te);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,q)}releaseHints(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_isValidInlayHint(q,te){return q.label.length===0||Array.isArray(q.label)&&q.label.every(G=>G.label.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(te&&!te.contains(q.position))}_convertInlayHint(q,te){const G=this._disposables.get(te[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:te,tooltip:q.tooltip&&k.MarkdownString.from(q.tooltip),position:k.Position.from(q.position),kind:k.InlayHintKind.from(q.kind??D.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter};return typeof q.label=="string"?X.label=q.label:X.label=q.label.map(oe=>{let me={label:oe.label};return me.collapsible=oe.collapsible,D.Location.isLocation(oe.action)?me.action=k.location.from(oe.action):oe.action&&(me.action=this._commands.toInternal(oe.action,G)),me}),X}}class K{constructor(q,te){this._documents=q,this._provider=te,this._cache=new E.Cache("DocumentLink")}async provideLinks(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentLinks(G,te);if(!(!Array.isArray(X)||X.length===0)&&!te.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(K._validateLink).map(k.DocumentLink.from)};{const oe=this._cache.add(X),me={links:[],id:oe};for(let Ie=0;Ie<X.length;Ie++){if(!K._validateLink(X[Ie]))continue;const xe=k.DocumentLink.from(X[Ie]);xe.cacheId=[oe,Ie],me.links.push(xe)}return me}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,te){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...q);if(!G)return;const X=await this._provider.resolveDocumentLink(G,te);if(!(!X||!K._validateLink(X)))return k.DocumentLink.from(X)}releaseLinks(q){this._cache.delete(q)}}class Q{constructor(q,te){this._documents=q,this._provider=te}async provideColors(q,te){const G=this._documents.getDocument(q),X=await this._provider.provideDocumentColors(G,te);return Array.isArray(X)?X.map(me=>({color:k.Color.from(me.color),range:k.Range.from(me.range)})):[]}async provideColorPresentations(q,te,G){const X=this._documents.getDocument(q),oe=k.Range.to(te.range),me=k.Color.to(te.color),Ie=await this._provider.provideColorPresentations(me,{document:X,range:oe},G);if(!!Array.isArray(Ie))return Ie.map(k.ColorPresentation.from)}}class ae{constructor(q,te){this._documents=q,this._provider=te}async provideFoldingRanges(q,te,G){const X=this._documents.getDocument(q),oe=await this._provider.provideFoldingRanges(X,te,G);if(!!Array.isArray(oe))return oe.map(k.FoldingRange.from)}}class fe{constructor(q,te,G){this._documents=q,this._provider=te,this._logService=G}async provideSelectionRanges(q,te,G){const X=this._documents.getDocument(q),oe=te.map(k.Position.to),me=await this._provider.provideSelectionRanges(X,oe,G);if(!(0,P.isNonEmptyArray)(me))return[];if(me.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let xe=0;xe<oe.length;xe++){const Ye=[];Ie.push(Ye);let it=oe[xe],st=me[xe];for(;;){if(!st.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(k.SelectionRange.from(st)),!st.parent)break;it=st.range,st=st.parent}}return Ie}}class be{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.prepareCallHierarchy(X,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(xe=>this._cacheAndConvertItem(Ie,xe)):[this._cacheAndConvertItem(Ie,me)]}async provideCallsTo(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!oe)return oe.map(me=>({from:this._cacheAndConvertItem(q,me.from),fromRanges:me.fromRanges.map(Ie=>k.Range.from(Ie))}))}async provideCallsFrom(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!oe)return oe.map(me=>({to:this._cacheAndConvertItem(q,me.to),fromRanges:me.fromRanges.map(Ie=>k.Range.from(Ie))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),X=k.CallHierarchyItem.from(te,q,G.size.toString(36));return G.set(X._itemId,te),X}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class Me{constructor(q,te){this._documents=q,this._provider=te,this._idPool=new g.IdGenerator(""),this._cache=new Map}async prepareSession(q,te,G){const X=this._documents.getDocument(q),oe=k.Position.to(te),me=await this._provider.prepareTypeHierarchy(X,oe,G);if(!me)return;const Ie=this._idPool.nextId();return this._cache.set(Ie,new Map),Array.isArray(me)?me.map(xe=>this._cacheAndConvertItem(Ie,xe)):[this._cacheAndConvertItem(Ie,me)]}async provideSupertypes(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}async provideSubtypes(q,te,G){const X=this._itemFromCache(q,te);if(!X)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!oe)return oe.map(me=>this._cacheAndConvertItem(q,me))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,te){const G=this._cache.get(q),X=k.TypeHierarchyItem.from(te,q,G.size.toString(36));return G.set(X._itemId,te),X}_itemFromCache(q,te){return this._cache.get(q)?.get(te)}}class ze{constructor(q,te){this.adapter=q,this.extension=te}}class Ge{constructor(q,te,G,X,oe,me,Ie){this._adapter=new Map,this._uriTransformer=te,this._proxy=q.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=oe,this._logService=me,this._apiDeprecation=Ie}_transformDocumentSelector(q){return k.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new D.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return Ge._handlePool++}async _withAdapter(q,te,G,X,oe){const me=this._adapter.get(q);if(!me||!(me.adapter instanceof te))return X;const Ie=Date.now();this._logService.trace(`[${me.extension.identifier.value}] INVOKE provider '${te.name}'`);const xe=G(me.adapter,me.extension);return Promise.resolve(xe).catch(Ye=>{(0,C.isCancellationError)(Ye)||(this._logService.error(`[${me.extension.identifier.value}] provider FAILED`),this._logService.error(Ye))}).finally(()=>{this._logService.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),l.CancellationToken.isCancellationToken(oe)?(0,s.raceCancellationError)(xe,oe):xe}_addNewAdapter(q,te){const G=this._nextHandle();return this._adapter.set(G,new ze(q,te)),G}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,te,G,X){const oe=this._addNewAdapter(new m(this._documents,G),q),me=X&&X.label||Ge._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(te),me),this._createDisposable(oe)}$provideDocumentSymbols(q,te,G){return this._withAdapter(q,m,X=>X.provideDocumentSymbols(f.URI.revive(te),G),void 0)}registerCodeLensProvider(q,te,G){const X=this._nextHandle(),oe=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ze(new o(this._documents,this._commands.converter,G),q)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(te),oe);let me=this._createDisposable(X);if(oe!==void 0){const Ie=G.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(oe));me=D.Disposable.from(me,Ie)}return me}$provideCodeLenses(q,te,G){return this._withAdapter(q,o,X=>X.provideCodeLenses(f.URI.revive(te),G),void 0)}$resolveCodeLens(q,te,G){return this._withAdapter(q,o,X=>X.resolveCodeLens(te,G),void 0)}$releaseCodeLenses(q,te){this._withAdapter(q,o,G=>Promise.resolve(G.releaseCodeLenses(te)),void 0)}registerDefinitionProvider(q,te,G){const X=this._addNewAdapter(new r(this._documents,G),q);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDefinition(q,te,G,X){return this._withAdapter(q,r,oe=>oe.provideDefinition(f.URI.revive(te),G,X),[])}registerDeclarationProvider(q,te,G){const X=this._addNewAdapter(new i(this._documents,G),q);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDeclaration(q,te,G,X){return this._withAdapter(q,i,oe=>oe.provideDeclaration(f.URI.revive(te),G,X),[])}registerImplementationProvider(q,te,G){const X=this._addNewAdapter(new n(this._documents,G),q);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideImplementation(q,te,G,X){return this._withAdapter(q,n,oe=>oe.provideImplementation(f.URI.revive(te),G,X),[])}registerTypeDefinitionProvider(q,te,G){const X=this._addNewAdapter(new u(this._documents,G),q);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideTypeDefinition(q,te,G,X){return this._withAdapter(q,u,oe=>oe.provideTypeDefinition(f.URI.revive(te),G,X),[])}registerHoverProvider(q,te,G,X){const oe=this._addNewAdapter(new c(this._documents,G),q);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideHover(q,te,G,X){return this._withAdapter(q,c,oe=>oe.provideHover(f.URI.revive(te),G,X),void 0)}registerEvaluatableExpressionProvider(q,te,G,X){const oe=this._addNewAdapter(new d(this._documents,G),q);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(te)),this._createDisposable(oe)}$provideEvaluatableExpression(q,te,G,X){return this._withAdapter(q,d,oe=>oe.provideEvaluatableExpression(f.URI.revive(te),G,X),void 0)}registerInlineValuesProvider(q,te,G,X){const oe=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new h(this._documents,G),q);this._proxy.$registerInlineValuesProvider(me,this._transformDocumentSelector(te),oe);let Ie=this._createDisposable(me);if(oe!==void 0){const xe=G.onDidChangeInlineValues(Ye=>this._proxy.$emitInlineValuesEvent(oe));Ie=D.Disposable.from(Ie,xe)}return Ie}$provideInlineValues(q,te,G,X,oe){return this._withAdapter(q,h,me=>me.provideInlineValues(f.URI.revive(te),G,X,oe),void 0)}registerDocumentHighlightProvider(q,te,G){const X=this._addNewAdapter(new v(this._documents,G),q);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDocumentHighlights(q,te,G,X){return this._withAdapter(q,v,oe=>oe.provideDocumentHighlights(f.URI.revive(te),G,X),void 0)}registerLinkedEditingRangeProvider(q,te,G){const X=this._addNewAdapter(new w(this._documents,G),q);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideLinkedEditingRanges(q,te,G,X){return this._withAdapter(q,w,async oe=>{const me=await oe.provideLinkedEditingRanges(f.URI.revive(te),G,X);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?Ge._serializeRegExp(me.wordPattern):void 0}},void 0)}registerReferenceProvider(q,te,G){const X=this._addNewAdapter(new A(this._documents,G),q);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideReferences(q,te,G,X,oe){return this._withAdapter(q,A,me=>me.provideReferences(f.URI.revive(te),G,X,oe),void 0)}registerCodeActionProvider(q,te,G,X){const oe=new b.DisposableStore,me=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,G,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(te),{providedKinds:X?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:X?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this._commands.converter.toInternal(Ie.command,oe)}))},Ge._extLabel(q),Boolean(G.resolveCodeAction)),oe.add(this._createDisposable(me)),oe}$provideCodeActions(q,te,G,X,oe){return this._withAdapter(q,O,me=>me.provideCodeActions(f.URI.revive(te),G,X,oe),void 0)}$resolveCodeAction(q,te,G){return this._withAdapter(q,O,X=>X.resolveCodeAction(te,G),void 0)}$releaseCodeActions(q,te){this._withAdapter(q,O,G=>Promise.resolve(G.releaseCodeActions(te)),void 0)}registerDocumentFormattingEditProvider(q,te,G){const X=this._addNewAdapter(new N(this._documents,G),q);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(X)}$provideDocumentFormattingEdits(q,te,G,X){return this._withAdapter(q,N,oe=>oe.provideDocumentFormattingEdits(f.URI.revive(te),G,X),void 0)}registerDocumentRangeFormattingEditProvider(q,te,G){const X=this._addNewAdapter(new F(this._documents,G),q);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(te),q.identifier,q.displayName||q.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(q,te,G,X,oe){return this._withAdapter(q,F,me=>me.provideDocumentRangeFormattingEdits(f.URI.revive(te),G,X,oe),void 0)}registerOnTypeFormattingEditProvider(q,te,G,X){const oe=this._addNewAdapter(new M(this._documents,G),q);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(te),X,q.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(q,te,G,X,oe,me){return this._withAdapter(q,M,Ie=>Ie.provideOnTypeFormattingEdits(f.URI.revive(te),G,X,oe,me),void 0)}registerWorkspaceSymbolProvider(q,te){const G=this._addNewAdapter(new V(te,this._logService),q);return this._proxy.$registerNavigateTypeSupport(G,typeof te.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(q,te,G){return this._withAdapter(q,V,X=>X.provideWorkspaceSymbols(te,G),{symbols:[]})}$resolveWorkspaceSymbol(q,te,G){return this._withAdapter(q,V,X=>X.resolveWorkspaceSymbol(te,G),void 0)}$releaseWorkspaceSymbols(q,te){this._withAdapter(q,V,G=>G.releaseWorkspaceSymbols(te),void 0)}registerRenameProvider(q,te,G){const X=this._addNewAdapter(new $(this._documents,G,this._logService),q);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(te),$.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(q,te,G,X,oe){return this._withAdapter(q,$,me=>me.provideRenameEdits(f.URI.revive(te),G,X,oe),void 0)}$resolveRenameLocation(q,te,G,X){return this._withAdapter(q,$,oe=>oe.resolveRenameLocation(f.URI.revive(te),G,X),void 0)}registerDocumentSemanticTokensProvider(q,te,G,X){const oe=this._addNewAdapter(new B(this._documents,G),q),me=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(te),X,me);let Ie=this._createDisposable(oe);if(me){const xe=G.onDidChangeSemanticTokens(Ye=>this._proxy.$emitDocumentSemanticTokensEvent(me));Ie=D.Disposable.from(Ie,xe)}return Ie}$provideDocumentSemanticTokens(q,te,G,X){return this._withAdapter(q,B,oe=>oe.provideDocumentSemanticTokens(f.URI.revive(te),G,X),null)}$releaseDocumentSemanticTokens(q,te){this._withAdapter(q,B,G=>G.releaseDocumentSemanticColoring(te),void 0)}registerDocumentRangeSemanticTokensProvider(q,te,G,X){const oe=this._addNewAdapter(new W(this._documents,G),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(te),X),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(q,te,G,X){return this._withAdapter(q,W,oe=>oe.provideDocumentRangeSemanticTokens(f.URI.revive(te),G,X),null)}registerCompletionItemProvider(q,te,G,X){const oe=this._addNewAdapter(new H(this._documents,this._commands.converter,G,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(oe,this._transformDocumentSelector(te),X,H.supportsResolving(G),`${q.identifier.value}(${X.join("")})`),this._createDisposable(oe)}$provideCompletionItems(q,te,G,X,oe){return this._withAdapter(q,H,me=>me.provideCompletionItems(f.URI.revive(te),G,X,oe),void 0,oe)}$resolveCompletionItem(q,te,G){return this._withAdapter(q,H,X=>X.resolveCompletionItem(te,G),void 0,G)}$releaseCompletionItems(q,te){this._withAdapter(q,H,G=>G.releaseCompletionItems(te),void 0)}registerInlineCompletionsProvider(q,te,G){const X=this._addNewAdapter(new x(this._documents,G,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideInlineCompletions(q,te,G,X,oe){return this._withAdapter(q,x,me=>me.provideInlineCompletions(f.URI.revive(te),G,X,oe),void 0)}$handleInlineCompletionDidShow(q,te,G){this._withAdapter(q,x,async X=>{X.handleDidShowCompletionItem(te,G)},void 0)}$freeInlineCompletionsList(q,te){this._withAdapter(q,x,async G=>{G.disposeCompletions(te)},void 0)}registerSignatureHelpProvider(q,te,G,X){const oe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,me=this._addNewAdapter(new ne(this._documents,G),q);return this._proxy.$registerSignatureHelpProvider(me,this._transformDocumentSelector(te),oe),this._createDisposable(me)}$provideSignatureHelp(q,te,G,X,oe){return this._withAdapter(q,ne,me=>me.provideSignatureHelp(f.URI.revive(te),G,X,oe),void 0)}$releaseSignatureHelp(q,te){this._withAdapter(q,ne,G=>G.releaseSignatureHelp(te),void 0)}registerInlayHintsProvider(q,te,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new se(this._documents,this._commands.converter,G,this._logService,q),q);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(te),typeof G.resolveInlayHint=="function",X);let me=this._createDisposable(oe);if(X!==void 0){const Ie=G.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(X));me=D.Disposable.from(me,Ie)}return me}$provideInlayHints(q,te,G,X){return this._withAdapter(q,se,oe=>oe.provideInlayHints(f.URI.revive(te),G,X),void 0,X)}$resolveInlayHint(q,te,G){return this._withAdapter(q,se,X=>X.resolveInlayHint(te,G),void 0,G)}$releaseInlayHints(q,te){this._withAdapter(q,se,G=>G.releaseHints(te),void 0)}registerDocumentLinkProvider(q,te,G){const X=this._addNewAdapter(new K(this._documents,G),q);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(te),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(q,te,G){return this._withAdapter(q,K,X=>X.provideLinks(f.URI.revive(te),G),void 0)}$resolveDocumentLink(q,te,G){return this._withAdapter(q,K,X=>X.resolveLink(te,G),void 0)}$releaseDocumentLinks(q,te){this._withAdapter(q,K,G=>G.releaseLinks(te),void 0)}registerColorProvider(q,te,G){const X=this._addNewAdapter(new Q(this._documents,G),q);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideDocumentColors(q,te,G){return this._withAdapter(q,Q,X=>X.provideColors(f.URI.revive(te),G),[])}$provideColorPresentations(q,te,G,X){return this._withAdapter(q,Q,oe=>oe.provideColorPresentations(f.URI.revive(te),G,X),void 0)}registerFoldingRangeProvider(q,te,G){const X=this._nextHandle(),oe=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ze(new ae(this._documents,G),q)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(te),oe);let me=this._createDisposable(X);if(oe!==void 0){const Ie=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));me=D.Disposable.from(me,Ie)}return me}$provideFoldingRanges(q,te,G,X){return this._withAdapter(q,ae,oe=>oe.provideFoldingRanges(f.URI.revive(te),G,X),void 0)}registerSelectionRangeProvider(q,te,G){const X=this._addNewAdapter(new fe(this._documents,G,this._logService),q);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$provideSelectionRanges(q,te,G,X){return this._withAdapter(q,fe,oe=>oe.provideSelectionRanges(f.URI.revive(te),G,X),[])}registerCallHierarchyProvider(q,te,G){const X=this._addNewAdapter(new be(this._documents,G),q);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$prepareCallHierarchy(q,te,G,X){return this._withAdapter(q,be,oe=>Promise.resolve(oe.prepareSession(f.URI.revive(te),G,X)),void 0)}$provideCallHierarchyIncomingCalls(q,te,G,X){return this._withAdapter(q,be,oe=>oe.provideCallsTo(te,G,X),void 0)}$provideCallHierarchyOutgoingCalls(q,te,G,X){return this._withAdapter(q,be,oe=>oe.provideCallsFrom(te,G,X),void 0)}$releaseCallHierarchy(q,te){this._withAdapter(q,be,G=>Promise.resolve(G.releaseSession(te)),void 0)}registerTypeHierarchyProvider(q,te,G){const X=this._addNewAdapter(new Me(this._documents,G),q);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(te)),this._createDisposable(X)}$prepareTypeHierarchy(q,te,G,X){return this._withAdapter(q,Me,oe=>Promise.resolve(oe.prepareSession(f.URI.revive(te),G,X)),void 0)}$provideTypeHierarchySupertypes(q,te,G,X){return this._withAdapter(q,Me,oe=>oe.provideSupertypes(te,G,X),void 0)}$provideTypeHierarchySubtypes(q,te,G,X){return this._withAdapter(q,Me,oe=>oe.provideSubtypes(te,G,X),void 0)}$releaseTypeHierarchy(q,te){this._withAdapter(q,Me,G=>Promise.resolve(G.releaseSession(te)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,I.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:Ge._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:Ge._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ge._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ge._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:Ge._serializeRegExp(q.beforeText),afterText:q.afterText?Ge._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?Ge._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(Ge._serializeOnEnterRule)}setLanguageConfiguration(q,te,G){let{wordPattern:X}=G;if(X&&(0,I.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(te,X):this._documents.setWordDefinitionFor(te,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const oe=this._nextHandle(),me={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ge._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?Ge._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ge._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,te,me),this._createDisposable(oe)}$setWordDefinitions(q){for(const te of q)this._documents.setWordDefinitionFor(te.languageId,new RegExp(te.regexSource,te.regexFlags))}}e.ExtHostLanguageFeatures=Ge,Ge._handlePool=0}),define(pe[241],ve([0,1,5,15,7,47,18,6]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(R,y,l,b){this._documents=y,this._commands=l,this._uriTransformer=b,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,y){await this._proxy.$changeLanguage(R,y);const l=this._documents.getDocumentData(R);if(!l)throw new Error(`document '${R.toString}' NOT found`);return l.document}async tokenAtPosition(R,y){const l=R.version,b=t.Position.from(y),p=await this._proxy.$tokensAtPosition(R.uri,b),g={type:k.StandardTokenType.Other,range:R.getWordRangeAtPosition(y)??new k.Range(y.line,y.character,y.line,y.character)};if(!p)return g;const E={range:t.Range.to(p.range),type:t.TokenType.to(p.type)};return!E.range.contains(y)||l!==R.version?g:E}createLanguageStatusItem(R,y,l){const b=this._handlePool++,p=this._proxy,g=this._ids,E=`${R.identifier.value}/${y}`;if(g.has(E))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);g.add(E);const L={selector:l,id:y,name:R.displayName??R.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let C,a=new I.DisposableStore;const s=()=>{C?.dispose(),C=(0,T.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(b,{id:E,name:L.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(L.selector,this._uriTransformer),label:L.text,detail:L.detail??"",severity:L.severity===k.LanguageStatusSeverity.Error?D.default.Error:L.severity===k.LanguageStatusSeverity.Warning?D.default.Warning:D.default.Info,command:L.command&&this._commands.toInternal(L.command,a),accessibilityInfo:L.accessibilityInformation,busy:L.busy})},0)},m={dispose(){a.dispose(),C?.dispose(),p.$removeLanguageStatus(b),g.delete(E)},get id(){return L.id},get name(){return L.name},set name(o){L.name=o,s()},get selector(){return L.selector},set selector(o){L.selector=o,s()},get text(){return L.text},set text(o){L.text=o,s()},get detail(){return L.detail},set detail(o){L.detail=o,s()},get severity(){return L.severity},set severity(o){L.severity=o,s()},get accessibilityInformation(){return L.accessibilityInformation},set accessibilityInformation(o){L.accessibilityInformation=o,s()},get command(){return L.command},set command(o){L.command=o,s()},get busy(){return L.busy},set busy(o){L.busy=o,s()}};return s(),m}}e.ExtHostLanguages=_}),define(pe[132],ve([0,1,11,5,26,14,3]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends f.AbstractLoggerService{constructor(R,y){const l=new T.Emitter;super(y.logLevel,l.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,y,l){return new _(this._proxy,R,y,l)}};I=je([He(0,D.IExtHostRpcService),He(1,k.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class _ extends f.AbstractMessageLogger{constructor(R,y,l,b){super(b?.always);this.proxy=R,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(y,b).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,y){const l=[[R,y]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(R){this.proxy.$log(this.file,R)}}}),define(pe[242],ve([0,1,5,11,28]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function D(I){return I&&I.title}let T=class{constructor(_,P){this._logService=P,this._proxy=_.getProxy(f.MainContext.MainThreadMessageService)}showMessage(_,P,R,y,l){const b={source:{identifier:_.identifier,label:_.displayName||_.name}};let p;typeof y=="string"||D(y)?p=[y,...l]:(b.modal=y?.modal,b.useCustom=y?.useCustom,b.detail=y?.detail,p=l),b.useCustom&&(0,k.checkProposedApiEnabled)(_,"resolvers");const g=[];for(let E=0;E<p.length;E++){const L=p[E];if(typeof L=="string")g.push({title:L,handle:E,isCloseAffordance:!1});else if(typeof L=="object"){let{title:C,isCloseAffordance:a}=L;g.push({title:C,isCloseAffordance:!!a,handle:E})}else this._logService.warn("Invalid message item:",L)}return this._proxy.$showMessage(P,R,b,g).then(E=>{if(typeof E=="number")return p[E]})}};T=je([He(1,t.ILogService)],T),e.ExtHostMessageService=T}),define(pe[243],ve([0,1,22,3,58,6,24,8,13,2,86,5,15,7,52,218,129]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class L{constructor(a,s,m,o,S){this._textDocumentsAndEditors=m,this._textDocuments=o,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,n=r.cell.handle,c=this._documents.get(i)?.getCell(n);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const s=this._editors.get(a);if(!s)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(a){for(const[s,m]of this._editors)if(m.apiEditor===a)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,s){const m=this._documents.get(a);if(!m&&!s)throw new Error(`NO notebook document for '${a}'`);return m}_getProviderData(a){const s=this._notebookContentProviders.get(a);if(!s)throw new Error(`NO provider for '${a}'`);return s}registerNotebookContentProvider(a,s,m,o,S){if((0,I.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:a,provider:m});let r;return m.onDidChangeNotebookContentOptions&&(r=m.onDidChangeNotebookContentOptions(()=>{const i=l.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(s,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},s,l.NotebookDocumentContentOptions.from(o),L._convertNotebookRegistrationData(a,S)),new b.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(a,s){if(!s)return;const m=s.filenamePattern.map(o=>l.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(s.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:s.displayName,filenamePattern:m,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,s,m){const o=L._notebookStatusBarItemProviderHandlePool++,S=typeof m.onDidChangeCellStatusBarItems=="function"?L._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(o,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(o,S,s);let r;return S!==void 0&&(r=m.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new b.Disposable(()=>{this._notebookStatusBarItemProviders.delete(o),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(o,S),r&&r.dispose()})}async createNotebookDocument(a){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&l.NotebookData.from(a.content)});return P.URI.revive(s)}async openNotebookDocument(a){const s=this._documents.get(a);if(s)return s.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(a),o=this._documents.get(P.URI.revive(m));return(0,_.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(a,s){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let m;typeof s=="object"?m={position:l.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(l.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:m={preserveFocus:!1};const o=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,m),S=o&&this._editors.get(o)?.apiEditor;if(S)return S;throw o?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,s,m,o){const S=this._notebookStatusBarItemProviders.get(a),r=P.URI.revive(s),i=this._documents.get(r);if(!i||!S)return;const n=i.getCellFromIndex(m);if(!n)return;const u=await S.provideCellStatusBarItems(n.apiCell,o);if(!u)return;const c=new D.DisposableStore,d=this._statusBarCache.add([c]),v=(Array.isArray(u)?u:[u]).map(w=>l.NotebookStatusBarItem.from(w,this._commandsConverter,c));return{cacheId:d,items:v}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,s,m,o,S){if((0,I.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,m),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},s,l.NotebookDocumentContentOptions.from(o),L._convertNotebookRegistrationData(a,S)),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,s,m){const o=this._notebookSerializer.get(a);if(!o)throw new Error("NO serializer found");const S=await o.deserializeNotebook(s.buffer,m);return new p.SerializableObjectWithBuffers(l.NotebookData.from(S))}async $notebookToData(a,s,m){const o=this._notebookSerializer.get(a);if(!o)throw new Error("NO serializer found");const S=await o.serializeNotebook(l.NotebookData.to(s.value),m);return f.VSBuffer.wrap(S)}async $openNotebook(a,s,m,o,S){const{provider:r}=this._getProviderData(a),i=await r.openNotebook(P.URI.revive(s),{backupId:m,untitledDocumentData:o?.buffer},S);return new p.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(l.NotebookCellData.from)})}async $saveNotebook(a,s,m){const o=this.getNotebookDocument(P.URI.revive(s)),{provider:S}=this._getProviderData(a);return await S.saveNotebook(o.apiNotebook,m),!0}async $saveNotebookAs(a,s,m,o){const S=this.getNotebookDocument(P.URI.revive(s)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(P.URI.revive(m),S.apiNotebook,o),!0}async $backupNotebook(a,s,m){const o=this.getNotebookDocument(P.URI.revive(s)),S=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,k.hash)([o.uri.toString(),this._backupIdPool++])),n=P.URI.joinPath(r,i),u=await S.provider.backupNotebook(o.apiNotebook,{destination:n},m);return o.updateBackup(u),u.id}_createExtHostEditor(a,s,m){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const o=new E.ExtHostNotebookEditor(s,this._notebookEditorsProxy,a,m.visibleRanges.map(l.NotebookRange.to),m.selections.map(l.NotebookRange.to),typeof m.viewColumn=="number"?l.ViewColumn.to(m.viewColumn):void 0);this._editors.set(s,o)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const m of a.value.removedDocuments){const o=P.URI.revive(m),S=this._documents.get(o);S&&(S.dispose(),this._documents.delete(o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===o.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const m=[];for(const o of a.value.addedDocuments){const S=P.URI.revive(o.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const r=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){r._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){r._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){r._onDidChangeCellMetadata.fire(n)}},S,o);m.push(...o.cells.map(n=>g.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const m of a.value.addedEditors){if(this._editors.has(m.id))return;const o=P.URI.revive(m.documentUri),S=this._documents.get(o);S&&this._createExtHostEditor(S,m.id,m)}const s=[];if(a.value.removedEditors)for(const m of a.value.removedEditors){const o=this._editors.get(m);o&&(this._editors.delete(m),this._activeNotebookEditor?.id===o.id&&(this._activeNotebookEditor=void 0),s.push(o))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(o=>this._editors.get(o)).filter(o=>!!o);const m=new Set;this._visibleNotebookEditors.forEach(o=>m.add(o.id));for(const o of this._editors.values()){const S=m.has(o.id);o._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(o=>o).filter(o=>o.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=L,L._notebookStatusBarItemProviderHandlePool=0}),define(pe[244],ve([0,1,3,77,11,5,14,15]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(y,l){const b=_._Keys.nextId();y.$registerNotebookEditorDecorationType(b,I.NotebookDecorationRenderOptions.from(l)),this.value={key:b,dispose(){y.$removeNotebookEditorDecorationType(b)}}}}_._Keys=new t.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,l,b){this._logService=y,this._extHostRpc=l,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new _(this._extHostRpc.getProxy(D.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,l);const b=this._notebooksAndEditors.getEditorById(y);l.visibleRanges&&b._acceptVisibleRanges(l.visibleRanges.ranges.map(I.NotebookRange.to)),l.selections&&b._acceptSelections(l.selections.selections.map(I.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:b.apiEditor,visibleRanges:b.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:b.apiEditor,selections:b.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const l in y)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(I.ViewColumn.to(y[l]))}};P=je([He(0,k.ILogService),He(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(pe[245],ve([0,1,17,18,21,3,6,24,2,27,11,5,38,15,7,87,211,28,52]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(r,i,n,u,c){this._initData=i,this._extHostNotebook=n,this._commands=u,this._logService=c,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new D.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(y.MainContext.MainThreadNotebookKernels);const d=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",h=>!0,h=>{if(h&&"notebookEditor"in h&&"id"in h){const v=this._extHostNotebook.getIdByEditor(h.notebookEditor);return{id:h.id,extension:h.extension,notebookEditorId:v}}else if(h&&"notebookEditor"in h){const v=this._extHostNotebook.getIdByEditor(h.notebookEditor);if(v===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${h.notebookEditor.document.uri.toString()}`);return{notebookEditorId:v}}return h})],l.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(r,i,n,u,c,d){for(const x of this._kernelData.values())if(x.controller.id===i&&P.ExtensionIdentifier.equals(r.identifier,x.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const h=this._handlePool++,v=this;this._logService.trace(`NotebookController[${h}], CREATED by ${r.identifier.value}, ${i}`);const w=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${r.identifier}'`);let A=!1;const O=new T.DisposableStore,N=new D.Emitter,F=new D.Emitter,M={id:`${r.identifier.value}/${i}`,notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:u||r.identifier.value,preloads:d?d.map(b.NotebookRendererScript.from):[]};let V=c??w,$;this._proxy.$addKernel(h,M).catch(x=>{console.log(x),A=!0});let U=0;const B=()=>{if(A)return;const x=++U;Promise.resolve().then(()=>{x===U&&this._proxy.$updateKernel(h,M)})},W=new I.ResourceMap,H={get id(){return i},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return M.label},set label(x){M.label=x??r.displayName??r.name,B()},get detail(){return M.detail??""},set detail(x){M.detail=x,B()},get description(){return M.description??""},set description(x){M.description=x,B()},get kind(){return(0,L.checkProposedApiEnabled)(r,"notebookControllerKind"),M.kind??""},set kind(x){(0,L.checkProposedApiEnabled)(r,"notebookControllerKind"),M.kind=x,B()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(x){M.supportedLanguages=x,B()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(x){M.supportsExecutionOrder=x,B()},get rendererScripts(){return M.preloads?M.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(x){V=x??w},get interruptHandler(){return $},set interruptHandler(x){$=x,M.supportsInterrupt=Boolean(x),B()},createNotebookCellExecution(x){if(A)throw new Error("notebook controller is DISPOSED");if(!W.has(x.notebook.uri))throw v._logService.trace(`NotebookController[${h}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(W.keys()).map(J=>J.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return v._createNotebookCellExecution(x)},dispose:()=>{A||(this._logService.trace(`NotebookController[${h}], DISPOSED`),A=!0,this._kernelData.delete(h),O.dispose(),N.dispose(),F.dispose(),this._proxy.$removeKernel(h))},updateNotebookAffinity(x,J){v._proxy.$updateNotebookPriority(h,x.uri,J)},onDidReceiveMessage:F.event,postMessage(x,J){return(0,L.checkProposedApiEnabled)(r,"notebookMessaging"),v._proxy.$postMessage(h,J&&v._extHostNotebook.getIdByEditor(J),x)},asWebviewUri(x){return(0,L.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(x,v._initData.remote)}};return this._kernelData.set(h,{extensionId:r.identifier,controller:H,onDidReceiveMessage:F,onDidChangeSelection:N,associatedNotebooks:W}),H}$acceptNotebookAssociation(r,i,n){const u=this._kernelData.get(r);if(u){const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(i));n?u.associatedNotebooks.set(c.uri,!0):u.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),n),u.onDidChangeSelection.fire({selected:n,notebook:c.apiNotebook})}}async $executeCells(r,i,n){const u=this._kernelData.get(r);if(!u)return;const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(i)),d=[];for(const h of n){const v=c.getCell(h);v&&d.push(v.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),d.length),await u.controller.executeHandler.call(u.controller,d,c.apiNotebook,u.controller)}catch(h){this._logService.error(`NotebookController[${r}] execute cells FAILED`,h),console.error(h)}}async $cancelCells(r,i,n){const u=this._kernelData.get(r);if(!u)return;const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(i));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,c.apiNotebook);else for(const d of n){const h=c.getCell(d);h&&this._activeExecutions.get(h.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,n){const u=this._kernelData.get(r);if(!u)return;const c=this._extHostNotebook.getEditorById(i);u.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:n}))}$cellExecutionChanged(r,i,n){const c=this._extHostNotebook.getNotebookDocument(_.URI.revive(r)).getCell(i);c&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:n??p.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const u=new m(n.notebook,n,this._proxy);this._activeExecutions.set(n.uri,u);const c=u.onDidChangeState(()=>{u.state===s.Resolved&&(u.dispose(),c.dispose(),this._activeExecutions.delete(n.uri))});return u.asApiObject()}};a=je([He(4,R.ILogService)],a),e.ExtHostNotebookKernels=a;var s;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(s||(s={}));class m extends T.Disposable{constructor(r,i,n){super();this._document=r,this._cell=i,this._proxy=n,this._onDidChangeState=new D.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new o(10,u=>this.update(u)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new C.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const n=p.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return n===i.items?b.NotebookCellOutput.from(i):b.NotebookCellOutput.from({items:n,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,n){const u=this.cellIndexToHandle(i),c=this.validateAndConvertOutputs((0,f.asArray)(r));return this.updateSoon({editType:E.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:u,append:n,outputs:c})}async updateOutputItems(r,i,n){return r=p.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(r),!0),this.updateSoon({editType:E.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:r.map(b.NotebookCellOutputItem.from),outputId:i.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(n){r._executionOrder=n,r.update([{editType:E.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,executionOrder:r._executionOrder}])},start(n){if(r._state===s.Resolved||r._state===s.Started)throw new Error("Cannot call start again");r._state=s.Started,r._onDidChangeState.fire(),r.update({editType:E.CellExecutionUpdateType.ExecutionState,uri:r._document.uri,cellHandle:r._cell.handle,runStartTime:n})},end(n,u){if(r._state===s.Resolved)throw new Error("Cannot call resolve twice");r._state=s.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._document.uri,r._cell.handle,new C.SerializableObjectWithBuffers({uri:r._document.uri,cellHandle:r._cell.handle,runEndTime:u,lastRunSuccess:n}))},clearOutput(n){return r.verifyStateForOutput(),r.updateOutputs([],n,!1)},appendOutput(n,u){return r.verifyStateForOutput(),r.updateOutputs(n,u,!0)},replaceOutput(n,u){return r.verifyStateForOutput(),r.updateOutputs(n,u,!1)},appendOutputItems(n,u){return r.verifyStateForOutput(),r.updateOutputItems(n,u,!0)},replaceOutputItems(n,u){return r.verifyStateForOutput(),r.updateOutputItems(n,u,!1)}})}}class o{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(pe[246],ve([0,1,3,5,129,28]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(_,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,P,R){const y=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(P)?.fire({editor:y.apiEditor,message:R})}createRendererMessaging(_,P){if(!_.contributes?.notebookRenderer?.some(b=>b.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const R=(0,D.isProposedApiEnabled)(_,"notebookEditor"),y=new WeakMap;return{onDidReceiveMessage:(b,p,g)=>{const E=R?b:L=>{const C={};y.set(C,L.editor),b({editor:C,message:L.message})};return this.getOrCreateEmitterFor(P).event(E,p,g)},postMessage:(b,p)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(b)&&([b,p]=[p,b]);const g=R?p:y.get(p),E=g&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(g);return this.proxy.$postMessage(E?.id,P,b)}}}getOrCreateEmitterFor(_){let P=this._rendererMessageEmitters.get(_);return P||(P=new f.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,P),P)}}e.ExtHostNotebookRenderers=T}),define(pe[133],ve([0,1,5,6,4,14,11,212,67,26,44,152,22]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class b extends t.Disposable{constructor(E,L,C,a){super();this.id=E,this.name=L,this.logger=C,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(E){this.append(E+`
`)}append(E){this.write(E),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const E=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,E)}replace(E){const L=this.offset;this.write(E),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,L),this.visible&&this.logger.flush()}show(E,L){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof E=="boolean"?E:L))}hide(){this.proxy.$close(this.id)}write(E){this.offset+=l.VSBuffer.fromString(E).byteLength,this.logger.info(E)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=b;let p=class{constructor(E,L,C,a,s){this.extHostFileSystem=C,this.extHostFileSystemInfo=a,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=E.getProxy(f.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(L.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.visibleChannelId=E;for(const[L,C]of this.channels)C.visible=L===this.visibleChannelId}createOutputChannel(E,L){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const C=this.doCreateOutputChannel(E,L);return C.then(a=>{this.channels.set(a.id,a),a.visible=a.id===this.visibleChannelId}),this.createExtHostOutputChannel(E,C)}async doCreateOutputChannel(E,L){const C=await this.createOutputDirectory(),a=this.extHostFileSystemInfo.extUri.joinPath(C,`${this.namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),m=await this.proxy.$register(E,!1,a,L.identifier.value);return new b(m,E,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(E,L){let C=!1;const a=()=>{if(C)throw new Error("Channel has been closed")};return{get name(){return E},append(s){a(),L.then(m=>m.append(s))},appendLine(s){a(),L.then(m=>m.appendLine(s))},clear(){a(),L.then(s=>s.clear())},replace(s){a(),L.then(m=>m.replace(s))},show(s,m){a(),L.then(o=>o.show(s,m))},hide(){a(),L.then(s=>s.hide())},dispose(){C=!0,L.then(s=>s.dispose())}}}};p=je([He(0,D.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,_.IExtHostConsumerFileSystem),He(3,R.IExtHostFileSystemInfo),He(4,T.ILoggerService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(pe[247],ve([0,1,18,21,3,6,5,2,7,16,17,47,85,28]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(g,E,L){const C=g.getProxy(T.MainContext.MainThreadQuickOpen);class a{constructor(c,d){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=d}showQuickPick(c,d,h=t.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(c),w=++this._instances,A=C.$show(w,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},h),O={},N=A.then(()=>O);return Promise.race([N,v]).then(F=>{if(F!==O)return v.then(M=>{const V=[];for(let $=0;$<M.length;$++){const U=M[$];typeof U=="string"?V.push({label:U,handle:$}):U.kind===_.QuickPickItemKind.Separator?V.push({type:"separator",label:U.label}):V.push({label:U.label,description:U.description,detail:U.detail,picked:U.picked,alwaysShow:U.alwaysShow,handle:$})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{d.onDidSelectItem(M[$])}),C.$setItems(w,V),A.then($=>{if(typeof $=="number")return M[$];if(Array.isArray($))return $.map(U=>M[U])})})}).then(void 0,F=>{if(!(0,P.isCancellationError)(F))return C.$setError(w,F),Promise.reject(F)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,d=t.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,C.$input(c,typeof this._validateInput=="function",d).then(void 0,h=>{if(!(0,P.isCancellationError)(h))return Promise.reject(h)})}$validateInput(c){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,d=t.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!h)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(w=>w.uri.toString()===h.uri.toString())}createQuickPick(c){const d=new i(c,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(c){const d=new n(c,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(c,d){const h=this._sessions.get(c);h&&h._fireDidChangeValue(d)}$onDidAccept(c){const d=this._sessions.get(c);d&&d._fireDidAccept()}$onDidChangeActive(c,d){const h=this._sessions.get(c);h instanceof i&&h._fireDidChangeActive(d)}$onDidChangeSelection(c,d){const h=this._sessions.get(c);h instanceof i&&h._fireDidChangeSelection(d)}$onDidTriggerButton(c,d){const h=this._sessions.get(c);h&&h._fireDidTriggerButton(d)}$onDidTriggerItemButton(c,d,h){const v=this._sessions.get(c);v instanceof i&&v._fireDidTriggerItemButton(d,h)}$onDidHide(c){const d=this._sessions.get(c);d&&d._fireDidHide()}}class s{constructor(c,d){this._extensionId=c,this._onDidDispose=d,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((d,h)=>{const v=d===_.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(v,d)}),this.update({buttons:c.map((d,h)=>({...r(d),tooltip:d.tooltip,handle:d===_.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const d=this._handlesToButtons.get(c);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),C.$dispose(this._id))}update(c){if(!this._disposed){for(const d of Object.keys(c)){const h=c[d];this._pendingUpdate[d]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){C.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function m(u){if(u instanceof _.ThemeIcon)return{id:u.id};const c=S(u),d=o(u);return{dark:typeof c=="string"?I.URI.file(c):c,light:typeof d=="string"?I.URI.file(d):d}}function o(u){return typeof u=="object"&&"light"in u?u.light:u}function S(u){return typeof u=="object"&&"dark"in u?u.dark:u}function r(u){const c=m(u.iconPath);let d,h;return"id"in c?h=l.ThemeIcon.asClassName(c):d=c,{iconPath:d,iconClass:h}}class i extends s{constructor(c,d){super(c.identifier,d);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(h=>h.kind!==void 0)&&(0,b.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((h,v)=>{this._handlesToItems.set(v,h),this._itemsToHandles.set(h,v)});const d=[];for(let h=0;h<c.length;h++){const v=c[h];v.kind===_.QuickPickItemKind.Separator?d.push({type:"separator",label:v.label}):d.push({handle:h,label:v.label,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,buttons:v.buttons?.map((w,A)=>({...r(w),tooltip:w.tooltip,handle:A}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(c){const d=(0,R.coalesce)(c.map(h=>this._handlesToItems.get(h)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(c){const d=(0,R.coalesce)(c.map(h=>this._handlesToItems.get(h)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(c,d){const h=this._handlesToItems.get(c);if(!h||!h.buttons||!h.buttons.length)return;const v=h.buttons[d];v&&this._onDidTriggerItemButtonEmitter.fire({button:v,item:h})}}class n extends s{constructor(c,d){super(c,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?y.default.Error:y.default.Ignore})}}return new a(E,L)}e.createExtHostQuickOpen=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[248],ve([0,1,2,3,56,6,18,5,17,101,11,27,85,15,28]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p){"use strict";var g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function L(d){if(d)return typeof d.iconPath=="string"?f.URI.file(d.iconPath):f.URI.isUri(d.iconPath)||l.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function C(d,h){if(!d.iconPath&&!h.iconPath)return 0;if(d.iconPath){if(!h.iconPath)return 1}else return-1;const v=typeof d.iconPath=="string"?d.iconPath:f.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,w=typeof h.iconPath=="string"?h.iconPath:f.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,P.comparePaths)(v,w)}function a(d,h){let v=0;if(d.strikeThrough!==h.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==h.faded)return d.faded?1:-1;if(d.tooltip!==h.tooltip)return(d.tooltip||"").localeCompare(h.tooltip||"");if(v=C(d,h),v!==0)return v;if(d.light&&h.light)v=C(d.light,h.light);else{if(d.light)return 1;if(h.light)return-1}if(v!==0)return v;if(d.dark&&h.dark)v=C(d.dark,h.dark);else{if(d.dark)return 1;if(h.dark)return-1}return v}function s(d,h){if(d.command!==h.command)return d.command<h.command?-1:1;if(d.title!==h.title)return d.title<h.title?-1:1;if(d.tooltip!==h.tooltip){if(d.tooltip!==void 0&&h.tooltip!==void 0)return d.tooltip<h.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(d.arguments===h.arguments)return 0;if(d.arguments)if(h.arguments){if(d.arguments.length!==h.arguments.length)return d.arguments.length-h.arguments.length}else return 1;else return-1;for(let v=0;v<d.arguments.length;v++){const w=d.arguments[v],A=h.arguments[v];if(w!==A)return w<A?-1:1}return 0}function m(d,h){let v=(0,P.comparePaths)(d.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(v!==0)return v;if(d.command&&h.command)v=s(d.command,h.command);else{if(d.command)return 1;if(h.command)return-1}if(v!==0)return v;if(d.decorations&&h.decorations)v=a(d.decorations,h.decorations);else{if(d.decorations)return 1;if(h.decorations)return-1}return v}function o(d,h){for(let v=0;v<d.length;v++)if(d[v]!==h[v])return!1;return!0}function S(d,h){return d.command===h.command&&d.title===h.title&&d.tooltip===h.tooltip&&(d.arguments&&h.arguments?o(d.arguments,h.arguments):d.arguments===h.arguments)}function r(d,h){return(0,_.equals)(d,h,S)}class i{constructor(h,v,w){this._extension=h,this._sourceControlHandle=w,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,nt(this,g,v,"f")}get value(){return this._value}set value(h){h=h??"",Le(this,g,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Le(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Le(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Le(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,v){(0,p.checkProposedApiEnabled)(this._extension,"scmValidation"),Le(this,g,"f").$showValidationMessage(this._sourceControlHandle,h,v)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,g=new WeakMap;class n{constructor(h,v,w,A,O){this._proxy=h,this._commands=v,this._sourceControlHandle=w,this._id=A,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,v){const w=this._resourceStatesCommandsMap.get(h);return w?(0,T.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(m),w=(0,_.sortedDiff)(this._resourceSnapshot,h,m).map(N=>{const F=N.toInsert.map(M=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,M);const $=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ae=new D.DisposableStore;U=this._commands.converter.toInternal(M.command,ae),this._resourceStatesDisposablesMap.set(V,ae)}else this._resourceStatesCommandsMap.set(V,M.command);const B=L(M.decorations),W=M.decorations&&L(M.decorations.light)||B,H=M.decorations&&L(M.decorations.dark)||B,x=[W,H],J=M.decorations&&M.decorations.tooltip||"",ne=M.decorations&&!!M.decorations.strikeThrough,se=M.decorations&&!!M.decorations.faded,K=M.contextValue||"";return{rawResource:[V,$,x,J,ne,se,K,U],handle:V}});return{start:N.start,deleteCount:N.deleteCount,toInsert:F}}),A=w.map(({start:N,deleteCount:F,toInsert:M})=>[N,F,M.map(V=>V.rawResource)]),O=w.reverse();for(const{start:N,deleteCount:F,toInsert:M}of O){const V=M.map(U=>U.handle),$=this._handlesSnapshot.splice(N,F,...V);for(const U of $)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=h,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class u{constructor(h,v,w,A,O,N){this._extension=h,this._commands=w,this._id=A,this._label=O,this._rootUri=N,E.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new D.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new D.MutableDisposable,this._statusBarDisposables=new D.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=u._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,nt(this,E,v,"f"),this._inputBox=new i(h,Le(this,E,"f"),this.handle),Le(this,E,"f").$registerSourceControl(this.handle,A,O,N)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Le(this,E,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Le(this,E,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Le(this,E,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new D.DisposableStore,this._acceptInputCommand=h;const v=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Le(this,E,"f").$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,p.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new D.DisposableStore,this._actionButton=h;const v=h!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Le(this,E,"f").$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&r(this._statusBarCommands,h))return;this._statusBarDisposables.value=new D.DisposableStore,this._statusBarCommands=h;const v=(h||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));Le(this,E,"f").$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(h,v){const w=new n(Le(this,E,"f"),this._commands,this.handle,h,v),A=t.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,A),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const h=[],v=[];for(const[w,A]of this.createdResourceGroups){A.dispose();const O=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});t.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),O.dispose(),this._groups.delete(w.handle),Le(this,E,"f").$unregisterGroup(this.handle,w.handle)}),h.push([w.handle,w.id,w.label,w.features]);const N=w._takeResourceStateSnapshot();N.length>0&&v.push([w.handle,N]),this._groups.set(w.handle,w)}Le(this,E,"f").$registerGroups(this.handle,h,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(v=>{const w=v._takeResourceStateSnapshot();w.length!==0&&h.push([v.handle,w])}),h.length>0&&Le(this,E,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Le(this,E,"f").$unregisterSourceControl(this.handle)}}E=new WeakMap,u._handlePool=0,je([(0,k.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),je([(0,k.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let c=class Vi{constructor(h,v,w){this._commands=v,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=h.getProxy(I.MainContext.MainThreadSCM),this._telemetry=h.getProxy(I.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const O=this._sourceControls.get(A.sourceControlHandle);if(!O)return A;const N=O.getResourceGroup(A.groupHandle);return N?N.getResourceState(A.handle):A}else if(A&&A.$mid===4){const O=this._sourceControls.get(A.sourceControlHandle);return O?O.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const O=this._sourceControls.get(A.handle);return O||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,v,w,A){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,v,w,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const O=Vi._handlePool++,N=new u(h,this._proxy,this._commands,v,w,A);this._sourceControls.set(O,N);const F=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return F.push(N),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(h.identifier),F),N}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const v=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(h.identifier)),w=v&&v[v.length-1];return w&&w.inputBox}$provideOriginalResource(h,v,w){const A=f.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,A.toString());const O=this._sourceControls.get(h);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(A,w)).then(N=>N||null)}$onInputBoxValueChange(h,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const w=this._sourceControls.get(h);return w&&w.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(h,v,w,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,v,w);const O=this._sourceControls.get(h);if(!O)return Promise.resolve(void 0);const N=O.getResourceGroup(v);return N?N.$executeResourceCommand(w,A):Promise.resolve(void 0)}$validateInput(h,v,w){this.logService.trace("ExtHostSCM#$validateInput",h);const A=this._sourceControls.get(h);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>A.inputBox.validateInput(v,w)).then(O=>{if(!O)return Promise.resolve(void 0);const N=b.MarkdownString.fromStrict(O.message);return N?Promise.resolve([N,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};c._handlePool=0,c=je([He(2,R.ILogService)],c),e.ExtHostSCM=c});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[249],ve([0,1,7,5,166,6,15,13]),function(Z,e,f,t,k,D,T,I){"use strict";var _,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(p,g,E,L,C=f.StatusBarAlignment.Left,a){_.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new D.DisposableStore,nt(this,_,p,"f"),nt(this,P,g,"f"),this._entryId=R.ID_GEN++,this._extension=E,this._id=L,this._alignment=C,this._priority=this.validatePriority(a)}validatePriority(p){if(!!(0,I.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!R.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:Le(this,P,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:Le(this,P,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Le(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let g;this._name?g=this._name:g=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const L=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Le(this,_,"f").$setEntry(this._entryId,p,g,this._text,L,this._command?.internal,E,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,_=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const g={message:p};return this._messages.unshift(g),this._update(),new f.Disposable(()=>{const E=this._messages.indexOf(g);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(p,g){this._proxy=p.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new y(this)}createStatusBarEntry(p,g,E,L){return new R(this._proxy,this._commands,p,g,E,L)}setStatusBarMessage(p,g){const E=this._statusMessage.setMessage(p);let L;return typeof g=="number"?L=setTimeout(()=>E.dispose(),g):typeof g!="undefined"&&g.then(()=>E.dispose(),()=>E.dispose()),new f.Disposable(()=>{E.dispose(),clearTimeout(L)})}}e.ExtHostStatusBar=l}),define(pe[90],ve([0,1,5,3,4]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class D{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,_){this._proxy.$registerExtensionStorageKeysToSync(I,_)}initializeExtensionStorage(I,_,P){return this._proxy.$initializeExtensionStorage(I,_).then(R=>R||P)}setValue(I,_,P){return this._proxy.$setValue(I,_,P)}$acceptValue(I,_,P){this._onDidChangeStorage.fire({shared:I,key:_,value:P})}}e.ExtHostStorage=D,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(pe[68],ve([0,1,4,26,11,67,2]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let I=class{constructor(P,R,y){this._logService=R,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=je([He(0,t.IExtHostInitDataService),He(1,k.ILogService),He(2,D.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(pe[34],ve([0,1,3,5,4,2,14,6,7,167,16,214,21,33,196,85,13,18]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class C{constructor(u,c,d,h){this._proxy=u,this._id=c,this._creationOptions=d,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},get state(){return v._state},sendText(w,A=!0){v._checkDisposed(),v._proxy.$sendText(v._id,w,A)},show(w){v._checkDisposed(),v._proxy.$show(v._id,w)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(u,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,E.withNullAsUndefined)(u.shellPath),shellArgs:(0,E.withNullAsUndefined)(u.shellArgs),cwd:(0,E.withNullAsUndefined)(u.cwd),env:(0,E.withNullAsUndefined)(u.env),icon:(0,E.withNullAsUndefined)(r(u.iconPath)),color:g.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,E.withNullAsUndefined)(u.message),strictEnv:(0,E.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,E.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,E.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,E.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(u.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,E.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,c,d,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:g.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(u,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,c){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,c){return u===this._cols&&c===this._rows||u===0||c===0?!1:(this._cols=u,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=C;class a{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new f.Emitter,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,c){this._pty.setDimensions?.({columns:u,rows:c})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let s=1,m=class extends I.Disposable{constructor(u,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new p.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[d,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,c){const d=new C(this._proxy,(0,b.generateUuid)(),u,u.name),h=new a(u.pty);return d.createExtensionTerminal(u.location,this._serializeParentTerminal(u,c).resolvedExtHostIdentifier,r(u.iconPath),i(u.color)).then(v=>{const w=this._setupExtHostProcessListeners(v,h);this._terminalProcessDisposables[v]=w}),this._terminals.push(d),d.value}_serializeParentTerminal(u,c){if(c=c||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const d=u.location.parentTerminal;if(d){const h=this._terminals.find(v=>v.value===d);h&&(c.resolvedExtHostIdentifier=h._id)}}else u.location&&typeof u.location!="object"?c.location=u.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(u,c){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const h=new a(c),v=this._setupExtHostProcessListeners(u,h);this._terminalProcessDisposables[u]=v}async $acceptActiveTerminalChanged(u){const c=this._activeTerminal;if(u===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(u);d&&(this._activeTerminal=d,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,c){const d=this._getTerminalById(u);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:c})}async $acceptTerminalDimensions(u,c,d){const h=this._getTerminalById(u);h&&h.setDimensions(c,d)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(u,c,d){this._terminalProcesses.get(u)?.resize(c,d)}async $acceptTerminalTitleChange(u,c){const d=this._getTerminalById(u);d&&(d.name=c)}async $acceptTerminalClosed(u,c){const d=this._getTerminalObjectIndexById(this._terminals,u);if(d!==null){const h=this._terminals.splice(d,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(u,c,d,h){if(c){const A=this._getTerminalObjectIndexById(this._terminals,c);if(A!==null){this._terminals[A]._id=u,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const v={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:D.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},w=new C(this._proxy,u,v,d);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(u,c){const d=this._getTerminalById(u);d&&d._setProcessId(c)}async $startExtensionTerminal(u,c){const d=this._getTerminalById(u);if(!d)return{message:(0,P.localize)(0,null,u)};d.isOpen||await new Promise(v=>{const w=this.onDidOpenTerminal(async A=>{A===d.value&&(w.dispose(),v())})});const h=this._terminalProcesses.get(u);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[u]={initialDimensions:c}}_setupExtHostProcessListeners(u,c){const d=new I.DisposableStore;d.add(c.onProcessReady(v=>this._proxy.$sendProcessReady(u,v.pid,v.cwd))),d.add(c.onDidChangeProperty(v=>this._proxy.$sendProcessProperty(u,v))),this._bufferer.startBuffering(u,c.onProcessData),d.add(c.onProcessExit(v=>this._onProcessExit(u,v))),this._terminalProcesses.set(u,c);const h=this._extensionTerminalAwaitingStart[u];return h&&c instanceof a&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),d}$acceptProcessAckDataEvent(u,c){this._terminalProcesses.get(u)?.acknowledgeDataEvent(c)}$acceptProcessInput(u,c){this._terminalProcesses.get(u)?.input(c)}$acceptTerminalInteraction(u){const c=this._getTerminalById(u);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(u,c,d){try{this._terminalProcesses.get(u)?.resize(c,d)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(u,c){this._terminalProcesses.get(u)?.shutdown(c)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(c=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:c}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,c,d){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,d),this._proxy.$registerProfileProvider(c,u.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(u,c){const d=new l.CancellationTokenSource().token;let h=await this._profileProviders.get(u)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(u,c){const d=this._getTerminalById(u);if(!d)return[];this._terminalLinkCache.delete(u);const h=this._terminalLinkCancellationSource.get(u);h&&h.dispose(!0);const v=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,v);const w=[],A={terminal:d.value,line:c},O=[];for(const M of this._linkProviders)O.push(L.Promises.withAsyncBody(async V=>{v.token.onCancellationRequested(()=>V({provider:M,links:[]}));const $=await M.provideTerminalLinks(A,v.token)||[];v.token.isCancellationRequested||V({provider:M,links:$})}));const N=await Promise.all(O);if(v.token.isCancellationRequested)return[];const F=new Map;for(const M of N)M&&M.links.length>0&&w.push(...M.links.map(V=>{const $={id:s++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return F.set($.id,{provider:M.provider,link:V}),$}));return this._terminalLinkCache.set(u,F),w}$activateLink(u,c){const d=this._terminalLinkCache.get(u)?.get(c);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(u,c){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const d=this._terminalProcessDisposables[u];d&&(d.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,c)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,c){const d=this._getTerminalObjectIndexById(u,c);return d!==null?u[d]:null}_getTerminalObjectIndexById(u,c){let d=null;return u.some((h,v)=>h._id===c?(d=v,!0):!1),d}getEnvironmentVariableCollection(u){let c=this._environmentVariableCollections.get(u.identifier.value);return c||(c=new o,this._setEnvironmentVariableCollection(u.identifier.value,c)),c}_syncEnvironmentVariableCollection(u,c){const d=(0,y.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(u,c.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(u){u.forEach(c=>{const d=c[0],h=new o(c[1]);this._setEnvironmentVariableCollection(d,h)})}$acceptDefaultProfile(u,c){this._defaultProfile=u,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(u,c){this._environmentVariableCollections.set(u,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,c)})}};m=je([He(1,T.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class o{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,c){this._setIfDiffers(u,{value:c,type:_.EnvironmentVariableMutatorType.Replace})}append(u,c){this._setIfDiffers(u,{value:c,type:_.EnvironmentVariableMutatorType.Append})}prepend(u,c){this._setIfDiffers(u,{value:c,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,c){const d=this.map.get(u);(!d||d.value!==c.value||d.type!==c.type)&&(this.map.set(u,c),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,c){this.map.forEach((d,h)=>u.call(c,h,d,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let S=class extends m{constructor(u){super(!1,u)}createTerminal(u,c,d){throw new R.NotSupportedError}createTerminalFromOptions(u,c){throw new R.NotSupportedError}};S=je([He(0,T.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function i(n){return g.ThemeColor.isThemeColor(n)?n:void 0}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[250],ve([0,1,17,22,21,3,76,58,6,25,13,33,5,14,64,15,7,220,127,88]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(A,O){this.resultsChangedEmitter=new D.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(l.MainContext.MainThreadTesting),this.observer=new d(this.proxy),this.runTracker=new S(this.proxy),O.registerArgumentProcessor({processArgument:N=>N?.$mid===13?g.TestItem.toItemFromContext(N):N})}createTestController(A,O,N){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const F=new _.DisposableStore,M=F.add(new L.SingleUseTestCollection(A));M.root.label=O;const V=new Map,$=this.proxy,U={items:M.root.children,get label(){return O},set label(W){O=W,M.root.label=W,$.$updateController(A,{label:O})},get refreshHandler(){return N},set refreshHandler(W){N=W,$.$updateController(A,{canRefresh:!!W})},get id(){return A},createRunProfile:(W,H,x,J,ne)=>{let se=(0,I.hash)(W);for(;V.has(se);)se++;const K=new h(this.proxy,A,se,W,H,x,J,ne);return V.set(se,K),K},createTestItem(W,H,x){return new p.TestItemImpl(A,W,H,x)},createTestRun:(W,H,x=!0)=>this.runTracker.createTestRun(A,M,W,H,x),set resolveHandler(W){M.resolveHandler=W},get resolveHandler(){return M.resolveHandler},dispose:()=>{F.dispose()}};$.$registerTestController(A,O,!!N),F.add((0,_.toDisposable)(()=>$.$unregisterTestController(A)));const B={controller:U,collection:M,profiles:V};return this.controllers.set(A,B),F.add((0,_.toDisposable)(()=>this.controllers.delete(A))),F.add(M.onDidGenerateDiff(W=>$.$publishDiff(A,W))),U}createTestObserver(){return this.observer.checkout()}async runTests(A,O=k.CancellationToken.None){const N=r(A);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(N.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(M=>M.id)??[F.collection.root.id],profileGroup:v[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:A.exclude?.map(M=>M.id)},O)}$provideFileCoverage(A,O,N){return(0,f.mapFind)(this.runTracker.trackers,M=>M.id===A?M.getCoverage(O):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(A,O,N,F){return(0,f.mapFind)(this.runTracker.trackers,V=>V.id===A?V.getCoverage(O):void 0)?.resolveFileCoverage(N,F)??Promise.resolve([])}$configureRunProfile(A,O){this.controllers.get(A)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(A,O){await this.controllers.get(A)?.controller.refreshHandler?.(O)}$publishTestResults(A){this.results=Object.freeze(A.map(O=>(0,P.deepFreeze)(g.TestResults.to(O))).concat(this.results).sort((O,N)=>N.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,O){const N=this.controllers.get(a.TestId.fromString(A).controllerId)?.collection;N&&(await N.expand(A,O<0?1/0:O),N.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,O){const N=this.controllers.get(A.controllerId);if(!N)return;const{collection:F,profiles:M}=N,V=M.get(A.profileId);if(!V)return;const $=A.testIds.map(H=>F.tree.get(H)).filter(R.isDefined),U=A.excludeExtIds.map(H=>N.collection.tree.get(H)).filter(R.isDefined).filter(H=>$.some(x=>x.fullId.compare(H.fullId)===2));if(!$.length)return;const B=new E.TestRunRequest($.some(H=>H.actual instanceof p.TestItemRootImpl)?void 0:$.map(H=>H.actual),U.map(H=>H.actual),V),W=this.runTracker.prepareForMainThreadTestRun(B,i.fromInternal(A,N.collection),O);try{await V.runHandler(B,O)}finally{W.isRunning&&!O.isCancellationRequested&&await D.Event.toPromise(W.onEnd),W.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};m=je([He(0,b.IExtHostRpcService)],m),e.ExtHostTesting=m;class o extends _.Disposable{constructor(A,O,N){super();this.dto=A,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new D.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const O=this.dto.id,N=this.dto.controllerId,F=(0,y.generateUuid)(),M=new n(this.proxy,O,F),V=W=>(H,...x)=>{if(U){console.warn(`Setting the state of test "${H.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(H)||(this.ensureTestIsKnown(H),W(H,...x))},$=(W,H)=>{const x=H instanceof Array?H.map(g.TestMessage.from):[g.TestMessage.from(H)];if(W.uri&&W.range){const J={range:g.Range.from(W.range),uri:W.uri};for(const ne of x)ne.location=ne.location||J}this.proxy.$appendTestMessagesInRun(O,F,a.TestId.fromExtHostTestItem(W,N).toString(),x)};let U=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return M.coverageProvider},set coverageProvider(W){M.coverageProvider=W},enqueued:V(W=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(W,N).toString(),1)}),skipped:V(W=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(W,N).toString(),5)}),started:V(W=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(W,N).toString(),2)}),errored:V((W,H,x)=>{$(W,H),this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(W,N).toString(),6,x)}),failed:V((W,H,x)=>{$(W,H),this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(W,N).toString(),4,x)}),passed:V((W,H)=>{this.proxy.$updateTestStateInRun(O,F,a.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString(),3,H)}),appendOutput:(W,H,x)=>{U||(x&&(this.dto.isIncluded(x)?this.ensureTestIsKnown(x):x=void 0),this.proxy.$appendOutputToRun(O,F,t.VSBuffer.fromString(W),H&&g.location.from(H),x&&a.TestId.fromExtHostTestItem(x,N).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(O,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:B,coverage:M}),this.proxy.$startedTestRunTask(O,{id:F,name:A,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof p.TestItemImpl))throw new p.InvalidTestItemError(A.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const O=[],N=this.dto.colllection.root;for(;;){const F=g.TestItem.from(A);if(O.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),A===N))break;A=A.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class S{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,O,N){return this.getTracker(A,O,N)}cancelRunById(A){for(const O of this.tracked.values())if(O.id===A){O.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,O,N,F,M){const V=this.tracked.get(N);if(V)return V.createRun(F);const $=i.fromPublic(A,O,N,M),U=r(N);this.proxy.$startedExtensionTestRun({controllerId:A,profile:U&&{group:v[U.kind],id:U.profileId},exclude:N.exclude?.map(W=>W.id)??[],id:$.id,include:N.include?.map(W=>W.id)??[O.root.id],persist:M});const B=this.getTracker(N,$);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun($.id)),B.createRun(F)}getTracker(A,O,N){const F=new o(O,this.proxy,N);return this.tracked.set(A,F),F.onEnd(()=>this.tracked.delete(A)),F}}e.TestRunCoordinator=S;const r=w=>{if(!!w.profile){if(!(w.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return w.profile}};class i{constructor(A,O,N,F,M,V){this.controllerId=A,this.id=O,this.isPersisted=M,this.colllection=V,this.includePrefix=N.map($=>$+"\0"),this.excludePrefix=F.map($=>$+"\0")}static fromPublic(A,O,N,F){return new i(A,(0,y.generateUuid)(),N.include?.map(M=>a.TestId.fromExtHostTestItem(M,A).toString())??[A],N.exclude?.map(M=>a.TestId.fromExtHostTestItem(M,A).toString())??[],F,O)}static fromInternal(A,O){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,O)}isIncluded(A){const O=a.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(O===N||O.startsWith(N))return!1;for(const N of this.includePrefix)if(O===N||O.startsWith(N))return!0;return!1}}e.TestRunDto=i;class n{constructor(A,O,N){this.proxy=A,this.runId=O,this.taskId=N}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(A,O){const N=await this.fileCoverage;let F=N?.[A];return!this._coverageProvider||!N||!F?[]:(F.detailedCoverage||(F=N[A]=await this._coverageProvider.resolveFileCoverage?.(F,O)??F),F.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class u extends C.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,g.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:O,removed:N}=this;return{get added(){return[...A].map(F=>F.revived)},get updated(){return[...O].map(F=>F.revived)},get removed(){return[...N].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new D.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,O){return{...A,revived:g.TestItem.toPlain(A.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=c;class d{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(O=>O.revived)},dispose:(0,T.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class h{constructor(A,O,N,F,M,V,$=!1,U=void 0){this.controllerId=O,this.profileId=N,this._label=F,this.kind=M,this.runHandler=V,this._isDefault=$,this._tag=U,s.set(this,void 0),nt(this,s,A,"f");const B=v[M];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Le(this,s,"f").$publishTestRunProfile({profileId:N,controllerId:O,tag:U?g.TestTag.namespace(this.controllerId,U.id):null,label:F,group:B,isDefault:$,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?g.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Le(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Le(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,s=new WeakMap;const v={[E.TestRunProfileKind.Coverage]:8,[E.TestRunProfileKind.Debug]:4,[E.TestRunProfileKind.Run]:2}}),define(pe[251],ve([0,1,3,17,5,130,15,7]),function(Z,e,f,t,k,D,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(R,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const y=this._extHostDocumentsAndEditors.allEditors();return R?y:y.map(l=>l.value)}async showTextDocument(R,y,l){let b;typeof y=="number"?b={position:T.ViewColumn.from(y),preserveFocus:l}:typeof y=="object"?b={position:T.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?T.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const p=await this._proxy.$tryShowTextDocument(R.uri,b),g=p&&this._extHostDocumentsAndEditors.getEditor(p);if(g)return g.value;throw p?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,y){return new D.TextEditorDecorationType(this._proxy,R,y).value}$acceptEditorPropertiesChanged(R,y){const l=this._extHostDocumentsAndEditors.getEditor(R);if(!l)throw new Error("unknown text editor");if(y.options&&l._acceptOptions(y.options),y.selections){const b=y.selections.selections.map(T.Selection.to);l._acceptSelections(b)}if(y.visibleRanges){const b=t.coalesce(y.visibleRanges.map(T.Range.to));l._acceptVisibleRanges(b)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...y.options,lineNumbers:T.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const b=I.TextEditorSelectionChangeKind.fromValue(y.selections.source),p=y.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:p,kind:b})}if(y.visibleRanges){const b=t.coalesce(y.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(R){for(const y in R){const l=this._extHostDocumentsAndEditors.getEditor(y);if(!l)throw new Error("Unknown text editor");const b=T.ViewColumn.to(R[y]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=_}),define(pe[252],ve([0,1,2,4,5,6,7]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(R,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(k.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const b=l.uri===void 0?void 0:f.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(b))?.get(l.handle)}return l}})}async $getTimeline(R,y,l,b,p){return this._providers.get(R)?.provideTimeline(f.URI.revive(y),l,b,p)}registerTimelineProvider(R,y,l,b){const p=new D.DisposableStore,g=this.convertTimelineItem(y.id,b,p).bind(this);let E;y.onDidChange&&(E=y.onDidChange(C=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:y.id}),this));const L=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:R,onDidChange:void 0,async provideTimeline(C,a,s,m){m?.resetCache&&(p.clear(),L.get(y.id)?.clear());const o=await y.provideTimeline(C,a,s);if(o==null)return;const S=g(C,m);return{...o,source:y.id,items:o.items.map(S)}},dispose(){for(const C of L.values())C.get(y.id)?.clear();E?.dispose(),p.dispose()}})}convertTimelineItem(R,y,l){return(b,p)=>{let g;if(p?.cacheResults){let E=this._itemsBySourceAndUriMap.get(R);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(R,E));const L=_(b);g=E.get(L),g===void 0&&(g=new Map,E.set(L,g))}return E=>{const{iconPath:L,...C}=E,a=`${R}|${E.id??E.timestamp}`;g?.set(a,E);let s,m,o;return E.iconPath&&(L instanceof T.ThemeIcon?o={id:L.id,color:L.color}:f.URI.isUri(L)?(s=L,m=L):{light:s,dark:m}=L),{...C,id:C.id??void 0,handle:a,source:R,command:E.command?y.toInternal(E.command,l):void 0,icon:s,iconDark:m,themeIcon:o,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,D.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=I;function _(P){return P?.toString()}}),define(pe[253],ve([0,1,6,10,2,5]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(_){this._openers=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,P,R,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=y.schemes.find(b=>!T.supportedSchemes.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,y.schemes,_,y.label),(0,f.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(_,P,R){const y=this._openers.get(_);if(!y)throw new Error(`Unknown opener with id: ${_}`);const l=k.URI.revive(P);return y.canOpenExternalUri(l,R)}async $openUri(_,P,R){const y=this._openers.get(_);if(!y)throw new Error(`Unknown opener id: '${_}'`);return y.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(pe[254],ve([0,1,5,2,6,16,27]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=I.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(y,R),this._proxy.$registerUriHandler(y,P),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,R){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(t.URI.revive(R))}catch(l){(0,D.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(P){return t.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=I,I.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[69],ve([0,1,3,10,2,179,204,87,5]),function(Z,e,f,t,k,D,T,I,_){"use strict";var P,R,y,l,b,p,g,E,L,C,a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(d,h,v,w,A,O,N){P.set(this,void 0),R.set(this,void 0),y.set(this,void 0),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,""),E.set(this,void 0),L.set(this,!1),C.set(this,!1),a.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new f.Emitter),this._onDidDispose=Le(this,s,"f").event,nt(this,P,d,"f"),nt(this,R,h,"f"),nt(this,E,v,"f"),nt(this,l,w,"f"),nt(this,b,A,"f"),nt(this,p,O,"f"),nt(this,a,o(O),"f"),nt(this,y,N,"f")}dispose(){nt(this,L,!0,"f"),Le(this,s,"f").fire(),Le(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,C,!0,"f"),(0,I.asWebviewUri)(d,Le(this,l,"f").remote)}get cspSource(){const d=Le(this,p,"f").extensionLocation;if(d.scheme===t.Schemas.https||d.scheme===t.Schemas.http){let h=d.toString();return h.endsWith("/")||(h+="/"),h+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Le(this,g,"f")}set html(d){this.assertNotDisposed(),Le(this,g,"f")!==d&&(nt(this,g,d,"f"),!Le(this,C,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,C,!0,"f"),Le(this,y,"f").report("Webview vscode-resource: uris",Le(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,R,"f").$setHtml(Le(this,P,"f"),d))}get options(){return this.assertNotDisposed(),Le(this,E,"f")}set options(d){this.assertNotDisposed(),Le(this,R,"f").$setOptions(Le(this,P,"f"),i(Le(this,p,"f"),Le(this,b,"f"),d)),nt(this,E,d,"f")}async postMessage(d){if(Le(this,L,"f"))return!1;const h=(0,T.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Le(this,a,"f")});return Le(this,R,"f").$postMessage(Le(this,P,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Le(this,L,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,P=new WeakMap,R=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,C=new WeakMap,a=new WeakMap,s=new WeakMap;function o(c){try{const d=(0,D.normalizeVersion)((0,D.parseVersion)(c.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class S{constructor(d,h,v,w,A){this.initData=h,this.workspace=v,this._logService=w,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=d.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(d,h,v){const w=this.getWebview(d);if(w){const{message:A}=(0,T.deserializeWebviewMessage)(h,v.value);w._onMessageEmitter.fire(A)}}$onMissingCsp(d,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,h,v){const w=new m(d,this._webviewProxy,n(h),this.initData,this.workspace,v,this._deprecationService);return this._webviews.set(d,w),w._onDidDispose(()=>{this._webviews.delete(d)}),w}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=S;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function i(c,d,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||u(c,d)}}e.serializeWebviewOptions=i;function n(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(d=>k.URI.from(d))}}e.reviveOptions=n;function u(c,d){return[...(d?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(pe[255],ve([0,1,21,58,6,10,23,2,15,69,86,5,7]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(o,S){this.document=o,this._storagePath=S,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,S){await this.getEdit(o).undo(),S||this.disposeBackup()}async redo(o,S){await this.getEdit(o).redo(),S||this.disposeBackup()}disposeEdits(o){for(const S of o)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=s(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const S=this._edits.get(o,0);if(!S)throw new Error("No edit found");return S}}class p{constructor(){this._documents=new Map}get(o,S){return this._documents.get(this.key(o,S))}add(o,S,r){const i=this.key(o,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${o} resource:${S.uri}`);const n=new b(S,r);return this._documents.set(i,n),n}delete(o,S){const r=this.key(o,S.uri);this._documents.delete(r)}key(o,S){return`${o}@@@${S}`}}var g;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(g||(g={}));class E{constructor(){this._providers=new Map}addTextProvider(o,S,r){return this.add(0,o,S,r)}addCustomProvider(o,S,r){return this.add(1,o,S,r)}get(o){return this._providers.get(o)}add(o,S,r,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:o,extension:r,provider:i}),new l.Disposable(()=>this._providers.delete(S))}}class L{constructor(o,S,r,i,n){this._extHostDocuments=S,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=n,this._editorProviders=new E,this._documents=new p,this._proxy=o.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,S,r,i){const n=new k.DisposableStore;return C(r)?(n.add(this._editorProviders.addTextProvider(S,o,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(o),S,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(o))):(n.add(this._editorProviders.addCustomProvider(S,o,r)),this.supportEditing(r)&&n.add(r.onDidChangeCustomDocument(u=>{const c=this.getCustomDocumentEntry(S,u.document.uri);if(a(u)){const d=c.addEdit(u);this._proxy.$onDidEdit(u.document.uri,S,d,u.label)}else this._proxy.$onContentChange(u.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(o),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(o))),l.Disposable.from(n,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(o,S,r,i,n){const u=this._editorProviders.get(S);if(!u)throw new Error(`No provider found for '${S}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${S}'`);const c=I.URI.revive(o),d=await u.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:i?.buffer},n);let h;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(S,d,h),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(o,S){const r=this._editorProviders.get(S);if(!r)throw new Error(`No provider found for '${S}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=I.URI.revive(o),{document:n}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,n),n.dispose()}async $resolveWebviewEditor(o,S,r,i,n,u){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const d=_.ViewColumn.to(n),h=this._extHostWebview.createNewWebview(S,i.webviewOptions,c.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(S,r,i.title,d,i.panelOptions,h),w=I.URI.revive(o);switch(c.type){case 1:{const{document:A}=this.getCustomDocumentEntry(r,w);return c.provider.resolveCustomEditor(A,v,u)}case 0:{const A=this._extHostDocuments.getDocument(w);return c.provider.resolveCustomTextEditor(A,v,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,S,r){this.getCustomDocumentEntry(S,o).disposeEdits(r)}async $onMoveCustomEditor(o,S,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const n=this._extHostWebviewPanels.getWebviewPanel(o);if(!n)throw new Error("No webview found");const u=I.URI.revive(S),c=this._extHostDocuments.getDocument(u);await i.provider.moveCustomTextEditor(c,n,f.CancellationToken.None)}async $undo(o,S,r,i){return this.getCustomDocumentEntry(S,o).undo(r,i)}async $redo(o,S,r,i){return this.getCustomDocumentEntry(S,o).redo(r,i)}async $revert(o,S,r){const i=this.getCustomDocumentEntry(S,o);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(o,S,r){const i=this.getCustomDocumentEntry(S,o);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(o,S,r,i){const n=this.getCustomDocumentEntry(S,o);return this.getCustomEditorProvider(S).saveCustomDocumentAs(n.document,I.URI.revive(r),i)}async $backup(o,S,r){const i=this.getCustomDocumentEntry(S,o),u=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(u),u.id}getCustomDocumentEntry(o,S){const r=this._documents.get(o,I.URI.revive(S));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=L;function C(m){return typeof m.resolveCustomTextEditor=="function"}function a(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function s(m){const o=m.scheme===D.Schemas.file||m.scheme===D.Schemas.untitled?m.fsPath:m.toString();return(0,t.hash)(o)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[256],ve([0,1,3,6,2,33,15,69,5,7]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";var R,y,l,b,p,g,E,L,C,a,s,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(u,c,d,h,v,w,A){super();R.set(this,void 0),y.set(this,void 0),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),E.set(this,void 0),L.set(this,void 0),C.set(this,!0),a.set(this,!0),s.set(this,!1),m.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,m,"f").event,o.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Le(this,o,"f").event,nt(this,R,u,"f"),nt(this,y,c,"f"),nt(this,l,d,"f"),nt(this,p,w,"f"),nt(this,L,v,"f"),nt(this,g,h,"f"),nt(this,b,A,"f")}dispose(){Le(this,s,"f")||(nt(this,s,!0,"f"),Le(this,m,"f").fire(),Le(this,y,"f").$disposeWebview(Le(this,R,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Le(this,b,"f")}get viewType(){return this.assertNotDisposed(),Le(this,l,"f")}get title(){return this.assertNotDisposed(),Le(this,g,"f")}set title(u){this.assertNotDisposed(),Le(this,g,"f")!==u&&(nt(this,g,u,"f"),Le(this,y,"f").$setTitle(Le(this,R,"f"),u))}get iconPath(){return this.assertNotDisposed(),Le(this,E,"f")}set iconPath(u){this.assertNotDisposed(),Le(this,E,"f")!==u&&(nt(this,E,u,"f"),Le(this,y,"f").$setIconPath(Le(this,R,"f"),k.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Le(this,p,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Le(this,L,"f")=="number"&&Le(this,L,"f")<0))return Le(this,L,"f")}get active(){return this.assertNotDisposed(),Le(this,a,"f")}get visible(){return this.assertNotDisposed(),Le(this,C,"f")}_updateViewState(u){Le(this,s,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(nt(this,a,u.active,"f"),nt(this,C,u.visible,"f"),nt(this,L,u.viewColumn,"f"),Le(this,o,"f").fire({webviewPanel:this}))}reveal(u,c){this.assertNotDisposed(),Le(this,y,"f").$reveal(Le(this,R,"f"),{viewColumn:u?T.ViewColumn.from(u):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Le(this,s,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,C=new WeakMap,a=new WeakMap,s=new WeakMap,m=new WeakMap,o=new WeakMap;class r{constructor(u,c,d){this.webviews=c,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,D.generateUuid)()}createWebviewPanel(u,c,d,h,v={}){const w=typeof h=="object"?h.viewColumn:h,A={viewColumn:T.ViewColumn.from(w),preserveFocus:typeof h=="object"&&!!h.preserveFocus},O=(0,I.shouldSerializeBuffersForPostMessage)(u),N=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(u),N,c,{title:d,panelOptions:i(v),webviewOptions:(0,I.serializeWebviewOptions)(u,this.workspace,v),serializeBuffersForPostMessage:O},A);const F=this.webviews.createNewWebview(N,v,u);return this.createNewWebviewPanel(N,c,d,w,v,F)}$onDidChangeWebviewPanelViewStates(u){const c=Object.keys(u);c.sort((d,h)=>{const v=u[d],w=u[h];return v.active?1:w.active?-1:+v.visible-+w.visible});for(const d of c){const h=this.getWebviewPanel(d);if(!h)continue;const v=u[d];h._updateViewState({active:v.active,visible:v.visible,viewColumn:T.ViewColumn.to(v.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,c,d){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:d,extension:u}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(u)}),new P.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(u,c,d,h){const v=this._serializers.get(c);if(!v)throw new Error(`No serializer found for '${c}'`);const{serializer:w,extension:A}=v,O=this.webviews.createNewWebview(u,d.webviewOptions,A),N=this.createNewWebviewPanel(u,c,d.title,h,d.panelOptions,O);await w.deserializeWebviewPanel(N,d.state)}createNewWebviewPanel(u,c,d,h,v,w){const A=new S(u,this._proxy,c,d,h,v,w);return this._webviewPanels.set(u,A),A}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=r;function i(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[257],ve([0,1,3,6,69,5,7]),function(Z,e,f,t,k,D,T){"use strict";var I,_,P,R,y,l,b,p,g,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class L extends t.Disposable{constructor(s,m,o,S,r,i){super();I.set(this,void 0),_.set(this,void 0),P.set(this,void 0),R.set(this,void 0),y.set(this,!1),l.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Le(this,g,"f").event,E.set(this,this._register(new f.Emitter)),this.onDidDispose=Le(this,E,"f").event,nt(this,P,o,"f"),nt(this,b,S,"f"),nt(this,I,s,"f"),nt(this,_,m,"f"),nt(this,R,r,"f"),nt(this,l,i,"f")}dispose(){Le(this,y,"f")||(nt(this,y,!0,"f"),Le(this,E,"f").fire(),Le(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Le(this,b,"f")}set title(s){this.assertNotDisposed(),Le(this,b,"f")!==s&&(nt(this,b,s,"f"),Le(this,_,"f").$setWebviewViewTitle(Le(this,I,"f"),s))}get description(){return this.assertNotDisposed(),Le(this,p,"f")}set description(s){this.assertNotDisposed(),Le(this,p,"f")!==s&&(nt(this,p,s,"f"),Le(this,_,"f").$setWebviewViewDescription(Le(this,I,"f"),s))}get visible(){return Le(this,l,"f")}get webview(){return Le(this,R,"f")}get viewType(){return Le(this,P,"f")}_setVisible(s){s===Le(this,l,"f")||Le(this,y,"f")||(nt(this,l,s,"f"),Le(this,g,"f").fire())}show(s){this.assertNotDisposed(),Le(this,_,"f").$show(Le(this,I,"f"),!!s)}assertNotDisposed(){if(Le(this,y,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,_=new WeakMap,P=new WeakMap,R=new WeakMap,y=new WeakMap,l=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,E=new WeakMap;class C{constructor(s,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,m,o,S){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:o,extension:s}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(s),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(s,m,o,S,r){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:n,extension:u}=i,c=this._extHostWebview.createNewWebview(s,{},u),d=new L(s,this._proxy,m,o,c,!0);this._webviewViews.set(s,d),await n.resolveWebviewView(d,{state:S},r)}async $onDidChangeWebviewViewVisibility(s,m){this.getWebviewView(s)._setVisible(m)}async $disposeWebviewView(s){const m=this.getWebviewView(s);this._webviewViews.delete(s),m.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const m=this._webviewViews.get(s);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=C}),define(pe[134],ve([0,1,3,5,2,10,8,4,14]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class ji{constructor(y){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=y.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,l){let b;if(typeof y=="string"){b=y;try{y=k.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,T.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,b,l)}async asExternalUri(y,l){if((0,T.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this._proxy.$asExternalUri(y,l);return k.URI.from(b)}};P.InitialState={focused:!0},P=je([He(0,_.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(pe[258],ve([0,1,9,81,33,38,6,5,2,14]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends T.Disposable{constructor(l,b){super();const p=l.getProxy(I.MainContext.MainThreadDownloadService);b.registerCommand(!1,"_workbench.downloadResource",async g=>{const E=_.URI.file((0,f.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await p.$download(g,E),E})}};R=je([He(0,P.IExtHostRpcService),He(1,D.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(pe[259],ve([0,1,132,10,188,33]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends f.ExtHostLoggerService{doCreateLogger(_,P,R){return _.scheme===t.Schemas.file?new k.SpdLogLogger(R?.name||(0,D.generateUuid)(),_.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,P):super.doCreateLogger(_,P,R)}}e.ExtHostLoggerService=T}),define(pe[260],ve([0,1,60,9,2,68,6,10,18,30]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends D.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const S=await super._getWorkspaceStorageURI(o);if(S.scheme!==I.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const r=S.fsPath;let i=0;do{let n;i===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${i}`:`${r}-${i}`,await y(n);const u=t.join(n,"vscode.lock"),c=await g(this._logService,u,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),k.URI.file(n);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function y(m){try{await P.Promises.stat(m);return}catch{}try{await P.Promises.mkdir(m,{recursive:!0})}catch{}}const l=1e3,b=10*60*1e3;class p extends T.Disposable{constructor(o,S){super();this.logService=o,this.filename=S,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await E(o,S);(!r||r.pid!==process.pid)&&(o.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(S,new Date,new Date)}catch(i){o.error(i),o.info(`Lock '${S}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+o};await P.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function g(m,o,S){try{const i={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(o,JSON.stringify(i),{flag:"wx"})}catch(i){m.error(i)}const r=await E(m,o);return!r||r.pid!==process.pid?S?(m.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),a(m,o)):(m.info(`Lock '${o}': Lock acquired.`),new p(m,o))}async function E(m,o){let S;try{S=await P.Promises.readFile(o)}catch(r){return m.error(r),null}try{return JSON.parse(String(S))}catch(r){return m.error(r),null}}async function L(m,o){let S;try{S=await P.Promises.stat(o)}catch(r){return m.error(r),0}return S.mtime.getTime()}function C(m){try{return process.kill(m,0),!0}catch{return!1}}async function a(m,o){const S=await E(m,o);if(!S)return m.info(`Lock '${o}': Could not read pid of lock holder.`),s(m,o);if(S.willReleaseAt){let c=S.willReleaseAt-Date.now();if(c<5e3){for(c>0?m.info(`Lock '${o}': The lockfile is scheduled to be released in ${c} ms.`):m.info(`Lock '${o}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,_.timeout)(Math.min(100,c)),await L(m,o)===0)return s(m,o);c=S.willReleaseAt-Date.now()}return s(m,o)}}if(!C(S.pid))return m.info(`Lock '${o}': The pid ${S.pid} appears to be gone.`),s(m,o);const r=await L(m,o),i=Date.now()-r;if(i<=b)return m.info(`Lock '${o}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;m.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const n=await L(m,o),u=Date.now()-n;return u<=b?(m.info(`Lock '${o}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(m.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),s(m,o))}async function s(m,o){m.info(`Lock '${o}': Deleting a stale lock.`);try{await P.Promises.unlink(o)}catch{}return g(m,o,!0)}}),define(pe[261],ve([0,1,33,14,34]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let D=class extends k.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,_,P){return this.createTerminalFromOptions({name:I,shellPath:_,shellArgs:P})}createTerminalFromOptions(I,_){const P=new k.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),I,I.name);return this._terminals.push(P),P.create(I,this._serializeParentTerminal(I,_)),P.value}};D=je([He(0,t.IExtHostRpcService)],D),e.ExtHostTerminalService=D}),define(pe[262],ve([0,1,5,14,171,6,26,2,37,23,30,7,12,51,3,121,94,11]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class C{constructor(d,h,v){this.remoteAddress=d,this.localAddress=h,this._dispose=v,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function a(c){const d=c.trim().split(`
`),h=[];return d.forEach(w=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);A&&A.length>=3&&h.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),h.reduce((w,A)=>(w[A.socket]=A,w),{})}e.getSockets=a;function s(...c){const d=[].concat(...c.map(o));return[...new Map(d.filter(h=>h.st==="0A").map(h=>{const v=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(v[0]),port:parseInt(v[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=s;function m(c){let d="";if(c.length===8)for(let h=c.length-2;h>=0;h-=2)d+=parseInt(c.substr(h,2),16),h!==0&&(d+=".");else for(let h=c.length-4;h>=0;h-=4)d+=parseInt(c.substr(h,4),16).toString(16),h!==0&&(d+=":");return d}e.parseIpAddress=m;function o(c){const d=c.trim().split(`
`),h=d.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return d.map(w=>w.trim().split(/\s+/).reduce((A,O,N)=>(A[h[N]||N]=O,A),{}))}e.loadConnectionTable=o;function S(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const d=c.trim().split(`
`),h=[];return d.forEach(v=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(v);w&&w.length>=4&&h.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),h}e.getRootProcesses=r;async function i(c,d,h){const v=h.reduce((A,O)=>(A[O.pid]=O,A),{}),w=[];return c.forEach(({socket:A,ip:O,port:N})=>{const F=d[A]?d[A].pid:void 0,M=F?v[F]?.cmd:void 0;F&&M&&!S(M)&&w.push({host:O,port:N,detail:M,pid:F})}),w}e.findPorts=i;function n(c,d,h){const v=new Map,w=r(d);for(const A of c){const O=h.get(A.port);if(O){v.set(A.port,O);continue}const N=w.find(F=>F.cmd.includes(`${A.port}`));if(N){let F=N,M;do M=w.find(V=>V.ppid===F.pid),M&&(F=M);while(M);v.set(A.port,{host:A.ip,port:A.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else v.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return v}e.tryFindRootPorts=n;let u=class extends D.Disposable{constructor(d,h,v){super();this.logService=v,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(f.MainContext.MainThreadTunnelService),l.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const v=await this._proxy.$openTunnel(h,d.displayName);if(v){const w=new C(v.remoteAddress,v.localAddress,()=>this._proxy.$closeTunnel(v.remoteAddress));return this._register(w),w}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,h){const v=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(v,{selector:d,provider:h}),this._proxy.$registerPortsAttributesProvider(d,v),new y.Disposable(()=>{this._portAttributesProviders.delete(v),this._proxy.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(d,h,v,w,A){const O=[];for(const F of d){const M=this._portAttributesProviders.get(F);if(!M)return[];O.push(...await Promise.all(h.map(async V=>M.provider.providePortAttributes(V,v,w,A))))}const N=O.filter(F=>!!F);return N.length>0?N.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let h=new E.MovingAverage,v;for(;this._candidateFindingEnabled;){const w=new Date().getTime(),A=(await this.findCandidatePorts()).filter(N=>(0,g.isLocalhost)(N.host)||(0,g.isAllInterfaces)(N.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map(N=>N.port).join(", ")}`);const O=new Date().getTime()-w;h.update(O),(!v||JSON.stringify(v)!==JSON.stringify(A))&&(v=A,await this._proxy.$onFoundNewCandidates(v)),await new Promise(N=>setTimeout(()=>N(),this.calculateDelay(h.value)))}}async setTunnelFactory(d){if(d){if(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory){this._forwardPortProvider=d.tunnelFactory;let h=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const v=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(v)}}else this._forwardPortProvider=void 0;return(0,D.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,h){if(this._extensionTunnels.has(d.host)){const v=this._extensionTunnels.get(d.host);v.has(d.port)&&(h&&v.get(d.port).disposeListener.dispose(),await v.get(d.port).tunnel.dispose(),v.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this._forwardPortProvider(d,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const w=await v;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const A=this._register(w.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(w.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:w,disposeListener:A}),b.TunnelDto.fromApiTunnel(w)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const h=await Promise.all(d.map(w=>this._showCandidatePort(w.host,w.port,w.detail??""))),v=d.filter((w,A)=>h[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(w=>w.port).join(", ")} to ${v.map(w=>w.port).join(", ")}`),v}async findCandidatePorts(){let d="",h="";try{d=await R.Promises.readFile("/proc/net/tcp","utf8"),h=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const v=s(d,h),w=await new Promise(U=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,W,H)=>{U(W)})}),A=a(w),O=await R.Promises.readdir("/proc"),N=[];for(let U of O)try{const B=Number(U),W=P.joinPath(I.URI.file("/proc"),U);if((await R.Promises.stat(W.fsPath)).isDirectory()&&!isNaN(B)){const x=await R.Promises.readlink(P.joinPath(W,"cwd").fsPath),J=await R.Promises.readFile(P.joinPath(W,"cmdline").fsPath,"utf8");N.push({pid:B,cwd:x,cmd:J})}}catch{}const F=[],M=v.filter(U=>{const B=A[U.socket];return B||F.push(U),B}),V=i(M,A,N);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(B=>{(0,_.exec)("ps -F -A -l | grep root",(W,H,x)=>{B(H)})});this._foundRootPorts=n(F,U,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return V.then(U=>$?U.concat($):U)}};u=je([He(0,t.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,L.ILogService)],u),e.ExtHostTunnelService=u}),define(pe[263],ve([0,1,18,22,21,16,3,6,103,226,52]),function(Z,e,f,t,k,D,T,I,_,P,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(v,w){try{return JSON.stringify(v,w)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class g{constructor(w,A){this.jsonString=w,this.referencedBuffers=A}}function E(v,w=null,A=!1){const O=[];return{jsonString:(A?l:JSON.stringify)(v,(F,M)=>{if(typeof M=="undefined")return p;if(typeof M=="object"){if(M instanceof t.VSBuffer){const V=O.push(M)-1;return{[b]:V}}if(w)return w(F,M)}return M}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=E;function L(v,w,A){return JSON.parse(v,(O,N)=>{if(N){const F=N[b];if(typeof F=="number")return w[F];if(A&&N.$mid===1)return A.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=L;function C(v,w){return JSON.stringify(v,w)}function a(v){return v?(w,A)=>A&&A.$mid===1?v.transformOutgoing(A):A:null}var s;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},S=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends I.Disposable{constructor(w,A=null,O=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=w,this._logger=A,this._uriTransformer=O,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,F=R.ProxyIdentifier.count;N<F;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(w=>{this._pendingRPCReplies[w].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(w){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(w){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(w){this._responsiveState!==w&&(this._responsiveState=w,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(w){return this._uriTransformer?(0,_.transformIncomingURIs)(w,this._uriTransformer):w}getProxy(w){const{nid:A,sid:O}=w;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,O)),this._proxies[A]}_createProxy(w,A){let O={get:(N,F)=>(typeof F=="string"&&!N[F]&&F.charCodeAt(0)===36&&(N[F]=(...M)=>this._remoteCall(w,F,M)),F===r?A:N[F])};return new Proxy(Object.create(null),O)}set(w,A){return this._locals[w.nid]=A,A}assertRegistered(w){for(let A=0,O=w.length;A<O;A++){const N=w[A];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(w){if(this._isDisposed)return;const A=w.byteLength,O=n.read(w,0),N=O.readUInt8(),F=O.readUInt32();switch(N){case 1:case 2:{let{rpcId:M,method:V,args:$}=c.deserializeRequestJSONArgs(O);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(A,F,M,V,$,N===2);break}case 3:case 4:{let{rpcId:M,method:V,args:$}=c.deserializeRequestMixedArgs(O);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(A,F,M,V,$,N===4);break}case 5:{this._logger&&this._logger.logIncoming(A,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(A,F);break}case 7:{this._receiveReply(A,F,void 0);break}case 9:{let M=c.deserializeReplyOKJSON(O);this._uriTransformer&&(M=(0,_.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(A,F,M);break}case 10:{const M=c.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(A,F,M);break}case 8:{let M=c.deserializeReplyOKVSBuffer(O);this._receiveReply(A,F,M);break}case 11:{let M=c.deserializeReplyErrError(O);this._uriTransformer&&(M=(0,_.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(A,F,M);break}case 12:{this._receiveReplyErr(A,F,void 0);break}default:console.error("received unexpected message"),console.error(w)}}_receiveRequest(w,A,O,N,F,M){this._logger&&this._logger.logIncoming(w,A,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(O)}.${N}(`,F);const V=String(A);let $,U;if(M){const W=new k.CancellationTokenSource;F.push(W.token),$=this._invokeHandler(O,N,F),U=()=>W.cancel()}else $=this._invokeHandler(O,N,F),U=o;this._cancelInvokedHandlers[V]=U;const B=c.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(B.byteLength,A,1,"ack"),this._protocol.send(B),$.then(W=>{delete this._cancelInvokedHandlers[V];const H=c.serializeReplyOK(A,W,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,A,1,"reply:",W),this._protocol.send(H)},W=>{delete this._cancelInvokedHandlers[V];const H=c.serializeReplyErr(A,W);this._logger&&this._logger.logOutgoing(H.byteLength,A,1,"replyErr:",W),this._protocol.send(H)})}_receiveCancel(w,A){this._logger&&this._logger.logIncoming(w,A,1,"receiveCancel");const O=String(A);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(w,A,O){this._logger&&this._logger.logIncoming(w,A,0,"receiveReply:",O);const N=String(A);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],F.resolveOk(O)}_receiveReplyErr(w,A,O){this._logger&&this._logger.logIncoming(w,A,0,"receiveReplyErr:",O);const N=String(A);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let M;O&&(O.$isError?(M=new Error,M.name=O.name,M.message=O.message,M.stack=O.stack):M=O),F.resolveErr(M)}_invokeHandler(w,A,O){try{return Promise.resolve(this._doInvokeHandler(w,A,O))}catch(N){return Promise.reject(N)}}_doInvokeHandler(w,A,O){const N=this._locals[w];if(!N)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(w));let F=N[A];if(typeof F!="function")throw new Error("Unknown method "+A+" on actor "+(0,R.getStringIdentifierForProxy)(w));return F.apply(N,O)}_remoteCall(w,A,O){if(this._isDisposed)return Promise.reject(D.canceled());let N=null;if(O.length>0&&k.CancellationToken.isCancellationToken(O[O.length-1])&&(N=O.pop()),N&&N.isCancellationRequested)return Promise.reject(D.canceled());const F=c.serializeRequestArguments(O,this._uriReplacer),M=++this._lastMessageId,V=String(M),$=new P.LazyPromise;N&&N.onCancellationRequested(()=>{const B=c.serializeCancel(M);this._logger&&this._logger.logOutgoing(B.byteLength,M,0,"cancel"),this._protocol.send(c.serializeCancel(M))}),this._pendingRPCReplies[V]=$,this._onWillSendRequest(M);const U=c.serializeRequest(M,w,A,F,!!N);return this._logger&&this._logger.logOutgoing(U.byteLength,M,0,`request: ${(0,R.getStringIdentifierForProxy)(w)}.${A}(`,O),this._protocol.send(U),$}}e.RPCProtocol=i,y=S,i.UNRESPONSIVE_TIME=3*1e3;class n{constructor(w,A){this._buff=w,this._offset=A}static alloc(w,A,O){let N=new n(t.VSBuffer.alloc(O+1+4),0);return N.writeUInt8(w),N.writeUInt32(A),N}static read(w,A){return new n(w,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(w){this._buff.writeUInt8(w,this._offset),this._offset+=1}readUInt8(){const w=this._buff.readUInt8(this._offset);return this._offset+=1,w}writeUInt32(w){this._buff.writeUInt32BE(w,this._offset),this._offset+=4}readUInt32(){const w=this._buff.readUInt32BE(this._offset);return this._offset+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this._buff.writeUInt8(w.byteLength,this._offset),this._offset+=1,this._buff.set(w,this._offset),this._offset+=w.byteLength}readShortString(){const w=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,O}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readLongString(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+w).toString();return this._offset+=w,O}writeBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this._buff.writeUInt32BE(w.byteLength,this._offset),this._offset+=4,this._buff.set(w,this._offset),this._offset+=w.byteLength}readVSBuffer(){const w=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+w);return this._offset+=w,A}static sizeMixedArray(w){let A=0;A+=1;for(let O=0,N=w.length;O<N;O++){const F=w[O];switch(A+=1,F.type){case 1:A+=this.sizeLongString(F.value);break;case 2:A+=this.sizeVSBuffer(F.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(F.value);for(let M=0;M<F.buffers.length;++M)A+=this.sizeVSBuffer(F.buffers[M]);break;case 4:break}}return A}writeMixedArray(w){this._buff.writeUInt8(w.length,this._offset),this._offset+=1;for(let A=0,O=w.length;A<O;A++){const N=w[A];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let F=0;F<N.buffers.length;++F)this.writeBuffer(N.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(w);for(let O=0;O<w;O++)switch(this.readUInt8()){case 1:A[O]=this.readLongString();break;case 2:A[O]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),M=this.readLongString(),V=[];for(let $=0;$<F;++$)V.push(this.readVSBuffer());A[O]=new R.SerializableObjectWithBuffers(L(M,V,null));break}case 4:A[O]=void 0;break}return A}}n.sizeUInt32=4;var u;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(u||(u={}));class c{static _useMixedArgSerialization(w){for(let A=0,O=w.length;A<O;A++)if(w[A]instanceof t.VSBuffer||w[A]instanceof R.SerializableObjectWithBuffers||typeof w[A]=="undefined")return!0;return!1}static serializeRequestArguments(w,A){if(this._useMixedArgSerialization(w)){const O=[];for(let N=0,F=w.length;N<F;N++){const M=w[N];if(M instanceof t.VSBuffer)O[N]={type:2,value:M};else if(typeof M=="undefined")O[N]={type:4};else if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:$}=E(M.value,A);O[N]={type:3,value:t.VSBuffer.fromString(V),buffers:$}}else O[N]={type:1,value:t.VSBuffer.fromString(C(M,A))}}return{type:1,args:O}}return{type:0,args:C(w,A)}}static serializeRequest(w,A,O,N,F){switch(N.type){case 0:return this._requestJSONArgs(w,A,O,N.args,F);case 1:return this._requestMixedArgs(w,A,O,N.args,F)}}static _requestJSONArgs(w,A,O,N,F){const M=t.VSBuffer.fromString(O),V=t.VSBuffer.fromString(N);let $=0;$+=n.sizeUInt8(),$+=n.sizeShortString(M),$+=n.sizeLongString(V);let U=n.alloc(F?2:1,w,$);return U.writeUInt8(A),U.writeShortString(M),U.writeLongString(V),U.buffer}static deserializeRequestJSONArgs(w){const A=w.readUInt8(),O=w.readShortString(),N=w.readLongString();return{rpcId:A,method:O,args:JSON.parse(N)}}static _requestMixedArgs(w,A,O,N,F){const M=t.VSBuffer.fromString(O);let V=0;V+=n.sizeUInt8(),V+=n.sizeShortString(M),V+=n.sizeMixedArray(N);let $=n.alloc(F?4:3,w,V);return $.writeUInt8(A),$.writeShortString(M),$.writeMixedArray(N),$.buffer}static deserializeRequestMixedArgs(w){const A=w.readUInt8(),O=w.readShortString(),N=w.readMixedArray(),F=new Array(N.length);for(let M=0,V=N.length;M<V;M++){const $=N[M];typeof $=="string"?F[M]=JSON.parse($):F[M]=$}return{rpcId:A,method:O,args:F}}static serializeAcknowledged(w){return n.alloc(5,w,0).buffer}static serializeCancel(w){return n.alloc(6,w,0).buffer}static serializeReplyOK(w,A,O){if(typeof A=="undefined")return this._serializeReplyOKEmpty(w);if(A instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(w,A);if(A instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:F}=E(A.value,O,!0);return this._serializeReplyOKJSONWithBuffers(w,N,F)}else return this._serializeReplyOKJSON(w,l(A,O))}static _serializeReplyOKEmpty(w){return n.alloc(7,w,0).buffer}static _serializeReplyOKVSBuffer(w,A){let O=0;O+=n.sizeVSBuffer(A);let N=n.alloc(8,w,O);return N.writeVSBuffer(A),N.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static _serializeReplyOKJSON(w,A){const O=t.VSBuffer.fromString(A);let N=0;N+=n.sizeLongString(O);let F=n.alloc(9,w,N);return F.writeLongString(O),F.buffer}static _serializeReplyOKJSONWithBuffers(w,A,O){const N=t.VSBuffer.fromString(A);let F=0;F+=n.sizeUInt32,F+=n.sizeLongString(N);for(const V of O)F+=n.sizeVSBuffer(V);let M=n.alloc(10,w,F);M.writeUInt32(O.length),M.writeLongString(N);for(const V of O)M.writeBuffer(V);return M.buffer}static deserializeReplyOKJSON(w){const A=w.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(w,A){const O=w.readUInt32(),N=w.readLongString(),F=[];for(let M=0;M<O;++M)F.push(w.readVSBuffer());return new R.SerializableObjectWithBuffers(L(N,F,A))}static serializeReplyErr(w,A){return A?this._serializeReplyErrEror(w,A):this._serializeReplyErrEmpty(w)}static _serializeReplyErrEror(w,A){const O=t.VSBuffer.fromString(l(D.transformErrorForSerialization(A),null));let N=0;N+=n.sizeLongString(O);let F=n.alloc(11,w,N);return F.writeLongString(O),F.buffer}static deserializeReplyErrError(w){const A=w.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(w){return n.alloc(12,w,0).buffer}}var d;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var h;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(h||(h={}))}),define(pe[264],ve([0,1,4]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(pe[265],ve([0,1,29,10,9,12,23,2,4,63,43,221,264]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let b=class qi{constructor(g,E,L,C){this.localUserHome=g,this.remoteAgentService=E,this.environmentService=L,this.contextService=C,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome||g})()}hasValidBasename(g,E,L){return typeof E=="string"||typeof E=="undefined"?this.resolveOS.then(C=>this.doHasValidBasename(g,C,E)):this.doHasValidBasename(g,E,L)}doHasValidBasename(g,E,L){return g.scheme===t.Schemas.file||g.scheme===t.Schemas.vscodeRemote?(0,f.isValidBasename)(L??(0,T.basename)(g),E===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,E){if(g.remoteAuthority)return t.Schemas.vscodeRemote;const L=(0,P.getVirtualWorkspaceScheme)(E.getWorkspace());if(L)return L;const C=E.getWorkspace().folders[0];if(C)return C.uri.scheme;const a=E.getWorkspace().configuration;return a?a.scheme:t.Schemas.file}async userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?k.win32:k.posix)}async fileURI(g){let E="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const C=g.indexOf("/",2);C===-1?(E=g.substring(2),g="/"):(E=g.substring(2,C),g=g.substring(C)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:E,path:g,query:"",fragment:""})}};b=je([He(1,l.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,R.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(pe[70],ve([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(T,I){this.line=T,this.character=I}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,I){return new f(0,0)}with(T){return new f(0,0)}}e.Position=f;class t{constructor(T,I,_,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(T,I),this.end=new f(_,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new t(0,0,0,0)}with(T){return new t(0,0,0,0)}}e.Range=t;var k;(function(D){D[D.Information=1]="Information",D[D.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([0,1,17,32,25,29,8,4,9,16,70,13]),function(Z,e,f,t,k,D,T,I,_,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",p=(l.length+b.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var g;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var E;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(E=e.QueryType||(e.QueryType={}));function L(B){return!!B.preview}e.resultIsMatch=L;function C(B){return!!B.resource}e.isFileMatch=C;function a(B){return!!B.message}e.isProgressMessage=a;var s;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(W){this.resource=W,this.results=[]}}e.FileMatch=m;class o{constructor(W,H,x){this.ranges=H;const J=Array.isArray(H)?H:[H];if(x&&x.matchLines===1&&S(J)){W=(0,T.getNLines)(W,x.matchLines);let ne="",se=0,K=0;const Q=Math.floor(x.charsPerLine/5),ae=[];for(const fe of J){const be=Math.max(fe.startColumn-Q,0),Me=fe.startColumn+x.charsPerLine;if(be>K+Q+p){const ze=l+(be-K)+b;ne+=ze+W.slice(be,Me),se+=be-(K+ze.length)}else ne+=W.slice(K,Me);ae.push(new i(0,fe.startColumn-se,fe.endColumn-se)),K=Me}this.preview={text:ne,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const ne=Array.isArray(H)?H[0].startLineNumber:H.startLineNumber;this.preview={text:W,matches:(0,f.mapArrayOrNot)(H,se=>new r(se.startLineNumber-ne,se.startColumn,se.endLineNumber-ne,se.endColumn))}}}}e.TextSearchMatch=o;function S(B){const W=B[0].startLineNumber;for(const H of B)if(H.startLineNumber!==W||H.endLineNumber!==W)return!1;return!0}class r{constructor(W,H,x,J){this.startLineNumber=W,this.startColumn=H,this.endLineNumber=x,this.endColumn=J}}e.SearchRange=r;class i extends r{constructor(W,H,x){super(W,H,W,x)}}e.OneLineRange=i;var n;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function u(B,W=!0){const H=B&&B.files&&B.files.exclude,x=W&&B&&B.search&&B.search.exclude;if(!H&&!x)return;if(!H||!x)return H||x;let J=Object.create(null);return J=k.mixin(J,k.deepClone(H)),J=k.mixin(J,k.deepClone(x),!0),J}e.getExcludes=u;function c(B,W){return B.excludePattern&&t.match(B.excludePattern,W)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&t.match(B.includePattern,W)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(H=>{const x=H.folder.fsPath;if(D.isEqualOrParent(W,x)){const J=_.relative(x,W);return!H.includePattern||!!t.match(H.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var d;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(W,H){super(W);this.code=H}}e.SearchError=h;function v(B){const W=B.message;if((0,P.isCancellationError)(B))return new h(W,d.canceled);try{const H=JSON.parse(W);return new h(H.message,H.code)}catch{return new h(W,d.other)}}e.deserializeSearchError=v;function w(B){const W={message:B.message,code:B.code};return new Error(JSON.stringify(W))}e.serializeSearchError=w;function A(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=A;function O(B){return B.type==="success"}e.isSerializedSearchSuccess=O;function N(B){return!!B.path}e.isSerializedFileMatch=N;function F(B,W){const H=B.searchPath?B.searchPath:B.relativePath;return(0,T.fuzzyContains)(H,W)}e.isFilePatternMatch=F;class M{constructor(W){this.path=W,this.results=[]}addMatch(W){this.results.push(W)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function V(B,W){const H={...B||{},...W||{}};return Object.keys(H).filter(x=>{const J=H[x];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=V;class ${constructor(W,H){this._parsedIncludeExpression=null,this._excludeExpression={...W.excludePattern||{},...H.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let x=W.includePattern;H.includePattern&&(x?x={...x,...H.includePattern}:x=H.includePattern),x&&(this._parsedIncludeExpression=t.parse(x))}matchesExcludesSync(W,H,x){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(W,H,x))}includedInQuerySync(W,H,x){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(W,H,x)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(W,H,x))}includedInQuery(W,H,x){const J=this._parsedExcludeExpression(W,H,x),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(W,H,x):!0;return(0,y.isPromise)(J)?J.then(se=>se?!1:ne()):ne()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=$;function U(B){for(const W in B)if(typeof B[W]!="boolean")return!0;return!1}}),define(pe[35],ve([0,1,17,18,21,3,24,10,94,23,8,13,2,169,4,11,189,43,44,26,14,15,7,31,5]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a,s,m,o,S,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(A,O,N){return new P.ExtUri(F=>d(F,N)).isEqual(A,O)}function n(A,O,N){return i(A.uri,O.uri,N)?0:(0,R.compare)(A.uri.toString(),O.uri.toString())}function u(A,O,N){return A.index!==O.index?A.index<O.index?-1:1:i(A.uri,O.uri,N)?(0,R.compare)(A.name,O.name):(0,R.compare)(A.uri.toString(),O.uri.toString())}function c(A,O,N,F){const M=A.slice(0).sort(($,U)=>N($,U,F)),V=O.slice(0).sort(($,U)=>N($,U,F));return(0,f.delta)(M,V,($,U)=>N($,U,F))}function d(A,O){const N=O.getCapabilities(A.scheme);return!(N&&N&1024)}class h extends L.Workspace{constructor(O,N,F,M,V,$,U){super(O,F.map(B=>new L.WorkspaceFolder(B)),M,V,U);this._name=N,this._isUntitled=$,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(U),F.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(O,N,F,M){if(!O)return{workspace:null,added:[],removed:[]};const{id:V,name:$,folders:U,configuration:B,transient:W,isUntitled:H}=O,x=[],J=N;N?U.forEach((Q,ae)=>{const fe=l.URI.revive(Q.uri),be=h._findFolder(F||N,fe,M);be?(be.name=Q.name,be.index=Q.index,x.push(be)):x.push({uri:fe,name:Q.name,index:ae})}):x.push(...U.map(({uri:Q,name:ae,index:fe})=>({uri:l.URI.revive(Q),name:ae,index:fe}))),x.sort((Q,ae)=>Q.index<ae.index?-1:1);const ne=new h(V,$,x,!!W,B?l.URI.revive(B):null,!!H,Q=>d(Q,M)),{added:se,removed:K}=c(J?J.workspaceFolders:[],ne.workspaceFolders,n,M);return{workspace:ne,added:se,removed:K}}static _findFolder(O,N,F){for(let M=0;M<O.folders.length;M++){const V=O.workspaceFolders[M];if(i(V.uri,N,F))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,N){return N&&this._structure.get(O)&&(O=(0,P.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let v=class{constructor(O,N,F,M){this._onDidChangeWorkspace=new D.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new D.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=F,this._requestIdProvider=new _.Counter,this._barrier=new t.Barrier,this._proxy=O.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(r.MainContext.MainThreadMessageService);const V=N.workspace;this._confirmedWorkspace=V?new h(V.id,V.name,[],!!V.transient,V.configuration?l.URI.revive(V.configuration):null,!!V.isUntitled,$=>d($,F)):void 0}$initializeWorkspace(O,N){this._trusted=N,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:I.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,N,F,...M){const V=[];if(Array.isArray(M)&&M.forEach(H=>{l.URI.isUri(H.uri)&&!V.some(x=>i(x.uri,H.uri,this._extHostFileSystemInfo))&&V.push({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri)})}),this._unconfirmedWorkspace||[N,F].some(H=>typeof H!="number"||H<0)||F===0&&V.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+F>$.length)return!1;const U=$.slice(0);U.splice(N,F,...V.map(H=>({uri:H.uri,name:H.name||(0,P.basenameOrAuthority)(H.uri),index:void 0})));for(let H=0;H<U.length;H++){const x=U[H];if(U.some((J,ne)=>ne!==H&&i(x.uri,J.uri,this._extHostFileSystemInfo)))return!1}U.forEach((H,x)=>H.index=x);const{added:B,removed:W}=c($,U,u,this._extHostFileSystemInfo);if(B.length===0&&W.length===0)return!1;if(this._proxy){const H=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(H,N,F,V).then(void 0,x=>{this._unconfirmedWorkspace=void 0;const J={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(E.Severity.Error,(0,b.localize)(0,null,H,x.toString()),J,[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(O,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,N)}async getWorkspaceFolder2(O,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,N)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,N){let F,M="";if(typeof O=="string"?(F=l.URI.file(O),M=O):typeof O!="undefined"&&(F=O,M=O.fsPath),!F)return M;const V=this.getWorkspaceFolder(F,!0);if(!V)return M;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let $=(0,P.relativePath)(V.uri,F);return N&&V.name&&($=`${V.name}/${$}`),$}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:N,added:F,removed:M}=h.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:M}))}findFiles(O,N,F,M,V=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let $;if(N===null?$=!1:N&&(typeof N=="string"?$=N:$=N.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:B}=w(m.GlobPattern.from(O));return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(U),(0,y.withUndefinedAsNull)(B),(0,y.withUndefinedAsNull)($),(0,y.withUndefinedAsNull)(F),V).then(W=>Array.isArray(W)?W.map(H=>l.URI.revive(H)):[])}async findTextInFiles(O,N,F,M,V=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),U=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:B,folder:W}=w(m.GlobPattern.from(N.include)),H=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,x={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:U,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:B,excludePattern:H},J=!1;if(this._activeSearchCallbacks[$]=ne=>{if(J)return;const se=l.URI.revive(ne.resource);ne.results.forEach(K=>{(0,S.resultIsMatch)(K)?F({uri:se,preview:{text:K.preview.text,matches:(0,f.mapArrayOrNot)(K.preview.matches,Q=>new o.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))},ranges:(0,f.mapArrayOrNot)(K.ranges,Q=>new o.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))}):F({uri:se,text:K.text,lineNumber:K.lineNumber})})},V.isCancellationRequested)return{};try{const ne=await this._proxy.$startTextSearch(O,(0,y.withUndefinedAsNull)(W),x,$,V);return delete this._activeSearchCallbacks[$],ne||{}}catch(ne){throw delete this._activeSearchCallbacks[$],ne}}$handleTextSearchResult(O,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=je([He(0,s.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,C.IExtHostFileSystemInfo),He(3,g.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function w(A){let O,N;return A&&(typeof A=="string"?O=A:(O=A.pattern,N=l.URI.revive(A.baseUri))),{includePattern:O,folder:N}}}),define(pe[36],ve([0,1,25,3,35,5,7,193,119,13,18,4,14,11,2]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(S,r){if(r){const i=r.split(".");let n=S;for(let u=0;n&&u<i.length;u++)n=n[i[u]];return n}}function E(S){return S instanceof p.URI}function L(S){return S&&S.uri instanceof p.URI&&S.languageId&&typeof S.languageId=="string"}function C(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function a(S){return S&&S.uri instanceof p.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function s(S){if(E(S))return{resource:S};if(L(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(C(S))return{overrideIdentifier:S.languageId};if(a(S))return{resource:S.uri};if(S===null)return{resource:null}}let m=class{constructor(r,i,n){this._proxy=r.getProxy(D.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=n,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(r,i))}};m=je([He(0,l.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,b.ILogService)],m),e.ExtHostConfiguration=m;class o{constructor(r,i,n,u){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=u,this._extHostWorkspace=i,this._configuration=I.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,n))}getConfiguration(r,i,n){const u=s(i)||{},c=this._toReadonlyValue(r?g(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,u,n?.identifier);function d(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(v){return typeof g(c,v)!="undefined"},get:(v,w)=>{this._validateConfigurationAccess(r?`${r}.${v}`:v,u,n?.identifier);let A=g(c,v);if(typeof A=="undefined")A=w;else{let O;const N=(F,M)=>{let V;const $=()=>{O=O||(0,f.deepClone)(c),V=V||g(O,M)};return(0,P.isObject)(F)?new Proxy(F,{get:(U,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return $(),()=>V;if(O)return V=V||g(O,M),V[B];const W=U[B];return typeof B=="string"?N(W,`${M}.${B}`):W},set:(U,B,W)=>($(),V&&(V[B]=W),!0),deleteProperty:(U,B)=>($(),V&&delete V[B],!0),defineProperty:(U,B,W)=>($(),V&&Object.defineProperty(V,B,W),!0)}):F};A=N(A,v)}return A},update:(v,w,A,O)=>{v=r?`${r}.${v}`:v;const N=d(A);return w!==void 0?this._proxy.$updateConfigurationOption(N,v,w,u,O):this._proxy.$removeConfigurationOption(N,v,u,O)},inspect:v=>{v=r?`${r}.${v}`:v;const w=(0,f.deepClone)(this._configuration.inspect(v,u,this._extHostWorkspace.workspace));if(w)return{key:v,defaultValue:w.default?.value,globalValue:w.user?.value,workspaceValue:w.workspace?.value,workspaceFolderValue:w.workspaceFolder?.value,defaultLanguageValue:w.default?.override,globalLanguageValue:w.user?.override,workspaceLanguageValue:w.workspace?.override,workspaceFolderLanguageValue:w.workspaceFolder?.override,languageIds:w.overrideIdentifiers}}};return typeof c=="object"&&(0,f.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(r){const i=n=>(0,P.isObject)(n)?new Proxy(n,{get:(u,c)=>i(u[c]),set:(u,c,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(u,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(u,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return i(r)}_validateConfigurationAccess(r,i,n){const u=_.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=n?`[${n.value}] `:"";if(u===4){typeof i?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const n=new I.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,c)=>n.affectsConfiguration(u,s(c))})}_toMap(r){return r.reduce((i,n)=>(i.set(n[0],n[1]),i),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[71],ve([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,66,213,16]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a,s){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(M){function V(U){if(U!=null)return U}M.from=V;function $(U){if(U!=null)return U}M.to=$})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(M){function V(U){if(U!=null)return U}M.from=V;function $(U){if(U!=null)return U}M.to=$})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(M){function V(U){if(U!=null)return U}M.from=V;function $(U){if(U!=null)return U}M.to=$})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(M){function V(B){if(B){const W=B;return W&&!!W.process}else return!1}M.is=V;function $(B){if(B==null)return;const W={process:B.process,args:B.args};return B.options&&(W.options=r.from(B.options)),W}M.from=$;function U(B){if(B!=null)return new T.ProcessExecution(B.process,B.args,B.options)}M.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(M){function V(U){if(U!=null)return U}M.from=V;function $(U){if(U!=null)return U}M.to=$})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(M){function V(B){if(B){const W=B;return W&&(!!W.commandLine||!!W.command)}else return!1}M.is=V;function $(B){if(B==null)return;const W={};return B.commandLine!==void 0?W.commandLine=B.commandLine:(W.command=B.command,W.args=B.args),B.options&&(W.options=n.from(B.options)),W}M.from=$;function U(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new T.ShellExecution(B.commandLine,B.options):new T.ShellExecution(B.command,B.args?B.args:[],B.options)}M.to=U})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(M){function V(B){if(B){let W=B;return W&&W.customExecution==="customExecution"}else return!1}M.is=V;function $(B){return{customExecution:"customExecution"}}M.from=$;function U(B,W){return W.get(B)}M.to=U})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(M){function V($,U){let B;return $.scope!==void 0&&typeof $.scope!="number"?B=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===T.TaskScope.Workspace&&U&&U.workspaceFile?B=U.workspaceFile:B=a.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:B}}M.from=V})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(M){function V($){if($!=null)return{_id:$.id,isDefault:$.isDefault}}M.from=V})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var v;(function(M){function V(B,W){if(B==null)return[];const H=[];for(let x of B){const J=$(x,W);J&&H.push(J)}return H}M.fromMany=V;function $(B,W){if(B==null)return;let H;B.execution instanceof T.ProcessExecution?H=i.from(B.execution):B.execution instanceof T.ShellExecution?H=u.from(B.execution):B.execution&&B.execution instanceof T.CustomExecution&&(H=c.from(B.execution));const x=o.from(B.definition);let J;return B.scope?typeof B.scope=="number"?J=B.scope:J=B.scope.uri:J=T.TaskScope.Workspace,!x||!J?void 0:{_id:B._id,definition:x,name:B.name,source:{extensionId:W.identifier.value,label:B.source,scope:J},execution:H,isBackground:B.isBackground,group:h.from(B.group),presentationOptions:S.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}M.from=$;async function U(B,W,H){if(B==null)return;let x;i.is(B.execution)?x=i.to(B.execution):u.is(B.execution)?x=u.to(B.execution):c.is(B.execution)&&(x=c.to(B._id,H));const J=o.to(B.definition);let ne;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ne=B.source.scope:ne=await W.resolveWorkspaceFolder(f.URI.revive(B.source.scope)):ne=T.TaskScope.Workspace),!J||!ne)return;const se=new T.Task(J,ne,B.name,B.source.label,x,B.problemMatchers);return B.isBackground!==void 0&&(se.isBackground=B.isBackground),B.group!==void 0&&(se.group=T.TaskGroup.from(B.group._id),se.group&&B.group.isDefault&&(se.group=new T.TaskGroup(se.group.id,se.group.label),B.group.isDefault&&(se.group.isDefault=B.group.isDefault))),B.presentationOptions&&(se.presentationOptions=S.to(B.presentationOptions)),B._id&&(se._id=B._id),B.detail&&(se.detail=B.detail),se}M.to=U})(v=e.TaskDTO||(e.TaskDTO={}));var w;(function(M){function V(U){return U}M.from=V;function $(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=$})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(V,$,U){this._id=$,this._task=U,m.set(this,void 0),nt(this,m,V,"f")}get task(){return this._task}terminate(){Le(this,m,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}m=new WeakMap;var O;(function(M){function V($){return{id:$._id,task:void 0}}M.from=V})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(V,$,U,B,W,H,x,J){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=V.getProxy(D.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=B,this._configurationService=W,this._terminalService=H,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,$,U){if(!U)return new T.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:$,provider:U,extension:V}),this._proxy.$registerTaskProvider(B,$),new T.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(V,$){this._proxy.$registerTaskSystem(V,$)}fetchTasks(V){return this._proxy.$fetchTasks(w.from(V)).then(async $=>{const U=[];for(let B of $){const W=await v.to(B,this._workspaceProvider,this._providedCustomExecutions2);W&&U.push(W)}return U})}get taskExecutions(){const V=[];return this._taskExecutions.forEach($=>V.push($)),V}terminateTask(V){if(!(V instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,$,U){const B=this._providedCustomExecutions2.get(V.id);B&&(this._activeCustomExecutions2.set(V.id,B),this._terminalService.attachPtyToTerminal($,await B.callback(U))),this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const $=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const $=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:$,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const $=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:V.exitCode})}$provideTasks(V,$){const U=this._handlers.get(V);if(!U)return Promise.reject(new Error("no handler found"));const B=[],W=(0,t.asPromise)(()=>U.provider.provideTasks(R.CancellationToken.None)).then(H=>this.provideTasksInternal($,B,U,H));return new Promise(H=>{W.then(x=>{Promise.all(B).then(()=>{H(x)})})})}async $resolveTask(V,$){const U=this._handlers.get(V);if(!U)return Promise.reject(new Error("no handler found"));if($.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${U.type}].`);const B=await v.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const W=await U.provider.resolveTask(B,R.CancellationToken.None);if(!W)return;this.checkDeprecation(W,U);const H=v.from(W,U.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(H.execution)&&await this.addCustomExecution(H,W,!0),await this.resolveTaskInternal(H)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,$,U){const B=await this._proxy.$createTaskId(V);!U&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,$.execution)),this._providedCustomExecutions2.set(B,$.execution)}async getTaskExecution(V,$){if(typeof V=="string"){const W=this._taskExecutionPromises.get(V);if(!W)throw new Error("Unexpected: The specified task is missing an execution");return W}let U=this._taskExecutionPromises.get(V.id);if(U)return U;const B=new Promise((W,H)=>{function x(J,ne,se){se?W(new A(J,ne.id,se)):H("Unexpected: Task does not exist.")}$?x(this,V,$):v.to(V.task,this._workspaceProvider,this._providedCustomExecutions2).then(J=>x(this,V,J))});return this._taskExecutionPromises.set(V.id,B),B.then(W=>(this._taskExecutions.set(V.id,W),W),W=>Promise.reject(W))}checkDeprecation(V,$){V._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let U=this._notProvidedCustomExecutions.values(),B=U.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=U.next()}};N=je([He(0,l.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,L.ILogService),He(7,C.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let F=class extends N{constructor(V,$,U,B,W,H,x,J){super(V,$,U,B,W,H,x,J);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(V,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const U=v.from($,V);if(U===void 0)throw new Error("Task is not valid");if(c.is(U.execution))await this.addCustomExecution(U,$,!1);else throw new s.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),$);return this._proxy.$executeTask(U).catch(W=>{throw new Error(W)}),B}provideTasksInternal(V,$,U,B){const W=[];if(B)for(let H of B){this.checkDeprecation(H,U),(!H.definition||!V[H.definition.type])&&this._logService.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const x=v.from(H,U.extension);x&&c.is(x.execution)?(W.push(x),$.push(this.addCustomExecution(x,H,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:W,extension:U.extension}}async resolveTaskInternal(V){if(c.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,$){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,$,U){}};F=je([He(0,l.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,L.ILogService),He(7,C.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(pe[266],ve([0,1,17,75,32,80,24,10,9,23,8,13,2,149,175,116,43,128,265,31]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(d,h,v,w){this.configurationService=d,this.workspaceContextService=h,this.editorGroupsService=v,this.pathService=w}text(d,h,v={}){d=this.getContentPattern(d,v);const w=this.configurationService.getValue(),A=h&&h.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(h?.map(E.toWorkspaceFolder),v),type:2,contentPattern:d,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:w.search.usePCRE2||A||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}getContentPattern(d,h){const v=this.configurationService.getValue();d.isRegExp&&(d.pattern=d.pattern.replace(/\r?\n/g,"\\n"));const w={...d,wordSeparators:v.editor.wordSeparators};return this.isCaseSensitive(d,h)&&(w.isCaseSensitive=!0),this.isMultiline(d)&&(w.isMultiline=!0),w}file(d,h={}){return{...this.commonQuery(d,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}handleIncludeExclude(d,h){return d?(d=Array.isArray(d)?d.map(i):i(d),h?this.parseSearchPaths(d):{pattern:o(...Array.isArray(d)?d:[d])}):{}}commonQuery(d=[],h={}){const v=this.handleIncludeExclude(h.includePattern,h.expandPatterns),w=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),A=d.length>1,O=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,h,w)):d.map(M=>this.getFolderQueryForRoot(M,h,w,A))).filter(M=>!!M),N={_reason:h._reason,folderQueries:O,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:w.pattern,includePattern:v.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const V=f.coalesce(f.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(B=>B.resource)))).filter(U=>(0,a.pathIncludedInQuery)(N,U.fsPath)),$=this.commonQueryFromFileList(V);return{...N,...$}}const F=h.extraFileResources&&h.extraFileResources.filter(M=>(0,a.pathIncludedInQuery)(N,M.fsPath));return N.extraFileResources=F&&F.length?F:void 0,N}commonQueryFromFileList(d){const h=[],v=new T.ResourceMap,w={};let A=!1;return d.forEach(O=>{if(O.scheme===I.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(O)){const F=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:_.dirname(O.fsPath)});let M=v.get(F);M||(A=!0,M={folder:F,includePattern:{}},h.push(M),v.set(F,M));const V=_.relative(F.fsPath,O.fsPath);(0,y.assertIsDefined)(M.includePattern)[V.replace(/\\/g,"/")]=!0}else O.fsPath&&(A=!0,w[O.fsPath]=!0)}),{folderQueries:h,includePattern:w,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(d,h){if(h.isSmartCase){if(d.isRegExp){if(R.containsUppercaseCharacter(d.pattern,!0))return!0}else if(R.containsUppercaseCharacter(d.pattern))return!0}return!!d.isCaseSensitive}isMultiline(d){return d.isMultiline||d.isRegExp&&(0,b.isMultilineRegexSource)(d.pattern)||d.pattern.indexOf(`
`)>=0?!0:!!d.isMultiline}parseSearchPaths(d){const h=$=>_.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),w=(Array.isArray(d)?d:S(d)).map($=>{const U=this.pathService.resolvedUserHome;return U?(0,D.untildify)($,U.scheme===I.Schemas.file?U.fsPath:U.path):$}),A=t.groupBy(w,$=>h($)?"searchPaths":"exprSegments"),O=(A.exprSegments||[]).map($=>R.rtrim($,"/")).map($=>R.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),r($))),N={},F=this.expandSearchPathPatterns(A.searchPaths||[]);F&&F.length&&(N.searchPaths=F);const M=f.flatten(O),V=o(...M);return V&&(N.pattern=V),N}getExcludesForFolder(d,h){return h.disregardExcludeSettings?void 0:(0,a.getExcludes)(d,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(d){if(!d||!d.length)return[];const h=f.flatten(d.map(w=>{let{pathPortion:A,globPortion:O}=m(w);O&&(O=n(O));const N=this.expandOneSearchPath(A);return f.flatten(N.map(F=>this.resolveOneSearchPathPattern(F,O)))})),v=new Map;return h.forEach(w=>{const A=w.searchPath.toString(),O=v.get(A);O?w.pattern&&(O.pattern=O.pattern||{},O.pattern[w.pattern]=!0):v.set(A,{searchPath:w.searchPath,pattern:w.pattern?o(w.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(d){if(_.isAbsolute(d)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==I.Schemas.file?[{searchPath:h[0].uri.with({path:d})}]:[{searchPath:l.URI.file(_.normalize(d))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(d=i(d),d.startsWith("../")||d===".."){const w=_.posix.resolve(h.path,d);return[{searchPath:h.with({path:w})}]}const v=n(d);return[{searchPath:h,pattern:v}]}else{if(d==="./"||d===".\\")return[];{const h=d.replace(/^\.[\/\\]/,""),w=this.workspaceContextService.getWorkspace().folders.map(A=>{const O=h.match(new RegExp(`^${R.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return O?{match:O,folder:A}:null}).filter(y.isDefined);if(w.length)return w.map(A=>{const O=A.match[1];return{searchPath:A.folder.uri,pattern:O&&n(O)}});{const A=d.match(/\.[\/\\](.+)[\/\\]?/),O=A?A[1]:d,N=p.localize(0,null,O);throw new Error(N)}}}}resolveOneSearchPathPattern(d,h){const v=d.pattern&&h?`${d.pattern}/${h}`:d.pattern||h,w=[{searchPath:d.searchPath,pattern:v}];return v&&!v.endsWith("**")&&w.push({searchPath:d.searchPath,pattern:v+"/**"}),w}getFolderQueryForSearchPath(d,h,v){const w=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(d.searchPath),h,v,!1);return w?{...w,includePattern:d.pattern}:null}getFolderQueryForRoot(d,h,v,w){let A;const O=l.URI.isUri(d)?d:d.uri;if(v.searchPaths){const $=v.searchPaths.filter(U=>(0,P.isEqual)(U.searchPath,O))[0];if($&&!$.pattern)return null;$&&(A=$.pattern)}const N=this.configurationService.getValue({resource:O}),M={...this.getExcludesForFolder(N,h)||{},...A||{}},V=l.URI.isUri(d)?(0,P.basename)(d):d.name;return{folder:O,folderName:w?V:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!N.search.followSymlinks}}};s=je([He(0,g.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,L.IEditorGroupsService),He(3,C.IPathService)],s),e.QueryBuilder=s;function m(c){const d=c.match(/[\*\{\}\(\)\[\]\?]/);if(d){const h=d.index,v=c.substr(0,h).match(/[/|\\][^/\\]*$/);if(v){let w=c.substr(0,v.index);return w.match(/[/\\]/)||(w+="/"),{pathPortion:w,globPortion:c.substr((v.index||0)+1)}}}return{pathPortion:c}}function o(...c){return c.length?c.reduce((d,h)=>(d[h]=!0,d),Object.create(null)):void 0}function S(c){return k.splitGlobAware(c,",").map(d=>d.trim()).filter(d=>!!d.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function i(c){return c.replace(/\\/g,"/")}function n(c){return i(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(c,d){c=f.distinct(c,w=>w.toString());const h=[],v=d.getWorkspace();return c&&c.forEach(w=>{let A;if(d.getWorkbenchState()===2)A=(0,P.relativePath)(v.folders[0].uri,w),A&&A!=="."&&(A="./"+A);else{const O=d.getWorkspaceFolder(w);if(O){const N=O.name;if(v.folders.filter(M=>M.name===N).length===1){const M=(0,P.relativePath)(O.uri,w);M===""?A=`./${O.name}`:A=`./${O.name}/${M}`}else A=w.fsPath}}A&&h.push(A)}),h}e.resolveResourcesForSearchIncludes=u}),define(pe[267],ve([0,1,23,2,21,16,4,266,31,43]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function y(g,E){const L=E.activationEvents;if(!L)return Promise.resolve(void 0);const C=[],a=[];for(const i of L)if(/^workspaceContains:/.test(i)){const n=i.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||g.forceUsingSearch?a.push(n):C.push(n)}if(C.length===0&&a.length===0)return Promise.resolve(void 0);let s;const m=new Promise((i,n)=>{s=i}),o=i=>s({activationEvent:i}),S=Promise.all(C.map(i=>l(g,i,o))).then(()=>{}),r=b(g,E.identifier,a,o);return Promise.all([S,r]).then(()=>{s(void 0)}),m}e.checkActivateWorkspaceContainsExtension=y;async function l(g,E,L){for(const C of g.folders)if(await g.exists(f.joinPath(t.URI.revive(C),E))){L(`workspaceContains:${E}`);return}}async function b(g,E,L,C){if(L.length===0)return Promise.resolve(void 0);const a=new k.CancellationTokenSource,s=g.checkExists(g.folders,L,a.token),m=setTimeout(async()=>{a.cancel(),g.logService.info(`Not activating extension '${E.value}': Timed out while searching for 'workspaceContains' pattern ${L.join(",")}`)},R);let o=!1;try{o=await s}catch(S){D.isCancellationError(S)||D.onUnexpectedError(S)}a.dispose(),clearTimeout(m),o&&C(`workspaceContains:${L.join(",")}`)}function p(g,E,L,C){const a=g.get(T.IInstantiationService),s=g.get(_.ISearchService),o=a.createInstance(I.QueryBuilder).file(E.map(S=>(0,P.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:L,exists:!0});return s.fileSearch(o,C).then(S=>!!S.limitHit,S=>D.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=p});var nt=this&&this.__classPrivateFieldSet||function(Z,e,f,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(Z,f):k?k.value=f:e.set(Z,f),f},Le=this&&this.__classPrivateFieldGet||function(Z,e,f,t){if(f==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!t:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?t:f==="a"?t.call(Z):t?t.value:e.get(Z)};define(pe[39],ve([0,1,164,9,72,23,18,6,24,2,11,5,36,224,90,35,28,222,16,27,22,199,7,120,4,26,68,14,84,51,34,3,267,89,201,10]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a,s,m,o,S,r,i,n,u,c,d,h,v,w,A,O,N){"use strict";var F,M,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=class Gi extends I.Disposable{constructor(x,J,ne,se,K,Q,ae,fe,be,Me){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=J,this._extHostContext=ne,this._initData=ae,this._extHostWorkspace=se,this._extHostConfiguration=K,this._logService=Q,this._extHostTunnelService=be,this._extHostTerminalService=Me,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new L.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new p.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=fe,this._instaService=x.createChild(new c.ServiceCollection([p.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const ze=new Set;this._initData.hostExtensions.forEach(Ge=>ze.add(a.ExtensionIdentifier.toKey(Ge))),this._activator=this._register(new b.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ge,Je,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ge,C.transformErrorForSerialization(Je),q)},actualActivateExtension:async(Ge,Je)=>{if(ze.has(a.ExtensionIdentifier.toKey(Ge)))return await this._mainThreadExtensionsProxy.$activateExtension(Ge,Je),new b.HostExtension;const q=this._registry.getExtensionDescription(Ge);return this._activateExtension(q,Je)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){C.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch{}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,J){return this._activator.activateByEvent(x,J)}_activateById(x,J){return this._activator.activateById(x,J)}activateByIdWithErrors(x,J){return this._activateById(x,J).then(()=>{const ne=this._activator.getActivatedExtension(x);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}async _realPathExtensionUri(x){if(x.scheme!==N.Schemas.file)return x;const J=await this._hostUtils.realpath(x.fsPath);return P.URI.file(J)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const x=_.TernarySearchTree.forUris(J=>D.extUriBiasedIgnorePathCase.ignorePathCasing(J));for(const J of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(J)){const ne=await this._realPathExtensionUri(J.extensionLocation);x.set(ne,J)}return x})()),this._extensionPathIndex}_deactivate(x){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return J;const ne=this._activator.getActivatedExtension(x);if(!ne)return J;try{typeof ne.module.deactivate=="function"&&(J=Promise.resolve(ne.module.deactivate()).then(void 0,se=>(this._logService.error(se),Promise.resolve(void 0))))}catch(se){this._logService.error(`An error occurred when deactivating the extension '${x.value}':`),this._logService.error(se)}try{(0,I.dispose)(ne.subscriptions)}catch(se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this._logService.error(se)}return J}async _activateExtension(x,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,J).then(ne=>{const se=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,se.codeLoadingTime,se.activateCallTime,se.activateResolvedTime,J),this._logExtensionActivationTimes(x,J,"success",se),ne},ne=>{throw this._logExtensionActivationTimes(x,J,"failure"),ne})}_logExtensionActivationTimes(x,J,ne,se){const K=U(x,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...se||{},outcome:ne})}_doActivateExtension(x,J){const ne=U(x,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const se=this._getEntryPoint(x);if(!se)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${x.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const K=new b.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,D.joinPath)(x.extensionLocation,se),K),this._loadExtensionContext(x)]).then(Q=>(k.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Gi._callActivate(this._logService,x.identifier,Q[0],Q[1],K))).then(Q=>(k.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Q))}_loadExtensionContext(x){const J=new m.ExtensionGlobalMemento(x,this._storage),ne=new m.ExtensionMemento(x.identifier.value,!1,this._storage),se=new O.ExtensionSecrets(x,this._secretState),K=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,Q=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([J.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ae=this;let fe,be;const Me=(0,E.isProposedApiEnabled)(x,"ipc")?this._initData.messagePorts?.get(a.ExtensionIdentifier.toKey(x.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:ne,secrets:se,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(ze){return t.join(x.extensionLocation.fsPath,ze)},get storagePath(){return ae._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return ae._storagePath.globalValue(x).fsPath},get logPath(){return t.join(ae._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return P.URI.joinPath(ae._initData.logsLocation,x.identifier.value)},get storageUri(){return ae._storagePath.workspaceValue(x)},get globalStorageUri(){return ae._storagePath.globalValue(x)},get extensionMode(){return K},get extension(){return fe===void 0&&(fe=new B(ae,x.identifier,x,Q)),fe},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(x,"extensionRuntime"),ae.extensionRuntime},get environmentVariableCollection(){return ae._extHostTerminalService.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!be){if(!Me)return;const ze=v.Event.buffer(v.Event.fromDOMEventEmitter(Me,"message",Ge=>Ge.data));Me.start(),be={onDidReceiveMessage:ze,postMessage:Me.postMessage.bind(Me)}}return be}})})}static _callActivate(x,J,ne,se,K){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,J,ne,se,K).then(Q=>new b.ActivatedExtension(!1,null,K.build(),ne,Q,se.subscriptions))}static _callActivateOptional(x,J,ne,se,K){if(typeof ne.activate=="function")try{K.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Q=typeof global=="object"?global:self,ae=ne.activate.apply(Q,[se]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(ae).then(fe=>(K.activateResolveStop(),fe))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(ne)}_activateOneStartupFinished(x,J){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:J}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const J of x.activationEvents)J==="onStartupFinished"&&this._activateOneStartupFinished(x,J)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._register(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(J),se=Promise.all([x,ne]).then(()=>{});return Promise.race([se,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),se}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(x,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,J){if(this.isActivated(J.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,se={logService:this._logService,folders:x.map(Q=>Q.uri),forceUsingSearch:ne,exists:Q=>this._hostUtils.exists(Q.fsPath),checkExists:(Q,ae,fe)=>this._mainThreadWorkspaceProxy.$checkExists(Q,ae,fe)},K=await(0,w.checkActivateWorkspaceContainsExtension)(se,J);if(!!K)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:K.activationEvent}).then(void 0,Q=>this._logService.error(Q))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:J}=this._initData.environment;if(!x||!J)throw new Error(f.localize(0,null));const ne=await this._loadCommonJSModule(null,J,new b.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(f.localize(1,null,J.toString()));return new Promise((se,K)=>{const Q=(be,Me)=>{be?K(be):se(typeof Me=="number"&&Me>0?1:0)},ae=(0,D.originalFSPath)(J),fe=ne.run(ae,Q);fe&&fe.then&&fe.then(()=>{se(0)}).catch(be=>{K(be instanceof Error&&be.stack?be.stack:String(be))})})}async $extensionTestsExit(x){this._logService.info(`Extension host terminating: test runner requested exit with code ${x}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,J){return this._resolvers[x]=J,(0,I.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const J=x.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const ne=x.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(x,J){this._logService.info(`$resolveAuthority invoked for authority (${W(x)})`);const{authorityPrefix:ne,resolver:se}=await this._activateAndGetResolver(x);if(!se)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(se)),k.mark(`code/extHost/willResolveAuthority/${ne}`);const K=await se.resolve(x,{resolveAttempt:J});k.mark(`code/extHost/didResolveAuthorityOK/${ne}`);const Q={authority:x,host:K.host,port:K.port,connectionToken:K.connectionToken},ae={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Q,options:ae,tunnelInformation:{environmentTunnels:K.environmentTunnels,features:K.tunnelFeatures}}}}catch(K){if(k.mark(`code/extHost/didResolveAuthorityError/${ne}`),K instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(x,J){this._logService.info(`$getCanonicalURI invoked for authority (${W(x)})`);const{authorityPrefix:ne,resolver:se}=await this._activateAndGetResolver(x);if(!se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ne}`);const K=P.URI.revive(J);if(typeof se.getCanonicalURI=="undefined")return K;const Q=await(0,T.asPromise)(()=>se.getCanonicalURI(K));return Q||K}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,J){return J===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(x,!1))}async $activate(x,J){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,J),!0):!1}async $deltaExtensions(x,J){x.forEach(se=>se.extensionLocation=P.URI.revive(se.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(J.map(async se=>{const K=this._registry.getExtensionDescription(se);K&&ne.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(x.map(async se=>{const K=await this._realPathExtensionUri(se.extensionLocation);ne.set(K,se)})),this._registry.deltaExtensions(x,J),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let J=s.VSBuffer.alloc(x),ne=Math.random()%256;for(let se=0;se<x;se++)J.writeUInt8(ne,se);return J}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};$=je([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,u.IExtHostRpcService),He(3,g.IExtHostWorkspace),He(4,l.IExtHostConfiguration),He(5,R.ILogService),He(6,i.IExtHostInitDataService),He(7,n.IExtensionStoragePaths),He(8,d.IExtHostTunnelService),He(9,h.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function U(H,x){return{id:H.identifier.value,name:H.name,extensionVersion:H.version,publisherDisplayName:H.publisher,activationEvents:H.activationEvents?H.activationEvents.join(","):null,isBuiltin:H.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class B{constructor(x,J,ne,se){F.set(this,void 0),M.set(this,void 0),V.set(this,void 0),nt(this,F,x,"f"),nt(this,M,J,"f"),nt(this,V,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=t.normalize((0,D.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=se}get isActive(){return Le(this,F,"f").isActivated(Le(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Le(this,F,"f").getExtensionExports(Le(this,V,"f"))}activate(){return Le(this,F,"f").activateByIdWithErrors(Le(this,V,"f"),{startup:!1,extensionId:Le(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,F=new WeakMap,M=new WeakMap,V=new WeakMap;function W(H){const x=H.indexOf("+");return x===-1?H:H.substring(0,x)}}),define(pe[54],ve([0,1,9,2,3,18,5,7,124,35,39,45,215,36,208,14,4,13,40,53]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let s=class{constructor(c,d,h,v,w,A){this._workspaceService=d,this._extensionService=h,this._editorsService=v,this._configurationService=w,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=c.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(N=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,d){const h=c;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let v=`debug:${encodeURIComponent(h.path||"")}`,w="?";return d&&(v+=`${w}session=${encodeURIComponent(d.id)}`,w="&"),v+=`${w}ref=${h.sourceReference}`,t.URI.parse(v)}else{if(h.path)return t.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const d=[];for(const h of c.getAllExtensionDescriptions())if(h.contributes){const v=h.contributes.debuggers;if(v&&v.length>0)for(const w of v)(0,p.isDebuggerMainContribution)(w)&&d.push(w.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(d=>c.push(d)),c}addBreakpoints(c){this.startBreakpoints();const d=c.filter(w=>{const A=w.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,w),!0)});this.fireBreakpointChanges(d,[],[]);const h=[],v=new Map;for(const w of d)if(w instanceof I.SourceBreakpoint){let A=v.get(w.location.uri.toString());A||(A={type:"sourceMulti",uri:w.location.uri,lines:[]},v.set(w.location.uri.toString(),A),h.push(A)),A.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof I.FunctionBreakpoint&&h.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(c){this.startBreakpoints();const d=c.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],d,[]);const h=d.filter(A=>A instanceof I.SourceBreakpoint).map(A=>A.id),v=d.filter(A=>A instanceof I.FunctionBreakpoint).map(A=>A.id),w=d.filter(A=>A instanceof I.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(h,v,w)}startDebugging(c,d,h){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,d,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,d,h){if(!d)return new I.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:v,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,h,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,v),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(c,d,h){if(!h)return new I.Disposable(()=>{});if(!this.definesDebugType(c,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:v,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,v),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(c,d){if(!d)return new I.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:h,factory:d}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==d)})}async $runInTerminal(c,d){return Promise.resolve(void 0)}async $substituteVariables(c,d){if(!this._variableResolver){const[w,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,A)}let h;const v=await this.getFolder(c);return v&&(h={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,d)}createDebugAdapter(c,d){if(c.type==="implementation")return new i(c.implementation)}createSignService(){}async $startDASession(c,d){const h=this,v=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const A=this.convertToDto(w),O=this.createDebugAdapter(A,v);if(!O)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const N=O;return this._debugAdapters.set(c,N),this.getDebugAdapterTrackers(v).then(F=>(F&&this._debugAdaptersTrackers.set(c,F),N.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const V=M,$={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(V.arguments.value);$.body={signature:U},N.sendResponse($)}else throw new Error("no signer")}catch(U){$.success=!1,$.message=U.message,N.sendResponse($)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(M),M=(0,p.convertToVSCPaths)(M,!0),h._debugServiceProxy.$acceptDAMessage(c,M)}),N.onError(M=>{F&&F.onError&&F.onError(M),this._debugServiceProxy.$acceptDAError(c,M.name,M.message,M.stack)}),N.onExit(M=>{F&&F.onExit&&F.onExit((0,L.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,L.withNullAsUndefined)(M),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),N.startSession()))})}$sendDAMessage(c,d){d=(0,p.convertToDAPaths)(d,!1);const h=this._debugAdaptersTrackers.get(c);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(d);const v=this._debugAdapters.get(c);v&&v.sendMessage(d)}$stopDASession(c){const d=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),d&&d.onWillStopSession&&d.onWillStopSession();const h=this._debugAdapters.get(c);return this._debugAdapters.delete(c),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const d=[],h=[],v=[];if(c.added)for(const w of c.added){const A=w.id;if(A&&!this._breakpoints.has(A)){let O;if(w.type==="function")O=new I.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")O=new I.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const N=t.URI.revive(w.uri);O=new I.SourceBreakpoint(new I.Location(N,new I.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}O._id=A,this._breakpoints.set(A,O),d.push(O)}}if(c.removed)for(const w of c.removed){const A=this._breakpoints.get(w);A&&(this._breakpoints.delete(w),h.push(A))}if(c.changed){for(const w of c.changed)if(w.id){const A=this._breakpoints.get(w.id);if(A){if(A instanceof I.FunctionBreakpoint&&w.type==="function"){const O=A;O.enabled=w.enabled,O.condition=w.condition,O.hitCondition=w.hitCondition,O.logMessage=w.logMessage,O.functionName=w.functionName}else if(A instanceof I.SourceBreakpoint&&w.type==="source"){const O=A;O.enabled=w.enabled,O.condition=w.condition,O.hitCondition=w.hitCondition,O.logMessage=w.logMessage,O.location=new I.Location(t.URI.revive(w.uri),new I.Position(w.line,w.character))}v.push(A)}}}this.fireBreakpointChanges(d,h,v)}$provideDebugConfigurations(c,d,h){return(0,D.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(d);return v.provideDebugConfigurations(w,h)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(c,d,h,v){return(0,D.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(d);return w.resolveDebugConfiguration(A,h,v)})}$resolveDebugConfigurationWithSubstitutedVariables(c,d,h,v){return(0,D.asPromise)(async()=>{const w=this.getConfigProviderByHandle(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(d);return w.resolveDebugConfigurationWithSubstitutedVariables(A,h,v)})}async $provideDebugAdapter(c,d){const h=this.getAdapterDescriptorFactoryByHandle(c);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(d);return this.getAdapterDescriptor(h,v).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(c){const d=await this.getSession(c);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(c){const d=await this.getSession(c);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,d){const h=await this.getSession(c);h&&h._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(c,d){const v={session:await this.getSession(c),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(c){if(c instanceof I.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof I.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const d=this._adapterFactories.filter(h=>h.type===c);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(c){const d=this._adapterFactories.filter(h=>h.handle===c);if(d.length>0)return d[0].factory}getConfigProviderByHandle(c){const d=this._configProviders.filter(h=>h.handle===c);if(d.length>0)return d[0].provider}definesDebugType(c,d){if(c.contributes){const h=c.contributes.debuggers;if(h&&h.length>0){for(const v of h)if(v.label&&v.type&&v.type===d)return!0}}return!1}getDebugAdapterTrackers(c){const h=c.configuration.type,v=this._trackerFactories.filter(w=>w.type===h||w.type==="*").map(w=>(0,D.asPromise)(()=>w.factory.createDebugAdapterTracker(c)).then(A=>A,A=>null));return Promise.race([Promise.all(v).then(w=>{const A=w.filter(O=>!!O);if(A.length>0)return new r(A)}),new Promise((w,A)=>{const O=setTimeout(()=>{clearTimeout(O),A(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(c,d){const h=d.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new I.DebugAdapterServer(h));if(c){const w=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>c.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,w))).then(A=>{if(A)return A})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,v))}daExecutableFromPackage(c,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,d,h){(c.length>0||d.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:d,changed:h}))}async getSession(c){if(c)if(typeof c=="string"){const d=this._debugSessions.get(c);if(d)return d}else{let d=this._debugSessions.get(c.id);if(!d){const h=await this.getFolder(c.folderUri),v=c.parent?this._debugSessions.get(c.parent):void 0;d=new m(this._debugServiceProxy,c.id,c.type,c.name,h,c.configuration,v),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(c){if(c){const d=t.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};s=je([He(0,g.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class m{constructor(c,d,h,v,w,A,O){this._debugServiceProxy=c,this._id=d,this._type=h,this._name=v,this._workspaceFolder=w,this._configuration=A,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,d)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=m;class o{constructor(c){this.value=Object.freeze({append(d){c.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=o;class S extends l.AbstractVariableResolverService{constructor(c,d,h,v,w){function A(){if(d){const O=d.activeEditor();if(O)return O.document.uri;const N=v.tabs.filter(F=>F.isActive);if(N.length>0){const F=N[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:N[0].resource}}}super({getFolderUri:O=>{const N=c.filter(F=>F.name===O);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(O,N)=>h.getConfiguration(void 0,O).get(N),getAppRoot:()=>C.cwd(),getExecPath:()=>C.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=A();if(O)return f.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const O=A();if(O){const N=w.getWorkspaceFolder(O);if(N)return f.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(d){const O=d.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(d){const O=d.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(C.env))}}e.ExtHostVariableResolverService=S;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(d=>d.onError?d.onError(c):void 0)}onExit(c,d){this.trackers.forEach(h=>h.onExit?h.onExit(c,d):void 0)}}class i extends _.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends s{constructor(c,d,h,v,w,A){super(c,d,h,v,w,A)}createVariableResolver(c,d,h){return new S(c,d,h,this._editorTabs)}};n=je([He(0,g.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,R.IExtHostExtensionService),He(3,y.IExtHostDocumentsAndEditors),He(4,b.IExtHostConfiguration),He(5,a.IExtHostEditorTabs)],n),e.WorkerExtHostDebugService=n}),define(pe[268],ve([0,1,72,2,5,36,28,27,14,26,4,39,40,11,8]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(m,o,S,r,i,n,u){this._apiFactory=m,this._extensionRegistry=o,this._instaService=S,this._extHostConfiguration=r,this._extHostExtensionService=i,this._initData=n,this._logService=u,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new L(this._apiFactory,o,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(C,o)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,o,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(let o of m.nodeModuleName)this._factories.set(o,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(o=>m.alternativeModuleName(o))}};g=je([He(2,R.IInstantiationService),He(3,D.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,b.ILogService)],g),e.RequireInterceptor=g;let E=class Hi{constructor(m){if(m.environment.appRoot&&Hi.aliased.size){const o=(0,p.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),S="[a-z0-9_.-]",r=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${i}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(m));if(!o)return;const[,S,r,i]=o,n=Hi.aliased.get(r);if(n!==void 0)return console.warn(`${r} as been renamed to ${n}, please update your imports`),S+n+i}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};E.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),E=je([He(0,P.IExtHostInitDataService)],E);class L{constructor(m,o,S,r,i){this._apiFactory=m,this._extensionPaths=o,this._extensionRegistry=S,this._configProvider=r,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,o){const S=this._extensionPaths.findSubstr(o);if(S){let r=this._extApiImpl.get(I.ExtensionIdentifier.toKey(S.identifier));return r||(r=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(S.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((i,n)=>r+=`	${n} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let C=class{constructor(m,o,S){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(k.MainContext.MainThreadTelemetry);const{environment:r}=S,i=o.getProxy(k.MainContext.MainThreadKeytar);if(r.appRoot){let n=r.appRoot.fsPath;l.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,u)=>i.$getPassword(n,u),setPassword:(n,u,c)=>i.$setPassword(n,u,c),deletePassword:(n,u)=>i.$deletePassword(n,u),findPassword:n=>i.$findPassword(n),findCredentials(n){return i.$findCredentials(n)}}}load(m,o){const S=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const o=m.length;if(o<=7||!this.alternativeNames)return;const S=o-7;if((m.charAt(S)==="/"||m.charAt(S)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};C=je([He(1,_.IExtHostRpcService),He(2,P.IExtHostInitDataService)],C);let a=class{constructor(m,o,S){this._extensionPaths=m,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(k.MainContext.MainThreadTelemetry);const r=S.getProxy(k.MainContext.MainThreadWindow);this._impl=(i,n)=>{const u=t.URI.parse(i);return n?this.callOriginal(i,n):u.scheme==="http"||u.scheme==="https"?r.$openUri(u,i,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this._appUriScheme?r.$openUri(u,i,{}):this.callOriginal(i,n)}}load(m,o,S){const r=this._extensionPaths.findSubstr(o);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=S(m),this._impl}callOriginal(m,o){return this.sendNoForwardTelemetry(),this._original(m,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=je([He(2,_.IExtHostRpcService)],a)}),define(pe[269],ve([0,1,170,12,7,209,35,39,45,36,34,14,54,195,18,210,53]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let L=class extends l.ExtHostDebugServiceBase{constructor(s,m,o,S,r,i,n){super(s,m,o,S,r,n);this._terminalService=i,this._integratedTerminalInstances=new C}createDebugAdapter(s,m){switch(s.type){case"server":return new D.SocketDebugAdapter(s);case"pipeServer":return new D.NamedPipeDebugAdapter(s);case"executable":return new D.ExecutableDebugAdapter(s,m.type)}return super.createDebugAdapter(s,m)}daExecutableFromPackage(s,m){const o=D.ExecutableDebugAdapter.platformAdapterExecutable(m.getAllExtensionDescriptions(),s.type);if(o)return new k.DebugAdapterExecutable(o.command,o.args,o.options)}createSignService(){return new b.SignService}async $runInTerminal(s,m){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(A=>{this._integratedTerminalInstances.onTerminalClosed(A)}));const o=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=s.title||f.localize(0,null),n=JSON.stringify({shell:S,shellArgs:r});let u=await this._integratedTerminalInstances.checkout(n,i),c,d=!1;if(u)c=s.cwd;else{const A={shellPath:S,shellArgs:r,cwd:s.cwd,name:i,iconPath:new k.ThemeIcon("debug")};d=!0,u=this._terminalService.createTerminalFromOptions(A,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,n)}u.show(!0);const h=await u.processId;d?await new Promise(A=>setTimeout(A,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?u.sendText("cls"):S.indexOf("bash")>=0?u.sendText("clear"):t.isWindows?u.sendText("cls"):u.sendText("clear"));const v=(0,g.prepareCommand)(S,s.args,c,s.env);u.sendText(v);const w=this.onDidTerminateDebugSession(A=>{A.id===m&&(this._integratedTerminalInstances.free(u),w.dispose())});return h}else if(s.kind==="external")return(0,g.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,m)}createVariableResolver(s,m,o){return new l.ExtHostVariableResolverService(s,m,o,this._editorTabs,this._workspaceService)}};L=je([He(0,y.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,_.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,E.IExtHostEditorTabs)],L),e.ExtHostDebugService=L;class C{constructor(){this._terminalInstances=new Map}async checkout(s,m){const S=[...this._terminalInstances.entries()].map(([r,i])=>(0,p.createCancelablePromise)(async n=>{if(r.name!==m||i.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await r.processId))return null;const u=Date.now();return i.lastUsedAt+C.minUseDelay>u||n.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=u,r)}));return await(0,p.firstParallel)(S,r=>!!r)}insert(s,m){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:m})}free(s){const m=this._terminalInstances.get(s);m&&(m.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}C.minUseDelay=1e3}),define(pe[270],ve([0,1,9,2,113,35,54,45,36,43,34,14,26,71,10,11,66,53,23,81]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends b.ExtHostTaskBase{constructor(o,S,r,i,n,u,c,d,h){super(o,S,r,i,n,u,c,d);this.workspaceService=r,this.editorTabs=h,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,S){const r=S;if(!S.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=b.TaskHandleDTO.from(r,this.workspaceService),n=await this._proxy.$getTaskExecution(i);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(n,S);return this._proxy.$executeTask(i).catch(()=>{}),u}else{const i=b.TaskDTO.from(S,o);if(i===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),n}}provideTasksInternal(o,S,r,i){const n=[];if(i)for(let u of i){this.checkDeprecation(u,r),(!u.definition||!o[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const c=b.TaskDTO.from(u,r.extension);c&&(n.push(c),b.CustomExecutionDTO.is(c.execution)&&S.push(this.addCustomExecution(c,u,!0)))}return{tasks:n,extension:r.extension}}async resolveTaskInternal(o){return o}async getVariableResolver(o){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(o,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(o){let S=o&&o.length>0?o[0]:void 0;if(!S){const r=t.URI.file((0,a.homedir)());S=new P.WorkspaceFolder({uri:r,name:C.basename(r),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,S){const r=t.URI.revive(o),i={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(r),u=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(u),d=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let h of S.variables)i.variables[h]=await c.resolveAsync(d,h);if(S.process!==void 0){let h;if(S.process.path!==void 0){h=S.process.path.split(f.delimiter);for(let v=0;v<h.length;v++)h[v]=await c.resolveAsync(d,h[v])}i.process=await k.win32.findExecutable(await c.resolveAsync(d,S.process.name),S.process.cwd!==void 0?await c.resolveAsync(d,S.process.cwd):void 0,h)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(o,S,r){return k.win32.findExecutable(o,S,r)}};s=je([He(0,y.IExtHostRpcService),He(1,l.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,I.IExtHostDocumentsAndEditors),He(4,_.IExtHostConfiguration),He(5,R.IExtHostTerminalService),He(6,g.ILogService),He(7,E.IExtHostApiDeprecationService),He(8,L.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(pe[271],ve([0,1,18,16,72,6,2,5,263,11,61,84,26,187,14,65,39,34]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class C{constructor(s,m,o,S,r){this._disposables=new D.DisposableStore,this._isTerminating=!1,this._hostUtils=o,this._rpcProtocol=new _.RPCProtocol(s,null,S),m=C._transform(m,this._rpcProtocol);const i=new y.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...m,messagePorts:r}),i.set(p.IExtHostRpcService,new p.ExtHostRpcService(this._rpcProtocol)),i.set(g.IURITransformerService,new g.URITransformerService(S)),i.set(E.IHostUtils,o);const n=new b.InstantiationService(i,!0);this._disposables.add(n.invokeFunction(h=>h.get(L.IExtHostTerminalService))),this._disposables.add(n.invokeFunction(h=>h.get(E.IExtHostExtensionService))),this._logService=n.invokeFunction(h=>h.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=n.invokeFunction(h=>h.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const u=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(v,w)=>{let A="",O,N;for(const F of w)A+=`
	at ${F.toString()}`,N=F.getFileName(),!O&&N&&(O=h.findSubstr(T.URI.file(N)));return u.set(v,O),`${v.name||"Error"}: ${v.message||""}${A}`}});const c=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),d=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(h=>{const v=t.transformErrorForSerialization(h),w=u.get(h);w?c.$onExtensionRuntimeError(w.identifier,v):d.$onUnexpectedError(v)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(o=>{this._logService.error(o)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();Promise.race([(0,f.timeout)(5e3),m]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,m){s.extensions.forEach(S=>S.extensionLocation=T.URI.revive(m.transformIncomingURIs(S.extensionLocation))),s.environment.appRoot=T.URI.revive(m.transformIncomingURIs(s.environment.appRoot));const o=s.environment.extensionDevelopmentLocationURI;return o&&(s.environment.extensionDevelopmentLocationURI=o.map(S=>T.URI.revive(m.transformIncomingURIs(S)))),s.environment.extensionTestsLocationURI=T.URI.revive(m.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=T.URI.revive(m.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=T.URI.revive(m.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=T.URI.revive(m.transformIncomingURIs(s.logsLocation)),s.logFile=T.URI.revive(m.transformIncomingURIs(s.logFile)),s.workspace=m.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=C}),define(pe[272],ve([0,1,9,21,49,32,23,46,31]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,b,p){this.config=l,this.provider=b,this.sessionToken=p,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&D.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&D.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const b=this.config.folderQueries||[];return new Promise((p,g)=>{const E=L=>{this.resultCount++,l(L)};if(this.isCanceled)return p({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(L=>{const C=L.toString(),a=f.basename(C);this.globalExcludePattern&&this.globalExcludePattern(C,a)||this.matchFile(E,{base:L,basename:a})}),Promise.all(b.map(L=>this.searchInFolder(L,E))).then(L=>{p({limitHit:this.isLimitHit,stats:L[0]||void 0})},L=>{g(new Error((0,k.toErrorMessage)(L)))})})}async searchInFolder(l,b){const p=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(l),E=this.initDirectoryTree(),L=new _.QueryGlobTester(this.config,l),C=!L.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(p),a=I.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,p.token),m=a.elapsed(),o=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(S=>{const r=f.posix.relative(l.folder.path,S.path);if(C){const i=f.basename(S.path);this.matchFile(b,{base:l.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(E,l.folder,r,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,L,b),{providerTime:m,postProcessTime:o.elapsed()})}finally{p.dispose(),this.activeCancellationTokens.delete(p)}}getSearchOptionsForFolder(l){const b=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),p=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},b,p,g){if(p===this.filePattern){const L=f.basename(this.filePattern);this.matchFile(g,{base:b,relativePath:this.filePattern,basename:L})}function E(L){const C=f.basename(L),a=f.dirname(L);let s=l[a];s||(s=l[a]=[],E(a)),s.push({base:b,relativePath:L,basename:C})}E(p)}matchDirectoryTree({rootEntries:l,pathToEntries:b},p,g){const E=this,L=this.filePattern;function C(a){const s=D.hasSiblingFn(()=>a.map(m=>m.basename));for(let m=0,o=a.length;m<o;m++){const S=a[m],{relativePath:r,basename:i}=S;if(p.matchesExcludesSync(r,i,L!==i?s:void 0))continue;const n=b[r];if(n)C(n);else{if(r===L)continue;E.matchFile(g,S)}if(E.isLimitHit)break}}C(l)}matchFile(l,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(b))}}class R{constructor(){this.sessions=new Map}fileSearch(l,b,p,g){const E=this.getSessionTokenSource(l.cacheKey),L=new P(l,b,E&&E.token);let C=0;const a=s=>{C+=s.length,p(s.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(L,R.BATCH_SIZE,a,g).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:C,detailStats:s.stats}}))}clearCache(l){const b=this.getSessionTokenSource(l);b&&b.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new t.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:T.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,b,p,g){g.onCancellationRequested(()=>{l.cancel()});const E=C=>{C&&(L.push(C),b>0&&L.length>=b&&(p(L),L=[]))};let L=[];return l.search(E).then(C=>(L.length&&p(L),C),C=>(L.length&&p(L),Promise.reject(C)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(pe[135],ve([0,1,17,21,49,32,10,9,23,13,2,31]),function(Z,e,f,t,k,D,T,I,_,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(a,s,m,o){this.query=a,this.provider=s,this.fileUtils=m,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,s){const m=this.query.folderQueries||[],o=new t.CancellationTokenSource;return s.onCancellationRequested(()=>o.cancel()),new Promise((S,r)=>{this.collector=new p(a);let i=!1;const n=(u,c)=>{if(!i&&!this.isLimitHit){const d=this.resultSize(u);E(u)&&typeof this.query.maxResults=="number"&&this.resultCount+d>this.query.maxResults&&(this.isLimitHit=!0,i=!0,o.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const h=this.resultSize(u);this.resultCount+=h,(h>0||!E(u))&&this.collector.add(u,c)}};Promise.all(m.map((u,c)=>this.searchInFolder(u,d=>n(d,c),o.token))).then(u=>{o.dispose(),this.collector.flush();const c=u.some(d=>!!d&&!!d.limitHit);S({limitHit:this.isLimitHit||c,messages:(0,f.flatten)(u.map(d=>d?.message?(0,P.isArray)(d.message)?d.message:[d.message]:[])),stats:{type:this.processType}})},u=>{o.dispose();const c=(0,k.toErrorMessage)(u);r(new Error(c))})})}resultSize(a){return E(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,s){const m=Array.isArray(a.ranges)?a.ranges:[a.ranges],o=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:m.slice(0,s),preview:{matches:o.slice(0,s),text:a.preview.text},uri:a.uri}}async searchInFolder(a,s,m){const o=new y.QueryGlobTester(this.query,a),S=[],r={report:u=>{if(!this.validateProviderResult(u))return;const c=a.folder.scheme===T.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(u.uri))):void 0,d=_.relativePath(a.folder,u.uri);if(d){const h=o.includedInQuery(d,I.basename(d),c);(0,P.isPromise)(h)?S.push(h.then(v=>{v&&s(u)})):h&&s(u)}}},i=this.getSearchOptionsForFolder(a),n=await this.provider.provideTextSearchResults(b(this.query.contentPattern),i,r,m);return S.length&&await Promise.all(S),n}validateProviderResult(a){if(E(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const s=(0,y.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),m=(0,y.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),o={folder:R.URI.from(a.folder),excludes:m,includes:s,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=l;function b(C){return{isCaseSensitive:C.isCaseSensitive||!1,isRegExp:C.isRegExp||!1,isWordMatch:C.isWordMatch||!1,isMultiline:C.isMultiline||!1,pattern:C.pattern}}class p{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new L(512,s=>this.sendItems(s))}add(a,s){this._currentFileMatch&&(this._currentFolderIdx!==s||!_.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=s,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(g(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=p;function g(C){return E(C)?{preview:{matches:(0,f.mapArrayOrNot)(C.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:C.preview.text},ranges:(0,f.mapArrayOrNot)(C.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:C.text,lineNumber:C.lineNumber}}function E(C){return!!C.preview}e.extensionResultIsMatch=E;class L{constructor(a,s){this.maxBatchSize=a,this.cb=s,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,s){!a||this.addItemToBatch(a,s)}addItems(a,s){!a||this.addItemsToBatch(a,s)}addItemToBatch(a,s){this.batch.push(a),this.batchSize+=s,this.onUpdate()}addItemsToBatch(a,s){this.batch=this.batch.concat(a),this.batchSize+=s,this.onUpdate()}onUpdate(){this.totalNumberCompleted<L.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},L.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=L,L.TIMEOUT=4e3,L.START_BATCH_AFTER_COUNT=50}),define(pe[73],ve([0,1,6,5,4,272,14,65,11,2,135]),function(Z,e,f,t,k,D,T,I,_,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let y=class{constructor(g,E,L){this.extHostRpc=g,this._uriTransformer=E,this._logService=L,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new D.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,E){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const L=this._handlePool++;return this._textSearchProvider.set(L,E),this._proxy.$registerTextSearchProvider(L,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(L),this._proxy.$unregisterProvider(L)})}registerFileSearchProvider(g,E){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const L=this._handlePool++;return this._fileSearchProvider.set(L,E),this._proxy.$registerFileSearchProvider(L,this._transformScheme(g)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(L),this._proxy.$unregisterProvider(L)})}$provideFileSearchResults(g,E,L,C){const a=l(L),s=this._fileSearchProvider.get(g);if(s)return this._fileSearchManager.fileSearch(a,s,m=>{this._proxy.$handleFileMatch(g,E,m.map(o=>o.resource))},C);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,E,L,C){const a=this._textSearchProvider.get(g);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const s=l(L);return this.createTextSearchManager(s,a).search(o=>this._proxy.$handleTextMatch(g,E,o),C)}$enableExtensionHostSearch(){}createTextSearchManager(g,E){return new R.TextSearchManager(g,E,{readdir:L=>Promise.resolve([]),toCanonicalName:L=>L},"textSearchProvider")}};y=je([He(0,T.IExtHostRpcService),He(1,I.IURITransformerService),He(2,_.ILogService)],y),e.ExtHostSearch=y;function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>P.URI.revive(g))}}e.reviveQuery=l;function b(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(pe[273],ve([0,1,61,133,35,131,36,38,45,34,71,54,73,90,51,66,134,67,44,89,122,53,132,11,225]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a,s,m,o,S,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(S.ILoggerService,o.ExtHostLoggerService),(0,f.registerSingleton)(S.ILogService,r.ExtHostLogService),(0,f.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,f.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,f.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,f.registerSingleton)(L.IExtHostConsumerFileSystem,L.ExtHostConsumerFileSystem),(0,f.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,f.registerSingleton)(D.IExtHostDecorations,D.ExtHostDecorations),(0,f.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(C.IExtHostFileSystemInfo,C.ExtHostFileSystemInfo),(0,f.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,f.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,f.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage),(0,f.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,f.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,f.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService),(0,f.registerSingleton)(E.IExtHostWindow,E.ExtHostWindow),(0,f.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,f.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,f.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,f.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(pe[91],ve([0,1,17,11,31,70]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}e.anchorGlob=T;function I(y,l,b,p){const g=(0,f.mapArrayOrNot)(b,_),E=new k.TextSearchMatch(l,g,p),L=E.preview.matches;return{ranges:(0,f.mapArrayOrNot)(g,P),uri:y,preview:{text:E.preview.text,matches:(0,f.mapArrayOrNot)(L,P)}}}e.createTextSearchResult=I;function _(y){return new k.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function P(y){return new D.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let R=class{constructor(l,b){this.prefix=l,this.logService=b}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};R=je([He(1,t.ILogService)],R),e.OutputChannel=R}),define(pe[274],ve([0,1,37,9,79,29,12,8,91,275]),function(Z,e,f,t,k,D,T,I,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(a,s,m,o){const S=l(a,s,m,o),r=s.folder.fsPath;return{cmd:f.spawn(R,S.args,{cwd:r}),rgDiskPath:R,siblingClauses:S.siblingClauses,rgArgs:S,cwd:r}}e.spawnRipgrepCmd=y;function l(a,s,m,o){const S=["--files","--hidden","--case-sensitive"];p([s],m,!1).forEach(i=>{const n=(0,_.anchorGlob)(i);if(S.push("-g",n),T.isMacintosh){const u=(0,k.normalizeNFD)(n);u!==n&&S.push("-g",u)}});const r=b([s],o,void 0,!1);return r.globArgs.forEach(i=>{const n=`!${(0,_.anchorGlob)(i)}`;if(S.push("-g",n),T.isMacintosh){const u=(0,k.normalizeNFD)(n);u!==n&&S.push("-g",u)}}),s.disregardIgnoreFiles!==!1?S.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),s.ignoreSymlinks||S.push("--follow"),a.exists&&S.push("--quiet"),S.push("--no-config"),s.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:r.siblingClauses}}function b(a,s,m,o=!0){const S=[];let r={};return a.forEach(i=>{const n=Object.assign({},i.excludePattern||{},s||{}),u=g(n,o?i.folder.fsPath:void 0,m);S.push(...u.globArgs),u.siblingClauses&&(r=Object.assign(r,u.siblingClauses))}),{globArgs:S,siblingClauses:r}}e.foldersToRgExcludeGlobs=b;function p(a,s,m=!0){const o=[];return a.forEach(S=>{const r=Object.assign({},s||{},S.includePattern||{}),i=g(r,m?S.folder.fsPath:void 0);o.push(...i.globArgs)}),o}e.foldersToIncludeGlobs=p;function g(a,s,m){const o=[],S={};return Object.keys(a).forEach(r=>{if(m&&m.has(r)||!r)return;const i=a[r];r=L(s?E(s,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),o.push(C(r))):i&&i.when&&(S[r]=i)}),{globArgs:o,siblingClauses:S}}function E(a,s){return t.isAbsolute(s)?s:t.join(a,s)}e.getAbsoluteGlob=E;function L(a){return a=I.rtrim(a,"\\"),I.rtrim(a,"/")}function C(a){return D.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=C}),define(pe[276],ve([0,1,37,60,9,104,17,49,32,79,29,12,46,8,13,30,31,274,102]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(r=>r())});class s{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&_.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,C.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&_.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(n=>{const u=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),c=n.folder.fsPath;i.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==c).forEach(d=>{(0,R.isEqualOrParent)(d,c)&&(u[k.relative(c,d)]=!0)}),this.folderExcludePatterns.set(c,new o(u,c))})}cancel(){this.isCanceled=!0,a.forEach(i=>i())}walk(i,n,u,c,d){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return d(null,this.isLimitHit);n.forEach(h=>{const v=k.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,v)||this.matchFile(u,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(i,(h,v)=>{this.call(this.cmdTraversal,this,h,u,c,w=>{if(w){const A=(0,I.toErrorMessage)(w);console.error(A),this.errors.push(A),v(w,void 0)}else v(null,void 0)})},(h,v)=>{this.fileWalkSW.stop();const w=h?T.coalesce(h)[0]:null;d(w,this.isLimitHit)})}parallel(i,n,u){const c=new Array(i.length),d=new Array(i.length);let h=!1,v=0;if(i.length===0)return u(null,[]);i.forEach((w,A)=>{n(w,(O,N)=>{if(O?(h=!0,c[A]=null,d[A]=O):(c[A]=N,d[A]=null),++v===i.length)return u(h?d:null,c)})})}call(i,n,...u){try{i.apply(n,u)}catch(c){u[u.length-1](c)}}cmdTraversal(i,n,u,c){const d=i.folder.fsPath,h=y.isMacintosh;let v;const w=()=>v&&v.kill();a.add(w);let A=U=>{a.delete(w),A=()=>{},c(U)},O="";const N=this.initDirectoryTree();let F;const M=(0,L.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=M.cmd,F=!Object.keys(M.siblingClauses).length;const V=M.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let $=`${M.rgDiskPath} ${V}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&($+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),u({message:$}),this.cmdResultCount=0,this.collectStdout(v,"utf8",u,(U,B,W)=>{if(U){A(U);return}if(this.isLimitHit){A();return}const x=(O+(h?P.normalizeNFC(B||""):B)).split(`
`);if(W){const J=x.length;x[J-1]=x[J-1].trim(),x[J-1]||x.pop()}else O=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){A(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=x.length,F){for(const J of x)if(this.matchFile(n,{base:d,relativePath:J,searchPath:this.getSearchPath(i,J)}),this.isLimitHit){w();break}(W||this.isLimitHit)&&A();return}this.addDirectoryEntries(i,N,d,x,n),W&&(this.matchDirectoryTree(N,d,n),A())})}spawnFindCmd(i){const n=this.folderExcludePatterns.get(i.folder.fsPath),u=n.getBasenameTerms(),c=n.getPathTerms(),d=["-L","."];if(u.length||c.length){d.push("-not","(","(");for(const h of u)d.push("-name",h),d.push("-o");for(const h of c)d.push("-path",h),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),f.spawn("find",d,{cwd:i.folder.fsPath})}readStdout(i,n,u){let c="";this.collectStdout(i,n,()=>{},(d,h,v)=>{if(d){u(d);return}c+=h,v&&u(null,c)})}collectStdout(i,n,u,c){let d=(w,A,O)=>{(w||O)&&(d=()=>{},this.cmdSW&&this.cmdSW.stop()),c(w,A,O)},h=!1;i.stdout?(this.forwardData(i.stdout,n,d),i.stdout.once("data",()=>h=!0)):u({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):u({message:"stderr is null"}),i.on("error",w=>{d(w)}),i.on("close",w=>{let A;!h&&(A=this.decodeData(v,n))&&S(A)?d(new Error(`command failed with error code ${w}: ${this.decodeData(v,n)}`)):(this.exists&&w===0&&(this.isLimitHit=!0),d(null,"",!0))})}forwardData(i,n,u){const c=new D.StringDecoder(n);return i.on("data",d=>{u(null,c.write(d))}),c}collectData(i){const n=[];return i.on("data",u=>{n.push(u)}),n}decodeData(i,n){const u=new D.StringDecoder(n);return i.map(c=>u.write(c)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:n},u,c,d){c.indexOf(this.filePattern)!==-1&&this.matchFile(d,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const h=v=>{const w=k.basename(v),A=k.dirname(v);let O=n[A];O||(O=n[A]=[],h(A)),O.push({base:u,relativePath:v,basename:w,searchPath:this.getSearchPath(i,v)})};c.forEach(h)}matchDirectoryTree({rootEntries:i,pathToEntries:n},u,c){const d=this,h=this.folderExcludePatterns.get(u),v=this.filePattern;function w(A){d.directoriesWalked++;const O=_.hasSiblingFn(()=>A.map(N=>N.basename));for(let N=0,F=A.length;N<F;N++){const M=A[N],{relativePath:V,basename:$}=M;if(h.test(V,$,v!==$?O:void 0))continue;const U=n[V];if(U)w(U);else{if(d.filesWalked++,V===v)continue;d.matchFile(c,M)}if(d.isLimitHit)break}}w(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,n,u,c,d){const h=i.folder,v=_.hasSiblingFn(()=>u);this.parallel(u,(w,A)=>{if(this.isCanceled||this.isLimitHit)return A(null);const O=n?[n,w].join(k.sep):w;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,w,this.config.filePattern!==w?v:void 0))return A(null);const N=[h.fsPath,O].join(k.sep);t.lstat(N,(F,M)=>{if(F||this.isCanceled||this.isLimitHit)return A(null);this.statLinkIfNeeded(N,M,(V,$)=>V||this.isCanceled||this.isLimitHit?A(null):$.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,M,(U,B)=>U||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?A(null):(this.walkedPaths[B]=!0,g.Promises.readdir(N).then(W=>{if(this.isCanceled||this.isLimitHit)return A(null);this.doWalk(i,O,W,c,H=>A(H||null))},W=>{A(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&p.isNumber($.size)&&$.size>this.maxFilesize||this.matchFile(c,{base:h.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),A(null,void 0)))})},w=>{const A=w&&T.coalesce(w);return d(A&&A.length>0?A[0]:void 0)})}matchFile(i,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,k.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(n))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,n,u){return n.isSymbolicLink()?t.stat(i,u):u(null,n)}realPathIfNeeded(i,n,u){return n.isSymbolicLink()?t.realpath(i,(c,d)=>c?u(c):u(null,d)):u(null,i)}getSearchPath(i,n){return i.folderName?k.join(i.folderName,n):n}}e.FileWalker=s;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new s(i)}search(i,n,u){this.walker.walk(this.folderQueries,this.extraFiles,i,n,(c,d)=>{u(c,{limitHit:d,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class o{constructor(i,n){this.expression=i,this.root=n,this.init(i)}init(i){let n,u;Object.keys(i).filter(c=>i[c]).forEach(c=>{k.isAbsolute(c)?(n=n||_.getEmptyExpression(),n[c]=i[c]):(u=u||_.getEmptyExpression(),u[c]=i[c])}),this.absoluteParsedExpr=n&&_.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=u&&_.parse(u,{trimForExclusions:!0})}test(i,n,u){return this.relativeParsedExpr&&this.relativeParsedExpr(i,n,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),n,u)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(..._.getPathTerms(this.relativeParsedExpr)),i}}function S(r){const i=r.trim().split(`
`),n=i[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return b.uppercaseFirstLetter(i[i.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=S}),define(pe[277],ve([0,1,97,22]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===r)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const D=512,T=512,I=512*8,_=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(i,n){super(i);this.decodeStreamErrorKind=n}}e.DecodeStreamError=R;class y{constructor(i){this.iconvLiteDecoder=i}static async create(i){let n;if(i!==e.UTF8)n=(await new Promise((c,d)=>{Z(["@vscode/iconv-lite-umd"],c,d)})).getDecoder(g(i));else{const u=new TextDecoder;n={write(c){return u.decode(c,{stream:!0})},end(){return u.decode()}}}return new y(n)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function l(r,i){const n=i.minBytesRequiredForDetection??i.guessEncoding?I:T;return new Promise((u,c)=>{const d=(0,f.newWriteableStream)(N=>N.join("")),h=[];let v=0,w,A;const O=async()=>{try{const N=await S({buffer:t.VSBuffer.concat(h),bytesRead:v},i.guessEncoding);if(N.seemsBinary&&i.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);N.encoding=await i.overwriteEncoding(N.encoding),w=await y.create(N.encoding);const F=w.write(t.VSBuffer.concat(h).buffer);d.write(F),h.length=0,v=0,u({stream:d,detected:N})}catch(N){A?.dispose(),d.destroy(),c(N)}};A=(0,f.listenStream)(r,{onData:async N=>{w?d.write(w.write(N.buffer)):(h.push(N),v+=N.byteLength,v>=n&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:N=>d.error(N),onEnd:async()=>{w||await O(),d.end(w?.end())}})})}e.toDecodeStream=l;async function b(r,i,n){const c=(await new Promise((v,w)=>{Z(["@vscode/iconv-lite-umd"],v,w)})).getEncoder(g(i),n);let d=!1,h=!1;return{read(){if(h)return null;const v=r.read();if(typeof v!="string"){if(h=!0,!d&&n?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const w=c.end();return w&&w.length>0?(d=!0,t.VSBuffer.wrap(w)):null}return d=!0,t.VSBuffer.wrap(c.write(v))}}}e.toEncodeReadable=b;async function p(r){return(await new Promise((n,u)=>{Z(["@vscode/iconv-lite-umd"],n,u)})).encodingExists(g(r))}e.encodingExists=p;function g(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=g;function E(r,i){if(!r||i<e.UTF16be_BOM.length)return null;const n=r.readUInt8(0),u=r.readUInt8(1);if(n===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const c=r.readUInt8(2);return n===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=E;const L=["ascii","utf-16","utf-32"];async function C(r){const i=await new Promise((h,v)=>{Z(["jschardet"],h,v)}),n=r.slice(0,_),u=m(n.buffer),c=i.detect(u);if(!c||!c.encoding)return null;const d=c.encoding.toLowerCase();return 0<=L.indexOf(d)?null:s(c.encoding)}const a={ibm866:"cp866",big5:"cp950"};function s(r){const i=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[i]||i}function m(r){let i="";for(let n=0;n<r.length;n++)i+=String.fromCharCode(r[n]);return i}function o(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=r.match(/windows(\d+)/);return i?"windows-"+i[1]:r}}}e.toCanonicalName=o;function S({buffer:r,bytesRead:i},n){let u=E(r,i),c=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&r){let d=!0,h=!0,v=!1;for(let w=0;w<i&&w<D;w++){const A=w%2==1,O=r.readUInt8(w)===0;if(O&&(v=!0),d&&(A&&!O||!A&&O)&&(d=!1),h&&(A&&O||!A&&!O)&&(h=!1),O&&!d&&!h)break}v&&(d?u=e.UTF16le:h?u=e.UTF16be:c=!0)}return n&&!c&&!u&&r?C(r.slice(0,i)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:c,encoding:u}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[136],ve([0,1,277,30,135]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class D extends k.TextSearchManager{constructor(I,_,P=t,R="searchProcess"){super(I,_,{readdir:y=>P.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,f.toCanonicalName)(y)},R)}}e.NativeTextSearchManager=D}),define(pe[278],ve([0,1,61,4]),function(Z,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class k{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(T){if(T&&this._dragOperations.has(T)){const I=this._dragOperations.get(T);return this._dragOperations.delete(T),I}}addDragOperationTransfer(T,I){this._dragOperations.set(T,I)}}e.TreeViewsDragAndDropService=k,(0,f.registerSingleton)(e.ITreeViewsDragAndDropService,k)}),define(pe[279],ve([0,1,168,23,2,3,6,18,7,13,17,15,21,205,278]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(C,a){if((0,P.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let s;return Array.isArray(C.highlights)&&(s=C.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),s=s.length?s:void 0),{label:C.label,highlights:s}}}class E{constructor(a,s,m){this._proxy=a,this.commands=s,this.logService=m,this.treeViews=new Map,this.treeDragAndDropService=new p.TreeViewsDragAndDropService;function o(S){return S&&S.$treeViewId&&S.$treeItemHandle}s.registerArgumentProcessor({processArgument:S=>o(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(r=>o(r)?this.convertArgument(r):r):S})}registerTreeDataProvider(a,s,m){const o=this.createTreeView(a,{treeDataProvider:s},m);return{dispose:()=>o.dispose()}}createTreeView(a,s,m){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=s.dragAndDropController?.supportedMimeTypes,S=!!s.dragAndDropController?.handleDrag,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:o,hasHandleDrag:S}),i=this.createExtHostTreeView(a,s,m);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(n){i.message=n},get title(){return i.title},set title(n){i.title=n},get description(){return i.description},set description(n){i.description=n},reveal:(n,u)=>i.reveal(n,u),dispose:async()=>{await r,this.treeViews.delete(a),i.dispose()}}}$getChildren(a,s){const m=this.treeViews.get(a);return m?m.getChildren(s):Promise.reject(new Error((0,f.localize)(0,null,a)))}async $handleDrop(a,s,m,o,S,r){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,f.localize)(1,null,a)));const n=b.TreeDataTransferConverter.toITreeDataTransfer(s);return S===a&&r&&await this.addAdditionalTransferItems(n,i,r,o),i.onDrop(n,m)}async addAdditionalTransferItems(a,s,m,o){const S=this.treeDragAndDropService.removeDragOperationTransfer(o);let r;if(S)r=await S;else if(o&&s.handleDrag){const i=s.handleDrag(m);this.treeDragAndDropService.addDragOperationTransfer(o,i),r=await i}return r&&r.forEach((i,n)=>{i&&a.set(n,i)}),a}async $handleDrag(a,s,m){const o=this.treeViews.get(a);if(!o)return Promise.reject(new Error((0,f.localize)(2,null,a)));const S=await this.addAdditionalTransferItems(new Map,o,s,m);if(!!S)return b.TreeDataTransferConverter.toTreeDataTransferDTO(S)}async $hasResolve(a){const s=this.treeViews.get(a);if(!s)throw new Error((0,f.localize)(3,null,a));return s.hasResolve}$resolve(a,s,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,f.localize)(4,null,a));return o.resolveTreeItem(s,m)}$setExpanded(a,s,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,f.localize)(5,null,a));o.setExpanded(s,m)}$setSelection(a,s){const m=this.treeViews.get(a);if(!m)throw new Error((0,f.localize)(6,null,a));m.setSelection(s)}$setVisible(a,s){const m=this.treeViews.get(a);if(!m)throw new Error((0,f.localize)(7,null,a));m.setVisible(s)}createExtHostTreeView(a,s,m){const o=new L(a,s,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(a,o),o}convertArgument(a){const s=this.treeViews.get(a.$treeViewId);return s?s.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=E;class L extends T.Disposable{constructor(a,s,m,o,S,r){super();if(this.viewId=a,this.proxy=m,this.commands=o,this.logService=S,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,r.contributes&&r.contributes.views)for(const u in r.contributes.views)for(const c of r.contributes.views[u])c.id===a&&(this._title=c.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(u=>this._onDidChangeData.fire({message:!1,element:u}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let i,n;this._register(D.Event.debounce(this._onDidChangeData.event,(u,c)=>(u||(u={message:!1,elements:[]}),c.element!==!1&&(i||(i=new Promise(d=>n=d),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(c.element)?u.elements.push(...c.element):u.elements.push(c.element)),c.message&&(u.message=!0),u),200,!0)(({message:u,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const d=n;return i=null,this.refresh(c).then(()=>d())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,P.isUndefinedOrNull)(a))}async getChildren(a){const s=a?this.getExtensionElement(a):void 0;if(a&&!s)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(a);return m||(m=await this.fetchChildrenNodes(s)),m?m.map(o=>o.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,s){s=s||{select:!0,focus:!1};const m=(0,P.isUndefinedOrNull)(s.select)?!0:s.select,o=(0,P.isUndefinedOrNull)(s.focus)?!1:s.focus,S=(0,P.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(n=>n.item)},{select:m,focus:o,expand:S})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:o,expand:S})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,s){const m=this.getExtensionElement(a);m&&(s?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(a){(0,R.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a){const s=[];for(const m of a){const o=this.getExtensionElement(m);o&&s.push(o)}if(!(!this.dndController?.handleDrag||s.length===0))return this.dndController.handleDrag(s)}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,s){const m=this.getExtensionElement(s);if(!!m)return(0,I.asPromise)(()=>this.dndController?.handleDrop(a,m))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,s){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(a);if(m){const o=this.nodes.get(m);if(o){const S=await this.dataProvider.resolveTreeItem(o.extensionItem,m,s)??o.extensionItem;return o.item.tooltip=this.getTooltip(S.tooltip),o.item.command=this.getCommand(o.disposableStore,S.command),o.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(s=>s?this.resolveUnknownParentChain(s).then(m=>this.resolveTreeNode(s,m[m.length-1]).then(o=>(m.push(o),m))):Promise.resolve([]))}resolveParent(a){const s=this.nodes.get(a);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,s){const m=this.nodes.get(a);return m?Promise.resolve(m):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(o=>this.createHandle(a,o,s,!0)).then(o=>this.getChildren(s?s.item.handle:void 0).then(()=>{const S=this.getExtensionElement(o);if(S){const r=this.nodes.get(S);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(a){if(a){let s;if(typeof a=="string"){const m=this.getExtensionElement(a);s=m?this.nodes.get(m):void 0}else s=a;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const s=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=a?this.nodes.get(a):void 0,o=await this.dataProvider.getChildren(a);if(s.token.isCancellationRequested)return;const S=await Promise.all((0,R.coalesce)(o||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,m):null}));return s.token.isCancellationRequested?void 0:(0,R.coalesce)(S)}finally{s.dispose()}}refresh(a){if(a.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(a);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const s=new Set,m=a.map(S=>this.nodes.get(S));for(const S of m)if(S&&!s.has(S.item.handle)){let r=S;for(;r&&r.parent&&m.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&s.add(S.item.handle)}const o=[];return s.forEach(S=>{const r=this.elements.get(S);if(r){const i=this.nodes.get(r);i&&(!i.parent||!s.has(i.parent.item.handle))&&o.push(S)}}),o}refreshHandles(a){const s={};return Promise.all(a.map(m=>this.refreshNode(m).then(o=>{o&&(s[m]=o.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(a){const s=this.getExtensionElement(a);if(s){const m=this.nodes.get(s);if(m)return this.clearChildren(s),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(o=>{if(o){const S=this.createTreeNode(s,o,m.parent);return this.updateNodeCache(s,S,m,m.parent),m.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,s,m){const o=this.createTreeNode(a,s,m);if(s.id&&this.elements.has(o.item.handle))throw new Error((0,f.localize)(8,null,s.id));return this.addNodeToCache(a,o),this.addNodeToParentCache(o,m),o}getTooltip(a){return _.MarkdownString.isMarkdownString(a)?y.MarkdownString.from(a):a}getCommand(a,s){return s?this.commands.toInternal(s,a):void 0}createTreeNode(a,s,m){const o=new T.DisposableStore,S=this.createHandle(a,s,m),r=this.getLightIconPath(s);return{item:{handle:S,parentHandle:m?m.item.handle:void 0,label:g(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(o,s.command),contextValue:s.contextValue,icon:r,iconDark:this.getDarkIconPath(s)||r,themeIcon:this.getThemeIcon(s),collapsibleState:(0,P.isUndefinedOrNull)(s.collapsibleState)?_.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:m,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(a){return a.iconPath instanceof _.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:s,label:m,resourceUri:o},S,r){if(s)return`${L.ID_HANDLE_PREFIX}/${s}`;const i=g(m,this.extension),n=S?S.item.handle:L.LABEL_HANDLE_PREFIX;let u=i?i.label:o?(0,t.basename)(o):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const c=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,d=this.getChildrenNodes(S)||[];let h,v=0;do{if(h=`${n}/${v}:${u}`,r||!this.elements.has(h)||c===h)break;v++}while(v<=d.length);return h}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof _.ThemeIcon))return typeof a.iconPath=="string"||k.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof _.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return k.URI.isUri(a)?a:k.URI.file(a)}addNodeToCache(a,s){this.elements.set(s.item.handle,a),this.nodes.set(a,s)}updateNodeCache(a,s,m,o){this.elements.delete(s.item.handle),this.nodes.delete(a),s.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(a,s);const S=this.getChildrenNodes(o)||[],r=S.filter(i=>i.item.handle===m.item.handle)[0];r&&S.splice(S.indexOf(r),1,s)}addNodeToParentCache(a,s){s?(s.children||(s.children=[]),s.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const s=this.nodes.get(a);if(s){if(s.children)for(const m of s.children){const o=this.elements.get(m.item.handle);o&&this.clear(o)}s.children=void 0}}else this.clearAll()}clear(a){const s=this.nodes.get(a);if(s){if(s.children)for(const m of s.children){const o=this.elements.get(m.item.handle);o&&this.clear(o)}this.nodes.delete(a),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}L.LABEL_HANDLE_PREFIX="0",L.ID_HANDLE_PREFIX="1"}),define(pe[280],ve([0,1,21,16,3,47,2,114,109,146,82,42,5,230,229,38,231,36,232,233,234,217,235,45,39,236,237,240,241,242,133,219,247,248,249,90,34,251,279,15,7,254,69,134,35,75,206,239,63,131,71,54,73,11,65,14,26,243,203,51,66,227,252,202,68,67,257,255,256,228,44,250,253,89,53,122,245,70,246,10,190,244,200,238,6,28]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C,a,s,m,o,S,r,i,n,u,c,d,h,v,w,A,O,N,F,M,V,$,U,B,W,H,x,J,ne,se,K,Q,ae,fe,be,Me,ze,Ge,Je,q,te,G,X,oe,me,Ie,xe,Ye,it,st,ot,tt,rt,gt,Ue,It,ee,ie,Se,re,Ce,Fe,qe,Ve,ut,Re,Ae,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ce(de){const we=de.get(Je.IExtHostInitDataService),ye=de.get(rt.IExtHostFileSystemInfo),Oe=de.get(Ye.IExtHostConsumerFileSystem),Ke=de.get(r.IExtHostExtensionService),We=de.get(x.IExtHostWorkspace),Ze=de.get(ie.IExtHostTelemetry),lt=de.get(L.IExtHostConfiguration),ct=de.get(ze.IURITransformerService),$e=de.get(Ge.IExtHostRpcService),Ee=de.get(N.IExtHostStorage),_e=de.get(xe.IExtensionStoragePaths),he=de.get(Me.ILoggerService),Y=de.get(Me.ILogService),ke=de.get(G.IExtHostTunnelService),Ne=de.get(X.IExtHostApiDeprecationService),Xe=de.get(H.IExtHostWindow),Qe=de.get(It.IExtHostSecretState),pt=de.get(ee.IExtHostEditorTabs);$e.set(l.ExtHostContext.ExtHostFileSystemInfo,ye),$e.set(l.ExtHostContext.ExtHostLogLevelServiceShape,he),$e.set(l.ExtHostContext.ExtHostWorkspace,We),$e.set(l.ExtHostContext.ExtHostConfiguration,lt),$e.set(l.ExtHostContext.ExtHostExtensionService,Ke),$e.set(l.ExtHostContext.ExtHostStorage,Ee),$e.set(l.ExtHostContext.ExtHostTunnelService,ke),$e.set(l.ExtHostContext.ExtHostWindow,Xe),$e.set(l.ExtHostContext.ExtHostSecretState,Qe),$e.set(l.ExtHostContext.ExtHostTelemetry,Ze),$e.set(l.ExtHostContext.ExtHostEditorTabs,pt);const St=$e.set(l.ExtHostContext.ExtHostDecorations,de.get(Q.IExtHostDecorations)),Ct=$e.set(l.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),ft=$e.set(l.ExtHostContext.ExtHostCommands,de.get(g.IExtHostCommands)),wt=$e.set(l.ExtHostContext.ExtHostTerminalService,de.get(F.IExtHostTerminalService)),bt=$e.set(l.ExtHostContext.ExtHostDebugService,de.get(fe.IExtHostDebugService)),Ut=$e.set(l.ExtHostContext.ExtHostSearch,de.get(be.IExtHostSearch)),Pt=$e.set(l.ExtHostContext.ExtHostTask,de.get(ae.IExtHostTask)),Ft=$e.set(l.ExtHostContext.ExtHostOutputService,de.get(h.IExtHostOutputService)),kt=$e.set(l.ExtHostContext.ExtHostUrls,new B.ExtHostUrls($e)),yt=$e.set(l.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments($e,Ct)),Qt=$e.set(l.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider($e,Ct,Y)),Vt=$e.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(Y,yt,$e.getProxy(l.MainContext.MainThreadBulkEdits))),Et=$e.set(l.ExtHostContext.ExtHostNotebook,new q.ExtHostNotebookController($e,ft,Ct,yt,_e)),Xt=$e.set(l.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(Y,Et)),qt=$e.set(l.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(Y,$e,Et)),Yt=$e.set(l.ExtHostContext.ExtHostNotebookKernels,new Se.ExtHostNotebookKernels($e,we,Et,ft,Y)),ai=$e.set(l.ExtHostContext.ExtHostNotebookRenderers,new Ce.ExtHostNotebookRenderers($e,Et)),Rt=$e.set(l.ExtHostContext.ExtHostEditors,new M.ExtHostEditors($e,Ct)),Jt=$e.set(l.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews($e.getProxy(l.MainContext.MainThreadTreeViews),ft,Y)),li=$e.set(l.ExtHostContext.ExtHostEditorInsets,new ne.ExtHostEditorInsets($e.getProxy(l.MainContext.MainThreadEditorInsets),Rt,we)),jt=$e.set(l.ExtHostContext.ExtHostDiagnostics,new C.ExtHostDiagnostics($e,Y,ye)),Zt=$e.set(l.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages($e,yt,ft.converter,ct)),vt=$e.set(l.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures($e,ct,yt,ft,jt,Y,Ne)),ci=$e.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem($e,vt)),Ot=$e.set(l.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService($e,Y,Ct)),Wt=$e.set(l.ExtHostContext.ExtHostQuickOpen,(0,w.createExtHostQuickOpen)($e,We,ft)),vi=$e.set(l.ExtHostContext.ExtHostSCM,new A.ExtHostSCM($e,ft,Y)),ui=$e.set(l.ExtHostContext.ExtHostComments,(0,E.createExtHostComments)($e,ft,yt)),ei=$e.set(l.ExtHostContext.ExtHostProgress,new v.ExtHostProgress($e.getProxy(l.MainContext.MainThreadProgress))),yi=$e.set(l.ExtHostContext.ExtHosLabelService,new se.ExtHostLabelService($e)),wi=$e.set(l.ExtHostContext.ExtHostTheming,new te.ExtHostTheming($e)),ti=$e.set(l.ExtHostContext.ExtHostAuthentication,new oe.ExtHostAuthentication($e)),Di=$e.set(l.ExtHostContext.ExtHostTimeline,new me.ExtHostTimeline($e,ft)),di=$e.set(l.ExtHostContext.ExtHostWebviews,new W.ExtHostWebviews($e,{remote:we.remote},We,Y,Ne)),Gt=$e.set(l.ExtHostContext.ExtHostWebviewPanels,new ot.ExtHostWebviewPanels($e,di,We)),hi=$e.set(l.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors($e,yt,_e,di,Gt)),ki=$e.set(l.ExtHostContext.ExtHostWebviewViews,new it.ExtHostWebviewViews($e,di)),Kt=$e.set(l.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting($e,ft)),Ii=$e.set(l.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners($e));$e.set(l.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive($e,Et,Ct,ft));const Pi=(0,J.values)(l.ExtHostContext);$e.assertRegistered(Pi);const ii=new tt.ExtHostBulkEdits($e,Ct),Ai=new p.ExtHostClipboard($e),fi=new d.ExtHostMessageService($e,Y),bi=new a.ExtHostDialogs($e),ni=new O.ExtHostStatusBar($e,ft.converter);return b.ExtHostApiCommands.register(ft),function(Be,$t,Bt){const _t=function(){let le=!Be.isUnderDevelopment;function ge(){le||(Y.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function Te(ht){if(Array.isArray(ht))ht.forEach(Te);else if(typeof ht=="string")ge();else{const Dt=ht;typeof Dt.scheme=="undefined"&&ge(),typeof Dt.exclusive=="boolean"&&(0,De.checkProposedApiEnabled)(Be,"documentFiltersExclusive")}return ht}}(),Mt={getSession(le,ge,Te){return ti.getSession(Be,le,ge,Te)},async hasSession(le,ge){return(0,De.checkProposedApiEnabled)(Be,"authSession"),!!await ti.getSession(Be,le,ge,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(le,ge,Te,ht){return ti.registerAuthenticationProvider(le,ge,Te,ht)}},ri={registerCommand(le,ge,Te){return ft.registerCommand(!0,le,ge,Te,void 0,Be)},registerTextEditorCommand(le,ge,Te){return ft.registerCommand(!0,le,(...ht)=>{const Dt=Rt.getActiveTextEditor();if(!Dt){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}return Dt.edit(Tt=>{ge.apply(Te,[Dt,Tt,...ht])}).then(Tt=>{Tt||Y.warn("Edits from command "+le+" were not applied.")},Tt=>{Y.warn("An error occurred while running command "+le,Tt)})},void 0,void 0,Be)},registerDiffInformationCommand:(le,ge,Te)=>((0,De.checkProposedApiEnabled)(Be,"diffCommand"),ft.registerCommand(!0,le,async(...ht)=>{const Dt=Ct.activeEditor(!0);if(!Dt){Y.warn("Cannot execute "+le+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Dt.id);ge.apply(Te,[Tt,...ht])},void 0,void 0,Be)),executeCommand(le,...ge){return ft.executeCommand(le,...ge)},getCommands(le=!1){return ft.getCommands(le)}},Ei={get machineId(){return we.telemetryInfo.machineId},get sessionId(){return we.telemetryInfo.sessionId},get language(){return we.environment.appLanguage},get appName(){return we.environment.appName},get appRoot(){return we.environment.appRoot?.fsPath??""},get appHost(){return we.environment.appHost},get uriScheme(){return we.environment.appUriScheme},get clipboard(){return Ai.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const le=Date.now()-new Date(we.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,ge){return Xe.openUri(le,{allowTunneling:!!we.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===we.environment.appUriScheme)return kt.createAppUri(le);try{return await Xe.asExternalUri(le,{allowTunneling:!!we.remote.authority})}catch(ge){if((0,qe.matchesScheme)(le,Fe.Schemas.http)||(0,qe.matchesScheme)(le,Fe.Schemas.https))return le;throw ge}},get remoteName(){return(0,K.getRemoteName)(we.remote.authority)},get remoteAuthority(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),we.remote.authority},get uiKind(){return we.uiKind}};we.environment.extensionTestsLocationURI||Object.freeze(Ei);const Si=we.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Ti={createTestController(le,ge,Te){return Te&&(0,De.checkProposedApiEnabled)(Be,"testRefresh"),Kt.createTestController(le,ge,Te)},createTestObserver(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.createTestObserver()},runTests(le){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.runTests(le)},get onDidChangeTestResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,De.checkProposedApiEnabled)(Be,"testObserver"),Kt.results}},Ri={getExtension(le){const ge=$t.getExtensionDescription(le);if(ge)return new r.Extension(Ke,Be.identifier,ge,Si)},get all(){return $t.getAllExtensionDescriptions().map(le=>new r.Extension(Ke,Be.identifier,le,Si))},get onDidChange(){return $t.onDidChange}},Li={createDiagnosticCollection(le){return jt.createDiagnosticCollection(Be.identifier,le)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:le=>jt.getDiagnostics(le),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(le,ge){return Zt.changeLanguage(le.uri,ge)},match(le,ge){return(0,R.score)($.LanguageSelector.from(le),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(le,ge,Te){return vt.registerCodeActionProvider(Be,_t(le),ge,Te)},registerCodeLensProvider(le,ge){return vt.registerCodeLensProvider(Be,_t(le),ge)},registerDefinitionProvider(le,ge){return vt.registerDefinitionProvider(Be,_t(le),ge)},registerDeclarationProvider(le,ge){return vt.registerDeclarationProvider(Be,_t(le),ge)},registerImplementationProvider(le,ge){return vt.registerImplementationProvider(Be,_t(le),ge)},registerTypeDefinitionProvider(le,ge){return vt.registerTypeDefinitionProvider(Be,_t(le),ge)},registerHoverProvider(le,ge){return vt.registerHoverProvider(Be,_t(le),ge,Be.identifier)},registerEvaluatableExpressionProvider(le,ge){return vt.registerEvaluatableExpressionProvider(Be,_t(le),ge,Be.identifier)},registerInlineValuesProvider(le,ge){return vt.registerInlineValuesProvider(Be,_t(le),ge,Be.identifier)},registerDocumentHighlightProvider(le,ge){return vt.registerDocumentHighlightProvider(Be,_t(le),ge)},registerLinkedEditingRangeProvider(le,ge){return vt.registerLinkedEditingRangeProvider(Be,_t(le),ge)},registerReferenceProvider(le,ge){return vt.registerReferenceProvider(Be,_t(le),ge)},registerRenameProvider(le,ge){return vt.registerRenameProvider(Be,_t(le),ge)},registerDocumentSymbolProvider(le,ge,Te){return vt.registerDocumentSymbolProvider(Be,_t(le),ge,Te)},registerWorkspaceSymbolProvider(le){return vt.registerWorkspaceSymbolProvider(Be,le)},registerDocumentFormattingEditProvider(le,ge){return vt.registerDocumentFormattingEditProvider(Be,_t(le),ge)},registerDocumentRangeFormattingEditProvider(le,ge){return vt.registerDocumentRangeFormattingEditProvider(Be,_t(le),ge)},registerOnTypeFormattingEditProvider(le,ge,Te,...ht){return vt.registerOnTypeFormattingEditProvider(Be,_t(le),ge,[Te].concat(ht))},registerDocumentSemanticTokensProvider(le,ge,Te){return vt.registerDocumentSemanticTokensProvider(Be,_t(le),ge,Te)},registerDocumentRangeSemanticTokensProvider(le,ge,Te){return vt.registerDocumentRangeSemanticTokensProvider(Be,_t(le),ge,Te)},registerSignatureHelpProvider(le,ge,Te,...ht){return typeof Te=="object"?vt.registerSignatureHelpProvider(Be,_t(le),ge,Te):vt.registerSignatureHelpProvider(Be,_t(le),ge,typeof Te=="undefined"?[]:[Te,...ht])},registerCompletionItemProvider(le,ge,...Te){return vt.registerCompletionItemProvider(Be,_t(le),ge,Te)},registerInlineCompletionItemProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),vt.registerInlineCompletionsProvider(Be,_t(le),ge)},registerDocumentLinkProvider(le,ge){return vt.registerDocumentLinkProvider(Be,_t(le),ge)},registerColorProvider(le,ge){return vt.registerColorProvider(Be,_t(le),ge)},registerFoldingRangeProvider(le,ge){return vt.registerFoldingRangeProvider(Be,_t(le),ge)},registerSelectionRangeProvider(le,ge){return vt.registerSelectionRangeProvider(Be,le,ge)},registerCallHierarchyProvider(le,ge){return vt.registerCallHierarchyProvider(Be,le,ge)},registerTypeHierarchyProvider(le,ge){return vt.registerTypeHierarchyProvider(Be,le,ge)},setLanguageConfiguration:(le,ge)=>vt.setLanguageConfiguration(Be,le,ge),getTokenInformationAtPosition(le,ge){return(0,De.checkProposedApiEnabled)(Be,"tokenInformation"),Zt.tokenAtPosition(le,ge)},registerInlayHintsProvider(le,ge){return(0,De.checkProposedApiEnabled)(Be,"inlayHints"),vt.registerInlayHintsProvider(Be,le,ge)},createLanguageStatusItem(le,ge){return(0,De.checkProposedApiEnabled)(Be,"languageStatus"),Zt.createLanguageStatusItem(Be,le,ge)}},Fi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(le,ge,Te){const ht=await(T.URI.isUri(le)?Promise.resolve(_i.openTextDocument(le)):Promise.resolve(le));return Rt.showTextDocument(ht,ge,Te)},createTextEditorDecorationType(le){return Rt.createTextEditorDecorationType(Be,le)},onDidChangeActiveTextEditor(le,ge,Te){return Rt.onDidChangeActiveTextEditor(le,ge,Te)},onDidChangeVisibleTextEditors(le,ge,Te){return Rt.onDidChangeVisibleTextEditors(le,ge,Te)},onDidChangeTextEditorSelection(le,ge,Te){return Rt.onDidChangeTextEditorSelection(le,ge,Te)},onDidChangeTextEditorOptions(le,ge,Te){return Rt.onDidChangeTextEditorOptions(le,ge,Te)},onDidChangeTextEditorVisibleRanges(le,ge,Te){return Rt.onDidChangeTextEditorVisibleRanges(le,ge,Te)},onDidChangeTextEditorViewColumn(le,ge,Te){return Rt.onDidChangeTextEditorViewColumn(le,ge,Te)},onDidCloseTerminal(le,ge,Te){return wt.onDidCloseTerminal(le,ge,Te)},onDidOpenTerminal(le,ge,Te){return wt.onDidOpenTerminal(le,ge,Te)},onDidChangeActiveTerminal(le,ge,Te){return wt.onDidChangeActiveTerminal(le,ge,Te)},onDidChangeTerminalDimensions(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"terminalDimensions"),wt.onDidChangeTerminalDimensions(le,ge,Te)},onDidChangeTerminalState(le,ge,Te){return wt.onDidChangeTerminalState(le,ge,Te)},onDidWriteTerminalData(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(le,ge,Te)},get state(){return Xe.state},onDidChangeWindowState(le,ge,Te){return Xe.onDidChangeWindowState(le,ge,Te)},showInformationMessage(le,...ge){return fi.showMessage(Be,D.default.Info,le,ge[0],ge.slice(1))},showWarningMessage(le,...ge){return fi.showMessage(Be,D.default.Warning,le,ge[0],ge.slice(1))},showErrorMessage(le,...ge){return fi.showMessage(Be,D.default.Error,le,ge[0],ge.slice(1))},showQuickPick(le,ge,Te){return Array.isArray(le)&&le.some(ht=>ht.kind===U.QuickPickItemKind.Separator)&&(0,De.checkProposedApiEnabled)(Be,"quickPickSeparators"),Wt.showQuickPick(le,ge,Te)},showWorkspaceFolderPick(le){return Wt.showWorkspaceFolderPick(le)},showInputBox(le,ge){return Wt.showInput(le,ge)},showOpenDialog(le){return bi.showOpenDialog(le)},showSaveDialog(le){return bi.showSaveDialog(le)},createStatusBarItem(le,ge,Te){let ht,Dt,Tt;return typeof le=="string"?(ht=le,Dt=ge,Tt=Te):(Dt=le,Tt=ge),ni.createStatusBarEntry(Be,ht,Dt,Tt)},setStatusBarMessage(le,ge){return ni.setStatusBarMessage(le,ge)},withScmProgress(le){return Ne.report("window.withScmProgress",Be,"Use 'withProgress' instead."),ei.withProgress(Be,{location:U.ProgressLocation.SourceControl},(ge,Te)=>le({report(ht){}}))},withProgress(le,ge){return ei.withProgress(Be,le,ge)},createOutputChannel(le){return Ft.createOutputChannel(le,Be)},createWebviewPanel(le,ge,Te,ht){return Gt.createWebviewPanel(Be,le,ge,Te,ht)},createWebviewTextEditorInset(le,ge,Te,ht){return(0,De.checkProposedApiEnabled)(Be,"editorInsets"),li.createWebviewEditorInset(le,ge,Te,ht,Be)},createTerminal(le,ge,Te){return typeof le=="object"?"pty"in le?wt.createExtensionTerminal(le):wt.createTerminalFromOptions(le):wt.createTerminal(le,ge,Te)},registerTerminalLinkProvider(le){return wt.registerLinkProvider(le)},registerTerminalProfileProvider(le,ge){return wt.registerProfileProvider(Be,le,ge)},registerTreeDataProvider(le,ge){return Jt.registerTreeDataProvider(le,ge,Be)},createTreeView(le,ge){return Jt.createTreeView(le,ge,Be)},registerWebviewPanelSerializer:(le,ge)=>Gt.registerWebviewPanelSerializer(Be,le,ge),registerCustomEditorProvider:(le,ge,Te={})=>hi.registerCustomEditorProvider(Be,le,ge,Te),registerFileDecorationProvider(le){return St.registerFileDecorationProvider(le,Be.identifier)},registerUriHandler(le){return kt.registerUriHandler(Be.identifier,le)},createQuickPick(){return Wt.createQuickPick(Be)},createInputBox(){return Wt.createInputBox(Be.identifier)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(le,ge,Te){return wi.onDidChangeActiveColorTheme(le,ge,Te)},registerWebviewViewProvider(le,ge,Te){return ki.registerWebviewViewProvider(Be,le,ge,Te?.webviewOptions)},get activeNotebookEditor(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(le,ge,Te)},get visibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(le,ge,Te)},onDidChangeNotebookEditorVisibleRanges(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(le,ge,Te)},showNotebookDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.showNotebookDocument(le,ge)},registerExternalUriOpener(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"externalUriOpener"),Ii.registerExternalUriOpener(Be.identifier,le,ge,Te)},get tabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.tabs},get activeTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.activeTab},get onDidChangeTabs(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,De.checkProposedApiEnabled)(Be,"tabs"),pt.onDidChangeActiveTab},getInlineCompletionItemController(le){return(0,De.checkProposedApiEnabled)(Be,"inlineCompletions"),u.InlineCompletionController.get(le)}},_i={get rootPath(){return Ne.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),We.getPath()},set rootPath(le){throw t.readonly()},getWorkspaceFolder(le){return We.getWorkspaceFolder(le)},get workspaceFolders(){return We.getWorkspaceFolders()},get name(){return We.name},set name(le){throw t.readonly()},get workspaceFile(){return We.workspaceFile},set workspaceFile(le){throw t.readonly()},updateWorkspaceFolders:(le,ge,...Te)=>We.updateWorkspaceFolders(Be,le,ge||0,...Te),onDidChangeWorkspaceFolders:function(le,ge,Te){return We.onDidChangeWorkspace(le,ge,Te)},asRelativePath:(le,ge)=>We.getRelativePath(le,ge),findFiles:(le,ge,Te,ht)=>We.findFiles(le,ge,Te,Be.identifier,ht),findTextInFiles:(le,ge,Te,ht)=>{(0,De.checkProposedApiEnabled)(Be,"findTextInFiles");let Dt,Tt;return typeof ge=="object"?(Dt=ge,Tt=Te):(Dt={},Tt=ge,ht=Te),We.findTextInFiles(le,Dt||{},Tt,Be.identifier,ht)},saveAll:le=>We.saveAll(le),applyEdit(le){return ii.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,ge,Te,ht)=>Ot.createFileSystemWatcher(We,Be,le,ge,Te,ht),get textDocuments(){return yt.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw t.readonly()},openTextDocument(le){let ge;const Te=le;if(typeof le=="string")ge=Promise.resolve(T.URI.file(le));else if(T.URI.isUri(le))ge=Promise.resolve(le);else if(!Te||typeof Te=="object")ge=yt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ht=>yt.ensureDocumentData(ht).then(Dt=>Dt.document))},onDidOpenTextDocument:(le,ge,Te)=>yt.onDidAddDocument(le,ge,Te),onDidCloseTextDocument:(le,ge,Te)=>yt.onDidRemoveDocument(le,ge,Te),onDidChangeTextDocument:(le,ge,Te)=>yt.onDidChangeDocument(le,ge,Te),onDidSaveTextDocument:(le,ge,Te)=>yt.onDidSaveDocument(le,ge,Te),onWillSaveTextDocument:(le,ge,Te)=>Vt.getOnWillSaveTextDocumentEvent(Be)(le,ge,Te),get notebookDocuments(){return Et.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,ge){let Te;if(T.URI.isUri(le))Te=le,await Et.openNotebookDocument(le);else if(typeof le=="string")Te=T.URI.revive(await Et.createNotebookDocument({viewType:le,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(le,ge,Te,ht){return Et.registerNotebookSerializer(Be,le,ge,Te,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(le,ge,Te,ht)=>((0,De.checkProposedApiEnabled)(Be,"notebookContentProvider"),Et.registerNotebookContentProvider(Be,le,ge,Te,(0,De.isProposedApiEnabled)(Be,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(le,ge,Te)=>Bt.onDidChangeConfiguration(le,ge,Te),getConfiguration(le,ge){return ge=arguments.length===1?void 0:ge,Bt.getConfiguration(le,ge,Be)},registerTextDocumentContentProvider(le,ge){return Qt.registerTextDocumentContentProvider(le,ge)},registerTaskProvider:(le,ge)=>(Ne.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Be,le,ge)),registerFileSystemProvider(le,ge,Te){return(0,Ae.combinedDisposable)(ci.registerFileSystemProvider(Be,le,ge,Te),Oe.addFileSystemProvider(le,ge))},get fs(){return Oe.value},registerFileSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"fileSearchProvider"),Ut.registerFileSearchProvider(le,ge)),registerTextSearchProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"textSearchProvider"),Ut.registerTextSearchProvider(le,ge)),registerRemoteAuthorityResolver:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),Ke.registerRemoteAuthorityResolver(le,ge)),registerResourceLabelFormatter:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),yi.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,ge,Te)=>Ot.onDidCreateFile(le,ge,Te),onDidDeleteFiles:(le,ge,Te)=>Ot.onDidDeleteFile(le,ge,Te),onDidRenameFiles:(le,ge,Te)=>Ot.onDidRenameFile(le,ge,Te),onWillCreateFiles:(le,ge,Te)=>Ot.getOnWillCreateFileEvent(Be)(le,ge,Te),onWillDeleteFiles:(le,ge,Te)=>Ot.getOnWillDeleteFileEvent(Be)(le,ge,Te),onWillRenameFiles:(le,ge,Te)=>Ot.getOnWillRenameFileEvent(Be)(le,ge,Te),openTunnel:le=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.openTunnel(Be,le).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(le,ge,Te)=>((0,De.checkProposedApiEnabled)(Be,"resolvers"),ke.onDidChangeTunnels(le,ge,Te)),registerPortAttributesProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"portsAttributes"),ke.registerPortsAttributesProvider(le,ge)),registerTimelineProvider:(le,ge)=>((0,De.checkProposedApiEnabled)(Be,"timeline"),Di.registerTimelineProvider(le,ge,Be.identifier,ft.converter)),get isTrusted(){return We.trusted},requestWorkspaceTrust:le=>((0,De.checkProposedApiEnabled)(Be,"workspaceTrust"),We.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,ge,Te)=>We.onDidGrantWorkspaceTrust(le,ge,Te)},mi={get inputBox(){return Ne.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Be)},createSourceControl(le,ge,Te){return vi.createSourceControl(Be,le,ge,Te)}},Mi={createCommentController(le,ge){return ui.createCommentController(Be,le,ge)}},Oi={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(le,ge,Te){return bt.onDidStartDebugSession(le,ge,Te)},onDidTerminateDebugSession(le,ge,Te){return bt.onDidTerminateDebugSession(le,ge,Te)},onDidChangeActiveDebugSession(le,ge,Te){return bt.onDidChangeActiveDebugSession(le,ge,Te)},onDidReceiveDebugSessionCustomEvent(le,ge,Te){return bt.onDidReceiveDebugSessionCustomEvent(le,ge,Te)},onDidChangeBreakpoints(le,ge,Te){return bt.onDidChangeBreakpoints(le,ge,Te)},registerDebugConfigurationProvider(le,ge,Te){return bt.registerDebugConfigurationProvider(le,ge,Te||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,ge){return bt.registerDebugAdapterDescriptorFactory(Be,le,ge)},registerDebugAdapterTrackerFactory(le,ge){return bt.registerDebugAdapterTrackerFactory(le,ge)},startDebugging(le,ge,Te){return!Te||typeof Te=="object"&&"configuration"in Te?bt.startDebugging(le,ge,{parentSession:Te}):bt.startDebugging(le,ge,Te||{})},stopDebugging(le){return bt.stopDebugging(le)},addBreakpoints(le){return bt.addBreakpoints(le)},removeBreakpoints(le){return bt.removeBreakpoints(le)},asDebugSourceUri(le,ge){return bt.asDebugSourceUri(le,ge)}},Ni={registerTaskProvider:(le,ge)=>Pt.registerTaskProvider(Be,le,ge),fetchTasks:le=>Pt.fetchTasks(le),executeTask:le=>Pt.executeTask(Be,le),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(le,ge,Te)=>Pt.onDidStartTask(le,ge,Te),onDidEndTask:(le,ge,Te)=>Pt.onDidEndTask(le,ge,Te),onDidStartTaskProcess:(le,ge,Te)=>Pt.onDidStartTaskProcess(le,ge,Te),onDidEndTaskProcess:(le,ge,Te)=>Pt.onDidEndTaskProcess(le,ge,Te)},Ui={createNotebookController(le,ge,Te,ht,Dt){return Yt.createNotebookController(Be,le,ge,Te,ht,(0,De.isProposedApiEnabled)(Be,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(le,ge)=>Et.registerNotebookCellStatusBarItemProvider(Be,le,ge),get onDidSaveNotebookDocument(){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,De.checkProposedApiEnabled)(Be,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Be,le)},onDidChangeNotebookDocumentMetadata(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Xt.onDidChangeNotebookDocumentMetadata(le,ge,Te)},onDidChangeNotebookCells(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeNotebookCells(le,ge,Te)},onDidChangeNotebookCellExecutionState(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(le,ge,Te)},onDidChangeCellOutputs(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellOutputs(le,ge,Te)},onDidChangeCellMetadata(le,ge,Te){return(0,De.checkProposedApiEnabled)(Be,"notebookEditor"),Et.onDidChangeCellMetadata(le,ge,Te)},createConcatTextDocument(le,ge){return(0,De.checkProposedApiEnabled)(Be,"notebookConcatTextDocument"),new Ie.ExtHostNotebookConcatDocument(Et,yt,le,ge)}};return{version:we.version,authentication:Mt,commands:ri,comments:Mi,debug:Oi,env:Ei,extensions:Ri,languages:Li,notebooks:Ui,scm:mi,tasks:Ni,tests:Ti,window:Fi,workspace:_i,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:P.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:l.UIKind,Uri:T.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:re.TextSearchCompleteMessageType,TreeDataTransfer:U.TreeDataTransfer,TreeDataTransferItem:U.TreeDataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ce}),define(pe[281],ve([0,1,282,293,294,2,295]),function(Z,e,f,t,k,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(y,l,b,p,g,E){const L=E.environment.useHostProxy,C=typeof L=="boolean"?L:!E.remote.isRemote,a=(0,T.createProxyResolver)({resolveProxy:m=>y.resolveProxy(m),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(m,o,...S)=>{switch(m){case T.LogLevel.Trace:p.trace(o,...S);break;case T.LogLevel.Debug:p.debug(o,...S);break;case T.LogLevel.Info:p.info(o,...S);break;case T.LogLevel.Warning:p.warn(o,...S);break;case T.LogLevel.Error:p.error(o,...S);break;case T.LogLevel.Critical:p.critical(o,...S);break;case T.LogLevel.Off:break;default:r(m,o,S);break}function r(i,n,...u){p.error("Unknown log level",i),p.error(n,...u)}},getLogLevel:()=>p.getLevel(),proxyResolveTelemetry:m=>{g.$publicLog2("resolveProxy",m)},useHostProxy:C,env:process.env}),s=_(l,a);return R(b,s)}e.connectProxyResolver=I;function _(y,l){const b={config:y.getConfiguration("http").get("proxySupport")||"off"};y.onDidChangeConfiguration(g=>{b.config=y.getConfiguration("http").get("proxySupport")||"off"});const p={config:!!y.getConfiguration("http").get("systemCertificates")};return y.onDidChangeConfiguration(g=>{p.config=!!y.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,T.createHttpPatch)(f,l,{config:"off"},p,!0)),on:Object.assign({},f,(0,T.createHttpPatch)(f,l,{config:"on"},p,!0)),override:Object.assign({},f,(0,T.createHttpPatch)(f,l,{config:"override"},p,!0)),onRequest:Object.assign({},f,(0,T.createHttpPatch)(f,l,b,p,!0)),default:Object.assign(f,(0,T.createHttpPatch)(f,l,b,p,!1))},https:{off:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"off"},p,!0)),on:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"on"},p,!0)),override:Object.assign({},t,(0,T.createHttpPatch)(t,l,{config:"override"},p,!0)),onRequest:Object.assign({},t,(0,T.createHttpPatch)(t,l,b,p,!0)),default:Object.assign(t,(0,T.createHttpPatch)(t,l,b,p,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const P=new Map;function R(y,l){return y.getExtensionPathIndex().then(b=>{const p=Z.__$__nodeRequire("module"),g=p._load;p._load=function(L,C,a){if(L==="tls")return l.tls;if(L!=="http"&&L!=="https")return g.apply(this,arguments);const s=l[L],m=b.findSubstr(D.URI.file(C.filename));let o=P.get(m);if(o||P.set(m,o={}),!o[L]){let S=s.default;o[L]={...S}}return o[L]}})}}),define(pe[137],ve([0,1,37,296,104,17,75,32,9,8,2,31,70,297,275,91]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=p.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class L{constructor(h){this.outputChannel=h}provideTextSearchResults(h,v,w,A){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((O,N)=>{A.onCancellationRequested(()=>H());const F=S(h,v),M=v.folder.fsPath,V=F.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.outputChannel.appendLine(`${E} ${V}
 - cwd: ${M}`);let $=f.spawn(E,F,{cwd:M});$.on("error",K=>{console.error(K),this.outputChannel.appendLine("Error: "+(K&&K.message)),N((0,y.serializeSearchError)(new y.SearchError(K&&K.message,y.SearchErrorCode.rgProcessError)))});let U=!1;const B=new s(v.maxResults,M,v.previewOptions);B.on("result",K=>{U=!0,J="",w.report(K)});let W=!1;const H=()=>{W=!0,$&&$.kill(),B&&B.cancel()};let x=!1;B.on("hitLimit",()=>{x=!0,H()});let J="";$.stdout.on("data",K=>{B.handleData(K),U||(J+=K)});let ne=!1;$.stdout.once("data",()=>ne=!0);let se="";$.stderr.on("data",K=>{const Q=K.toString();this.outputChannel.appendLine(Q),se+=Q}),$.on("close",()=>{if(this.outputChannel.appendLine(ne?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),J&&this.outputChannel.appendLine(`Got data without result: ${J}`),this.outputChannel.appendLine(""),W)O({limitHit:x});else{B.flush(),$=null;let K;se&&!ne&&(K=C(se))?N((0,y.serializeSearchError)(new y.SearchError(K.message,K.code))):O({limitHit:x})}})})}}e.RipgrepTextSearchEngine=L;function C(d){const h=d.split(`
`),v=h[0].trim();if(h.some(A=>A.startsWith("regex parse error")))return new y.SearchError(a(h),y.SearchErrorCode.regexParseError);const w=v.match(/grep config error: unknown encoding: (.*)/);if(w)return new y.SearchError(`Unknown encoding: ${w[1]}`,y.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new y.SearchError(v.charAt(0).toUpperCase()+v.substr(1),y.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new y.SearchError(v.charAt(0).toUpperCase()+v.substr(1),y.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new y.SearchError(v,y.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=C;function a(d){const h=["Regex parse error"],v=d.filter(w=>w.startsWith("PCRE2:"));if(v.length>=1){const w=v[0].replace("PCRE2:","");if(w.indexOf(":")!==-1&&w.split(":").length>=2){const A=w.split(":")[1];h.push(":"+A)}}return h.join("")}e.buildRegexParseError=a;class s extends t.EventEmitter{constructor(h,v,w){super();this.maxResults=h,this.rootFolder=v,this.previewOptions=w,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,v){return super.on(h,v),this}handleData(h){if(this.isDone)return;const v=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(v)}handleDecodedData(h){let v=h.indexOf(`
`);const w=this.remainder+h;if(v>=0)v+=this.remainder.length;else{this.remainder=w;return}let A=0;for(;v>=0;)this.handleLine(w.substring(A,v).trim()),A=v+1,v=w.indexOf(`
`,A);this.remainder=w.substring(A)}handleLine(h){if(this.isDone||!h)return;let v;try{v=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(v.type==="match"){const w=m(v.data.path),A=R.URI.file(_.join(this.rootFolder,w)),O=this.createTextSearchMatch(v.data,A);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const w=m(v.data.path),A=R.URI.file(_.join(this.rootFolder,w));this.createTextSearchContext(v.data,A).forEach(N=>this.onResult(N))}}createTextSearchMatch(h,v){const w=h.line_number-1,A=m(h.lines),O=Buffer.from(A);let N=0,F=0,M=w;h.submatches.length===0&&h.submatches.push(A.length?{start:0,end:1,match:{text:A[0]}}:{start:0,end:0,match:{text:""}});const V=(0,D.coalesce)(h.submatches.map(($,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=m($.match),W=O.slice(N,$.start).toString().length,H=F+W,x=o(B),J=M,ne=x.numLines+J,se=x.numLines>0?x.lastLineLength:x.lastLineLength+H;return N=$.end,F=se,M=ne,new l.Range(J,H,ne,se)}));return(0,g.createTextSearchResult)(v,A,V,this.previewOptions)}createTextSearchContext(h,v){const w=m(h.lines),A=h.line_number;return w.replace(/\r?\n$/,"").split(`
`).map((O,N)=>({text:O,uri:v,lineNumber:A+N}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=s;function m(d){return d.bytes?Buffer.from(d.bytes,"base64").toString():d.text}function o(d){const h=/\n/g;let v=0,w=-1,A;for(;A=h.exec(d);)v++,w=A.index;const O=w>=0?d.length-w-1:d.length;return{numLines:v,lastLineLength:O}}function S(d,h){const v=["--hidden"];v.push(d.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:w,otherIncludes:A}=(0,T.groupBy)(h.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(A&&A.length){const N=new Set;A.forEach(F=>{N.add(F)}),v.push("-g","!*"),N.forEach(F=>{r(F).map(g.anchorGlob).forEach(M=>{v.push("-g",M)})})}w&&w.length&&w.forEach(N=>{v.push("-g",N)}),h.excludes.map(g.anchorGlob).forEach(N=>v.push("-g",`!${N}`)),h.maxFileSize&&v.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||v.push("--no-ignore-parent"):v.push("--no-ignore"),h.followSymlinks&&v.push("--follow"),h.encoding&&h.encoding!=="utf8"&&v.push("--encoding",h.encoding),d.pattern==="--"&&(d.isRegExp=!0,d.pattern="\\-\\-"),d.isMultiline&&!d.isRegExp&&(d.pattern=(0,P.escapeRegExpCharacters)(d.pattern),d.isRegExp=!0),h.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),d.isRegExp&&(d.pattern=i(d.pattern),v.push("--engine","auto"));let O;if(d.isWordMatch){const F=(0,P.createRegExp)(d.pattern,!!d.isRegExp,{wholeWord:d.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",F)}else if(d.isRegExp){let N=u(d.pattern);N=c(N),v.push("--regexp",N)}else O=d.pattern,v.push("--fixed-strings");return v.push("--no-config"),h.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),d.isMultiline&&v.push("--multiline"),h.beforeContext&&v.push("--before-context",h.beforeContext+""),h.afterContext&&v.push("--after-context",h.afterContext+""),v.push("--"),O&&v.push(O),v.push("."),v}function r(d){const h=(0,I.splitGlobAware)(d,"/");return h.map((v,w)=>h.slice(0,w+1).join("/"))}e.spreadGlobComponents=r;function i(d){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;d.match(h);)d=d.replace(h,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;d.match(v);)d=d.replace(v,"$1\\x{$2}");return d}e.unicodeEscapesToPCRE2=i;const n=d=>d.type==="Assertion"&&d.kind==="lookbehind";function u(d){let h;try{h=new b.RegExpParser().parsePattern(d)}catch{return d}let v="",w=0;const A=(F,M,V)=>{v+=d.slice(w,F)+V,w=M},O=[];return new b.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const M=O[0];if(!M)A(F.start,F.end,"\\r?\\n");else if(!O.some(n))if(M.type==="CharacterClass")if(M.negate){const V=d.slice(M.start+2,F.start)+d.slice(F.end,M.end-1);if(M.parent?.type==="Quantifier"){const $=M.parent;A($.start,$.end,(V?`[^${V}]`:".")+($.greedy?"+":"*"))}else A(M.start,M.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=d.slice(M.start+1,F.start)+d.slice(F.end,M.end-1);A(M.start,M.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else M.type==="Quantifier"&&A(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){O.unshift(F)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(F){O.unshift(F)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(F){O.unshift(F)},onCharacterClassLeave(){O.shift()},onAssertionEnter(F){n(F)&&O.push(F)},onAssertionLeave(F){O[0]===F&&O.shift()}}).visit(h),v+=d.slice(w),v}e.fixRegexNewline=u;function c(d){return d.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(pe[283],ve([0,1,21,137,118,10]),function(Z,e,f,t,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,R,y,l){const b=new t.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===D.Schemas.userData){const p={...R,folder:R.folder.with({scheme:D.Schemas.file})},g=new k.Progress(E=>y.report({...E,uri:E.uri.with({scheme:R.folder.scheme})}));return this.withToken(l,E=>b.provideTextSearchResults(P,p,g,E))}else return this.withToken(l,p=>b.provideTextSearchResults(P,R,y,p))}async withToken(P,R){const y=I(P);this.inProgress.add(y);const l=await R(y.token);return this.inProgress.delete(y),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=T;function I(_){const P=new f.CancellationTokenSource;return _.onCancellationRequested(()=>P.cancel()),P}}),define(pe[284],ve([0,1,30,137,136]),function(Z,e,f,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class D{constructor(_){this.query=_}search(_,P,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const y={appendLine(b){R({message:b})}},l=new k.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(y),f);return new Promise((b,p)=>l.search(g=>{P(g.map(T))},_).then(g=>b({limitHit:g.limitHit,type:"success",stats:g.stats}),p))}}e.TextSearchEngineAdapter=D;function T(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((_,P)=>{if(P.ranges){const R=P;return _+(Array.isArray(R.ranges)?R.ranges.length:1)}else return _+1},0)}}}),define(pe[285],ve([0,1,17,18,16,3,102,9,46,2,42,31,276,284]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class p{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let m;const o=L(s),S=new D.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(r=>this.doFileSearchWithEngine(l.Engine,o,i=>S.fire(i),r)),m.then(r=>S.fire(r),r=>S.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return S.event}textSearch(s){let m;const o=L(s),S=new D.Emitter({onFirstListenerDidAdd:()=>{m=(0,t.createCancelablePromise)(r=>this.ripgrepTextSearch(o,i=>S.fire(i),r)),m.then(r=>S.fire(r),r=>S.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return S.event}ripgrepTextSearch(s,m,o){return s.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new b.TextSearchEngineAdapter(s).search(o,m,m)}doFileSearch(s,m,o){return this.doFileSearchWithEngine(l.Engine,s,m,o)}doFileSearchWithEngine(s,m,o,S,r=p.BATCH_SIZE){let i=0;const n=c=>{Array.isArray(c)?(i+=c.length,o(c.map(d=>this.rawMatchToSearchItem(d)))):c.relativePath?(i++,o(this.rawMatchToSearchItem(c))):o(c)};if(m.sortByScore){let c=this.trySortedSearchFromCache(m,n,S);if(!c){const d=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new s(d);c=this.doSortedSearch(h,m,o,n,S)}return new Promise((d,h)=>{c.then(([v,w])=>{const A=w.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(A,o,r),d(v)},h)})}const u=new s(m);return this.doSearch(u,n,r,S).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,I.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,m,o,S,r){const i=new D.Emitter;let n=(0,t.createCancelablePromise)(c=>{let d=[];const h=v=>{Array.isArray(v)?d=v:(S(v),i.fire(v))};return this.doSearch(s,h,-1,c).then(v=>[v,d])}),u;if(m.cacheKey){u=this.getOrCreateCache(m.cacheKey);const c={promise:n,event:i.event,resolved:!1};u.resultsToSearchCache[m.filePattern||""]=c,n.then(()=>{c.resolved=!0},d=>{delete u.resultsToSearchCache[m.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([c,d])=>{const h=u?u.scorerCache:Object.create(null),v=(typeof m.maxResults!="number"||m.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(m,d,h,r).then(w=>{const A=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:A,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:w.length},messages:c.messages,limitHit:c.limitHit||typeof m.maxResults=="number"&&d.length>m.maxResults},w]})})}getOrCreateCache(s){const m=this.caches[s];return m||(this.caches[s]=new g)}trySortedSearchFromCache(s,m,o){const S=s.cacheKey&&this.caches[s.cacheKey];if(!S)return;const r=this.getResultsFromCache(S,s.filePattern||"",m,o);if(r)return r.then(([i,n,u])=>{const c=_.StopWatch.create(!1);return this.sortResults(s,n,S.scorerCache,o).then(d=>{const h=c.elapsed(),v={fromCache:!0,detailStats:u,type:this.processType,resultCount:n.length,sortingTime:h};return[{type:"success",limitHit:i.limitHit||typeof s.maxResults=="number"&&n.length>s.maxResults,stats:v},d]})})}sortResults(s,m,o,S){const r=(0,T.prepareQuery)(s.filePattern||""),i=(u,c)=>(0,T.compareItemsByFuzzyScore)(u,c,r,!0,E,o),n=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return f.topAsync(m,i,n,1e4,S)}sendProgress(s,m,o){if(o&&o>0)for(let S=0;S<s.length;S+=o)m(s.slice(S,S+o));else m(s)}getResultsFromCache(s,m,o,S){const r=_.StopWatch.create(!1),i=m.indexOf(I.sep)>=0;let n;for(const h in s.resultsToSearchCache)if(m.startsWith(h)){if(i&&h.indexOf(I.sep)<0&&h!=="")continue;const v=s.resultsToSearchCache[h];n={promise:this.preventCancellation(v.promise),event:v.event,resolved:v.resolved};break}if(!n)return null;const u=r.elapsed(),c=_.StopWatch.create(!1),d=n.event(o);return S&&S.onCancellationRequested(()=>{d.dispose()}),n.promise.then(([h,v])=>{if(S&&S.isCancellationRequested)throw(0,k.canceled)();const w=[],A=(0,T.prepareQuery)(m).normalizedLowercase;for(const O of v)!(0,y.isFilePatternMatch)(O,A)||w.push(O);return[h,w,{cacheWasResolved:n.resolved,cacheLookupTime:u,cacheFilterTime:c.elapsed(),cacheEntryCount:v.length}]})}doSearch(s,m,o,S){return new Promise((r,i)=>{let n=[];S&&S.onCancellationRequested(()=>s.cancel()),s.search(u=>{u&&(o?(n.push(u),o>0&&n.length>=o&&(m(n),n=[])):m(u))},u=>{m(u)},(u,c)=>{n.length&&m(n),u?i(u):r(c)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,o){return s.then(m,o)}catch(m){return this.then(void 0,m)}finally(m){return s.finally(m)}}}}e.SearchService=p,p.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(a){return(0,I.basename)(a.relativePath)}getItemDescription(a){return(0,I.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function L(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(C),extraFileResources:a.extraFileResources&&a.extraFileResources.map(s=>P.URI.revive(s))}}function C(a){return{...a,folder:P.URI.revive(a.folder)}}}),define(pe[286],ve([0,1,6,10,2,30,11,26,14,73,65,31,285,283,91,136]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends P.ExtHostSearch{constructor(C,a,s,m){super(C,s,m);this._pfs=D,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new p.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new b.RipgrepSearchProvider(o)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const C=new p.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new b.RipgrepSearchProvider(C)),this.registerInternalFileSearchProvider(t.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(C,a){const s=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(C)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(C,a,s,m){const o=(0,P.reviveQuery)(s);return C===this._internalFileSearchHandle?this.doInternalFileSearch(C,a,o,m):super.$provideFileSearchResults(C,a,s,m)}doInternalFileSearch(C,a,s,m){const o=S=>{if((0,y.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(C,a,S.map(r=>k.URI.file(r.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,o,m)}$clearCache(C){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(C),super.$clearCache(C)}createTextSearchManager(C,a){return new g.NativeTextSearchManager(C,a,void 0,"textSearchProvider")}};E=je([He(0,_.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,R.IURITransformerService),He(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(pe[138],ve([0,1,298,125,81,22,16,3,6,9,12,33,106,107,299]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(v,w=""){this.debugLabel=w,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(v,w){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,w)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const w=A=>{this.traceSocketEvent("read",A),v(D.VSBuffer.wrap(A))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(v){const w=A=>{this.traceSocketEvent("close",{hadError:A}),v({type:0,hadError:A,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(v){const w=()=>{this.traceSocketEvent("nodeEndReceived"),v()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(v){if(!this.socket.destroyed)try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=g;var E;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var L;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(L||(L={}));class C extends _.Disposable{constructor(v,w,A,O){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:A?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new a(this,w,A,O,this._onData,(N,F)=>this._write(N,F))),this._register(this._flowManager.onError(N=>{console.error(N),(0,T.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(v,w){this.socket.traceSocketEvent(v,w)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._flowManager.writeMessage(v)}_write(v,w){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let A=2;v.byteLength<126?A+=0:v.byteLength<2**16?A+=2:A+=8;const O=D.VSBuffer.alloc(A);if(w?O.writeUInt8(194,0):O.writeUInt8(130,0),v.byteLength<126)O.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(v.byteLength>>>8&255,++N),O.writeUInt8(v.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(v.byteLength>>>24&255,++N),O.writeUInt8(v.byteLength>>>16&255,++N),O.writeUInt8(v.byteLength>>>8&255,++N),O.writeUInt8(v.byteLength>>>0&255,++N)}this.socket.write(D.VSBuffer.concat([O,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),A=w.readUInt8(0),O=(A&128)>>>7,N=(A&64)>>>6,F=w.readUInt8(1),M=(F&128)>>>7,V=F&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),A=w.readUInt8(1),O=(A&128)>>>7;let N=A&127,F=1;N===126?N=w.readUInt8(++F)*2**8+w.readUInt8(++F):N===127&&(N=w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F));let M=0;O&&(M=w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F)),this._state.state=3,this._state.readLen=N,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),o(w,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(w,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=C;class a extends _.Disposable{constructor(v,w,A,O,N,F){super();this._tracer=v,this._onData=N,this._writeFn=F,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,w?(this._zlibInflateStream=this._register(new s(this._tracer,O,A,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(v){this._writeQueue.push(v),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const v=this._writeQueue.shift();if(this._zlibDeflateStream){const w=await this._deflateMessage(this._zlibDeflateStream,v);this._writeFn(w,!0)}else this._writeFn(v,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(v,w){return new Promise((A,O)=>{v.write(w),v.flush(N=>A(N))})}acceptFrame(v,w,A){this._readQueue.push({data:v,isCompressed:w,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const v=this._readQueue.shift();if(this._zlibInflateStream&&v.isCompressed){const w=await this._inflateFrame(this._zlibInflateStream,v.data,v.isLastFrameOfMessage);this._onData.fire(w)}else this._onData.fire(v.data)}this._isProcessingReadQueue=!1}}_inflateFrame(v,w,A){return new Promise((O,N)=>{v.write(w),A&&v.write(D.VSBuffer.fromByteArray([0,0,255,255])),v.flush(F=>O(F))})}}class s extends _.Disposable{constructor(v,w,A,O){super();this._tracer=v,this._recordInflateBytes=w,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=p.createInflateRaw(O),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(D.VSBuffer.wrap(N))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(v){this._recordInflateBytes&&this._recordedInflateBytes.push(v.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",v),this._zlibInflate.write(v.buffer)}flush(v){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const w=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,v(w)})}}class m extends _.Disposable{constructor(v,w){super();this._tracer=v,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(D.VSBuffer.wrap(A))})}write(v){this._tracer.traceSocketEvent("zlibDeflateWrite",v.buffer),this._zlibDeflate.write(v.buffer)}flush(v){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let w=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.byteLength-4),v(w)})}}function o(h,v){if(v===0)return;let w=h.byteLength>>>2;for(let V=0;V<w;V++){const $=h.readUInt32BE(V*4);h.writeUInt32BE($^v,V*4)}let A=w*4,O=h.byteLength-A;const N=v>>>24&255,F=v>>>16&255,M=v>>>8&255;O>=1&&h.writeUInt8(h.readUInt8(A)^N,A),O>=2&&h.writeUInt8(h.readUInt8(A+1)^F,A+1),O>=3&&h.writeUInt8(h.readUInt8(A+2)^M,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function r(){const h=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):v=(0,P.join)((0,k.tmpdir)(),`vscode-ipc-${h}.sock`),n(v),v}e.createRandomIPCHandle=r;function i(h,v,w){const A=(0,f.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${w}-${v}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${w}-${v}.sock`):O=(0,P.join)(h,`${w}-${v}.sock`),n(O),O}e.createStaticIPCHandle=i;function n(h){const v=S[R.platform];typeof v=="number"&&h.length>=v&&console.warn(`WARNING: IPC handle "${h}" is longer than ${v} chars, try a shorter --user-data-dir`)}class u extends l.IPCServer{constructor(v){super(u.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const w=I.Event.fromNodeEventEmitter(v,"connection");return I.Event.map(w,A=>({protocol:new b.Protocol(new g(A,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function c(h){return new Promise((v,w)=>{const A=(0,t.createServer)();A.on("error",w),A.listen(h,()=>{A.removeListener("error",w),v(new u(A))})})}e.serve=c;function d(h,v){return new Promise((w,A)=>{const O=(0,t.createConnection)(h,()=>{O.removeListener("error",A),w(b.Client.fromSocket(new g(O,`ipc-client${v}`),v))});O.once("error",A)})}e.connect=d}),define(pe[287],ve([0,1,138,282,60,38,2,198,11]),function(Z,e,f,t,k,D,T,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,b,p){this._commands=l,this.logService=b,this._ipcHandlePath=p,this._server=t.createServer((g,E)=>this.onRequest(g,E)),this.setup().catch(g=>(b.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,b){const p=[];l.setEncoding("utf8"),l.on("data",g=>p.push(g)),l.on("end",()=>{const g=JSON.parse(p.join(""));switch(g.type){case"open":this.open(g,b);break;case"openExternal":this.openExternal(g,b);break;case"status":this.getStatus(g,b);break;case"extensionManagement":this.manageExtensions(g,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${g.type}`,E=>{E&&this.logService.error(E)}),b.end();break}})}open(l,b){const{fileURIs:p,folderURIs:g,forceNewWindow:E,diffMode:L,addMode:C,forceReuseWindow:a,gotoLineMode:s,waitMarkerFilePath:m,remoteAuthority:o}=l,S=[];if(Array.isArray(g))for(const u of g)try{S.push({folderUri:T.URI.parse(u)})}catch{}if(Array.isArray(p))for(const u of p)try{(0,I.hasWorkspaceFileExtension)(u)?S.push({workspaceUri:T.URI.parse(u)}):S.push({fileUri:T.URI.parse(u)})}catch{}const r=m?T.URI.file(m):void 0,n={forceNewWindow:E,diffMode:L,addMode:C,gotoLineMode:s,forceReuseWindow:a,preferNewWindow:!a&&!r&&!C,waitMarkerFileURI:r,remoteAuthority:o};this._commands.executeCommand("_remoteCLI.windowOpen",S,n),b.writeHead(200),b.end()}async openExternal(l,b){for(const p of l.uris){const g=T.URI.parse(p),E=g.scheme==="file"?g:p;await this._commands.executeCommand("_remoteCLI.openExternal",E)}b.writeHead(200),b.end()}async manageExtensions(l,b){try{const p=L=>L?.map(C=>/\.vsix$/i.test(C)?T.URI.parse(C):C),g={list:l.list,install:p(l.install),uninstall:p(l.uninstall),force:l.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);b.writeHead(200),b.write(E)}catch(p){b.writeHead(500),b.write(String(p),g=>{g&&this.logService.error(g)})}b.end()}async getStatus(l,b){try{const p=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(p),b.end()}catch(p){b.writeHead(500),b.write(String(p),g=>{g&&this.logService.error(g)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let R=class extends P{constructor(l,b){super(l,b,(0,f.createRandomIPCHandle)())}};R=je([He(0,D.IExtHostCommands),He(1,_.ILogService)],R),e.CLIServer=R}),define(pe[288],ve([0,1,72,280,268,5,281,39,258,2,10,7,287,105]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class p extends k.RequireInterceptor{_installInterceptor(){const L=this,C=Z.__$__nodeRequire("module"),a=C._load;C._load=function(S,r,i){return S=m(S),L._factories.has(S)?L._factories.get(S).load(S,P.URI.file((0,b.realpathSync)(r.filename)),n=>a.apply(this,[n,r,i])):a.apply(this,arguments)};const s=C._resolveLookupPaths;C._resolveLookupPaths=(o,S)=>s.call(this,m(o),S);const m=o=>{for(let S of L._alternatives){let r=S(o);if(r){o=r;break}}return o}}}class g extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const L=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const o=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}await this._instaService.createInstance(p,L,this._registry).install(),f.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const s=process.send,m=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);process.send=(...o)=>o.length===0||!o[0]||o[0].type!=="__$console"?s.apply(process,o):(m.$logExtensionHostMessage(o[0]),!1)}_getEntryPoint(L){return L.main}_loadCommonJSModule(L,C,a){if(C.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${C}', must be of file-scheme`);let s=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${C.toString(!0)}`),this._logService.flush();try{L&&f.mark(`code/extHost/willLoadExtensionCode/${L.value}`),s=Z.__$__nodeRequire(C.fsPath)}catch(m){return Promise.reject(m)}finally{L&&f.mark(`code/extHost/didLoadExtensionCode/${L.value}`),a.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(L){if(!!this._initData.remote.isRemote)for(const C in L){const a=L[C];a===null?delete process.env[C]:process.env[C]=a}}}e.ExtHostExtensionService=g}),define(pe[289],ve([0,1,61,261,270,269,286,288,262,54,39,73,71,34,51,68,260,259,11]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(R.IExtHostExtensionService,I.ExtHostExtensionService),(0,f.registerSingleton)(C.ILoggerService,L.ExtHostLoggerService),(0,f.registerSingleton)(g.IExtensionStoragePaths,E.ExtensionStoragePaths),(0,f.registerSingleton)(P.IExtHostDebugService,D.ExtHostDebugService),(0,f.registerSingleton)(y.IExtHostSearch,T.NativeExtHostSearch),(0,f.registerSingleton)(l.IExtHostTask,k.ExtHostTask),(0,f.registerSingleton)(b.IExtHostTerminalService,t.ExtHostTerminalService),(0,f.registerSingleton)(p.IExtHostTunnelService,_.ExtHostTunnelService)}),define(pe[290],ve([0,1,125,300,72,16,107,138,191,223,271,22,103,30,105,18,114,273,289]),function(Z,e,f,t,k,D,T,I,_,P,R,y,l,b,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const L=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=Z.__$__nodeRequire("module"),n=i._load;i._load=function(u){if(u==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const C=process.exit.bind(process);function a(i){process.exit=function(n){if(i)C(n);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let s=function(i){C()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,n)=>{let u=null,c=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const d=108e5,h=3e5,v=new g.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),d),w=new g.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),h);process.on("message",(O,N)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const F=y.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let M;if(O.skipWebSocketFrames)M=new I.NodeSocket(N,"extHost-socket");else{const V=y.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));M=new I.WebSocketNodeSocket(new I.NodeSocket(N,"extHost-socket"),O.permessageDeflate,V,!1)}u?(v.cancel(),w.cancel(),u.beginAcceptReconnection(M,F),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(c),u=new T.PersistentProtocol(M,F),u.sendResume(),u.onDidDispose(()=>s("renderer disconnected")),i(u),u.onSocketClose(()=>{v.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(w.isScheduled())return;v.isScheduled()&&w.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,u)=>{const c=f.createConnection(i,()=>{c.removeListener("error",u),n(new T.PersistentProtocol(new I.NodeSocket(c,"extHost-renderer")))});c.once("error",u),c.on("close",()=>{s("renderer closed the socket")})})}}async function o(){const i=await m();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(n=>{(0,P.isMessageOfType)(n,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||i.send(n)}drain(){return i.drain()}}}function S(i){return new Promise(n=>{const u=i.onMessage(c=>{u.dispose();const d=JSON.parse(c.toString()),h=d.commit,v=_.default.commit;h&&v&&h!==v&&C(55);let w=0;setInterval(function(){try{process.kill(d.parentPid,0),w=0}catch(O){O&&O.code==="EPERM"?(w++,w>=3&&s(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):s(`parent process ${d.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let A;try{A=Z.__$__nodeRequire("native-watchdog"),A.start(d.parentPid)}catch(O){(0,D.onUnexpectedError)(O)}i.send((0,P.createMessageOfType)(0)),n({protocol:i,initData:d})});i.send((0,P.createMessageOfType)(1))})}async function r(){const i=[];process.on("unhandledRejection",(w,A)=>{i.push(A),setTimeout(()=>{const O=i.indexOf(A);O>=0&&A.catch(N=>{i.splice(O,1),(0,D.isCancellationError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),w&&(0,D.onUnexpectedError)(w))})},1e3)}),process.on("rejectionHandled",w=>{const A=i.indexOf(w);A>=0&&i.splice(A,1)}),process.on("uncaughtException",function(w){(0,D.onUnexpectedError)(w)}),k.mark("code/extHost/willConnectToRenderer");const n=await o();k.mark("code/extHost/didConnectToRenderer");const u=await S(n);k.mark("code/extHost/didWaitForInitData");const{initData:c}=u;a(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=!!L.useHostProxy,c.environment.skipWorkspaceStorageLock=(0,E.boolean)(L.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(A){C(A)}exists(A){return b.Promises.exists(A)}realpath(A){return(0,p.realpath)(A)}};let h=null;if(c.remote.authority&&L.uriTransformerPath)try{const A=Z.__$__nodeRequire(L.uriTransformerPath)(c.remote.authority);h=new l.URITransformer(A)}catch(w){console.error(w)}const v=new R.ExtensionHostMain(u.protocol,c,d,h);s=w=>v.terminate(w)}e.startExtensionHostProcess=r}),define(pe[301],ve([0,1,290]),function(Z,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.startExtensionHostProcess)().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7ae7f9d40b82a0f1a49d8ad180d27e16812ad95e/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
